<?php

class push_notification {

    public static $android_access_key = '';
    public static $ios_apn_password = '';
    public static $ios_cert_path = '';
    public static $apns_topic = '';

    public function __construct() {
        exit('Init function is not allowed');
    }

    // Sends Push notification for Android users
    private static function android($data, $devicetoken) {
        $fields = array(
            'to' => $devicetoken,
            'notification' => $data,
        );
        $headers = array(
            'Authorization: key=' . push_notification::$android_access_key,
            'Content-Type: application/json'
        );

        $url = 'https://fcm.googleapis.com/fcm/send';

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($fields));

        $result = curl_exec($ch);
        curl_close($ch);

        return json_decode($result, true);
    }

    // Sends Push notification for iOS users
    private static function ios($data, $devicetoken) {

        if (defined("CURL_VERSION_HTTP2") && (curl_version()["features"] & CURL_VERSION_HTTP2) !== 0) {
            $ch = curl_init();

            $curlconfig = array(
                CURLOPT_URL => "https://api.push.apple.com/3/device/$devicetoken",
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_POSTFIELDS => json_encode($data),
                CURLOPT_SSLCERT => push_notification::$ios_cert_path,
                CURLOPT_HTTPHEADER => array("apns-topic: " . push_notification::$apns_topic),
                CURLOPT_SSLCERTPASSWD => push_notification::$ios_apn_password,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_2_0,
                CURLOPT_VERBOSE => true
            );
            curl_setopt_array($ch, $curlconfig);
            $result = curl_exec($ch);
            parr($result);
            if ($result === FALSE) {
                echo('Curl failed: ' . curl_error($ch));
            }
            curl_close($ch);
        } else {
            echo "No HTTP/2 support on client.";
        }
        return json_decode($result, true);
    }

    public static function send_notification($device_type, $device_token, $title, $body, $sound = 'default') {
        if ($device_type == 'ios') {
            $data ['aps'] = array(
                "alert" => array(
                    "title" => $title,
                    "body" => $body
                ),
                "sound" => $sound
            );
            return self::ios($data, $device_token);
        }
        if ($device_type == 'android') {
            $data = array(
                'title' => $title,
                'body' => $body
            );

            return self::android($data, $device_token);
        }
    }

}

push_notification::$android_access_key = 'AAAAtFHbMfg:APA91bHzqSpjDKAd7QyBoJGrjBRFgyRSsD6FlqOQC2ITrNCP0HKjwiBRWdAC_DQwch83EWWL6CgrZcqet_rsd5n8huqcHbVUmDVhqnPPQRGV2le8a5sD-nuUJYF6KtiixLryxGRDOn2i';                //API Access key from Google Console (FCM)
push_notification::$ios_apn_password = '';                                                         //Apple Push Notifications certifcate passphrase
$dir_path = getcwd();
$cert_path = 'app_pushnotification_end.pem'; 
$cert_path = preg_replace("/static/", 'extension/lib/'.$cert_path, $dir_path);

//$cert_path = '/home/altarbia/azsoon.com/ap/extension/lib/app_pushnotification_end.pem'; 

      //Apple Push Notifications certifcate path
//parr($cert_path);
push_notification::$ios_cert_path = $cert_path;
push_notification::$apns_topic = "com.octasolutions.parisAline";

