<?php
/*
 * insert query for forms in different language
 */
function form_insert($data, $table, $type = "add") {
    $osql=new sql();
    $insert_table = "{$table}_lang";
    $query = " insert into {$insert_table} (`{$table}_id`,`lang_id`,";
    foreach ($data as $kfeild => $value):
        $fld = explode("__", $kfeild);
        if ($fld[1]) {
            $arr_flds[$fld[0]] = $fld[0];
            if (!$arr_vals[$fld[1]])
                $arr_vals[$fld[1]] = array();
            array_push($arr_vals[$fld[1]], $value);
        }
    endforeach;

    $query .= implode($arr_flds, ",");
    $query .= " ) values ";
    $frgn_id = $data["{$table}_id"];

    $arr_qurys = array();
    foreach ($arr_vals as $lang_id => $details):
        $arr_vls = array();
        foreach ($details as $k => $feild_value):
            if ($feild_value or $feild_value == "0")
                $val_feild = "'".$osql->escape ($feild_value)."'";
            else
                $val_feild = 'NULL';
            array_push($arr_vls, $val_feild);
        endforeach;
        $str = "('{$frgn_id}','{$lang_id}', " . implode($arr_vls, ",") . ")";
        array_push($arr_qurys, $str);
    endforeach;

    $query .= implode($arr_qurys, ",");
    
    $osql->begin();
    $osql->execute_statment("delete from {$insert_table} where {$table}_id={$frgn_id}");
    $osql->execute_statment($query);
    if ($osql::$is_rollback) {
        $osql->rollback();
        if ($type == "add")
            $osql->execute_statment("delete from {$table} where {$table}_id='{$frgn_id}'");
        return "error";
    } else {
        $osql->commit();
        return "success";
    }
}

/*
 * get lang feild for tables
 */

function get_lang_values($data, $table) {
    $osql = new sql();
    $fld_id = "{$table}_id";
    if ($data[$fld_id]) {
        $lang_table = "{$table}_lang";
        $res = $osql->get_result("select * from {$lang_table} where {$fld_id}='{$data["$fld_id"]}'");
        while ($row = $osql->next($res)):
            foreach ($row as $fld => $val):
                $data["{$fld}__{$row["lang_id"]}"] = $val;
            endforeach;
        endwhile;
    }
    return $data;
}

/*
 * get language
 */

function get_lang() {
    $osql = new sql();
    $res = $osql->get_result("select lang_id,lang_code from lang where lang_is_disable=0");
    while ($row = $osql->next($res)):
        $arr_lang[$row["lang_id"]] = $row["lang_code"];
    endwhile;
    return $arr_lang;
}

/**
 * get default precision
 */
function def_precision() {
    $pre = globals::_get('app_setting_precision');
    if (is_numeric($pre) && $pre > 0)
        return $pre;
    return 2;
}

function assemble_code($parent_code, $code) {
    return $parent_code . "&nbsp;" . $code . '<br/>'
            . '<div style="float:' . DIR_ALIGN . ';width:110px;font-size: 10px;">' . def_app_account_parent_code . '</div>'
            . '<div style="float:' . DIR_ALIGN . ';display:block;font-size: 10px;color:red;">' . def_app_account_code . '</div>'
            . '<div style="clear:both;"></div>';
}

/**
 * Format No.
 */
function no_format($val, $pre = 0, $end_zero = true) {
    if (!is_numeric($val))
        return $val;
    $pre = !$pre ? def_precision() : $pre;
    return $end_zero ? number_format($val, $pre, '.', ',') : round($val, $pre);
}

/**
 * Xls Format No.
 */
function xls_no_format($pre = 0) {
    $xls_no_format = "#,##0.";
    $pre = !$pre ? def_precision() : $pre;
    for ($i = 0; $i < $pre; $i++)
        $xls_no_format .= "0";
    return $xls_no_format;
}

/*
 * rounding
 */

function int_round($rounding, $number, $fraction) {
    if ($rounding === "ceil") {
        return ceil($number / $fraction) * $fraction;
    } elseif ($rounding === "floor") {
        return floor($number / $fraction) * $fraction;
    } else {
        return round($number / $fraction) * $fraction;
    }
}

/*
 * get correct entry 
 */

function int_round_entry($basic_round, $basic_fraction, $number, $entry_rate) {
    //$_POST["app_bill_entry_dbt"]=(round($_POST["app_bill_entry_dbt"]*$rate)/$basic_cur_fraction)*$basic_cur_fraction/entry_rate
    if ($basic_round === "ceil") {
        return (ceil(($number * $entry_rate) / $basic_fraction)) * $basic_fraction / $entry_rate;
    } elseif ($basic_round === "floor") {
        return (floor(($number * $entry_rate) / $basic_fraction)) * $basic_fraction / $entry_rate;
    } else {
        return (round(($number * $entry_rate) / $basic_fraction)) * $basic_fraction / $entry_rate;
    }
}

/*
 * Random String
 */

function random_string($length) {
    $key = '';
    $keys = array_merge(range(0, 9), range('A', 'Z'));

    for ($i = 0; $i < $length; $i++) {
        $key .= $keys[array_rand($keys)];
    }

    return $key;
}

/**
 * Get header Authorization
 * */
function getAuthorizationHeader() {
    $headers = null;
    if (isset($_SERVER['Authorization'])) {
        $headers = trim($_SERVER["Authorization"]);
    } else if (isset($_SERVER['HTTP_AUTHORIZATION'])) { //Nginx or fast CGI
        $headers = trim($_SERVER["HTTP_AUTHORIZATION"]);
    } elseif (function_exists('apache_request_headers')) {
        $requestHeaders = apache_request_headers();
        // Server-side fix for bug in old Android versions (a nice side-effect of this fix means we don't care about capitalization for Authorization)
        $requestHeaders = array_combine(array_map('ucwords', array_keys($requestHeaders)), array_values($requestHeaders));
        //print_r($requestHeaders);
        if (isset($requestHeaders['Authorization'])) {
            $headers = trim($requestHeaders['Authorization']);
        }
    }
    return $headers;
}

/**
 * get access token from header
 * */
function getBearerToken() {
    $headers = getAuthorizationHeader();
    // HEADER: Get the access token from the header
    if (!empty($headers)) {
        if (preg_match('/Bearer\s(\S+)/', $headers, $matches)) {
            return $matches[1];
        }
    }
    return null;
}

/**
 * example: echo '-265359030.75===' . number_to_string(-265359030.75, 'rtl', 'دولار', 'سنت') . '<br/>';
 * if after decimals is null then we take the $number as it is so if it is 2.460 we will put 3 numbers after decimal
 * but if we put it $after_decimal=2 & number is 2.2 then it will be 2.20 [two point twenty] & not [two point two]
 */
function number_to_string($number, $dir = null, $integer_unit = null, $decimal_unit = null, $after_decimal = null) {
    $lang = $dir == 'rtl' ? 'ar' : 'en';
    include_once(extension_physical_path . 'num_to_str/' . $lang . '/cls_num2str.php');
    $num_to_str = $lang == 'ar' ? new ar_num_to_str() : new en_num_to_str();
    if ($lang == 'ar')
        $num_to_str->setFeminine(1) //1 for mozakar, 2 for mo2anath
                ->setFormat(1); //1 if Marfoua & 2 if Mansoub or Majrour
    if ($integer_unit)
        $num_to_str->setIntegerUnit($integer_unit);
    if ($decimal_unit)
        $num_to_str->setDecimalUnit($decimal_unit);
    //first if number contains any char except 0 to 9 & + or - then remove it also if there is 3,250 we remove comma
    $number = preg_replace('/[^0-9.\-\+]+/', '', $number);
    //if null $after_decimal then we keep number of decimals as are in $number, else if there is values
    //we use number_format to add zeros as the needed after decimal & truncate if exist decimal more
    if (!is_null($after_decimal) && is_numeric($after_decimal))
        $number = number_format($number, $after_decimal, '.', '');
    return $num_to_str->int2str($number);
}

/*
 * get value of addition and discount
 */

function get_val($val, $code, $price, $service_curr_id, $service_curr_rate, $dealer_id = null) {
    $osql = new sql();

    if ($code === "%"):
        $value = (($val * $price) / 100);
    elseif ($code === $service_curr_id):
        $value = $val;
    else:

        if ($dealer_id) {
            $arr = get_dealer_currency_rate($dealer_id, $code);
            if ($arr[$code])
                $currency_rate = $arr[$code];
        }
        if (!$dealer_id or!$currency_rate) {
            $c_res = $osql->get_result("select app_currency_rate from app_currency where app_currency_id={$code}");
            $c_row = $osql->next($c_res);
            $currency_rate = $c_row["app_currency_rate"];
        }
        $value = ($val * $currency_rate) / $service_curr_rate;
    endif;
    return $value;
}

function get_curr_code($code) {
    $osql = new sql();

    if ($code === "%"):
        $value = "%";
    else:
        $c_res = $osql->get_result("select app_currency_code_" . dir . " as app_currency_code from app_currency where app_currency_id={$code}");
        $c_row = $osql->next($c_res);
        $value = $c_row["app_currency_code"];
    endif;
    return $value;
}

/*
 * get direction between 2 nodes
 */

function get_distance($lat1, $lat2, $lon1, $lon2) {
    $theta = $lon1 - $lon2;
    $miles = (sin(deg2rad($lat1)) * sin(deg2rad($lat2))) + (cos(deg2rad($lat1)) * cos(deg2rad($lat2)) * cos(deg2rad($theta)));
    $miles = acos($miles);
    $miles = rad2deg($miles);
    $miles = $miles * 60 * 1.1515;
    $kilometers = $miles * 1.609344;
    return $kilometers;
}

/*
 * get default parent account
 */

function get_default_parent_account($dealer_id, $acct_type, $used_for) {
    $osql = new sql();
    $res_acc = $osql->get_result("select app_account_id from app_account "
            . " where app_dealer_id='{$dealer_id}' and app_account_type='{$acct_type}'"
            . " and app_account_used_for='{$used_for}' order by app_account_id asc limit 1");
    $row_acc = $osql->next($res_acc);
    return $row_acc["app_account_id"];
}

/*
 * get account full code
 */

function get_acct_full_code($acct_id) {
    $osql = new sql();
    $res_acc = $osql->get_result("select " . prefix::_get("concat_account_code") . " as account_code from app_account "
            . " where app_account_id='{$acct_id}'");
    $row_acc = $osql->next($res_acc);
    return $row_acc["account_code"];
}

/*
 * get account code
 */

function get_account_code($index_id, $digit_no = null) {
    $osql = new sql();
    $res_acc = $osql->get_result("select app_account_code as max_code,app_account_lz from app_account "
            . " where index_id='{$index_id}' "
            . "order by length(app_account_code) desc,cast(app_account_code AS UNSIGNED ) desc limit 1");
    $row_acc = $osql->next($res_acc);
    $code = $row_acc["max_code"] ? (int) $row_acc["max_code"] + 1 : 1;
    if (!$digit_no) {
        $res = $osql->get_result("select app_account_lz from app_account where app_account_id='{$index_id}'");
        $row = $osql->next($res);
        if ($row["app_account_lz"])
            $digit_no = $row["app_account_lz"] + 1;
    }
    if (!$digit_no) {
        $digit_no = strlen($row_acc["max_code"]) ? strlen($row_acc["max_code"]) : 4;
    }
    $code = sprintf("%0{$digit_no}d", $code);
    return $code;
}

/*
 * recursive function for dealer
 */

function get_all_child($index_id, &$all_childs) {
    $osql = new sql();
    $result = $osql->get_result("select app_dealer_id from `app_dealer` where index_id='{$index_id}'");

    if ($result->num_rows) {
        while ($row = $osql->next($result)) {
            array_push($all_childs, $row['app_dealer_id']);
            get_all_child($row['app_dealer_id'], $all_childs);
        }
    }
//    return $all_childs;
}

/*
 * get parent nodes
 */

function get_parent_node($index_id, &$all_parents) {
    $osql = new sql();
    $result = $osql->get_result("select index_id from `app_node` where app_node_id='{$index_id}'");
    if ($result->num_rows) {
        while ($row = $osql->next($result)) {
            if ($row['index_id'] > 0) {
                array_push($all_parents, $row['index_id']);
                get_parent_node($row['index_id'], $all_parents);
            }
        }
    }
}

/*
 * get all child nodes
 */

function get_all_child_node($node_id, &$all_childs) {
    $osql = new sql();
    $result = $osql->get_result("select * from `app_node` where index_id='{$node_id}'");
    if ($result->num_rows) {
        while ($row = $osql->next($result)) {
            array_push($all_childs, $row['app_node_id']);
            get_all_child_node($row['app_node_id'], $all_childs);
        }
    }
}

/*
 * Sending SMS
 */

function SendSmsWithAPI($method, $url, $username, $password, $data = false) {
    $curl = curl_init();

    switch ($method) {
        case "POST":
            curl_setopt($curl, CURLOPT_POST, 1);

            if ($data)
                curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($data));
            break;
        case "PUT":
            curl_setopt($curl, CURLOPT_PUT, 1);
            break;
        default:
            if ($data)
                $url = sprintf("%s?%s", $url, http_build_query($data));
    }

    $headers = array(
        'Content-Type:application/json',
        'Accept: application/json'
    );
    // Optional Authentication:
    curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
    //curl_setopt($curl, CURLOPT_HEADER, 1);
    curl_setopt($curl, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
    curl_setopt($curl, CURLOPT_USERPWD, "$username:$password");

    curl_setopt($curl, CURLOPT_URL, $url);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);

    $result = curl_exec($curl);

    curl_close($curl);

    return $result;
}

//function application_form_names(&$priv_arr, &$fin_arr) {
//    $arr_priv["is_permit"] = 0;
//    $arr_priv["is_add"] = 0;
//    $arr_priv["is_modify"] = 0;
//    $arr_priv["is_delete"] = 0;
//    $arr_names = array("subscriber_form", "recharge_form", "statment_of_account_report", "consumption_report", "service_pricing_form", "fb_log_report");
//    foreach ($arr_names as $key):
//        $priv_arr[$key] = $arr_priv;
//    endforeach;
//    $arr_fin_names = array("receipt_form", "payment_form", "collection_form", "discount_form", "addition_form", "maintenance_form",
//        "maintenance_refund_form", "product_form", "product_refund_form", "dealer_deposit_form", "dealer_deposit_withdrawal_form",
//        "collector_receipt_form","collector_payment_form");
//    foreach ($arr_fin_names as $key):
//        $fin_arr[$key] = $arr_priv;
//    endforeach;
//}

function application_action_names() {
    $arr_group_pr["is_disable"] = "0";
    $arr_group_pr["is_terminate"] = "0";
    $arr_group_pr["is_change_service"] = "0";
    $arr_group_pr["is_infect"] = "0";
    $arr_group_pr["is_auto_recharge"] = "0";
    $arr_group_pr["is_collection"] = "0";
    $arr_group_pr["is_end_session"] = "0";
    $arr_group_pr["is_add_extra_g"] = "0";
    $arr_group_pr["is_clear_mac"] = "0";
    $arr_group_pr["is_ping"] = "0";
    $arr_group_pr["is_disconnect"] = "0";
    $arr_group_pr["is_recharge"] = "0";
    $arr_group_pr["is_enable"] = "0";
    $arr_group_pr["is_archive"] = "0";
    return $arr_group_pr;
}

/**
 * ______________________________________________________________________________________________________________
 */
function phpexcel_load($phpexcel, $file_name = null) {
//it may be delete the extension if there is space in name
    if (empty($file_name))
        $file_name = str_replace(" ", "-", str_replace('.php', '', basename(self)));
    //just to keep letters & numbers & space & - & _
    $file_name = preg_replace('/[^a-zA-Z0-9_-]/s', '', $file_name);
    $file_name .= '.xlsx';
    $file_save = upload_physical_path . $file_name;
    $phpexcel->setActiveSheetIndex(0);
    //excel write
    $writer = PHPExcel_IOFactory::createWriter($phpexcel, 'Excel2007');   //Excel5
    $writer->save($file_save);
    //excel download
    header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
    header("Content-Disposition: inline; filename=" . $file_name);
    header("Cashe-Control: max-sge :0 ");
    //unlink the file afyer send the header
    $fh = fopen($file_save, "rb");
    fpassthru($fh);
    @unlink($file_save);    //if permission problem then it will put the warning in the excel
    exit;
}

//function get_end_account($obj,$main_act_id, &$end_acts){
//    
//    $result = $obj->get_result("select app_account_id,app_account_type from app_account where 
//                index_id = '{$main_act_id}'", false);
//    if (!$result->num_rows)
//        $end_acts[$main_act_id] = $main_act_id;
//    while ($row = $obj->next($result)) {
//        if ($row['app_account_type'] == 'final')
//            $end_acts[$row['app_account_id']] = $row['app_account_id'];
//        else
//            get_end_account($obj, $row['app_account_id'], $end_acts);
//    }
//}

function get_end_account($obj, $main_act_id, &$end_acts, $start = null, $limit = null, $acct_name = null) {
    if (!$main_act_id) {
        get_all_end_account($obj, $end_acts, $start, $limit);
        return;
    }
    $qry_limit = null;
    if ($start and $limit) {
        $qry_limit = "limit {$start},{$limit}";
    }
    $result = $obj->get_result("select app_account_id," . prefix::_get("concat_account") . " as app_account_name,app_account_type from app_account where 
                index_id = '{$main_act_id}' order by app_account_id {$qry_limit}");
    if (!$result->num_rows) {
        if ($acct_name) {
            $arr["app_account_id"] = $main_act_id;
            $arr["app_account_name"] = $acct_name;
            $end_acts[$main_act_id] = $arr;
        } else {
            $end_acts[$main_act_id] = $main_act_id;
        }
    }
    while ($row = $obj->next($result)) {
        if ($row['app_account_type'] == 'final') {
            $start = $start + 1;
            $end_acts[$row['app_account_id']] = $row;
        } else {
            get_end_account($obj, $row['app_account_id'], $end_acts, $start, $limit);
        }
    }
}

function get_all_end_account($obj, &$all_end_acts, $start, $limit) {
    $limits = null;
    if ($start and $limit)
        $limits = " limit {$start},{$limit} ";
    $result = $obj->get_result("select app_account_id,app_account_name from app_account where app_account_type = 'final' order by app_account_id {$limits}", false);
    while ($row = $obj->next($result))
        $all_end_acts[$row['app_account_id']] = $row;
}

function get_index_end_account($obj, &$child_acts, $main_act_id = null) {
    if ($main_act_id)
        $con = " and index_id = '{$main_act_id}'";
    $result = $obj->get_result("select app_account_id," . prefix::_get("concat_account") . " as app_account_name,app_account_type from app_account where 
                app_account_type='index' and app_dealer_id='" . authentication::_get("app_dealer_id") . "' {$con} order by app_account_id");
    if (!$result->num_rows) {
        $child_acts[$main_act_id] = $main_act_id;
    }
    while ($row = $obj->next($result)) {
        $child_acts[$row['app_account_id']] = $row['app_account_id'];
        get_index_end_account($obj, $child_acts, $row['app_account_id']);
    }
}

function get_user_price_define($price_no) {
    if (globals::_get("app_seting_price_type{$price_no}_def"))
        return globals::_get("app_setting_price_type{$price_no}_def");
    return get_define("app_material_unit_price{$price_no}");
}

//get rate for each currency from table currency_rate
function get_dealer_currency_rate($dealer_id, $curr_id = null) {
    $osql = new sql();
    if ($dealer_id)
        $con = " and app_dealer_id='{$dealer_id}'";
    if ($curr_id)
        $con .= " and app_currency_id='{$curr_id}'";
    $res_rate = $osql->get_result("select app_currency_id,app_currency_rate_amount from app_currency_rate "
            . "where 1=1 {$con} order by app_currency_rate_time asc", false);
    while ($row_rate = $osql->next($res_rate)):
        $arr_curr[$row_rate["app_currency_id"]] = $row_rate["app_currency_rate_amount"];
    endwhile;
    /*
     * system currency
     */
    $res= $osql->get_result("select app_currency_id,app_currency_rate from app_currency");
    while ($row= $osql->next($res)):
        $arr_curr["system"][$row["app_currency_id"]] = $row["app_currency_rate"];
    endwhile;
    return $arr_curr;
}

function send_notification($sql, $user_id, $title, $template) {
    
    $result_devices = $sql->get_result("SELECT * FROM `user_device` WHERE `user_id` in ({$user_id})");
    $arr_devices = array();
    while ($row_devices = $sql->next($result_devices)):
        array_push($arr_devices, $row_devices);
    endwhile;
    $title = $title ? $title : "Title";
    $template = $template ? $template : "Message";
    foreach ($arr_devices as $key => $arr_device):
        $device_token = $arr_device["device_id"];
        $device_type = $arr_device["device_os"];

        $result = push_notification::send_notification($device_type, $device_token, $title, $template);
//        if($device_type == "ios"){
//        parr($device_token);
//parr($result);}
        if ($result["results"][0]["error"] == "NotRegistered"):
            $sql->execute_statment("DELETE FROM user_device WHERE device_id='{$device_token}'");
        endif;
    endforeach;
}