<?php

$excel = new PHPExcel();
if (dir == "rtl")
    $excel->getActiveSheet()->setRightToLeft(true);
$sheet = $excel->getActiveSheet();
$sheet->getTabColor()->setRGB('FF0000');
$sheet->getHeaderFooter()->setOddHeader('&R &D  &T ');
$sheet->getHeaderFooter()->setOddFooter('&R Page &P of &N');   //&R: Right, &C for Center
$sheet->getPageMargins()->setTop(0.6)
        ->setBottom(0.6)
        ->setLeft(0.1)
        ->setRight(0.1);
$sheet->getDefaultStyle()->getFont()->setName('Arial')->setSize(12);
$sheet->getDefaultStyle()->getAlignment()->setVertical('center');
$col_start = PHPExcel_Cell::stringFromColumnIndex(0);
$col_end = PHPExcel_Cell::stringFromColumnIndex(count($head_arr) - 1);
$alignment = array(
    'alignment' => array(
        'horizontal' => DIR_ALIGN,
    )
);
$ralignment = array(
    'alignment' => array(
        'horizontal' => DIR_RALIGN,
    )
);

$align_cntr = array('alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER)
);
$header_font = array(
    'font' => array('bold' => "true", 'color' => array('rgb' => 'ffffff'), 'name' => 'Roboto')
);
//$rows_font = array(
//    'font' => array('size' => 15, 'name' => 'Roboto'));
$style_head = array(
    'fill' => array('type' => PHPExcel_Style_Fill::FILL_SOLID, 'color' => array('rgb' => '30A7AA'))
);
$even_row_style = array(
    'fill' => array('type' => PHPExcel_Style_Fill::FILL_SOLID, 'color' => array('rgb' => 'E9F5F7'))
);
$odd_row_style = array(
    'fill' => array('type' => PHPExcel_Style_Fill::FILL_SOLID, 'color' => array('rgb' => 'FFFFFF'))
);
$row = 1;
if (count($top_header) > 0) {
    $key = 1;
    foreach ($top_header as $data):
        $sheet->getCellByColumnAndRow($col, $row)->setValueExplicit($data["value"]);
        $sheet->getStyle(chr(64 + $key) . $row)->applyFromArray($alignment);
        $sheet->getColumnDimension(chr(64 + $key));
        $sheet->mergeCells(chr(64 + $key) . "{$row}:" . chr(64 + count($head_arr)) . "{$row}");
        $sheet->getRowDimension($row)->setRowHeight(45);
        $row++;
    endforeach;
}
$head_row = $row;
foreach ($head_arr as $col => $value) {
    $key = 1;
    $sheet->getCellByColumnAndRow($col, $head_row)->setValueExplicit(get_const($value));
    $sheet->getColumnDimension(chr(64 + $key))->setAutoSize(true);
}
$sheet->freezePaneByColumnAndRow(0, $head_row + 1);
$sheet->getStyle("{$col_start}{$row}:{$col_end}{$row}")->applyFromArray(array_merge($style_head, $align_cntr, $header_font));
$sheet->getPageSetup()->setFitToHeight(1)
        ->setFitToWidth('1')
        ->setPaperSize(9)
        ->setOrientation('portrait')
        ->setRowsToRepeatAtTopByStartAndEnd(1, $head_row)
;
//Freeze
$sheet->freezePaneByColumnAndRow(0, $head_row + 1);
