<?php
/**
* inherited from sql_class
* @copyright copyright (c) copyright 2009 
* @license GNU Public Licence (GPL)
*/
class array_tree extends sql {
    protected $params = array();
    /**
     *__construct
     * @param string $db_table_name
     */
    public function  __construct($db_table_name) {
        $this->set_db_table_name($db_table_name);
        parent::__construct();
    }
    /**
     * set_db_table_name
     * @param string $db_table_name
     * @return $this
     */
    public function set_db_table_name($db_table_name) {
        $this->params['db_table_name'] = $db_table_name;
        return $this;
    }
    /**
     *
     * @return db_table_name
     */
    public function get_db_table_name() {
        return $this->params['db_table_name'];
    }
    /**
     * set_query
     * @param string $query
     * @return $this
     */
    public function set_query($query) {
        $this->params['query'] = $query;
        return $this;
    }
    /**
     *
     * @return query
     */
    public function get_query() {
        if($this->params['query'])
            return $this->params['query'];
            
        return "select * from {$this->get_db_table_name()}";
    }
    /**
     * set_index_id
     * @param string $index_id
     * @return $this
     */
    public function set_index_id($index_id) {
        $this->params['index_id'] = $index_id;
        return $this;
    }
    /**
     *
     * @return index_id
     */
    public function get_index_id() {
        if($this->params['index_id'])
            return $this->params['index_id'];
            
        return "index_id";
    }
    /**
     * set_table_id
     * @param string $table_id
     * @return $this
     */
    public function set_table_id($table_id) {
        $this->params['table_id'] = $table_id;
        return $this;
    }
    /**
     *
     * @return table_id
     */
    public function get_table_id() {
        if($this->params['table_id'])
            return $this->params['table_id'];
         return $this->get_db_table_name()._id;
    }
    /**
     * set_index
     * @param string $index
     * @return $this
     */
    public function add_index($key,$array) {
        $this->params['index'][$key] = $array;
        return $this;
    }
    /**
     *
     * @return index
     */
    public function get_index() {
        return $this->params['index'];
    }
    /**
     *
     * @return index
     */
    public function get_tree() {
        return $this->params['index'];
    }
    /**
     * set_children
     * @param string $children
     * @return $this
     */
    public function add_children($key,$id,$array) {
        $this->params['child_by_index'][$key] ++;
        $this->params['child_by_id'][$id]=$array;
        return $this;
    }
    /**
     *
     * @return children
     */
    public function get_children() {
        return $this->params['children'];
    }
    /**
     * recursive function which search for last childs and assign it to its parents.
     */
    public function rec() {
        while($this->params['child_by_id']) {
            foreach($this->params['child_by_id'] as $key=>&$value) {
                if(!$this->params['child_by_index'][$key]) {
                    $this->params['child_by_index'][$value[$this->get_index_id()]]--;
                    if($this->params['index'][$value[$this->get_index_id()]])
                        $this->params['index'][$value[$this->get_index_id()]]['children'][$key]=$value;
                    else
                        if($this->params['child_by_id'][$value[$this->get_index_id()]])
                            $this->params['child_by_id'][$value[$this->get_index_id()]]['children'][$key]=$value;
                          else
                            $this->params['index'][$key]=$value;
                            
                        unset($this->params['child_by_id'][$key]);

                }

            }
        }
    }
    /**
     *
     */
    public function debug($debug=true){
        $this->params['debug'] = $debug;
        return $this;
    }
    public function get_debug(){
        return $this->params['debug'];
    }
    public function load() {

        $result = parent::get_result($this->get_query(),$this->get_debug());
        while($row = parent::next($result)) {
            if($row[$this->get_index_id()]==0)
                $this->add_index($row[$this->get_db_table_name()._id], $row);
            else
                $this->add_children($row[$this->get_index_id()],$row[$this->get_table_id()], $row);
        }

        $this->rec();
        return $this->get_index();

        
    }
}
?>
