<?php

class basic_form extends sql {

    /**
     * object of class theme
     * @var object $theme
     */
    protected $theme = null;

    /**
     * object of class form
     * @var object $form
     */
    protected $form = null;

    /**
     * object of class form_src
     * @var object $form_src
     */
    protected $form_src = self;

    /**
     * object of class taber
     * @var object $taber
     */
    protected $taber = null;

    /**
     * object of class table
     * @var object $table
     */
    protected $table = null;

    /**
     * object of class grid
     * @var object $grid
     */
    protected $grid = null;

    /**
     * object of class tree
     * @var object $tree
     */
    protected $tree = null;

    /**
     * object of class grid_exe
     * @var object $grid_exe
     */
    protected $grid_exe = null;

    /**
     * object of class grid_result
     * @var object $grid_result
     */
    protected $grid_result = null;

    /**
     * object of class tree_result
     * @var object $tree_result
     */
    protected $tree_result = null;

    /**
     * @var bool $debug
     */
    protected $debug = false;

    /**
     *
     * @var array $html
     */
    private $html = array();

    /**
     *
     * @var array $script
     */
    private $script = array();

    /**
     *
     * @var array $ready_script
     */
    private $ready_script = array();

    /**
     *
     * @var array $join
     */
    private $join = array();

    /**
     *
     * @var array  $select_field
     */
    private $select_field = array();

    /**
     * form action _GET or _POST
     * @access protected
     * @var $action
     */
    protected $action = null;

    /**
     *
     * @var bool $show_message
     */
    protected $show_message = false;

    /**
     * disable or not the right mouse click
     * @access protected
     * @var $disable_menu
     */
    protected $context_menu = true;
    /*     * Rank
      -
     * the title of the blue xp windows frame style
     * @access protected
     * @var $theme_title
     */
    protected $theme_title = theme_title;

    /**
     * width of theme
     * @access protected
     * @var $theme_width
     */
    protected $theme_width = theme_width;

    /**
     * height of theme
     * @access protected
     * @var $theme_height
     */
    protected $theme_height = theme_height;

    /**
     * align of theme
     * @access protected
     * @var $theme_align
     */
    protected $theme_align = theme_align;

    /**
     * data base name
     * @access protected
     * @var $db_table_name
     */
    protected $db_table_name = db_table_name;

    /**
     * define wether the column should be dispalayed from form column
     * or fixed text defined by user
     * @access protected
     * @var $auto_message_column
     */
    protected $auto_message_column = true;

    /**
     * the column that should be dispalayed in the message
     * @access protected
     * @var $message_column
     */
    protected $message_column = message_column;

    /**
     * the title of the fameset
     * @access protected
     * @var $table_title
     */
    protected $table_title = table_title;

    /**
     * @access protected
     * @var $element_per_row
     */
    protected $element_per_row = element_per_row;

    /**
     * @access protected
     * @var $form_buttons
     */
    protected $form_buttons = null;

    /**
     * @access protected
     * @var $read_only
     */
    protected $read_only = false;

    /**
     * @access protected
     * @var $disable_search
     */
    protected $disable_search = false;

    /**
     * @access protected
     * @var $disable_form
     */
    protected $disable_form = false;

    /**
     * @access protected
     * @var $enable_tree
     */
    protected $enable_tree = false;

    /**
     * @access protected
     * @var $called_tab
     */
    protected $called_tab = 0;

    /**
     * used to call for search and init grid result auto.
     * @access private
     * @var $auto_export
     */
    private static $auto_export = false;

    /**
     *
     * @var extend new record link
     */
    private $extend_actions = "";

    /**
     *  Used for JWT
     */
    protected $iat = null;
    protected $table_id_value = null;
    protected $device_src = "web";

    /**
     * class construct
     * @access public
     * @param string $action _GET or _POST action to direct the form
     */
    public function __construct() {

        $this->iat = $_SERVER['REQUEST_TIME_FLOAT'];
        parent::__construct();
        if ($_POST['action'] === 'dont_direct') {
            return;
        }

        switch ($_SERVER['REQUEST_METHOD']) {
            case 'GET':
                if ($_GET['action'] == 'add_form'
                        OR $_GET['action'] == 'modify_form'
                        OR $_GET['action'] == 'load'
                        OR $_GET['action'] == 'search'
                        OR $_GET['action'] == 'ajax'
                        OR $_GET['action'] == 'delete'
                        OR $_GET['action'] == 'refresh'
                        OR $_GET['action'] == 'print'
                )
                    $this->set_action(strtolower($_GET['action']));
                else
                if (!$_GET['action'])
                    $this->set_action("load");
                else
                    $this->set_action($_GET['action']);
                break;
            case 'POST':
                if (in_array($_POST["action"], array("add", "modify", "delete")) AND $this->device_src == "web") {
                    exit("Error Injection Attempt");
                } else
                if ($_POST["token"]) {
                    $arr = jwt::decode($_POST["token"], JWT_KEY, array('HS256'));

                    $token_key = JWT_KEY . $arr->table . $arr->iat . $arr->table_id_value;
                    $action_arr = jwt::decode($_POST["action"], $token_key, array('HS256'));
                    if ($action_arr->disabled === 'disabled' OR anti_inspection::check_injected_disabled_elements($action_arr)) {
                        exit("Error Injection Attempt ");
                    }
                    $_POST["action"] = $action_arr->action;
                    $_REQUEST["action"] = $action_arr->action;
                    $_POST[$this->get_db_table_name() . "_id"] = $action_arr->table_id_value;
                    $_REQUEST[$this->get_db_table_name() . "_id"] = $action_arr->table_id_value;
                }
                if (!is_null($_POST['action'])) {
                    $this->set_action(strtolower($_POST['action']));
                }
                break;
        }



        $this->form = new form();
        $this->form->disable_context_menu($this->get_context_menu());
        if ($_GET['message_type']) {
            $this->form->set_message($_GET['message_type'], $_GET['message_text']);
        }


        $this->direct($this->get_action());
    }

    /**
     *
     * @param bool $disable_search
     * to enable or disable search
     */
    public function disable_search($disable_search = true) {
        $this->disable_search = $disable_search;
        return $this;
    }

    public function get_disable_search() {
        return $this->disable_search;
    }

    /**
     *
     * @param bool $read_only
     * to enable or disable search
     */
    public function set_read_only($read_only = true) {
        $this->read_only = $read_only;
        return $this;
    }

    public function get_read_only() {
        return $this->read_only;
    }

    /**
     *
     * @param bool $disable_form
     * to enable or disable form
     */
    public function disable_form($disable_form = true) {
        $this->disable_form = $disable_form;
        return $this;
    }

    public function get_disable_form() {
        return $this->disable_form;
    }

    /**
     *
     * @param bool $enable_tree
     * to enable or disable tree
     */
    public function enable_tree($enable_tree = true) {
        $this->enable_tree = $enable_tree;
        return $this;
    }

    public function get_enable_tree() {
        return $this->enable_tree;
    }

    /**
     *
     * @param bool $called_tab
     */
    public function set_called_tab($called_tab = 0) {
        $this->called_tab = $called_tab;
        return $this;
    }

    public function get_called_tab() {
        return $this->called_tab;
    }

    /**
     *
     * @param bool $extend_actions
     */
    public function set_extend_actions($extend_actions = null) {
        $this->extend_actions = $extend_actions;
        return $this;
    }

    public function get_extend_actions() {
        return $this->extend_actions;
    }

    /**
     *
     * @param bool $form_src
     */
    public function set_form_src($form_src = self) {
        $this->form_src = $form_src;
        return $this;
    }

    public function get_form_src() {
        return $this->form_src;
    }

    /**
     * add record
     * @access public
     * @param array $input_files <input_file objects>
     */
    public function add($input_files = array(), $doms = array()) {
        parent::begin();
        if (!$input_files)
            $input_files = $this->attach_input_files();
        if (!$doms)
            $doms = $this->attach_doms();
        $this->before_add_modify("add");
        $tmp_hide_error = $this->get_hide_error();
        $this->hide_error();
        parent::insert($this->get_db_table_name(), $this->get_debug());
        if ($this->get_error_no()) {
//            $sql_error = ($this->get_error_no() == 1062 ? MSG_EXIST : ($this->get_error_no() . ": " . $this->get_error_text()));
            $this->form->override_message_type("error")->override_message_text($this->get_error_no() . ": " . $this->get_error_text());
            return $this->direct("add_form", $_POST);
        }
        $this->hide_error($tmp_hide_error);
        $_REQUEST[$this->get_db_table_name() . _id] = $_POST[$this->get_db_table_name() . _id] = parent::get_last_id();
        $this->form->set_message("success", MSG_OPERATION_SUCCESS);
        //
        foreach ($doms as $dom) {
            $dom->add(parent::get_last_id());
        }
        //
        foreach ($input_files as $obj) {
            $obj->set_db_table_name($this->get_db_table_name())
                    ->set_record_id(parent::get_last_id())
                    ->add();
            if ($obj->get_return()) {
                $this->form->override_message_type("warning")
                        ->add_message_text(@constant($obj->get_name()) . ' ' . $obj->get_return());
                $go_back = true;
            }
        }
        //
        $this->after_add_modify("add");
        $this->extend_add();
        //

        if ($go_back)
            return $this->direct("modify_form", parent::get_last_id());
        //
        return $this->direct("add_form", "", true);
        /**
         * when we need this script we have to send Message params with location
         * and resolve it on _construct.
         * return header ("location: ".self."?action=add_form");
         */
    }

    /**
     * this function needed if we want to do something but we need the inserted id
     * so when we use this function we can use $_POST of the table id
     */
    public function extend_add() {
        
    }

    /**
     * modify record
     * @access public
     * @param array $input_files <input_file objects>
     */
    public function modify($input_files = array(), $doms = array()) {
        $this->begin();
        $this->before_add_modify("modify");
        if (!$input_files)
            $input_files = $this->attach_input_files();
        if (!$doms)
            $doms = $this->attach_doms();

        $tmp_hide_error = $this->get_hide_error();
        $this->hide_error();
        parent::update($this->get_db_table_name(), $this->get_debug());
        if (sql::$is_rollback) {
            //$sql_error = ($this->get_error_no() == 1062 ? MSG_EXIST : ($this->get_error_no() . ": " . $this->get_error_text()));
            $this->form->override_message_type("error")->override_message_text($this->get_error_no() . ": " . $this->get_error_text());
            return $this->direct("modify_form", $_POST);
        }
        $this->hide_error($tmp_hide_error);
        $this->form->set_message("success", MSG_OPERATION_SUCCESS);
        //
        foreach ($doms as $dom) {
            $dom->modify();
        }
        //
        foreach ($input_files as $obj) {
            $obj->set_db_table_name($this->get_db_table_name())
                    ->set_record_id($_POST[$this->get_db_table_name() . _id])
                    ->modify();
            if ($obj->get_return()) {
                $this->form->override_message_type("warning")
                        ->add_message_text(@constant($obj->get_name()) . ' ' . $obj->get_return());
            }
            $go_back = true;
        }
        $this->after_add_modify("modify");
        $this->extend_modify();
        //
        if ($go_back)
            return $this->direct("modify_form", $_POST[$this->get_db_table_name() . _id]);
        //
        return $this->direct("modify_form", $_POST);
    }

    /**
     * this function needed if we want to do something after the insert to db. & we don't to
     * overwrite the modify() just want to do something before redirect or to redirect to specific url
     */
    public function extend_modify() {
        
    }

    //
    public function before_add_modify($type) {
        
    }

    //
    public function after_add_modify($type) {
        
    }

    //
    public function before_delete() {

    }

    //
    public function after_delete() {
        
    }

    /**
     * delete record
     * @access public
     * @param array $input_files <input_file objects>
     * @param int $id
     */
    public function delete($input_files = array(), $doms = array()) {

        parent::begin();
        $this->before_delete();
        if (!$input_files)
            $input_files = $this->attach_input_files();
        if (!$doms)
            $doms = $this->attach_doms();
        foreach ($doms as $dom) {
            $dom->delete();
        }
        foreach ($input_files as $obj) {
            $obj->set_db_table_name($this->get_db_table_name());
            if ($_GET[$this->get_db_table_name() . _id])
                $obj->set_record_id($_GET[$this->get_db_table_name() . _id]);
            $obj->delete();
        }
        if ($_GET[$this->get_db_table_name() . _id] && $this->get_auto_message_column()) {
            $result = $this->get_result("select * from `{$this->get_db_table_name()}`
                                            where `" . $this->get_db_table_name() . _id . "` = '" . $_GET[$this->get_db_table_name() . _id] . "'", $this->get_debug());
            $columns = $this->next($result);
            $_POST[$this->message_column] = $columns[$this->message_column];
        }

        parent::delete($this->get_db_table_name(), $_REQUEST[$this->get_db_table_name() . _id], $this->get_debug());
        $this->after_delete();

        $this->form->set_message("success", MSG_OPERATION_SUCCESS);

        $this->direct("add_form", null, true);
    }

    /**
     * this function will be called from add,modify and delete functions
     * and it will return array contains the dom objects
     * @example
     * public function attach_input_files(){
     *  return parent::attach_input_files(array($this->upload_center_file));
     * }
     * @param array $doms
     * @return array $doms
     */
    public function attach_doms($doms = array()) {
        if (!is_array($doms))
            $doms = array($doms);
        return $doms;
    }

    /**
     * this function will be called from add,modify and delete functions
     * and it will return array contains the dom objects
     * @example
     * public function attach_input_files(){
     *  return parent::attach_input_files(array($this->upload_center_file));
     * }
     * @param array $input_files
     * @return array $input_files
     */
    public function attach_input_files($input_files = array()) {
        if (!is_array($input_files))
            $input_files = array($input_files);
        return $input_files;
    }

    /**
     * use this class to add delete condition
     * this class will be called currently from group_delete and delete function
     * and will returns true or false bool variable
     * false will continue to delete.
     * @param int $id
     * @return bool $bool
     */
    public function delete_validation($id = null) {
        return false;
    }

    /**
     * public function group Delete
     * this function will delete all the  rows which are valid by user
     * and displays the delete rows message columns in a success message
     * if none were deleted the function will display error message
     * override this function when needed and attach the needed texts to the displayed message
     * @param array $input_files
     * @param array $doms
     */
    public function group_delete($input_files = array(), $doms = array()) {
        if (!$input_files) {
            $input_files = $this->attach_input_files();
        }
        if (!$doms) {
            $doms = $this->attach_doms();
        }
        $ids = explode(",", $_GET['ids']);
        $delete_records = array();
        foreach ($ids as $id) {
            if (!$this->delete_validation($id)) {
                foreach ($doms as $dom) {
                    $dom->delete($id);
                }
                foreach ($input_files as $obj) {
                    $obj->set_db_table_name($this->get_db_table_name())
                            ->set_record_id($id)
                            ->delete();
                }
                $result = $this->get_result("select * from `{$this->get_db_table_name()}`
                                            where `" . $this->get_db_table_name() . _id . "` = '{$id}'", $this->debug);
                $columns = $this->next($result);
                $_POST[$this->message_column] = $columns[$this->message_column];
                array_push($delete_records, $columns[$this->message_column]);
                parent::delete($this->get_db_table_name(), $id, false);
            } else {
                $result = $this->get_result("select * from `{$this->get_db_table_name()}`
                                            where `" . $this->get_db_table_name() . _id . "` = '{$id}'", $this->debug);
                $columns = $this->next($result);
                array_push($delete_records, $columns[$this->message_column]);
            }
        }

        if ($delete_records) {
            if ($not_deleted)
                $this->form->set_message("warning", implode(",", $not_deleted) . " " . MSG_DELTE_FAIL);
            else
                $this->form->set_message("success", MSG_SUCCESS);
        } else
            $this->form->set_message("error", MSG_OPERATION_FAILED);

        return $this->direct("add_form");
    }

    /**
     * @access protected
     * @category function load the outer form and grid
     */
    protected function load_theme($id = null) {

        if (!$_GET[$this->get_db_table_name() . _id]
        )
            $action = "add_form";
        else {
            $action = "modify_form";
            $this->taber->call_tab(0);
        }

        
        foreach ($_GET as $key => $value)
            $action .= "&{$key}={$value}";

            if (!$this->get_disable_form()) {
            $iframe = new iframe();
            $iframe->add_attr("scrolling", "no")
                    ->set_src($this->get_form_src() . '?action=' . $action);


            $this->taber->add_tab(LANG_ADD_MODIFY_FORM, $iframe->load());
        }
        if (!$this->get_disable_search())
            $this->taber->add_tab(LANG_LIST_FORM, $this->search_form());
        else
            $this->set_called_tab(0);        
        if ($this->get_enable_tree())
            $this->taber->add_tab(LANG_TREE_FORM, $this->tree_form());


        if (theme_title == "theme_title") {
            $this->set_theme_title(defines::get_title());
            define("theme_title", defines::get_title());
        }

        $this->taber->set_default_tab($this->get_called_tab());
        $this->theme->set_html($this->taber->load())
                ->set_width($this->get_theme_width())
                ->set_height($this->get_theme_height())
                ->set_title($this->get_theme_title())
                ->set_align($this->get_theme_align())
                ->show_message($this->get_show_message())
                ->disable_context_menu($this->get_context_menu())
                ->load();
    }

    protected function ajax_tree_children() {
        
        echo $this->tree_result->load();
    }

    /**
     * @access protected
     * @category function build search form
     */
    protected function tree_form() {
        if (!$this->get_form_buttons())
            $user_buttons = authentication::get_buttons();
        else
            $user_buttons = $this->get_form_buttons();

        if (!@in_array('delete', $user_buttons)
                AND authentication::get_user_type() != 'super') {
            $this->tree->disable_delete();
        }
        if (!@in_array('modify', $user_buttons)
                AND authentication::get_user_type() != 'super') {
            $this->tree->disable_modify();
        }
        if (!@in_array('add', $user_buttons)
                AND authentication::get_user_type() != 'super') {
            $this->tree->disable_copy();
        }
        if (!@in_array('add', $user_buttons)
                AND ! @in_array('modify', $user_buttons)
                AND ! @in_array('delete', $user_buttons)
                AND authentication::get_user_type() != 'super'
        )
            $this->tree->disable_context_menu();

        return $this->tree->load();
    }

    /**
     *
     */
    protected function search() {
        if (self::$auto_export) {
            self::$auto_export = false;
            return false;
        }

        echo $this->grid_result->load();
    }

    /**
     * @access protected
     * @category function build search form
     */
    protected function search_form() {
        if (!$this->get_form_buttons())
            $user_buttons = authentication::get_buttons();
        else
            $user_buttons = $this->get_form_buttons();

        if (!@in_array('delete', $user_buttons)
                AND authentication::get_user_type() != 'super') {
            $this->grid->disable_delete();
            $this->grid->disable_group_delete();
        }
        if (!@in_array('modify', $user_buttons)
                AND authentication::get_user_type() != 'super') {
            $this->grid->disable_modify();
        }
        if (!@in_array('add', $user_buttons)
                AND authentication::get_user_type() != 'super') {
            $this->grid->disable_copy();
        }
        if (@in_array('print', $user_buttons)
                OR authentication::get_user_type() == 'super') {
            $this->grid->enable_print();
        }

        if (!@in_array('add', $user_buttons)
                AND ! @in_array('modify', $user_buttons)
                AND ! @in_array('delete', $user_buttons)
                AND authentication::get_user_type() != 'super'
        )
            $this->grid->disable_context_menu();

        $this->grid->set_filter($this->grid_exe->get_filter())
                ->set_header($this->grid_exe->get_header());

        return $this->grid->load();
    }

    /**
     * @access protected
     * @category function build add form
     */
    protected function add_form($var = null) {
        if (!is_array($var) && $var) {
            $results = parent::get_result("select * {$this->get_select_field()} from `{$this->get_db_table_name() }`  {$this->get_join()} where `{$this->get_db_table_name()}`.`{$this->get_db_table_name()}" . _id . "` = '{$var}' ", $this->get_debug());
            $var = parent::next($results);
        }

        $_REQUEST['action_ref'] = $_REQUEST['action'];
        $_REQUEST['function_ref'] = 'add_form';

        if ($_REQUEST['function_ref'] == "add_form" && !$_REQUEST[$this->get_db_table_name() . _id]) {
            $_REQUEST['trigger_ref'] = 'new';
        } elseif ($_REQUEST['function_ref'] == "add_form" && $_REQUEST[$this->get_db_table_name() . _id]) {
            $_REQUEST['trigger_ref'] = 'copy';
        }
        if ($var)
            $var = array_merge($_REQUEST, $var);
        else
            $var = $_REQUEST;


        $this->load($var);
    }

    /**
     * @access protected
     * @category function build modify form
     */
    protected function modify_form($var = null) {

        if (!is_array($var)) {
            $results = parent::get_result("select * " . $this->get_select_field() . " from `" . $this->get_db_table_name() . "` " . $this->get_join() . " where `{$this->get_db_table_name()}`.`" . $this->get_db_table_name() . _id . "` = '$var' ", $this->get_debug());
            $var = parent::next($results);
        }
        $_REQUEST['trigger_ref'] = 'modify';
        $_REQUEST['action_ref'] = $_REQUEST['action'];
        $_REQUEST['function_ref'] = 'modify_form';
        $this->table_id_value = $var[$this->get_db_table_name() . _id];

        $var = @array_merge($_REQUEST, $var);

        $this->load($var);
    }

    protected function generate_token() {

        $key = JWT_KEY;

        $token = array(
            "table" => $this->get_db_table_name(),
            "iat" => $this->iat
        );
        if ($this->table_id_value) {
            $token['table_id_value'] = $this->table_id_value;
        }
        return JWT::encode($token, $key);
    }

    /**
     * @access protected
     * @category call this function to load the html u want
     */
    public function load() {
        $this->add_html($this->table->load());
        $token_input = new input_hidden("token");

        $token_input->set_value($this->generate_token());
        $this->add_html($token_input->load());
        $this->form->set_buttons($this->load_buttons($_REQUEST['function_ref'], $var));
        $this->form->set_html($this->get_html());
        $this->form->add_ready_script($this->get_ready_script());
        $this->form->add_script($this->get_script());
        $this->form->load();
    }

    /**
     *
     */
    protected function export() {

        foreach ($_POST as $key => $value) {
            $_POST[$key] = urldecode($value);
        }

        switch ($_POST['export_file']) {
            case'xls':
                self::$auto_export = true;
                $this->search();
                $this->grid_result->export_xls();
                break;
        }
    }

    /**
     *
     * @return <type>
     */
    protected function generate_report() {
        return;    //just to do not give error
    }

    /**
     *
     * @param string $html
     */
    protected function add_html($html) {
        array_push($this->html, $html);
        return $this;
    }

    /**
     *
     * @return string $html
     */
    protected function get_html() {
        return implode("\n", $this->html);
    }

    /**
     * add js script inside a <script> tag at the end of the document
     * and no document ready function
     * @param string $script
     */
    protected function add_script($script) {
        array_push($this->script, $script);
        return $this;
    }

    /**
     *
     */
    protected function add_ready_script($script) {
        array_push($this->ready_script, $script);
        return $this;
    }

    /**
     *
     * @return string $ready_script
     */
    protected function get_ready_script() {
        return implode("\n", $this->ready_script);
    }

    /**
     *
     * @return string $script
     */
    protected function get_script() {
        return implode("\n", $this->script);
    }

    /**
     *
     * @param string $action
     */
    protected function set_action($action) {
        $this->action = $action;
        return $this;
    }

    /*     * Rank
      -
     *
     * @return string $action
     */

    protected function get_action() {
        return $this->action;
    }

    /**
     *
     * @param string $join
     */
    protected function add_join($join) {
        array_push($this->join, $join);
        return $this;
    }

    /**
     *
     * @return string $join
     */
    protected function get_join() {
        return implode(" ", $this->join);
    }

    /**
     *
     * @param string $select_field
     */
    protected function add_select_field($select_field) {
        array_push($this->select_field, $select_field);
        return $this;
    }

    /**
     *
     * @return string $select_field
     */
    protected function get_select_field() {
        if ($this->select_field)
            return "," . implode(",", $this->select_field);
    }

    /**
     *
     * @param string $action
     * @param string $var
     */
    protected function direct($action, $var = null, $location = false) {
        $this->set_action(strtolower($action));
        //
        if (sql::$is_rollback) {
            $this->rollback();
            //  $this->form->override_message_type("error")->override_message_text(SQL_ERROR_MSG_NOT_SAVED);            
        } else {
            $this->commit();
        }
        switch ($this->get_action()) {
            case "add_form":
            case "modify_form":
                $this->table = new table();
                if ($this->get_element_per_row() > 1)
                    $this->table->set_elements_per_row($this->get_element_per_row());
                $this->table->set_cell_spacing(15)
                        ->set_cell_padding(15)
                        ->set_border(0)
                        ->set_title($this->get_table_title())
                        ->set_width('100%');
                break;
        }
        //
        switch ($this->get_action()) {
            case 'print':
                $this->generate_report();
                break;
            case 'load':
                $this->theme = new theme();
                $this->taber = new taber();
                if (!$this->get_disable_search()) {
                    $this->grid = new grid();
                    $this->grid_exe = new grid_extension();
                }
                if ($this->get_enable_tree())
                    $this->tree = new tree();

                $this->load_theme();
                break;
            case 'add_form':
                if ($location)
                    location(self . "?action=add_form&message_type={$this->form->get_message_type()}&message_text={$this->form->get_message_text()}{$this->get_extend_actions()}");
                //
                if (!$var && $_GET[$this->get_db_table_name() . _id])
                    $var = $_GET[$this->get_db_table_name() . _id];
                $this->add_form($var);
                break;
            case 'modify_form':
                if (!$var) {
                    $var = $_GET[$this->get_db_table_name() . _id];
                }
                $this->modify_form($var);
                break;
            case 'add':
                $this->add();
                break;
            case 'modify':
                $this->modify();
                break;
            case 'delete':
                $this->delete();
                break;
            case 'ajax_tree_children':
                $this->tree_result = new tree_result($this->get_db_table_name());
                $this->ajax_tree_children();
                break;
            case 'search':
                $this->grid_result = new grid_result($this->get_db_table_name());
                $this->search();
                break;
            case 'ajax':
                $this->ajax();
                break;
            case 'export':
                $this->grid_result = new grid_result($this->get_db_table_name());
                $this->export();
                break;
            default :
                eval('$this->' . $action . '();');
        }
        exit;
    }

    /**
     * enable debuging
     */
    protected function debug($debug = true) {
        $this->debug = $debug;
        return $this;
    }

    /**
     * get debug()
     */
    protected function get_debug() {
        return $this->debug;
    }
    protected function set_form_buttons($buttons) {
        if (is_string($buttons))
            $buttons = explode("-", $buttons);

        foreach ($buttons as $key => &$button) {
            if (!in_array(strtolower($button), authentication::get_buttons()))
                unset($buttons);
            else
                $button = strtolower($button);
        }


        $this->form_buttons = $buttons;
        return $this;
    }

    protected function get_form_buttons() {
        return $this->form_buttons;
    }

    /**
     *
     * @param  $type
     * @param  $form_buttons
     * @return
     */
    protected function generate_action_token($action, $disabled = "", $post_vars = array()) {

        $token = array(
            'iat' => $this->iat,
            'script_name'=>$_SERVER['PHP_SELF'],
            'user_id'=> authentication::get_user_id(),
            'table' => $this->get_db_table_name(),
            'table_id_value' => $this->table_id_value,
            'action' => $action,
            'disabled' => $disabled,
            'post_vars' => $post_vars,
            'disabled_elements' => anti_inspection::get_disabled_elemnts()
        );
        $key = JWT_KEY . $this->get_db_table_name() . $this->iat . $this->table_id_value;
        return jwt::encode($token, $key);
    }

    protected function load_buttons($type = "add_form", $var = null) {

        if (!$this->get_form_buttons())
            $user_buttons = authentication::get_buttons();
        else
            $user_buttons = $this->get_form_buttons();
        //
        switch ($type) {
            case 'modify_form':
                if (in_array('modify', $user_buttons) || authentication::get_user_type() == 'super') {

                    $modify_button = new button("action");
                    $modify_button
                            ->set_value($this->generate_action_token("modify", $this->get_read_only() ? "disabled" : ""))
                            ->set_text(LANG_MODIFY);

                    if ($this->get_read_only()) {
                        $modify_button
                                ->add_attr("disabled", "disabled")
                                ->add_attr("sys_disabled", "disabled");
                    }
                    $buttons .= "&nbsp;" . $modify_button->load() . $this->extend_load_buttons('modify', $var);
                }
                if (in_array('add', $user_buttons) || authentication::get_user_type() == 'super') {
                    $copy_button = new button('copy_record');
                    $copy_button
                            ->set_type("button")
                            ->set_value("copy")
                            ->set_text(LANG_COPY);
                    $copy_button->add_event("onclick", "location='" . self . "?action=add_form&" . db_table_name . "_id={$_REQUEST[db_table_name . "_id"]}'");
                    $buttons .= "&nbsp;" . $copy_button->load();
                }
                if (in_array('delete', $user_buttons) || authentication::get_user_type() == 'super') {

                    $delete_button = new button("action");
                    $delete_button
                            ->set_type("button")
                            ->add_attr("id", "delete_record_bt")
                            ->set_value($this->generate_action_token("delete", $this->get_read_only() ? "disable" : ""))
                            ->set_text(LANG_DELETE);

                    if ($this->get_read_only()) {
                        $delete_button
                                ->add_attr("disabled", "disabled")
                                ->add_attr("sys_disabled", "disabled");
                    }
                    $buttons .= "&nbsp;" . $delete_button->load() . $this->extend_load_buttons('delete', $var);
                }
                break;
            case 'print':
                if (in_array('print', $user_buttons) || authentication::get_user_type() == 'super') {
                    $buttons .= $this->extend_load_buttons('print', $var);
                }
                break;
            case 'save':
            case 'import':
                $add_token = array("action" => "add");
                $add_token = array_merge($add_token, $token);
                $add_button = new button("action");
                $add_button->set_value($this->generate_action_token("add"))
                        ->set_id('add')
                        ->set_text($type == 'save' ? LANG_SAVE : LANG_IMPORT);
                $buttons = $add_button->load() . $this->extend_load_buttons('add', $var);
                break;
            default:
                if (in_array('add', $user_buttons) || authentication::get_user_type() == 'super') {
                    $add_token = array("action" => "add");
                    $add_token = array_merge($add_token, $token);
                    $add_button = new button("action");
                    $add_button->set_value($this->generate_action_token("add"))
                            ->set_id('add')
                            ->set_text(LANG_ADD);
                    if ($this->get_read_only()) {
                        $add_button->add_attr("disabled", "disabled")
                                ->add_attr("sys_disabled", "disabled");
                    }

                    $buttons = "&nbsp;" . $add_button->load() . $this->extend_load_buttons('add', $var);
                }
                break;
        }
        if ((@in_array('add', $user_buttons) and !$var["is_hide_new_btn"]) || authentication::get_user_type() == 'super') {
            $new_button = new button('new_record');
            $new_button->set_type("button")
                    ->set_text(LANG_NEW_RECORD)
                    ->set_value("new_record")
            ;
            $new_button->add_event("onclick", "load_confirm('" . CONFIRM_NEW_RECORD . "',function(){location='" . self . "?action=add_form{$this->get_extend_actions()}'},function(){})");
            $buttons .= "&nbsp;" . $new_button->load();
        }
        //
        $buttons .= $this->extend_load_buttons('all', $var);
        //
        return $buttons;
    }

    //
    public function extend_load_buttons($type, $var) {
        
    }

    /**
     * set set_show_message()
     */
    protected function set_show_message($show_message = true) {
        $this->show_message = $show_message;
        return $this;
    }

    /**
     * get set_show_message()
     */
    protected function get_show_message() {
        return $this->show_message;
    }

    /**
     * set set_context_menu()
     */
    protected function set_context_menu($context_menu = true) {
        $this->context_menu = $context_menu;
        return $this;
    }

    /**
     * get set_context_menu()
     */
    protected function get_context_menu() {
        return $this->context_menu;
    }

    /**
     * set set_theme_title()
     */
    protected function set_theme_title($theme_title = null) {
        $this->theme_title = $theme_title;
        return $this;
    }

    /**
     * get set_theme_title()
     */
    protected function get_theme_title() {
        return $this->theme_title;
    }

    /**
     * set set_theme_height()
     */
    protected function set_theme_height($theme_height = null) {
        $this->theme_height = $theme_height;
        return $this;
    }

    /**
     * get set_theme_height()
     */
    protected function get_theme_height() {
        return $this->theme_height;
    }

    /**
     * set set_theme_width()
     */
    protected function set_theme_width($theme_width = null) {
        $this->theme_width = $theme_width;
        return $this;
    }

    /**
     * get set_theme_width()
     */
    protected function get_theme_width() {
        return $this->theme_width;
    }

    /**
     * set set_theme_align()
     */
    protected function set_theme_align($theme_align = null) {
        $this->theme_align = $theme_align;
        return $this;
    }

    /**
     * get set_theme_align()
     */
    protected function get_theme_align() {
        return $this->theme_align;
    }

    /**
     * set set_db_table_name()
     */
    protected function set_db_table_name($db_table_name = null) {
        $this->db_table_name = $db_table_name;
        return $this;
    }

    /**
     * get set_db_table_name()
     */
    protected function get_db_table_name() {
        return $this->db_table_name;
    }

    /**
     * set set_auto_message_column()
     */
    protected function set_auto_message_column($message_column = true) {
        $this->auto_message_column = $auto_message_column;
        return $this;
    }

    /**
     * get set_auto_message_column()
     */
    protected function get_auto_message_column() {
        return $this->auto_message_column;
    }

    /**
     * set set_message_column()
     */
    protected function set_message_column($message_column) {
        $this->message_column = $message_column;
        return $this;
    }

    /**
     * get set_message_column()
     */
    protected function get_message_column() {
        if ($this->get_auto_message_column())
            return $_REQUEST[$this->message_column];
        else
            return $this->message_column;
    }

    /**
     * set set_table_title()
     */
    protected function set_table_title($table_title = null) {
        $this->table_title = $table_title;
        return $this;
    }

    /**
     * get set_table_title()
     */
    protected function get_table_title() {
        return $this->table_title;
    }

    /**
     * set set_element_per_row()
     */
    protected function set_element_per_row($element_per_row = 2) {
        $this->element_per_row = $element_per_row;
        return $this;
    }

    /**
     * get set_element_per_row()
     */
    protected function get_element_per_row() {
        return $this->element_per_row;
    }

    private function check_ref($needle, $hystack) {

        if ($hystack == $needle)
            return true;

        return false;
    }

    /**
     * return true if new ref
     */
    protected function is_new_ref($var = null) {
        if (!$var)
            $var = $_REQUEST;
        return $this->check_ref('new', $var['trigger_ref']);
    }

    /**
     * return true if copy ref
     */
    protected function is_copy_ref($var = null) {
        if (!$var)
            $var = $_REQUEST;
        return $this->check_ref('copy', $var['trigger_ref']);
    }

    /**
     * return true if modify ref
     */
    protected function is_modify_ref($var = null) {
        if (!$var)
            $var = $_REQUEST;
        return $this->check_ref('modify', $var['trigger_ref']);
    }

    /**
     * return true if add or copy form 
     */
    protected function is_add_form($var = null) {
        if (!$var)
            $var = $_REQUEST;
        return $this->check_ref('add_form', $var['function_ref']);
    }

    /**
     * return true if modify form 
     */
    protected function is_modify_form($var = null) {
        if (!$var)
            $var = $_REQUEST;
        return $this->check_ref('modify_form', $var['function_ref']);
    }

    protected function is_submit($var = null) {
        if (!$var)
            $var = $_REQUEST;
        if ($var['action_ref'] == "add" || $var['action_ref'] == "modify")
            return true;
        return false;
    }

    public function __destruct() {
        logger::$_message_column = $_POST[message_column];
        if (logger::get_query()) {
            $this->conn->query(logger::get_query());
        }
    }

}

?>