<?php

class builder_elements {
    /**
     * element validation
     * @access private
     * @var string hide valid icon
     */
    private $hide_valid_icon = false;
    /**
     * element validation
     * @access private
     * @var string valid
     */
    private $valid = false;
    /**
     * element disable
     * @access private
     * @var string diable
     */
    protected $disable = false;

    /**
     * to create any new attribute
     * element attr
     * @access private
     * @var array attr
     */
    protected $attr = array();

    /**
     * to create any new styling
     * element css
     * @access private
     * @var array css
     */
    protected $css = array();

    /**
     * @access public
     * @param string $name
     */
    public function set_name($name) {
        $this->attr['name'] = $name;
        if (!$this->id){
            $this->attr['id'] = $this->get_name();
        }
        return $this;
    }

    /**
     * @access public
     * @return string $name
     */
    public function get_name() {
        return $this->attr['name'];
    }

    /**
     * @access public
     * @param string $id
     */
    public function set_id($id) {
        $this->attr['id'] = $id;
        return $this;
    }

    /**
     * @access public
     * @return string $id
     */
    public function get_id() {
        return $this->attr['id'];
    }

    /**
     * @access public
     * @param string $value
     */
    public function set_value($value = null) {
        if (!is_array($value)) {
            $this->attr['value'] = htmlspecialchars($value);
        } else {
            $this->attr['value'] = $value;
        }
        return $this;
    }

    /**
     * @access public
     * @return string $value
     */
    public function get_value() {
        return $this->attr['value'];
    }

    /**
     * @access public
     * @param string $valid
     */
    public function set_valid($valid = true) {
        $this->valid = $valid;
        return $this;
    }

    /**
     * @access public
     * @return string $valid
     */
    public function get_valid() {
        if ($this->valid){
            return true;
        }

        return false;
    }
/*
 * @access public
     * @param string $hide_valid_icon
 */
    public function hide_valid_icon($hide_valid_icon = false) {
        $this->hide_valid_icon = $hide_valid_icon;
        return $this;
    }
    /**
     * @access public
     * @param string $title
     */
    public function set_title($title) {
        $this->attr['title'] = $title;
        return $this;
    }
    /**
     * @access public
     * @return string $valid_msg
     */
    public function get_title() {
        return $this->attr['title'];
    }

    /**
     * @access public
     * @param int $width
     */
    public function set_width($width = "180px") {
        $this->add_css("width", $width);
        return $this;
    }

    /**
     * @access public
     * @return int $width
     */
    public function get_width() {
        $this->attr["width"];
    }

    /**
     * @access public
     * @param string $disable
     */
    public function set_disable($disable = true) {
        $this->disable = $disable;
        return $this;
    }

    /**
     * @access public
     * @return string $disable
     */
    public function get_disable() {
        if ($this->disable){
            return true;
        }
        return false;
    }

    /**
     * 
     */
    public function add_class($class) {
        $this->attr['class'] .= $class . " ";
        return $this;
    }

    /**
     * add attributes
     * @access public
     * @param string $key
     * @param string $value
     */
    public function add_attr($key, $value) {
        $this->attr[$key] = $value;
        return $this;
    }

    /**
     * remove attributes
     * @access public
     * @param string $key
     */
    public function remove_attr($key) {
        unset($this->attr[$key]);
        return $this;
    }

    /**
     * get attributes
     * @access public
     * @return string $attributes
     */
    protected function get_attr($key = null) {
        if ($key){
            return $this->attr[$key];
        }
        foreach ($this->attr as $key => $value) {
            $attributes .= $key . '="' . $value . '" ';
        }
        return $attributes;
    }
    /**
     * add css styles
     * @access public
     * @param string $key
     * @param string $value
     */
    public function add_css($key, $value) {
        $this->css[$key] = $value;
        return $this;
    }

    /**
     * get styles
     * @access public
     * @return string $css
     */
    protected function get_css() {
        $styles = 'style="';
        foreach ($this->css as $key => $value) {
            $styles .= "$key:$value;";
        }
        $styles .= '"';
        return $styles;
    }
    public function set_placeholder($placeholder = null) {
        $this->add_attr('placeholder', $placeholder);
        return $this;
    }
    public function get_placeholder(){
        return $this->get_attr('placeholder');
    }

    /**
     * add js scripts
     * @access public
     * @param string $key
     * @param string $value
     */
    public function add_event($key, $value) {
        $this->attr[$key] = $value;
        return $this;
    }
    public function get_required_span(){
        if($this->valid and !$this->hide_valid_icon){
            return " <span class='mdil mdil-alert-circle' id='". $this->get_id()."_required_alert' data-toggle='required-tooltip' title='".LANG_REQUIRED."'></span>";
        }
        return false;
    }
}

?>