<?php
/**
 * grid filter builder . use this class to create the filter form of the grid
 * this class extends class grid_filter
 * @author Ihab A. Ali
 * @copyright copyright (c) copyright 2009 , Ihab A. Ali 
 * @license GNU Public Licence (GPL)
 */
class grid_filter extends grid_header {

    /**
     * the filter_alias of the column
     * @access protected
     * @var string $filter_alias
     */
    protected $filter_alias   =  null;
    /**
     * set the filter (string || int || date || list || multi)
     * @access protected
     * @var string $filter_type
     */
    protected $filter_type       =   'string';
    /**
     * the filter_width of the column
     * @access protected
     * @var string $filter_width
     */
    protected $filter_width   =  180;
    /**
     * field filter_title in filter
     * @access protected
     * @var string $filter_title
     */
    protected $filter_title = null ;
    /**
     * set user custom object (select || combo || multilist)
     * @access protected
     * @var string $object
     */
    protected $object     =   null;

    /**
     * set the filter (string || int || date || select || multi)
     * @access public
     * @param string $filter_type
     */
    public function set_filter_type($filter_type = 'string') {
        $this->filter_type = $filter_type;
        return $this;
    }
    /**
     *
     * @return string $filter_type
     */
    public function get_filter_type() {
        return $this->filter_type;
    }
    /**
     * this filter_alias will set the real db_name like (concate or as menu_name ....)
     * @access public
     * @param string $filter_alias
     */
    public function set_filter_alias($filter_alias) {
        $this->filter_alias    =   $filter_alias;
        return $this;
    }
    /**
     *
     * @return string $filter_alias
     */
    public function get_filter_alias() {
        return $this->filter_alias;
    }
    /**
     * this filter_title which will be shown in the filter of grid
     * @access public
     * @param string $filter_title
     */
    public function set_filter_title($filter_title) {
        $this->filter_title    =   $filter_title;
        return $this;
    }
    /**
     *
     * @return string $filter_title
     */
    public function get_filter_title() {
        return $this->filter_title;
    }
    /**
     * the filter_width which will be shown in the filter of grid
     * @access public
     * @param int $filter_width
     */
    public function set_filter_width($filter_width) {
        $this->filter_width    =   $filter_width;
        return $this;
    }
    /**
     *
     * @return int $filter_width
     */
    public function get_filter_width() {
        return $this->filter_width;
    }
    /**
     * set user custom object (select || combo || multilist)
     * @access public
     * @param string $object
     */
    public function set_object($object) {
        $this->object = $object;
        return $this;
    }
    /**
     *
     * @return string $object
     */
    public function get_object() {
        return $this->object;
    }
}
?>