<?php
/**
 * grid header builder . use this class to create the header columns of the grid
 * inherited from form_parser class
 * @author Ihab A. Ali
 * @copyright copyright (c) copyright 2020
 * @license GNU Public Licence (GPL)
 */
class grid_header {
    /**
     * the data base field name
     * @access protected
     * @var string db_name
     */
    protected $db_name = null;
    /**
     * the header_alias of the column
     * @access protected
     * @var string $header_alias
     */
    protected $header_alias   =  null;
    /**
     * set the filter (string || int || date || list || multi)
     * @access protected
     * @var string $header_type
     */
    protected $header_type       =   'string';
    /**
     * field header_title in filter
     * @access protected
     * @var string $header_title
     */
    protected $header_title = null ;
    /**
     * the header_width of the column
     * @access protected
     * @var string $header_width
     */
    protected $header_width   =  '180';
    /**
     * min width
     * @access protected
     * @var string $min_width
     */
    protected $min_width   =  '80';
    /**
     * is Resizable
     * @access protected
     * @var string $is_resizable
     */
    protected $is_resizable   =  true;
    /**
     *
     * @var <type>
     */
    protected $header_align  = DIR_ALIGN;
    /**
     *
     * @var <type>
     */
    protected $column_align = DIR_ALIGN;
    /**
     * set the data base column name to be used in ordering
     * @access public
     * @param string $db_name
     */
    public function set_db_name($db_name) {
        $this->db_name = $db_name;
        $this->set_header_title(@constant($name));
        return $this;
    }
    /**
     *
     * @return string $db_name
     */
    public function get_db_name() {
        return $this->db_name;
    }

    /**
     * this header_alias will set the real db_name like (concate or as menu_name ....)
     * @access public
     * @param string $header_alias
     */
    public function set_header_alias($header_alias) {
        $this->header_alias    =   $header_alias;
        return $this;
    }
    /**
     *
     * @return string $header_alias
     */
    public function get_header_alias() {
        return $this->header_alias;
    }
    /**
     * set the filter (string || int || numbering || id || check)
     * @access public
     * @param string $header_type
     */
    public function set_header_type($header_type = 'string') {
        $this->header_type = $header_type;
        return $this;
    }
    /**
     *
     * @return string $header_type
     */
    public function get_header_type() {
        return $this->header_type;
    }
    /**
     * this header_title which will be shown in the header of grid
     * @access public
     * @param string $header_title
     */
    public function set_header_title($header_title) {
        $this->header_title    =   $header_title;
        return $this;
    }
    /**
     *
     * @return string $header_title
     */
    public function get_header_title() {
        return $this->header_title;
    }
    /**
     * the header_width which will be shown in the header of grid
     * @access public
     * @param int $header_width
     */
    public function set_header_width($header_width = 180) {
        $this->header_width    =   $header_width;
        return $this;
    }
    /**
     *
     * @return int $header_width
     */
    public function get_header_width() {
        return $this->header_width;
    }
    /**
     *
     * @param <type> $align
     * @return <type>
     */
    public function set_column_align($align=DIR_ALIGN) {
        $this->column_align = $align;
        return $this;
    }
    /**
     *
     * @return <type>
     */
    public function get_column_align() {
        return $this->column_align;
    }
    /**
     *
     * @param <type> $align
     * @return <type>
     */
    public function set_header_align($align=DIR_ALIGN) {
        $this->header_align = $align;
        return $this;
    }
    /**
     *
     * @return <type>
     */
    public function get_header_align() {
        return $this->header_align;
    }
    /**
     *
     * @param <type> $min_width
     * @return <type>
     */
    public function set_min_width($min_width= 80) {
        $this->min_width = $min_width;
        return $this;
    }
    /**
     *
     * @return <type>
     */
    public function get_min_width() {
        return $this->min_width;
    }
    /**
     *
     * @param <type> $is_resizable
     * @return <type>
     */
    public function set_is_resizable($is_resizable=true) {
        if(!$is_resizable)
            $this->is_resizable = "false";
        else
            $this->is_resizable = "true";
        return $this;
    }
    /**
     *
     * @return <type>
     */
    public function get_is_resizable() {
        return $this->is_resizable;
    }
}
?>