<?php

/**
 * builder_grid_result class . use this class to load the results after search
 * inherited from sql class
 * @author Ihab A. Ali
 * @copyright copyright (c) copyright 2009 , Ihab A. Ali
 * @license GNU Public Licence (GPL)
 */
//error_reporting(E_ERROR);
class grid_result extends sql {

    /**
     *
     * @var string $grid_result
     */
    protected $grid_result = null;

    /**
     *
     * @var string  $db_table_name
     */
    protected $debug = false;

    /**
     * used to set the overrided query
     * @access protected
     * @var string  $override_query
     */
    protected $override_query = null;

    /**
     *
     * @var string  $override_select
     */
    protected $attach_select = array();

    /**
     *
     * @var string $override_select
     */
    protected $override_select = null;

    /**
     *
     * @var string  $db_table_name
     */
    protected $db_table_name = null;

    /**
     *
     * @var string  $join
     */
    protected $join = array();

    /**
     *
     * @var string  $override_conditions
     */
    protected $override_conditions = null;

    /**
     *
     * @var string  $attach_conditions
     */
    protected $attach_conditions = array();

    /**
     *
     * @var string  $init_conditions
     */
    protected $init_conditions = array();

    /**
     *
     * @var string group
     */
    protected $group = null;

    /**
     *
     * @var string init_order
     */
    protected $init_order = null;

    /**
     *
     * @var string attach_order
     */
    protected $attach_order = null;

    /**
     *
     * @var string $modify_link
     */
    protected $modify_link = null;

    /**
     *
     * @var string $delete_link
     */
    protected $delete_link = null;

    /**
     *
     * @var string $print_link
     */
    protected $print_link = null;

    /**
     * specify the remote page
     * @var string remote_page
     */
    protected $remote_page = null;

    /**
     * class __construct($db_table_name)
     * @param string $db_table_name
     */
    public function __construct($db_table_name) {
        $this->set_db_table_name($db_table_name)
                ->set_modify_link("?action=modify_form")
                ->set_delete_link("?action=delete")
                ->set_group_delete_link("?action=group_delete")
                ->set_copy_link("?action=add_form")
                ->set_print_link("?action=print");
        parent::__construct();
    }

    /**
     * used to set your owen extendend HTML
     * @access public
     * @param string $result
     * @return none
     */
    public function set_grid_result($grid_result = null) {
        $this->grid_result = $grid_result;
        return $this;
    }

    /**
     * @access public
     * @return get_result
     */
    public function get_grid_result() {
        return $this->grid_result;
    }

    /**
     * @access public
     * @param string $debug
     * @return none
     */
    public function debug($debug = true) {
        $this->debug = $debug;
        return $this;
    }

    /**
     * @access public
     * @return get_debug
     */
    public function get_debug() {
        return $this->debug;
    }

    /**
     * defines the databasee table name which is the source of the grid results
     * @access public
     * @param string $db_table_name
     * @return none
     */
    public function set_db_table_name($db_table_name) {
        $this->db_table_name = $db_table_name;
        return $this;
    }

    /**
     * get the databasee table name which is the source of the grid results
     * @access public
     * @param none
     * @return $db_table_name databasee table name
     */
    public function get_db_table_name() {
        return $this->db_table_name;
    }

    /**
     * adds a sql string to group tables , example  group by  user.userid
     * @access public
     * @param string $group
     */
    public function set_group($group) {
        $this->group = $group;
        return $this;
    }

    /**
     *
     * @return string $group
     */
    public function get_group() {
        return $this->group;
    }

    /**
     * specify remote_page path
     * @access public
     * @param string $remote_page
     */
    public function set_remote_page($remote_page) {
        $this->remote_page = $remote_page . " as __remote_page";
        return $this;
    }

    /**
     *
     * @return string $remote_page
     */
    public function get_remote_page() {
        return $this->remote_page;
    }

    /**
     * adds a sql string to join tables , example inner join user on user.userid = emp.userid
     * @access public
     * @param string $join
     */
    public function add_join($join) {
        array_push($this->join, $join);
        return $this;
    }

    /**
     *
     * @return string $join
     */
    public function get_join() {
        return implode(" ", $this->join);
    }

    /**
     * adds an string of sql query
     * @access public
     * @param string $query
     */
    public function override_query($query) {
        $this->override_query = $query;
        return $this;
    }

    public function get_override_query() {
        return $this->override_query;
    }

    /**
     *
     * @param string $select
     */
    public function attach_select($select) {
        $this->attach_select[] = $select;
        return $this;
    }

    public function get_attach_select() {
        if ($this->attach_select)
            return implode(",", $this->attach_select);
    }

    /**
     *
     * @param string $select
     */
    public function override_select($select) {
        $this->override_select = $select;
        return $this;
    }

    public function get_override_select() {
        return $this->override_select;
    }

    /**
     * the selected feilds
     * @return string $select
     */
    public function get_select() {
        if ($this->get_override_select())
            return $this->get_override_select();

        if (is_array($_POST['select_fields']))
            $_POST['select_fields'] = implode(',', $_POST['select_fields']);

        $this->attach_select(
                str_replace('numbering', '`' . $this->get_db_table_name() . '`.' . $this->get_db_table_name() . _id . ' as numbering', $_POST['select_fields'])
        );
        if ($_POST['extend_link']) {
            $arr_extend_link = explode('&', $_POST['extend_link']);
            $extend_link = null;
            foreach ($arr_extend_link as $feild) {
                if (!$this->is_preged($feild))
                    $this->attach_select(preg_replace("/_as_/", " as ", $feild));
            }
        }
        if ($this->get_remote_page())
            $this->attach_select($this->get_remote_page());
        return $this->get_attach_select();
    }

    /**
     *
     * @param string $value
     * @return bool
     */
    protected function is_preged($value) {

        $check_array = $_POST['select_fields'];

        if (!is_array($check_array))
            $check_array = explode(",", $check_array);
        $check_array = array_merge($check_array, $this->attach_select);
        if ($check_array)
            foreach ($check_array as $field) {
                if (preg_match("/($value)$|(`$value`)$/", $field)) {
                    return true;
                }
            }
        return false;
    }

    /**
     * adds a sql string of sql condition to the main query , example AND employee.age >= 12;
     * @access public
     * @param string $condition
     */
    public function attach_conditions($condition) {
        array_push($this->attach_conditions, $condition);
        return $this;
    }

    protected function get_attach_conditions() {
        return implode(" ", $this->attach_conditions);
    }

    /**
     * adds a sql string of sql condition to the main query , example AND employee.age >= 12;
     * @access public
     * @param string $condition
     */
    public function set_init_conditions($condition) {
        array_push($this->init_conditions, $condition);
        return $this;
    }

    protected function get_init_conditions() {
        return implode(" ", $this->init_conditions);
    }

    /**
     * adds a sql string of sql condition to the main query , example AND employee.age >= 12;
     * @access public
     * @param string $condition
     */
    public function override_conditions($condition) {
        $this->override_conditions = $condition;
        return $this;
    }

    public function get_condition() {
        if ($this->override_conditions)
            return $this->override_conditions;

        if (!is_array($_POST['filter_elements']))
            $filter_elements = explode(",", $_POST['filter_elements']);
        else
            $filter_elements = $_POST['filter_elements'];

        $condition = null;
        if ($_POST['quicksearch']) {
            $_POST['quicksearch'] = parent::escape($_POST['quicksearch']);
            $condition = " and ( 1<>1 ";
        }
        foreach ($filter_elements as $value) {
            if ($_POST[$value . '__value']
                    OR $_POST[$value . '__value__1']
                    OR $_POST[$value . '__value__2']
                    OR is_numeric($_POST[$value . '__value'])
                    OR $_POST['quicksearch'])
                switch ($_POST[$value . '__type']) {
                    case 'string':
                        if ($_POST['quicksearch']):
                            $condition .= "OR {$_POST[$value . '__alias']} LIKE  \"%{$_POST['quicksearch']}%\" ";
                        else:
                            switch ($_POST[$value . '__like']) {
                                case 'LIKE':
                                    $condition .= " AND {$_POST[$value . '__alias']} LIKE  \"%" . $this->escape($_POST[$value . '__value']) . "%\" ";
                                    break;
                                case 'NOT LIKE':
                                    $condition .= " AND {$_POST[$value . '__alias']} NOT LIKE  \"%" . $this->escape($_POST[$value . '__value']) . "%\" ";
                                    break;
                                case '=':
                                    $condition .= " AND {$_POST[$value . '__alias']} =  \"" . $this->escape($_POST[$value . '__value']) . "\" ";
                                    break;
                                case '!=':
                                    $condition .= " AND {$_POST[$value . '__alias']} !=  \"" . $this->escape($_POST[$value . '__value']) . "\" ";
                                    break;
                                default : $condition .= " AND {$_POST[$value . '__alias']} LIKE  \"%" . $this->escape($_POST[$value . '__value']) . "%\" ";
                            }
                        endif;
                        break;
                    case 'text':
                        if ($_POST['quicksearch']):
                            $condition .= " OR {$_POST[$value . '__alias']} LIKE  \"%{$_POST['quicksearch']}%\" ";
                        else:
                            $array_value = explode("\n", $_POST[$value . '__value']);
                            switch ($_POST[$value . '__like']) {
                                case 'LIKE':
                                    foreach ($array_value as $textvalue) {
                                        $textvalue = $this->escape($textvalue);
                                        $condition .= " AND {$_POST[$value . '__alias']} LIKE  \"%$textvalue%\" ";
                                    }
                                    break;
                                case 'NOT LIKE':
                                    foreach ($array_value as $textvalue) {
                                        $textvalue = $this->escape($textvalue);
                                        $condition .= " AND {$_POST[$value . '__alias']} NOT LIKE  \"%$textvalue%\" ";
                                    }
                                    break;
                                case '=':
                                    foreach ($array_value as $textvalue) {
                                        $textvalue = $this->escape($textvalue);
                                        $condition .= " AND {$_POST[$value . '__alias']} =  \"$textvalue\" ";
                                    }
                                    break;
                                case '!=':
                                    foreach ($array_value as $textvalue) {
                                        $textvalue = $this->escape($textvalue);
                                        $condition .= " AND {$_POST[$value . '__alias']} !=  \"$textvalue\" ";
                                    }
                                    break;
                            }
                        endif;
                        break;

                    case 'list':
                        if ($_POST['quicksearch']) {
                            $condition .= " OR {$_POST[$value . '__alias']}  like '%" . $this->escape($_POST['quicksearch']) . "%'";
                        } else
                        if ($_POST[$value . '__value'] != 'null') {
                            $condition .= " AND {$_POST[$value . '__alias']} =   '" . $this->escape($_POST[$value . '__value']) . "'";
                        }
                        break;
                    case 'multi':
                        if ($_POST['quicksearch']) {
                            $condition .= " OR {$_POST[$value . '__alias']}  like '%" . $this->escape($_POST['quicksearch']) . "%'";
                        } else
                        if ($_POST[$value . '__value']) {
                            $condition .= " AND {$_POST[$value . '__alias']}  " . $_POST[$value . "__like"] . " (" . $this->escape($_POST[$value . '__value']) . ")";
                        }
                        break;
                    case 'int':
                        if ($_POST['quicksearch']) {
                            $condition .= " OR {$_POST[$value . '__alias']}  like '%" . $this->escape($_POST['quicksearch']) . "%'";
                        } else {
                            if (($_POST[$value . '__like__1'] != 'IS NULL' OR $_POST[$value . '__like__1'] != 'IS NOT NULL') AND $_POST[$value . '__value__1'])
                                $condition .= " AND {$_POST[$value . '__alias']} " . $_POST[$value . '__like__1'] . "  '" . $this->escape($_POST[$value . '__value__1']) . "'";
                            if (($_POST[$value . '__like__1'] == 'IS NULL' OR $_POST[$value . '__like__1'] == 'IS NOT NULL') AND $_POST[$value . '__value__1'])
                                $condition .= " AND {$_POST[$value . '__alias']} " . $_POST[$value . '__like__1'];

                            if (($_POST[$value . '__like__2'] != 'IS NULL' OR $_POST[$value . '__like__2'] != 'IS NOT NULL') AND $_POST[$value . '__value__2'])
                                $condition .= " AND {$_POST[$value . '__alias']} " . $_POST[$value . '__like__2'] . "  '" . $this->escape($_POST[$value . '__value__2']) . "'";
                            if (($_POST[$value . '__like__2'] == 'IS NULL' OR $_POST[$value . '__like__2'] == 'IS NOT NULL') AND $_POST[$value . '__value__2'])
                                $condition .= " AND {$_POST[$value . '__alias']} " . $_POST[$value . '__like__2'];
                        }
                        break;
                    case 'date':
                        if ($_POST['quicksearch']) {
                            $condition .= " OR {$_POST[$value . '__alias']} like '%{$_POST['quicksearch']}%'";
                        } else {
                            if (($_POST[$value . '__like__1'] != 'IS NULL' OR $_POST[$value . '__like__1'] != 'IS NOT NULL') AND $_POST[$value . '__value__1'])
                                $condition .= " AND date({$_POST[$value . '__alias']}) " . $_POST[$value . '__like__1'] . "  '" . $this->escape($_POST[$value . '__value__1']) . "'";
                            if (($_POST[$value . '__like__1'] == 'IS NULL' OR $_POST[$value . '__like__1'] == 'IS NOT NULL') AND $_POST[$value . '__value__1'])
                                $condition .= " AND date({$_POST[$value . '__alias']}) " . $_POST[$value . '__like__1'];

                            if (($_POST[$value . '__like__2'] != 'IS NULL' OR $_POST[$value . '__like__2'] != 'IS NOT NULL') AND $_POST[$value . '__value__2'])
                                $condition .= " AND date({$_POST[$value . '__alias']}) " . $_POST[$value . '__like__2'] . "  '" . $this->escape($_POST[$value . '__value__2']) . "'";
                            if (($_POST[$value . '__like__2'] == 'IS NULL' OR $_POST[$value . '__like__2'] == 'IS NOT NULL') AND $_POST[$value . '__value__2'])
                                $condition .= " AND date({$_POST[$value . '__alias']}) " . $_POST[$value . '__like__2'];
                        }
                        break;
                    case ('bool' OR 'gender'):
                        if ($_POST['quicksearch']) {
                            $condition .= " OR {$_POST[$value . '__alias']} like '%{$_POST['quicksearch']}%'";
                        } else {
                            if ($_POST[$value . '__value'] != '')
                                $condition .= " AND {$_POST[$value . '__alias']} = '" . $this->escape($_POST[$value . '__value']) . "'";
                        }
                        break;
                }
        }
        if ($_POST['quicksearch'])
            $condition .= " )";
        if ($this->get_init_conditions() AND!$condition)
            return $this->get_init_conditions() . " " . $this->get_attach_conditions();

        return $condition . " " . $this->get_attach_conditions();
    }

    /**
     * adds a sql string to order tables , example  group by  user.userid
     * @access public
     * @param string $init_order
     */
    public function set_init_order($init_order) {
        $this->init_order = $init_order;
        return $this;
    }

    /**
     *
     * @return $this->init_order
     */
    protected function get_init_order() {
        return $this->init_order;
    }

    /**
     * adds a sql string to order tables , example  group by  user.userid
     * @access public
     * @param string $init_order
     */
    public function attach_order($attach_order) {
        $this->attach_order = $attach_order;
        return $this;
    }

    /**
     *
     * @return $this->init_order
     */
    protected function get_attach_order() {
        return $this->attach_order;
    }

    /**
     * this function returns the sql limit and order
     * @return return $init_order
     */
    protected function get_order() {
        if ($_POST['page'] <= 1)
            $_POST['page'] = 1;

        if ($_POST['sort'])
            $order = ' order by ' . $_POST['sort'] . ' ' . $this->get_attach_order() . ' ' . $_POST['dir'];
        else
            $order = $this->get_init_order();

        $rpg = $_POST['records_per_page'];
        $order .= ' LIMIT ' . (($_POST['page'] - 1) * $rpg) . ' , ' . $rpg;
        return $order;
    }

    public function get_query() {
        if ($this->override_query)
            return $this->override_query;

        $statment = " select " . $this->get_select() . " from `";
        $statment .= $this->get_db_table_name() . "` ";
        $statment .= $this->get_join();
        $statment .= " where 1=1 ";
        $statment .= $this->get_condition();
        $statment .= $this->get_group();
        $statment .= " ";

        return $statment;
    }

    /**
     * defines the link of modify form , in order to direct the record to its link
     * @access public
     * @param string $modify_link
     * @return none
     */
    public function set_modify_link($modify_link = null) {
        $this->modify_link = $modify_link;
        return $this;
    }

    /**
     * returns the link of modify form , in order to direct the record to its link
     * @access public
     * @return string $modify_link
     */
    public function get_modify_link() {

        return $this->modify_link;
    }

    /**
     * defines the link of copy form , in order to direct the record to its link
     * @access public
     * @param string $copy_link
     * @return none
     */
    public function set_copy_link($copy_link = null) {
        $this->copy_link = $copy_link;
        return $this;
    }

    /**
     * returns the link of copy form , in order to direct the record to its link
     * @access public
     * @return string $copy_link
     */
    public function get_copy_link() {

        return $this->copy_link;
    }

    /**
     * defines the link of print form , in order to direct the record to its link
     * @access public
     * @param string $print_link
     * @return none
     */
    public function set_print_link($print_link = null) {
        $this->print_link = $print_link;
        return $this;
    }

    /**
     * returns the link of modify form , in order to direct the record to its link
     * @access public
     * @return string $print_link
     */
    public function get_print_link() {

        return $this->print_link;
    }

    /**
     * defines the link of delete form , in order to direct the record to its link
     * @access public
     * @param string $delete_link
     * @return none
     */
    public function set_delete_link($delete_link = null) {
        $this->delete_link = $delete_link;
        return $this;
    }

    /**
     * returns the link of modify form , in order to direct the record to its link
     * @access public
     * @return string $delete_link
     */
    public function get_delete_link() {

        return $this->delete_link;
    }

    /**
     * defines the link of group_delete form , in order to direct the record to its link
     * @access public
     * @param string $group_delete_link
     * @return none
     */
    public function set_group_delete_link($group_delete_link = null) {
        $this->group_delete_link = $group_delete_link;
        return $this;
    }

    /**
     * returns the link of modify form , in order to direct the record to its link
     * @access public
     * @return string $group_delete_link
     */
    public function get_group_delete_link() {

        return $this->group_delete_link;
    }

    /**
     *
     */
    public function get_data_set() {
        $statment = $this->get_query() . $this->get_order();
        return parent::get_array_rows($statment, $this->get_debug());
    }

    protected function get_sorting() {
        if ($_POST['sort'] AND $_POST['sort'] != 'numbering')
            return $order = ' order by `' . $this->get_db_table_name() . '`.`' . $_POST['sort'] . '` ' . $_POST['dir'];
    }

    /**
     *
     * @return <type>
     */
    public function get_export_data_set() {
        //if($_POST['page'] <= 1)$_POST['page'] = 1;
        //$rpg = $_POST['records_per_page'];

        if ($_POST['sort'])
            $order = ' order by ' . $_POST['sort'] . ' ' . $_POST['dir'];

        $statment = $this->get_query() . $order;
        return parent::get_array_rows($statment, $this->get_debug());
    }

    /**
     *
     */
    public function load() {
        if (!isset($_SERVER['HTTP_REFERER']))
            exit;

        $br = strtolower($_SERVER['HTTP_USER_AGENT']); // what browser they use.
        $data = $this->get_data_set();
        $total_results = parent::get_result($this->get_query(), $this->get_debug());
        $total_results_rows = '<tr style="display:none" _total="' . htmlentities(number_format($total_results->num_rows)) . '" _viewing="' . count($data) . '"
                modify="' . $this->get_modify_link() . '"
                delete="' . $this->get_delete_link() . '"
                group_delete="' . $this->get_group_delete_link() . '"
                copy="' . $this->get_copy_link() . '" 
                print="' . $this->get_print_link() . '">';
        if (!is_array($_POST['header']))
            $header = explode(",", $_POST['header']);
        else
            $header = $_POST['header'];
        foreach ($header as $value) {
            $total_results_rows .= '<td>&nbsp;</td>';
        }
        $total_results_rows .= '
                 </tr>';
        $total_results_rows .= '
            </tbody>
        </table>';
        if ($this->get_grid_result())
            return '<table border=1>
                            <tbody>' . $this->get_grid_result() . $total_results_rows;

        if ($data) {
            $rows = null;
            $row_selection = array();
            if ($_COOKIE['rowSelection']) {
                $row_selection = explode(",", $_COOKIE['rowSelection']);
            }
            foreach ($data as $key => $value) {
                if ($_POST['extend_link']) {
                    $arr_extend_link = explode('&', $_POST['extend_link']);
                    $extend_link = null;
                    foreach ($arr_extend_link as $feild) {
                        if (preg_match("/`/", $feild))
                            $feild = str_replace("`", "", $feild);

                        if (preg_match("/./", $feild)) {

                            $exploded_field = explode(".", $feild);
                            $feild = $exploded_field[count($exploded_field) - 1];
                        }

                        $extend_link .= "&{$feild}={$value[$feild]}";
                    }
                }
                $row_selection_attr = null;
                if (in_array($value[db_table_name . '_id'], $row_selection)) {
                    $row_selection_attr = "_selected='true'";
                }

                $rows .= '<tr ' . $row_selection_attr . ' _record_id="' . $value[db_table_name . '_id'] . '" extended_link="' . $extend_link . '" __remote_page="' . $value['__remote_page'] . '">';

                foreach ($header as $db_name) {
                    switch ($_POST['header_' . $db_name . '_type']) {
                        case 'numbering':
                            $num = "";
                            ++$i;
                            if ($i < 10)
                                $num = "0";
                            $rows .= '<td class="num">' . $num . $i . '</td>';
                            break;
                        case 'file':
                            $arr_extention = explode('.', $value[$db_name]);
                            $extention = $arr_extention[(count($arr_extention) - 1)];
                            $icon = 'all';
                            if (in_array($extention, array('png', 'jpg', 'jpeg', 'gif', 'ico', 'bmp', 'img')))
                                $icon = 'image';
                            if (in_array($extention, array('doc', 'docx')))
                                $icon = 'word';
                            if (in_array($extention, array('xls', 'xlsx')))
                                $icon = 'excel';
                            if (in_array($extention, array('zip', 'rar', 'jz', 'tar')))
                                $icon = 'compress';
                            if (in_array($extention, array('ppt', 'pptx')))
                                $icon = 'power_point';
                            if (in_array($extention, array('mdb', 'accdb')))
                                $icon = 'access';
                            if (in_array($extention, array('rm', 'mp3', 'wma', 'wa', 'wav', 'ram', 'ra', 'aac', 'm4a', 'm3u')))
                                $icon = 'music';
                            if (in_array($extention, array('3gp', 'avi', 'mpeg', 'mpeg', 'mp4', 'flv', 'ogg', 'asf', 'dat', 'mov')))
                                $icon = 'video';
                            if ($extention == 'pdf')
                                $icon = 'adobe_pdf';
                            if ($extention == 'txt')
                                $icon = 'txt';
                            if ($extention == 'psd')
                                $icon = 'adobe_psd';
                            if ($extention == 'psd')
                                $icon = 'adobe_psd';
                            if ($extention == 'pps')
                                $icon = 'slide_show';
                            if ($extention == 'swf')
                                $icon = 'swf';
                            $href_attachment_content = null;
                            $href_attachment_content = '<img src="' . theme_common_url_path . 'images/grid/' . $icon . '.png" border=0>';

                            $rows .= '<td><div class="nowrap_div" title="' . $value[$db_name] . '">';
                            if ($value[$db_name]) {
                                $rows .= '<a class="" href="' . upload_url_path . $value[$db_name] . '" target="blank" title="open file">
                                              ' . $href_attachment_content . '
                                            </a>';
                            }
                            $rows .= '</div>
                            </td>';
                            break;
                        case 'bool':
                            $bool_content = null;
                            if ((bool) $value[$db_name]) {
                                $bool_content = '<i class = "mdi mdi-check"></i>';
                            } else {
                                $bool_content = '<i class = "mdi mdi-minus"></i>';
                            }
                            $rows .= '<td><div class = "nowrap_div" title = "' . $value[$db_name] . '">' . $bool_content . '</div></td>';
                            break;
                        case 'input':
                            $rows .= '<td><div class = "nowrap_div" title = "' . $value[$db_name] . '"><input type = "text" dir = "rtl" name = "' . $db_name . '_input" style = "border:1px solid #000;height:14px;font-size:12px;width:140px;" value = "' . $value[$db_name] . '" onclick = "$(this).focus();$(this).select();"/></div></td>';
                            break;
                        case 'gender':
                            $gender_content = null;
                            $gender_content = '<img src = "' . theme_common_url_path . 'images/grid/gender_' . $value[$db_name] . '.png" alt = ""/>';
                            $rows .= '<td><div class = "nowrap_div" title = "' . $value[$db_name] . '">' . $gender_content . '</div></td>';
                            break;
                        case 'radio':
                            if (!$repalce_array)
                                $repalce_array = json_decode($_POST["{$db_name}__replace_value"], true);
                            $rows .= '<td><div class = "nowrap_div" title = "' . $value[$db_name] . '">' . $repalce_array[$value[$db_name]] . '</div></td>';
                            break;
                        case 'constant':
                            $constant = @constant($value[$db_name]);
                            if (!@constant($value[$db_name]))
                                $constant = $value[$db_name];
                            $rows .= '<td><div class = "nowrap_div" title = "' . $value[$db_name] . '">' . $constant . '</div></td>';
                            break;
                        default:
                            $rows .= '<td><div class = "nowrap_div" title = "' . $value[$db_name] . '">' . $value[$db_name] . '</div></td>';
                    }
                }
                $rows .= '</tr>';
            }
        }
        return '<table>
                        <tbody>' . $rows . $total_results_rows;
    }

    public function export_xls() {
        
        if (count($this->get_export_data_set()) > 0) {
            $arr_header = explode(",", $_POST['header_titles']); //array header send for first row

            $file_name = str_replace('.php', '.xls', basename(self)); // replace the file extension of the current page
            $file_save = upload_physical_path . $file_name;  //set the file path to wher we will write the excel

            $php_excel = new PHPExcel();
            $php_excel->setActiveSheetIndex(0);
            $sheet = $php_excel->getActiveSheet();
            $sheet->setRightToLeft(dir == 'rtl' ? true : false);

            $text_align = dir == 'rtl' ? PHPExcel_Style_Alignment::HORIZONTAL_RIGHT : PHPExcel_Style_Alignment::HORIZONTAL_LEFT;
            $style_head = array(
                'fill' => array(
                    'type' => PHPExcel_Style_Fill::FILL_SOLID,
                    'color' => array('rgb' => '3767BB')
                ),
                'font' => array(
                    'bold' => true,
                    'color' => array('rgb' => 'ffffff')
                ),
                'borders' => array(
                    'outline' => array(
                        'style' => PHPExcel_Style_Border::BORDER_THIN,
                        'color' => array('rgb' => '000000'),
                    ),
                ),
                'alignment' => array(
                    'horizontal' => $text_align,
                ),
            );


            $alignment = array(
                'alignment' => array(
                    'horizontal' => $text_align,
                )
            );


            $col = 0;
            foreach ($arr_header as $key => $value) {
                if ($value != '#' AND $value != ' ') {

                        $value = $this->escape(htmlspecialchars($value));
                        $sheet->getCellByColumnAndRow($col, 1)->setValue($value);
                        $sheet->getStyleByColumnAndRow($col, 1)->applyFromArray($style_head);
                        $sheet->getColumnDimensionByColumn($col)->setAutoSize(true);
                        $col++;
                    }
                }

                $row = 2;
                $sheet->freezePaneByColumnAndRow(0, $row); //freeze the first row;
                foreach ($this->get_export_data_set() as $key => $value) {
                    $col = 0;

                    foreach ($value as $key2 => $value2) {
                        if (!is_numeric($key2)
                                AND $_POST['header_' . $key2 . '_type'] != "numbering"
                                AND $key2 != $this->get_db_table_name() . _id
                                AND (
                                $_POST['header_' . $key2 . '_type']
                                OR
                                $_POST['' . $key2 . '__type']
                                )
                        ) {
                            if ($_POST['header_' . $key2 . '_type'] == "constant")
                                $value2 = @constant($value2);

                            $value2 = $this->escape(htmlspecialchars($value2));
                            $value2 = htmlspecialchars($value2);
                            if (mb_substr($value2, 0, 1, "UTF-8") === "="):
                                $value2 = "'" . $value2;
                            endif;

                            $sheet->getCellByColumnAndRow($col, $row)->setValue($value2);
                            $sheet->getStyleByColumnAndRow($col, $row)->applyFromArray($alignment);
                            $col++;
                        }
                    }
                    $row++;
                }


                //excel write
                $writer = PHPExcel_IOFactory::createWriter($php_excel, 'Excel2007'); //for excel 2007 Excel2007 instead of Excel5 as well as check extension later on
                $writer->save($file_save);

                //excel download
                header("Content-Type: application/x-msexcel; name=" . $file_name);
                header("Content-Disposition: inline; filename=" . $file_name);
                $fopen = fopen($file_save, "rb");
                fpassthru($fopen);
                unlink($file_save);
            }
        }

    }

?>