<?php

// ################################################################################################################################################
// LIB EXCEL ######################################################################################################################################
// ################################################################################################################################################
if ($is_libxl) {

// create excel based on the new library 
// ########################################################################
    $excel = new ExcelBook(libxl_name, libxl_key, $is_2007_excel);
    $excel->setLocale("UTF-8");


// common format
// ########################################################################

    $sheet = $excel->addSheet($sheet_name);
    $sheet->setRightToLeft((dir == 'rtl'));
    $sheet->setLandscape(true);
    $sheet->setPrintRepeatRows(0, 0);
    $sheet->setPrintFit(1, 0);
    $sheet->setPaper(ExcelSheet::PAPER_A4);
    $sheet->setMarginBottom(0);
    $sheet->setMarginTop(0);
    $sheet->setMarginLeft(0);
    $sheet->setMarginRight(0);
    $sheet->splitSheet(1, 0);
    //sheet->setDisplayGridlines(true);
// common format
// ########################################################################
    $cmn_format = $excel->addFormat();
    $cmn_format->borderColor(ExcelFormat::COLOR_BLACK);
    $cmn_format->borderStyle(ExcelFormat::BORDERSTYLE_THIN);
    $cmn_format->horizontalAlign(ExcelFormat::ALIGNH_RIGHT);

// create format for header
// ########################################################################
    $hd_format = $excel->addFormat($cmn_format);
    $hd_format->fillPattern(ExcelFormat::FILLPATTERN_SOLID);
    $hd_format->patternForegroundColor(ExcelFormat::COLOR_AQUA);

// create format for dates
// ########################################################################
    $date_format = $excel->addFormat($cmn_format);
    $date_format->numberFormat($excel->addCustomFormat("yyyy-mm-dd"));

// create format for date and time
// ########################################################################
    $datetime_format1 = $excel->addFormat($cmn_format);
    $datetime_format1->numberFormat($excel->addCustomFormat("yyyy-mm-dd hh:mm:ss"));

    $datetime_format2 = $excel->addFormat($cmn_format);
    $datetime_format2->numberFormat($excel->addCustomFormat("yyyy-mm-dd hh:mm"));

// create format for time
// ########################################################################
    $time_format1 = $excel->addFormat($cmn_format);
    $time_format1->numberFormat($excel->addCustomFormat("hh:mm:ss"));

    $time_format2 = $excel->addFormat($cmn_format);
    $time_format2->numberFormat($excel->addCustomFormat("hh:mm"));

// init row starting from zero
// ########################################################################
    $row = 0;

// draw the header title
// ########################################################################
    foreach ($arr_header_titles as $col => $value) {
        $sheet->write($row, $col, $value, $hd_format);
    }

// loop on data array and build rows
//########################################################################
    foreach ($data_rows_arr as $data) {
        $is_extra_row = $data['__fr_is_extra_row'] === true;
        $row++;

// loop on the header to get data based on fields
// ########################################################################
        foreach ($arr_header as $col => $field) {

            ######### initialize cell type to specify if date or normal field
            $data_type = -1;
            $row_format = $cmn_format;

            ######### check that field exist
            if ($field) {

                ######### get the data type of the field
                $cell_type = $_POST["header_{$field}_type"];


                ######### get the value of column in a row
                $value = $data[$field];


                ######### check that cell type is a defintion
                if ($cell_type == "constant")
                    $value = @constant($data[$field]);


                ######### check that value exist and celltype related to time
                else if ($value && in_array($cell_type, array("date", "datetime", "time"))) {


                    ######### check if value exist in db
                    if (preg_replace(array("/-/", "/:/", "/ /"), "", $value) > 0) {

                        ######### get the length of the date or time to use proper format
                        $length = strlen($value);

                        ######### conver the value to time to enable excel use it
                        $value = strtotime($value);

                        ######### specify the data type for excel that field is date or time
                        $data_type = ExcelFormat::AS_DATE;


                        ######### check that cell type is time or not in order to specify the time or date format
                        if ($cell_type != "time") {

                            ######### check length of the string to know what format to use
                            switch ($length) {
                                case 19:
                                    $row_format = $datetime_format1;
                                    break;
                                case 16:
                                    $row_format = $datetime_format2;
                                    break;
                                default:
                                    $row_format = $date_format;
                                    break;
                            }
                        } else {

                            ######### check length of the string to know what format to use
                            switch ($length) {

                                case 5:
                                    $row_format = $time_format2;
                                    break;
                                default:
                                    $row_format = $time_format1;
                                    break;
                            }
                        }
                    }

                    ######### when no value in date or time assign null
                    else
                        $value = null;
                }
                else if ($cell_type == "int")
                    $data_type = ExcelFormat::AS_NUMERIC_STRING;
            }

            ######### write the row and column excel
            $sheet->write($row, $col, $value, $row_format, $data_type);
        }
    }

// excel save
// ########################################################################
    $excel->save($file_save);
}


// ################################################################################################################################################
// PHP EXCEL ######################################################################################################################################
// ################################################################################################################################################
else if ($is_php_excel) {

// create excel based on phpexcel
// ########################################################################
    $php_excel = new PHPExcel();
    $php_excel->setActiveSheetIndex(0);

// page setting
// ########################################################################    
    $sheet = $php_excel->getActiveSheet();
    $sheet->setRightToLeft(dir == 'rtl' ? true : false);
    $sheet->getPageSetup()->setFitToHeight('0');
    $sheet->getPageSetup()->setFitToWidth('1');
    $sheet->getPageSetup()->setOrientation('landscape');

// styling
// ########################################################################  

    $border = array('borders' => array('allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN)));
    $align = array('alignment' => array('horizontal' => (dir == 'rtl' ? PHPExcel_Style_Alignment::HORIZONTAL_RIGHT : PHPExcel_Style_Alignment::HORIZONTAL_LEFT)));
    $fill = array('fill' => array('type' => PHPExcel_Style_Fill::FILL_SOLID, 'color' => array('rgb' => '33CCCC')));
    $wrap = array('wrap' => true);

// init row starting from 1
// ########################################################################
    $head_row = $row = 1;
    $data_row = $head_row + 1;

// draw the header title
// ########################################################################
    foreach ($arr_header_titles as $col => $value) {
        $sheet->getCellByColumnAndRow($col, $row)->setValue($value);
        $sheet->getStyleByColumnAndRow($col, $row)->applyFromArray($fill);
        $sheet->getColumnDimensionByColumn($col)->setAutoSize(true);
    }

//freeze the first row;
// ########################################################################
    $sheet->freezePaneByColumnAndRow(0, $data_row);
    $date_header_format_cols = array();


// loop on data array and build rows
//########################################################################
    foreach ($data_rows_arr as $data) {
        $is_extra_row = $data['__fr_is_extra_row'] === true;
        $row++;

// loop on the header to get data based on fields
// ########################################################################
        foreach ($arr_header as $col => $field) {

            ######### check that field exist
            if ($field) {

                ######### get the data type of the field
                $cell_type = $_POST["header_{$field}_type"];


                ######### get the value of column in a row
                $value = $data[$field];


                ######### check that cell type is a defintion
                if ($cell_type == "constant")
                    $value = @constant($data[$field]);


                ######### check that value exist and celltype related to time
                else if ($value && in_array($cell_type, array("date", "datetime", "time"))) {


                    ######### check if value exist in db
                    if (preg_replace(array("/-/", "/:/", "/ /"), "", $value) > 0) {

                        ######### get the length of the date or time to use proper format
                        $length = strlen($value);

                        ######### check that cell type is time or not in order to specify the time or date format
                        if ($cell_type != "time") {

                            ######### check length of the string to know what format to use
                            switch ($length) {
                                case 19:
                                    $date_header_format_cols[$col] = 'yyyy-mm-dd hh:mm:ss';
                                    break;
                                case 16:
                                    $date_header_format_cols[$col] = 'yyyy-mm-dd hh:mm';
                                    break;
                                default:
                                    $date_header_format_cols[$col] = 'yyyy-mm-dd';
                                    break;
                            }
                            ######### to allow give special date format we must convert our date to excel special number, make it after check above strlength
                            $value = PHPExcel_Shared_Date::stringToExcel($value);
                        } else {

                            ######### check length of the string to know what format to use
                            switch ($length) {
                                case 5:
                                    $date_header_format_cols[$col] = 'hh:mm';
                                    break;
                                default:
                                    $date_header_format_cols[$col] = 'hh:mm:ss';
                                    break;
                            }
                        }
                    }

                    ######### when no value in date or time assign null
                    else
                        $value = null;
                }

                ######### fill string or number or date
                if ($cell_type == "string")
                    $sheet->getCellByColumnAndRow($col, $row)->setValueExplicit($value);
                else
                    $sheet->getCellByColumnAndRow($col, $row)->setValue($value);
            }
            if($is_extra_row)
                $sheet->getStyleByColumnAndRow($col, $row)->applyFromArray($fill);
        }
    }


    ######### first col
    $colum_start = PHPExcel_Cell::stringFromColumnIndex(0);

    #########  highest col, 
    $colum_end = PHPExcel_Cell::stringFromColumnIndex($col);

    ######### assign the style for date case
    if ($date_header_format_cols) {
        foreach ($date_header_format_cols as $formated_col => $col_format) {
            $format_col = PHPExcel_Cell::stringFromColumnIndex($formated_col);
            $sheet->getStyle($format_col . $data_row . ":" . $format_col . $row)->getNumberFormat()->setFormatCode($col_format);
        }
    }

    #########  style all rows and cols
    $sheet->getStyle($colum_start . $head_row . ":" . $colum_end . $row)->applyFromArray(array_merge($border, $align, $wrap));

    ######### excel write
    $writer = PHPExcel_IOFactory::createWriter($php_excel, $is_2007_excel ? 'Excel2007' : 'Excel5');
    $writer->save($file_save);
}


// ################################################################################################################################################
// HTML EXCEL #####################################################################################################################################
// ################################################################################################################################################
else {

    #########  style initialize
    $is_rtl = (dir == 'rtl' ? "<x:DisplayRightToLeft/>" : "");
    $align = dir == 'rtl' ? 'right' : 'left';

    #########  table define
    $excel_head = $excel_body = null;

    /*
     *  we write data to file then automatic write to buffer but if direct echo the client will be download at fly
     *  and the data are still in memory till the client download whole but here client read from the file not memory
     */
    $handle = fopen($file_save, "w");


// draw the header title
// ########################################################################
    foreach ($arr_header_titles as $col => $value) {
        $excel_head.= "<th>{$value}</th>";
    }

// loop on data array and build rows
//########################################################################
    foreach ($data_rows_arr as $data) {
        $is_extra_row = $data['__fr_is_extra_row'] === true;
        ### row start
        $excel_body.="<tr>";

// loop on the header to get data based on fields
// ########################################################################
        foreach ($arr_header as $col => $field) {

            ######### check that field exist
            if ($field) {

                ######### get the data type of the field
                $cell_type = $_POST["header_{$field}_type"];

                ######### get the value of column in a row
                $value = $data[$field];

                ######### check that cell type is a defintion
                if ($cell_type == "constant")
                    $value = @constant($data[$field]);

                $excel_body.= "<td>{$value}</td>";
            }
        }

        ### row end
        $excel_body.="</tr>";
    }


// if data exceeded the limit no of rows
// ########################################################################   
    if ($this->is_more_export_rows_exist)
        $excel_body . "<tr class='exceed'><td colspan='{$col}'>" . LANG_EXPORT_DATA_EXCEED_ROWS_LIMIT . " {$this->max_export_data_rows}</td></tr>";


// draw the table
// ########################################################################   
    $excel_html = <<< excel_html
                    <html xmlns:o="urn:schemas-microsoft-com:office:office"
                          xmlns:x="urn:schemas-microsoft-com:office:excel"
                          xmlns="http://www.w3.org/TR/REC-html40">
                        <head>
                            <meta http-equiv=Content-Type content="text/html; charset=utf-8">
                            <meta name=ProgId content=Excel.Sheet>
                            <meta name=Generator content="Microsoft Excel 11">
                            <style type='text/css'>
                                    table{border-collapse:collapse}
                                    th,td{text-align:{$align}}
                                    thead th{background:#33CCCC}
                                    tbody .exceed td{height:30px;vertical-align:middle}
                            </style>
                            <!--[if gte mso 9]><xml>
                                <x:ExcelWorkbook>
                                    <x:ExcelWorksheets>
                                    <x:ExcelWorksheet>
                                    <x:Name>Worksheet</x:Name>
                                    <x:WorksheetOptions>
                                        {$is_rtl}
                                        <x:Selected/>
                                        <x:FreezePanes/>
                                        <x:FrozenNoSplit/>
                                        <x:SplitHorizontal>1</x:SplitHorizontal>
                                        <x:TopRowBottomPane>1</x:TopRowBottomPane>
                                        <x:ActivePane>2</x:ActivePane>
                                        <x:Panes>
                                        <x:Pane>
                                        <x:Number>3</x:Number>
                                        </x:Pane>
                                        <x:Pane>
                                        <x:Number>2</x:Number>
                                        </x:Pane>
                                        <x:Pane>
                                        <x:Number>0</x:Number>
                                        </x:Pane>
                                        </x:Panes>
                                        <x:ProtectContents>False</x:ProtectContents>
                                        <x:ProtectObjects>False</x:ProtectObjects>
                                        <x:ProtectScenarios>False</x:ProtectScenarios>
                                    </x:WorksheetOptions>
                                    </x:ExcelWorksheet>
                                    </x:ExcelWorksheets>
                                    <x:ProtectStructure>False</x:ProtectStructure>
                                    <x:ProtectWindows>False</x:ProtectWindows>
                                </x:ExcelWorkbook>
                            </xml><![endif]-->
                        </head>
                        <body>
                            <table border='1'>
                                 <thead><tr>{$excel_head}</tr></thead>
                                 <tbody>{$excel_body}</tbody>
                           </table>
                        </body>
                  </html>
excel_html;

    fwrite($handle, $excel_html);
    fclose($handle);
}


// download excel (we can suggest type application for each version like below)
// ########################################################################
if ($is_2007_excel)
    header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
else
    header("Content-Type: application/x-msexcel; name=" . $file_name);


// for above we can just use the below, which let browser guess the application type & work for both 2003 & 2007 versions
// ########################################################################
//header("Content-Type: application/download");
//  if we put "attachment" it will only allow to download it but if we put
//  "inline" it will open inside the iframe if we have the plugin needed
// ########################################################################
header("Content-Disposition: inline; filename=" . $file_name);


//Reads to EOF on the given file pointer from the current position and writes the results to the output buffer
// ########################################################################
$handle = fopen($file_save, "rb");
fpassthru($handle);
fclose($handle);
unlink($file_save);
?>