<?php

class builder_input extends builder_elements {

    public function __construct() {
        parent::add_attr("autocomplete", "off");
    }

    public function set_readonly($bool = true) {
        if ($bool) {
            parent::add_attr("readonly", "readonly");
        } else {
            parent::remove_attr("readonly", "readonly");
        }
        return $this;
    }

    /**
     * set input type
     * @access protected
     * @param string $type
     */
    public function set_type($type = 'text') {
        parent::add_attr('type', $type);
        return $this;
    }
    public function get_type() {
        return parent::get_attr('type');
    }
    /**
     * get validation
     * @return string $valid
     */

    public function get_valid() {
        if (parent::get_valid()) {
                parent::add_class('valid');
                return true;
            }
        return false;
    }

    /**
     * @access public
     * @return bool $disable returns select disable
     */
    public function get_disable() {
        if (parent::get_disable()) {
            parent::add_attr('disabled', 'disabled');
        }
    }

    /**
     * @access public
     * @return string $input
     */
    public function load() {
        $this->get_disable();
        
        $this->get_valid();
        $span = $this->get_required_span();
        
        if (parent::get_width()){
            parent::add_attr('width', parent::get_width());
        }
        if(parent::get_disable() AND $this->get_type() != "radio"){
            anti_inspection::push_disabled_elments(parent::get_name(), parent::get_value());
        }
        return '<input ' . parent::get_attr() . ' ' . parent::get_css() . '/>'.$span;
    }

}

?>