<?php
class builder_message {
    /**
     * @access private
     * @var string $message_text
     */
    private $message_text           =   array();
    /**
     * set message type
     * @var string  $message_type
     */
    private $message_type           =   null;
    /**
     * used to overrid the old message type
     * @var string $new_message_type
     */
    private $new_message_type       =   null;
    /**
     * used to overrid the old message text
     * @var string  $new_message_text
     */
    private $new_message_text       =   array();
    /**
     * @access public
     * @param string $message_text
     */
    public function add_message_text ($message_text) {
        array_push($this->message_text, $message_text);
        return $this;
    }
    /**
     * @access public
     * @param string $message_text
     */
    public function override_message_text($message_text) {
        $this->new_message_text = $message_text;
        return $this;
    }
    /**
     * @access public
     * @return string $message_text
     */
    public function get_message_text() {
        if($this->message_text)
            $message_text = implode(", " ,$this->message_text);
        if($this->new_message_text)
            $message_text = $this->new_message_text;
        $this->message_text        = null;
        $this->new_message_text    = null;
        return $message_text;
    }
    /**
     * @access public
     * @param string $message_type
     */
    public function set_message_type ($message_type  = null) {
        if(!$message_type)$message_type="success";
        $this->message_type  = $message_type ;
        return $this;
    }
    /**
     * @access public
     * @param string $message_type
     */
    public function override_message_type($message_type) {
        $this->new_message_type = $message_type;
        return $this;
    }
    /**
     *
     * @return string $message_type
     */
    public function get_message_type() {
        if($this->new_message_type)
            $message_type = $this->new_message_type;
        else
            $message_type = $this->message_type;
        $this->message_type     = null;
        $this->new_message_type = null;
        return $message_type;
    }
    /**
     *
     * @param string $message_type
     * @param string $message_text
     */
    public function set_message($message_type  = null , $message_text = null) {
        $this->add_message_text($message_text);
        $this->set_message_type($message_type);
        return $this;
    }
    /**
     * js script which will be loaded in form (child class)
     * @return string $message
     */
    public function load() {
        $messaging   = 'hide_message();';
        $message_type = $this->get_message_type();
        $message_text = $this->get_message_text();
        if($message_type && $message_text) {
            $messaging ='load_message("'.htmlspecialchars($message_type).'","'.htmlspecialchars($message_text).'");';
        }
        return $messaging;
    }
    public static function alert($type="success",$text=null){

        $type=htmlspecialchars($type);
        $text=htmlspecialchars($text);        

        return "load_message('{$type}','{$text}');";

    }
}
?>
