<?php

/**
 * Description of builder_tags
 *
 * @author ihab
 */
class builder_tags {

    /**
     * to create any new attribute
     * element attr
     * @access private
     * @var array attr
     */
    private $attr = array();

    /**
     * to create any new styling
     * element css
     * @access private
     * @var array css
     */
    private $css = array();

    /**
     * @access public
     * @param string $name
     */
    public function set_name($name) {
        $this->attr['name'] = $name;
        if (!$this->id)
            $this->attr['id'] = $this->get_name();

        return $this;
    }

    /**
     * @access public
     * @return string $name
     */
    public function get_name() {
        return $this->attr['name'];
    }

    /**
     * @access public
     * @param string $id
     */
    public function set_id($id) {
        $this->attr['id'] = $id;
        return $this;
    }

    /**
     * @access public
     * @return string $id
     */
    public function get_id() {
        return $this->attr['id'];
    }

    /**
     * 
     */
    public function add_class($class) {
        $this->attr['class'].= $class . " ";
        return $this;
    }

    /**
     * add attributes
     * @access public
     * @param string $key
     * @param string $value
     */
    public function add_attr($key, $value) {
        $this->attr[$key] = $value;
        return $this;
    }

    /**
     * get attributes
     * @access public
     * @return string $attributes
     */
    protected function get_attr($attr = null) {
        if ($attr)
            return $this->attr[$attr];

        foreach ($this->attr as $key => $value) {
            $attributes .= $key . '="' . $value . '" ';
        }
        return $attributes;
    }

    public function remove_attr($key) {
        unset($this->attr[$key]);
        return $this;
    }

    /**
     * add css styles
     * @access public
     * @param string $key
     * @param string $value
     */
    public function add_css($key, $value) {
        $this->css[$key] = $value;
        return $this;
    }

    /**
     * get styles
     * @access public
     * @return string $css
     */
    protected function get_css($key = null) {
        if ($key)
            return $this->css[$key];

        $styles = 'style="';
        foreach ($this->css as $key => $value) {
            $styles .="$key:$value;";
        }
        $styles .='"';
        return $styles;
    }

    public function remove_css($key) {
        unset($this->css[$key]);
        return $this;
    }

    /**
     * add js scripts
     * @access public
     * @param string $key
     * @param string $value
     */
    public function add_event($key, $value) {
        $this->attr[$key] = $value;
        return $this;
    }

}

?>