<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of builder_tree_result
 *
 * @author ihab
 */
class tree_result extends grid_result {

    /**
     * used to set the class params
     * @var array $params
     */
    private $params = array();

    public function __construct($db_table_name) {
        parent::__construct($db_table_name);
        $this->set_parent_field();
        $this->set_option_value(parent::get_db_table_name() . _id);
        $this->set_option_view(parent::get_db_table_name() . "_name");
    }

    /**
     *
     * @param <type> $tree_result
     */
    public function set_tree_result($tree_result) {
        parent::set_grid_result($tree_result);
    }

    /**
     *
     * @return <type>
     */
    public function get_tree_result() {
        return parent::get_grid_result();
    }

    /**
     * set option view (the field which will be shown)
     * @param string $option_value
     * @return $this
     */
    public function set_option_view($option_view, $alias = null) {
        $this->params['option_view'] = $option_view;
        if ($alias) {
            $this->params['option_view'] = $option_view . " as " . $alias;
        }
        $this->params['alias_option_view'] = $option_view;
        if ($alias) {
            $this->params['alias_option_view'] = $alias;
        }
        $this->params['real_option_view'] = $option_view;
        return $this;
    }

    /**
     *
     * @return $this->params['option_view']
     */
    public function get_option_view() {
        return $this->params['option_view'];
    }

    /**
     * 
     * @return type
     */
    public function get_alias_optoin_view() {
        return $this->params['alias_option_view'];
    }

    /**
     * 
     * @return type
     */
    public function get_real_optoin_view() {
        return $this->params['real_option_view'];
    }

    /**
     * set option value (the field which will be used)
     * @param string $option_value
     * @return $this
     */
    public function set_option_value($option_value) {
        $this->params['option_value'] = $option_value;
        return $this;
    }

    /**
     *
     * @return $this->params['option_value']
     */
    public function get_option_value() {
        return $this->params['option_value'];
    }

    /**
     * 
     * @param type $param
     * @return $this
     */
    public function extend_link($param) {
        if (!is_array($this->params['extend_link'])) {
            $this->params['extend_link'] = array();
        }
        if (is_array($param)) {
            $this->params['extend_link'] = array_merge($this->params['extend_link'], $param);
            return $this;
        }

        $this->params['extend_link'][] = $param;

        return $this;
    }

    /**
     *
     */
    public function get_condition() {
        if ($this->override_conditions) {
            return $this->override_conditions;
        }
        if ($_POST['filter']) {

            $condition .= $this->get_filter();

            return $condition;
        }

        if ($_POST['data']) {
            foreach (get_object_vars(json_decode($_POST['data'])) as $key => $value) {
                $condition .= " and  `{$this->get_db_table_name()}`.`{$key}` = '{$value}'";
            }
        } else
        if (!parent::get_attach_conditions()) {
            $condition .= " and  (
                                    `{$this->get_db_table_name()}`.`{$this->get_parent_field()}` = '0'
                                    or  `{$this->get_db_table_name()}`.`{$this->get_parent_field()}` is null
                                )";
        } else
        if (parent::get_attach_conditions()) {
            $condition .= " and (`{$this->get_db_table_name()}`.`{$this->get_parent_field()}` not in (
                                select `{$this->get_db_table_name()}`.`{$this->get_option_value()}`
                                        from `{$this->get_db_table_name()}` inner join `{$this->get_db_table_name()}` as `sub`
                                        on `{$this->get_db_table_name()}`.`{$this->get_db_table_name()}" . _id . "` = `sub`.`{$this->get_parent_field()}`
                                        where 1=1
                    " . parent::get_attach_conditions() . "
                                        group by `{$this->get_db_table_name()}`.`{$this->get_db_table_name()}" . _id . "`
                ) OR `{$this->get_db_table_name()}`.`{$this->get_parent_field()}` IS  NULL OR `{$this->get_db_table_name()}`.`{$this->get_parent_field()}` = '')";
        }
        return $condition . " " . parent::get_attach_conditions();
    }

    /**
     *
     */
    public function set_order($order = null) {
        $this->params['order'] = $order;
        return $this;
    }

    /**
     * this function returns the sql limit and order
     * @return return $init_order
     */
    public function get_order() {
        return $this->params['order'];
    }

    /**
     *
     * @param string $parent_field
     * @return $this
     */
    public function set_parent_field($parent_field = 'index_id') {
        $this->params['parent_field'] = $parent_field;
        return $this;
    }

    /**
     *
     * @return $parent_field
     */
    public function get_parent_field() {
        return $this->params['parent_field'];
    }
    /**
     *
     * @param string $filter_field
     * @return $this
     */
    public function set_filter_field($filter_field) {
        $this->params['filter_field'] = $filter_field;
        return $this;
    }

    /**
     *
     * @return $filter_field
     */
    public function get_filter_field() {
        return $this->params['filter_field'];
    }

    /**
     *
     * @param string $sub_condition
     * @return $this
     */
    public function attach_sub_conditions($sub_condition = null) {
        $this->params['sub_condition'][] = $sub_condition;
        return $this;
    }

    /**
     *
     * @return $sub_condition
     */
    private function get_sub_condition() {
        if ($this->params['sub_condition'])
            return implode(" ", $this->params['sub_condition']);
        return "";
    }

    /**
     *
     */
    public function get_filter() {
        if ($_POST['filter']) {
            $filter = "{$this->get_db_table_name()}.{$this->get_real_optoin_view()}";
            if($this->get_filter_field()){
                $filter = $this->get_filter_field();
            }
            $condition .= " and {$filter} like '%{$_POST['filter']}%'";
            return $condition . " " . parent::get_attach_conditions();
        }
    }

    /**
     *
     * @param string $value
     * @return bool
     */
    public function get_query() {
        if ($this->override_query) {
            return $this->override_query;
        }
        $statment = " select `{$this->get_db_table_name()}`.`{$this->get_option_value()}` ,
                {$this->get_option_view()},
                             `{$this->get_db_table_name()}`.`{$this->get_parent_field()}`
                {$this->get_select()}
                        from `";
        $statment .= parent::get_db_table_name() . "` ";
        $statment .= $this->get_join();
        $statment .= " where 1=1 ";
        $statment .= $this->get_condition();
        if ($_POST['filter']) {
            $statment .= " and (`{$this->get_db_table_name()}`.`{$this->get_parent_field()}` not in (
                                select `{$this->get_db_table_name()}`.`{$this->get_option_value()}`
                                        from `{$this->get_db_table_name()}`
                                        inner join `{$this->get_db_table_name()}` as `sub`
                                        on `{$this->get_db_table_name()}`.`{$this->get_db_table_name()}" . _id . "` = `sub`.`{$this->get_parent_field()}`
                                        where 1=1
                    {$this->get_condition()}
                                        group by `{$this->get_db_table_name()}`.`{$this->get_db_table_name()}" . _id . "`
            ) OR `{$this->get_db_table_name()}`.`{$this->get_parent_field()}` IS  NULL OR `{$this->get_db_table_name()}`.`{$this->get_parent_field()}` = '' )";
        }
        $statment .= $this->get_group() . " ";


        return $statment;
    }

    public function rec($data_source, $classes, $last_child) {
        foreach ($data_source as $key => $row) {
            $expandable = "false";
            $class = $classes[3];
            $last_child_class = $last_child;
            if ($row['children']) {
                $expandable = "true";
                $class = $classes[1];
                $last_child_class = "";
            }
            $extend_link = null;
            if ($this->params['extend_link'])
                foreach ($this->params['extend_link'] as $key => $value) {
                    if ($row[$value])
                        $extend_link .= "&{$value}={$row[$value]}";
                }
            $action = "id='{$row[$this->get_option_value()]}' value='{$row[$this->get_option_value()]}'
                                                modify_link='{$row['__remote_page']}{$this->get_modify_link()}&{$this->get_option_value()}={$row[$this->get_option_value()]}{$extend_link}'
                                                delete_link='{$row['__remote_page']}{$this->get_delete_link()}&{$this->get_option_value()}={$row[$this->get_option_value()]}{$extend_link}'
                                                copy_link='{$row['__remote_page']}{$this->get_copy_link()}&{$this->get_option_value()}={$row[$this->get_option_value()]}{$extend_link}'
                                                print_link='{$row['__remote_page']}{$this->get_print_link()}&{$this->get_option_value()}={$row[$this->get_option_value()]}{$extend_link}'";
            $html .= "<li data='{{$this->get_parent_field()}:{$row[$this->get_option_value()]}}' id='{$row[$this->get_option_value()]}' expandable='{$expandable}'>
                        <div>
                            <i class='mdi {$class}'></i>
                            <a href='javascript:;'  class='control_href {$last_child_class}' {$action}>{$row[$this->get_alias_optoin_view()]}</a>"
                    . "</div>";
            if ($row['children']) {

                $html .= "<ul>";
                //parr($this->rec($row['children']));exit;
                $html .= $this->rec($row['children'], $classes, $last_child);
                $html .= "</ul>";
            }
            $html .= "</li>";
        }
        return $html;
    }

    public function get_select() {
        if (parent::get_remote_page()) {
            parent::attach_select(parent::get_remote_page());
        }
        if ($this->attach_select) {
            return "," . implode(",", $this->attach_select);
        }
    }

    public function get_full_tree() {

        $arr = json_decode($_POST['data']);

        $classes = json_decode($arr->classes);
        if ($arr->id) {
            $children_ids = new children_ids($this->get_db_table_name());
            $children_ids->set_needle($arr->id)->load();
            $keys = implode(",", $children_ids->get_keys());
        }

        $statment = " select `{$this->get_db_table_name()}`.`{$this->get_option_value()}` ,
                {$this->get_option_view()},
                             `{$this->get_db_table_name()}`.`{$this->get_parent_field()}`
                {$this->get_select()}
                        from `";
        $statment .= parent::get_db_table_name() . "` ";
        $statment .= $this->get_join();

        $statment .= " where 1=1 ";
        $statment .= $this->get_attach_conditions();
        if ($arr->id) {
            $statment .= " and {$this->get_db_table_name()}.{$this->get_option_value()} in ({$keys})
                          and {$this->get_db_table_name()}.{$this->get_option_value()} <> '{$arr->id}'";
        }
        $statment .= $this->get_group() . " ";
        $statment .= $this->get_order() . " ";

        $tree = new array_tree($this->get_db_table_name());
        $data_source = $tree
                ->set_index_id($this->get_parent_field())
                ->set_table_id($this->get_option_value())
                ->set_query($statment)
                ->debug($this->get_debug())
                ->load();

        foreach ($data_source as $key => $row) {
            $expandable = "false";
            $class = $classes[3];
            $last_child_class = $arr->last_child_class;
            if ($row['children']) {
                $expandable = "true";
                $class = $classes[1];
                $last_child_class = "";
            }
            $extend_link = null;
            if ($this->params['extend_link'])
                foreach ($this->params['extend_link'] as $key => $value) {
                    if ($row[$value]) {
                        $extend_link .= "&{$value}={$row[$value]}";
                    }
                }
            $action = "id='{$row[$this->get_option_value()]}' value='{$row[$this->get_option_value()]}'
                                                modify_link='{$row['__remote_page']}{$this->get_modify_link()}&{$this->get_option_value()}={$row[$this->get_option_value()]}{$extend_link}'
                                                delete_link='{$row['__remote_page']}{$this->get_delete_link()}&{$this->get_option_value()}={$row[$this->get_option_value()]}{$extend_link}'
                                                copy_link='{$row['__remote_page']}{$this->get_copy_link()}&{$this->get_option_value()}={$row[$this->get_option_value()]}{$extend_link}'
                                                print_link='{$row['__remote_page']}{$this->get_print_link()}&{$this->get_option_value()}={$row[$this->get_option_value()]}{$extend_link}'";
            $html .= "<li data='{{$this->get_parent_field()}:{$row[$this->get_option_value()]}}' id='{$row[$this->get_option_value()]}' expandable='{$expandable}'>
                        <div>
                        <i class='mdi {$class}'></i>
                        <a href='javascript:;'  class='control_href {$last_child_class}' {$action}>{$row[$this->get_alias_optoin_view()]}</a>"
                    . "</div>";
            if ($row['children']) {

                $html .= "<ul>";
                //parr($this->rec($row['children']));exit;
                $html .= $this->rec($row['children'], $classes, $arr->last_child_class);
                $html .= "</ul>";
            }
            $html .= "</li>";
        }

        $this->set_tree_result($html);
    }

    public function load() {
        if (!isset($_SERVER['HTTP_REFERER']))
            exit;
        if ($_POST['get_full_tree'] == 'true') {
            $this->get_full_tree();
        }
        $html = '<ul style="display:none">';
        /**
         * case the html is set from outside by user
         */
        if ($this->get_tree_result())
            return $html . $this->get_tree_result() . "</ul>";
        /**
         * get parents in array
         */
        $result = parent::get_result("select `{$this->get_db_table_name()}`.`{$this->get_option_value()}`
                                from `{$this->get_db_table_name()}`
                                {$this->get_join()}
                                inner join `{$this->get_db_table_name()}` as `sub`
                                on `{$this->get_db_table_name()}`.`{$this->get_db_table_name()}" . _id . "` = `sub`.`{$this->get_parent_field()}`
                                where 1=1
                                {$this->get_condition()}
                                {$this->get_sub_condition()}
                                group by `{$this->get_db_table_name()}`.`{$this->get_db_table_name()}" . _id . "`", parent::get_debug());
        $parents = array();
        while ($row = parent::next($result)) {
            $parents[] = $row[$this->get_option_value()];
        }

        $result = parent::get_result($this->get_query() . $this->get_order(), parent::get_debug());
        /**
         * normal case html
         */
        while ($row = parent::next($result)) {
            $expandable = "false";
            if (in_array($row[$this->get_option_value()], $parents))
                $expandable = "true";
            $extend_link = null;
            if ($this->params['extend_link'])
                foreach ($this->params['extend_link'] as $key => $value) {
                    if ($row[$value])
                        $extend_link .= "&{$value}={$row[$value]}";
                }
            $action = "id='{$row[$this->get_option_value()]}' value='{$row[$this->get_option_value()]}'
                                                modify_link='{$row['__remote_page']}{$this->get_modify_link()}&{$this->get_option_value()}={$row[$this->get_option_value()]}{$extend_link}'
                                                delete_link='{$row['__remote_page']}{$this->get_delete_link()}&{$this->get_option_value()}={$row[$this->get_option_value()]}{$extend_link}'
                                                copy_link='{$row['__remote_page']}{$this->get_copy_link()}&{$this->get_option_value()}={$row[$this->get_option_value()]}{$extend_link}'
                                                print_link='{$row['__remote_page']}{$this->get_print_link()}&{$this->get_option_value()}={$row[$this->get_option_value()]}{$extend_link}'";

            $html .= "<li data='{{$this->get_parent_field()}:{$row[$this->get_option_value()]}}' id='{$row[$this->get_option_value()]}' expandable='{$expandable}' >
                        <div><a href='javascript:;'  class='control_href' {$action}>{$row[$this->get_alias_optoin_view()]}</a></div>
                    </li>";
        }
        $html .= '</ul>';
        return $html;
    }

}

?>