<?php

/**
 * class check_exsitence , used to check if a record existed inside DB
 * inherited from sql
 * @author Ihab A. Ali <ihab@opentechcom.com>
 * @copyright copyright (c) copyright 2009 , Ihab A. Ali as a part of Opentechcom Development Team
 * @license GNU Public Licence (GPL)
 * @example  $html = new check_exsitence();
 */
class check_exsitence extends sql {

    private $db_table_name = null;
    private $sql_conditions = null;
    private $and_cols = array();
    private $or_cols = array();
    private $option_view = "";
    private $relation = array();
    /**
     * @var string  $db_table_name
     */
    private $debug = false;

    /**
     *
     * @param <type> $db_table_name
     * @param <type> $table_columns
     * @param <type> $sql_condition
     */
    public function __construct($db_table_name, $table_column=null, $sql_condition = null) {
        $this->set_db_table_name($db_table_name);
        if ($table_column)
            $this->add_and_col($table_column);
        if ($sql_condition)
            $this->add_sql_condition($sql_condition);
        parent::__construct();
    }

    /**
     *
     */
    public function __destruct() {
        parent::__destruct();
    }

    /**
     *
     * @param <type> $db_table_name
     */
    public function set_db_table_name($db_table_name) {
        $this->db_table_name = $db_table_name;
        return $this;
    }

    /**
     *
     * @return <type>
     */
    public function get_db_table_name() {
        return $this->db_table_name;
    }

    /**
     *
     * @param <type> $option_view
     */
    public function set_option_view($option_view) {
        $this->option_view = $option_view;
        return $this;
    }

    /**
     *
     * @return <type>
     */
    public function get_option_view() {
        return $this->option_view;
    }

    /**
     *
     * @param <type> $table_columns
     */
    public function add_and_col($table_columns) {
        array_push($this->and_cols, $table_columns);
        return $this;
    }

    public function get_and_col() {
        return $this->and_cols;
    }

    /**
     *
     * @param <type> $table_columns
     */
    public function add_or_col($table_columns) {
        array_push($this->or_cols, $table_columns);
        return $this;
    }

    /**
     *
     */
    public function get_or_col() {
        return $this->or_cols;
    }

    /**
     *
     * @param <type> $sql_condition
     */
    public function add_sql_condition($sql_condition) {
        $this->sql_conditions .= $sql_condition;
        return $this;
    }

    /**
     *
     */
    public function get_sql_condition() {
        return $this->sql_conditions;
    }

    /**
     *
     * @return <type>
     */
    public function check() {
        $statment = "select * from `" . $this->get_db_table_name() . "` where 1=1 ";
        //==
        foreach ($this->get_and_col() as $value)
            $statment .=" and `$value` = '" . $this->escape($GLOBALS['_' . $_SERVER['REQUEST_METHOD']][$value]) . "' ";
        $or_arr = array();

        //==
        foreach ($this->get_or_col() as $value)
            array_push($or_arr, " $value = '" . $this->escape($GLOBALS['_' . $_SERVER['REQUEST_METHOD']][$value]) . "'");
        if (count($or_arr) > 1)
            $statment_or = "and (" . implode(" or ", $or_arr) . ")";
        else
        if (count($or_arr) == 1)
            $statment_or = " or {$or_arr[0]} ";
        //==
        $statment .= $statment_or;
        $statment .= $this->get_sql_condition();
        $results = $this->get_result($statment, $this->get_debug());
        if ($results->num_rows > 0) {
            if (!$this->get_option_view())
                $this->set_option_view($this->get_db_table_name() . "_name");

            while ($row = $this->next($results)) {
                $this->relation[] = $row[$this->get_option_view()];
            }

            return true;
        }
        return false;
    }

    public function get_relation() {
        return implode(",", $this->relation);
    }

    /**
     * @access public
     * @param string $debug
     * @return none
     */
    public function debug($debug = true) {
        $this->debug = $debug;
        return $this;
    }

    /**
     * @access public
     * @return get_debug
     */
    public function get_debug() {
        return $this->debug;
    }

}

?>