<?php

class color_picker extends builder_input {

    public static $is_used = false;
    private $color_picker_width = null;
    private $show_defined_colors = false;

    public function __construct($name) {
        self::$is_used = true;
        parent::__construct();
        parent::set_name($name);
        parent::set_type("text");
//        parent::set_valid_msg(LANG_VALID);
        $this->set_width();
    }

    public static function get_js_css_head() {
        return "
            <link rel='stylesheet' href='" . theme_common_url_path . "/css/colorpicker.css?v=1.2' type='text/css' />
            <script type='text/javascript' src='" . theme_common_url_path . "/js/colorpicker.js?v=1.3'></script>
            ";
    }

    public function set_width($width = 180) {
        if (!is_numeric($width))
            $width = intval($width);
        $this->color_picker_width = $width;
        return $this;
    }

    public function show_defined_colors($show_defined_colors = true) {
        $this->show_defined_colors = $show_defined_colors;
        return $this;
    }

    public function load() {
        if (parent::get_disable()) {
            anti_inspection::push_disabled_elments(parent::get_name(), parent::get_value());
        }
        $this->set_readonly()
                ->add_css('float', DIR_ALIGN)
                ->add_css('text-align', DIR_ALIGN)
                ->add_css('direction', 'ltr')
                ->add_attr('show_defined_colors', $this->show_defined_colors);
        //subtract the width of the clear & color picker, the float div's
        $width = $this->color_picker_width - 25 - 25;
        parent::set_width($width . 'px')
                ->add_css('width', $width . 'px');
        //
        return'
                <div class="color_picker_main" style="width:' . ($this->color_picker_width + 4) . 'px;" >
                    ' . parent::load() . '
                    <div class="color_picker" style="float:' . DIR_ALIGN . ';background-color:' . $this->get_value() . ';"></div>
                    <div class="color_picker_clear" style="float:' . DIR_ALIGN . ';"></div>
                    <div style="clear:both;width:0px;height:0px;"></div>
                </div>';
    }

}

?>