<?php
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
*/

/**
 * Description of parser_ajax
 *
 * @author ihab
 */
class parser_ajax {
    private $params = array();
    public function  __construct() {
    }
    /**
     * The type of request to make ("POST" or "GET"),
     * default is "GET".
     * Note: Other HTTP request methods, such as PUT and DELETE, can also be used here,
     * but they are not supported by all browsers.
     * @param string $type
     * @return object $this
     */
    public function set_type($type=null) {
        $this->params['type'] =   json_encode($type);
        return $this;
    }
    /**
     * get Type
     */
    public function get_type() {
        return $this->params['type'];
    }
    /**
     * Default: Intelligent Guess (xml, json, script, or html)
     * The type of data that you're expecting back from the server.
     * If none is specified, $ will intelligently try to get the results,
     * based on the MIME type of the response (an XML MIME type will yield XML,
     * in 1.4 JSON will yield a JavaScript object, in 1.4 script will execute the script,
     * and anything else will be returned as a string).
     * The available types (and the result passed as the first argument to your success callback) are:
     * "xml": Returns a XML document that can be processed via $.
     * "html": Returns HTML as plain text; included script tags are evaluated when inserted in the DOM.
     * "script": Evaluates the response as JavaScript and returns it as plain text. Disables caching unless option "cache" is used. Note: This will turn POSTs into GETs for remote-domain requests.
     * "json": Evaluates the response as JSON and returns a JavaScript object. In $ 1.4 the JSON parsing is done in a strict manner, any malformed JSON is rejected and a parsererror is thrown.
     * "jsonp": Loads in a JSON block using JSONP. Will add an extra "?callback=?" to the end of your URL to specify the callback.
     * "text": A plain text string.
     * @param string $data_type
     * @return object $this
     */
    public function set_data_type($data_type=null) {
        $this->params['dataType'] =   json_encode($data_type);
        return $this;
    }
    /*
     * get dataType
    */
    public function get_data_type() {
        return $this->params['dataType'];
    }
    /**
     * Default: The current page
     * A string containing the URL to which the request is sent.
     * @param string $url
     * @return object $this
     */
    public function set_url($url=null) {
        $this->params['url'] =   json_encode($url);
        return $this;
    }
    /**
     *
     * @return $url
     */
    public function get_url() {
        return $this->params['url'];
    }
    /**
     * Default: true
     * By default, all requests are sent asynchronous (i.e. this is set to true by default).
     * If you need synchronous requests, set this option to false.
     * Note that synchronous requests may temporarily lock the browser,
     * disabling any actions while the request is active.
     * @param bool $async
     * @return object $this
     */
    public function set_async($async=true) {
        $this->params['async'] =   json_encode($async);
        return $this;
    }
    /**
     *
     * @return async
     */
    public function get_async() {
        return $this->params['async'];
    }
    /**
     * Default: true, false for dataType 'script' and 'json'
     * If set to false it will force the pages that you request to not be cached by the browser.
     * @param bool $cache
     * @return $this
     */
    public function set_cache($cache=true) {
        $this->params['cache'] =   json_encode($cache);
        return $this;
    }
    /**
     *
     * @return cache
     */
    public function get_cache() {
        return $this->params['cache'];
    }
    /**
     * script Charset String
     * Only for requests with "jsonp" or "script" dataType and "GET" type.
     * Forces the request to be interpreted as a certain charset. Only needed for charset differences between the remote and local content.
     */
    public function set_script_charset($script_charset=null) {
        $this->params['scriptCharset'] =   json_encode($script_charset);
        return $this;
    }
    /**
     *
     * @return script_charset
     */
    public function get_script_charset() {
        return $this->params['scriptCharset'];
    }
    /**
     * ifModified Boolean
     * Default: false
     * Allow the request to be successful only if the response has changed since the last request.
     * This is done by checking the Last-Modified header. Default value is false,
     * ignoring the header. In $ 1.4 this technique also checks the 'etag' specified by the server to catch unmodified data.
     * @param bool $if_modified
     * @return object $this
     */
    public function set_if_modified($if_modified=null) {
        $this->params['ifModified'] =  json_encode($if_modified);
        return $this;
    }
    /**
     *
     * @return ifModified
     */
    public function get_if_modified() {
        return $this->params['ifModified'];
    }
    /**
     * processData Boolean
     * Default: true
     * By default, data passed in to the data option as an object (technically, anything other than a string)
     * will be processed and transformed into a query string,
     * fitting to the default content-type "application/x-www-form-urlencoded". If you want to send a DOMDocument, or other non-processed data, set this option to false.
     * @param bool  $process_data
     * @return $this
     */
    public function set_process_data($process_data=null) {
        $this->params['processData'] =   json_encode($process_data);
        return $this;
    }
    /**
     *
     * @return processData
     */
    public function get_process_data() {
        return $this->params['processData'];
    }
    /**
     * timeout Number
     * Set a local timeout (in milliseconds) for the request.
     * This will override the global timeout, if one is set via $.ajaxSetup.
     * For example, you could use this property to give a single request a longer timeout than all other requests
     * that you've set to time out in one second.
     * See $.ajaxSetup() for global timeouts.
     * @param number $timeout
     * @return $this
     */
    public function set_timeout($timeout=null) {
        $this->params['timeout'] =   $timeout;
        return $this;
    }
    /**
     *
     * @return timeout
     */
    public function get_timeout() {
        return $this->params['timeout'];
    }
    /**
     * global Boolean
     * Default: true
     * Whether to trigger global Ajax event handlers for this request.
     * The default is true.
     * Set to false to prevent the global handlers like ajaxStart or ajaxStop from being triggered.
     * This can be used to control various Ajax Events.
     * @param Boolean $global
     * @return $this
     */
    public function set_global($global=null) {
        $this->params['global'] =   json_encode($global);
        return $this;
    }
    /**
     *
     * @return bool global
     */
    public function get_global() {
        return $this->params['global'];
    }
    /**
     * traditional Boolean
     * Set this to true if you wish to use the traditional style of param serialization.
     * @param bool $traditional
     * @return $this
     */
    public function set_traditional($traditional=null) {
        $this->params['traditional'] =   json_encode($traditional);
        return $this;
    }
    /**
     * @return $this
     */
    public function get_traditional() {
        return $this->params['traditional'];
    }
    /**
     * contentType String
     * Default: 'application/x-www-form-urlencoded'
     * When sending data to the server, use this content-type.
     * Default is "application/x-www-form-urlencoded", which is fine for most cases.
     * If you explicitly pass in a content-type to $.ajax() then it'll always be sent to the server (even if no data is sent).
     * @param string $content_type
     * @return $this
     */
    public function set_content_type($content_type=null) {
        $this->params['contentType'] =   json_encode($content_type);
        return $this;
    }
    /**
     * @return $contentType
     */
    public function get_content_type() {
        return $this->params['contentType'];
    }
    /**
     * context Object
     * This object will be made the context of all Ajax-related callbacks.
     * For example specifying a DOM element as the context will make that the context for the complete callback of a request, like so:
     * $.ajax({ url: "test.html", context: document.body, success: function(){
     $(this).addClass("done");
     }});
     * @param string $context
     * @return $this
     */
    public function set_context($context=null) {
        $this->params['context'] =   $context;
        return $this;
    }
    /**
     * return $context
     */
    public function get_context() {
        return $this->params['context'];
    }
    /**
     * beforeSend(XMLHttpRequest)Function
     * A pre-callback to modify the XMLHttpRequest object before it is sent. Use this to set custom headers etc.
     * The XMLHttpRequest is passed as the only argument. This is an Ajax Event. You may return false in function to cancel the request.
     * @param string $before_send
     * @return $this
     */
    public function set_before_send($before_send=null) {
        $this->params['beforeSend'] =   $before_send;
        return $this;
    }
    /**
     * @return $beforeSend
     */
    public function get_before_send() {
        return $this->params['beforeSend'];
    }
    /**
     *success(data, textStatus, XMLHttpRequest) Function
     * A function to be called if the request succeeds.
     * The function gets passed three arguments: The data returned from the server, formatted according to the 'dataType' parameter;
     * a string describing the status; and the XMLHttpRequest object (available as of $ 1.4). This is an Ajax Event.
     * @param string $success
     * @return $this
     */
    public function set_success($success=null) {
        $this->params['success'] =   $success;
        return $this;
    }
    /**
     *
     * @return Success function js code
     */
    public function get_success() {
        return $this->params['success'];
    }
    /**
     * complete(XMLHttpRequest, textStatus) Function
     * A function to be called when the request finishes (after success and error callbacks are executed).
     * The function gets passed two arguments: The XMLHttpRequest object and a string describing the status of the request.
     * This is an Ajax Event.
     * @param bool $complete
     * @return $this
     */
    public function set_complete($complete=null) {
        $this->params['complete'] =  $complete;
        return $this;
    }
    /**
     *
     * @return $complete
     */
    public function get_complete() {
        return $this->params['complete'];
    }
    /**
     * error(XMLHttpRequest, textStatus, errorThrown) Function
     * A function to be called if the request fails.
     * The function is passed three arguments: The XMLHttpRequest object,
     * a string describing the type of error that occurred and an optional exception object,
     * if one occurred.
     * Possible values for the second argument (besides null) are "timeout", "error", "notmodified" and "parsererror".
     * This is an Ajax Event.
     * @param bool $error
     * @return $this
     */
    public function set_error($error=null) {
        $this->params['error'] =   $error;
        return $this;
    }
    /**
     *
     * @return error function js code
     */
    public function get_error() {
        return $this->params['error'];
    }
    /**
     * Data to be sent to the server.
     * It is converted to a query string, if not already a string.
     * It's appended to the url for GET-requests.
     * See processData option to prevent this automatic processing.
     * Object must be Key/Value pairs. If value is an Array,
     * $ serializes multiple values with same key
     * i.e. {foo:["bar1", "bar2"]} becomes '&foo=bar1&foo=bar2'(not supported yet in this php class).
     * @param string $key
     * @param string $value
     */
    public function add_data($key,$value,$is_js=false) {

        $arr['key'] =   $key;
        $arr['value'] =   $value;

        if($is_js)
            $arr['type'] =   'object';
        else
            $arr['type'] =   'string';
        $this->params['data'][$key] = $arr;
        return $this;
    }
    public  function get_data() {
        return $this->params['data'];
    }
    /**
     * load ajax script
     */
    public function load() {
        $data_query = array();
        foreach($this->params['data'] as $key=>$value) {
            if($value['type'] == 'string')
                $data_query[] =  "{$value['key']}={$value['value']}";
            else
                $data_query[] = "{$value['key']}='+{$value['value']}+'";
        }
        $data_query = "'".implode("&",$data_query)."'";
        $this->params['data'] = $data_query;
        $js= " $.ajax({";
        
        $this->params['beforeSend'] ="function(XMLHttpRequest){
                                            $('input:submit,input:button').attr('disabled','disabled');
                                            $('input:submit,input:button').each(function(){
                                                mabvalid.set_valid(this);
                                            })
                {$this->params['beforeSend']}
                                        }";

        $this->params['success'] ="function(result, textStatus, XMLHttpRequest){
                {$this->params['success']}
                                        }";

        $this->params['complete'] ="function(XMLHttpRequest, textStatus){
                                            $('input:submit,input:button').not('input[sys_disabled=\"disabled\"]').removeAttr('disabled');
                                            $('input:submit,input:button').each(function(){
                                                mabvalid.set_valid(this);
                                            })
                {$this->params['complete']}
                                        }";

        $this->params['error'] ="function(XMLHttpRequest, textStatus, errorThrown){       
                                            alert(errorThrown);
                                            load_message('error','".LANG_ERROR_CONNECTION_LOST."');
                {$this->params['error']}
                                        }";
        foreach ($this->params as $key=>$value)
            $ajax_params[]="{$key}:{$value}";

        $js.= implode(",", $ajax_params);
        $js.= "})";
        return $js;
    }

}
?>