<?php

/**
 * last update Sat Jul 10,2010
 * select combo class . use this class build combo class
 * inherited from sql_class
 */
class combo extends data_source {

    /**
     *
     * @var int width
     */
    private $width = 280;

    /**
     *
     * @var int width
     */
    private $list_width = null;

    /**
     *
     * @var extra_optns
     */
    private $extra_optns = array();

    /**
     * @access private
     * @var string container
     * in case of combo we need a div container
     */
    private $container = null;

    /**
     *
     * @var $readonly
     */
    private $readonly = false;

    /**
     * @access private
     * @var int options_height
     */
    private $options_height = null;

    /**
     *
     * @var string
     * for ajax call
     */
    private $ajax_url = null;

    /**
     *
     * @var string
     * for filtering purpose
     */
    private $ajax_mask = null;

    /**
     *
     * @var int
     * to set how many field to display
     */
    private $ajax_limit = 60;

    /**
     *
     * @var string
     * to set ajax data source
     */
    private $ajax_data_source = null;

    /**
     *
     * @var ajax_data_source
     * to set ajax_js_condition
     */
    private $ajax_js_condition = null;

    /**
     *
     * @var string
     * to ajax_condition
     */
    private $ajax_condition = array();

    /**
     *
     * @var string
     * to set ajax data source
     */
    private $ajax_sign_condition = array();

    /**
     *
     * @var string
     * to set ajax data source
     */
    private $ajax_advance_filter = false;

    /**
     *
     * @var array
     * to add event
     */
    private $event = array();

    /**
     *
     * @var type 
     */
    private $data_field = array();

    /**
     * 
     * @param type $name
     * @param type $option_view
     * @param type $option_value
     * @param type $sql_obj here if we want from the data source to use not new sql object but our sql object
     */
    public function __construct($name, $option_view = null, $option_value = null, $sql_obj = null) {
        parent::__construct($option_view, $option_value, $sql_obj);
        parent::set_name($name)->set_placeholder('');
//        parent::set_valid_msg(LANG_VALID);
        $this->set_container();
    }

    /**
     * 
     * @param type $name
     * @param type $change_id
     * @return \combo
     */
    public function set_name($name, $change_id = true) {
        parent::set_name($name, $change_id);
        $this->set_container();
        return $this;
    }

    /**
     * set the width of the combo
     * @access public
     * @param string $width
     */
    public function set_width($width = null) {
        $this->width = $width;
        return $this;
    }

    /**
     * @access public
     * @return string $width
     */
    public function get_width() {
        return $this->width;
    }

    /**
     * set the list_width of the combo
     * @access public
     * @param string $list_width
     */
    public function set_list_width($list_width = null) {
        $this->list_width = $list_width;
        return $this;
    }

    /**
     * @access public
     * @return string $list_width
     */
    public function get_list_width() {
        return $this->list_width;
    }

    /**
     * set the popup_link
     * @access public
     * @param string $popup_link
     */
    public function set_popup_link($popup_link = null, $authenticate_link = true) {
        //here he can send to $authenticate_link different then the $popup_link so we check if it is string..
        $href_check_link = explode("?", is_string($authenticate_link) ? $authenticate_link : $popup_link);
        if ($popup_link && ($authenticate_link === false || authentication::check_authentication($href_check_link[0])))
            $this->extra_optns['popup_link'] = $popup_link;
        else
            $popup_link = null;
        //
        if (!$popup_link)
            unset($this->extra_optns['popup_link']);
        return $this;
    }

    /**
     * @access public
     * @return string $popup_link
     */
    public function get_popup_link() {
        return $this->extra_optns['popup_link'];
    }

    /**
     * set the container of the combo
     * @access public
     * @param string $container
     */
    public function set_container($container = null) {
        if (!$container)
            $container = parent::get_name() . '_container';
        $this->container = $container;
        return $this;
    }

    /**
     * @access public
     * @return string $container
     */
    public function get_container() {
        return $this->container;
    }

    /**
     * 
     * @param type $field
     * @return \combo
     */
    public function set_data_field($arr) {
        if (!is_array($arr))
            $arr = array($arr);
        $this->data_field = $arr;
        $this->is_data_field = true;
        return $this;
    }

    /**
     * @access public
     * @return string $event
     */
    public function get_data_field() {
        return $this->data_field;
    }

    /**
     * add event for js case
     * usually used to call events
     * @access public
     * @param string $event,$function
     */
    public function add_event($event, $function) {
        $this->event[$event] = parent::get_name() . ".attachEvent('{$event}',function(){{$function}});";
        return $this;
    }

    /**
     * @access public
     * @return string $event
     */
    public function get_event($event = null) {
        if ($event)
            return $this->event[$event];
        return $this->event;
    }

    public function set_onchange($function) {
        $this->add_event('onChange', $function);
        return $this;
    }

    /**
     * @access public
     * @return string $combo_onchange
     */
    public function get_onchange() {
        return $this->get_event('onChange');
    }

    /**
     * @access public
     * @return string $combo_onKeyPressed
     */
    public function set_onKeyPressed($function) {
        $this->add_event('onKeyPressed', $function);
        return $this;
    }

    /**
     * @access public
     * @return string $combo_onKeyPressed
     */
    public function get_onKeyPressed() {
        return $this->get_event('onKeyPressed');
    }

    /**
     * @access public
     * @return string $combo_onBlur
     */
    public function set_onBlur($function) {
        $this->add_event('onBlur', $function);
        return $this;
    }

    /**
     * @access public
     * @return string $combo_onBlur
     */
    public function get_onBlur() {
        return $this->get_event('onBlur');
    }

    /**
     * @access public
     * @return string $combo_onSelectionChange
     */
    public function set_onSelectionChange($function) {
        $this->add_event('onSelectionChange', $function);
        return $this;
    }

    /**
     * @access public
     * @return string $combo_onSelectionChange
     */
    public function get_onSelectionChange() {
        return $this->get_event('onSelectionChange');
    }

    /**
     * @access public
     * @return string $combo_onOpen
     */
    public function set_onOpen($function) {
        $this->add_event('onOpen', $function);
        return $this;
    }
    /**
     * @access public
     * @return string $combo_onOpen
     */
    public function get_onOpen() {
        return $this->get_event('onOpen');
    }

    public function set_readonly($readonly = true) {
        $this->readonly = $readonly;
        return $this;
    }
    /**
     * @access public
     * @return string $combo_oblur
     */
    public function get_readonly() {
        return $this->readonly;
    }

    /**
     * @access public
     * @param int $options_height
     */
    public function set_options_height($options_height = 200) {
        $this->options_height = $options_height;
        return $this;
    }
    /**
     * @access public
     * @return int $options_height
     */
    public function get_options_height() {
        return $this->options_height;
    }

    /**
     * @access public
     * @param string $value
     */
    public function set_value($value = null, $view = null) {
        if ($view)
            parent::add_attr('view', $view);
        parent::set_value($value);
        return $this;
    }

    /**
     * @access public
     */
    public function get_view() {
        return parent::get_attr("view");
    }

    /**
     * @access private
     * @return array $options
     */
    public function get_options($filter = null, $advance_filter = false) {
        if (parent::get_data_set()) {
            $fields = $this->get_data_field();
            $ptrn = "(?=[^<>]*(?:<|$))";
            $field_option = "";
            $options .= '.addOption([';
            foreach (parent::get_data_set() as $value => $data) {
                $view = ($fields) ? $data[$this->get_option_view()] : $data;
                if ($filter) {
                    if ($advance_filter) {
                        foreach ($filter as $key => $val) {
                            if ($val) {
                                $val = preg_replace("/[\\/]/", "\\/", $val);
                                $view = preg_replace("/({$val}){$ptrn}/si", "<mark>$1</mark>", $view);
                            }
                        }
                    } else {
                        $filter = preg_replace("/[\\/]/", "\\/", $filter);
                        $view = preg_replace("/({$filter}){$ptrn}/si", "<mark>$1</mark>", $view);
                    }
                }
                $view = '"' . $this->fix_value($view) . '"';
                $value = '"' . $this->fix_value($value) . '"';
                $options .= '[' . $value . ',' . $view . '],';
                if ($fields) {
                    $_opt = "";
                    foreach ($fields as $field)
                        $_opt .= $field . ":'" . $this->fix_value($data[$field]) . "',";
                    $_opt = substr($_opt, 0, -1);
                    $field_option .= "{$value}:{{$_opt}},";
                }
            }

            $options = substr($options, 0, -1) . "])";
            if ($field_option)
                $options .= ".setDataField({" . substr($field_option, 0, -1) . "})";
            $options .= ";";
            return $options;
        }
    }

    /**
     * @access public
     * @param string $combo
     */
    public function load() {
        if (parent::get_disable()) {
            anti_inspection::push_disabled_elments(parent::get_name(), parent::get_value(),"combo");
        }
        $span = $this->get_required_span();
        $title = null;
        if (parent::get_title())
            $title = "title='" . parent::get_title() . "'";
        $combo = '<div ' . $title . ' id="' . $this->get_container() . '" style="direction:' . dir . ';" ></div>' . $span;
        $combo .= '<script type="text/javascript">';
        $combo .= parent::get_name() . ' = new dhtmlXCombo("' . $this->get_container() . '","' . parent::get_name() . '",' . $this->get_width() . ');';
        $combo .= parent::get_name() . '.enableFilteringMode(true,"' . $this->get_ajax_url() . '");';
        if (parent::get_valid())
            $combo .= parent::get_name() . '.valid("' . parent::get_valid() . '");';
        if (parent::get_title())
            $combo .= parent::get_name() . '.setComboTitle("' . parent::get_title() . '");';
        if (parent::get_placeholder())
            $combo .= parent::get_name() . '.setPlaceholder("' . parent::get_placeholder() . '");';
        if ($this->get_options_height())
            $combo .= parent::get_name() . '.setOptionHeight(' . $this->get_options_height() . ');';
        if (parent::get_disable())
            $combo .= parent::get_name() . '.disable(' . $this->get_disable() . ');';

        $combo .= '$(document).ready(function(){';
        if ($this->get_event())
            foreach ($this->get_event() as $key => $event)
                $combo .= $event;
        $combo .= $this->get_ajax_js_condition();
        $combo .= '});';
        $combo .= parent::get_name() . '.clearAll();';
        if ($this->get_options())
            $combo .= parent::get_name() . $this->get_options() . ';';
        if ($this->get_readonly())
            $combo .= parent::get_name() . '.readonly();';
        if ($this->get_list_width())
            $combo .= parent::get_name() . '.setListWidth(' . $this->get_list_width() . ');';
        if (is_array($this->extra_optns) && count($this->extra_optns))
            $combo .= parent::get_name() . '.setExtraOptions(' . json_encode($this->extra_optns) . ');';
        if ($this->get_view())
            $combo .= $this->get_name() . '.setComboValueText("' . parent::get_value() . '","' . $this->get_view() . '");';
        else {
            $tmp_val = htmlspecialchars_decode(parent::get_value());    //we make this since in set_value we make htmlspecialchars so to compare good..
            if (/* $tmp_val && we stop it as maybe it is zero and we want it */array_key_exists($tmp_val, parent::get_data_set()))
                $combo .= $this->get_name() . '.setComboValue("' . parent::get_value() . '",false);';
        }
        if (parent::get_debug())
            $combo .= $this->get_name() . '.debug=true;';
        $combo .= '</script>';
        return $combo;
    }

    /**
     * ajax data set
     */
    public function set_ajax_url($ajax_url) {
        $this->ajax_url = $ajax_url;
        return $this;
    }

    public function get_ajax_url() {
        return $this->ajax_url;
    }

    public function set_ajax_mask($ajax_mask) {
        $this->ajax_mask = $ajax_mask;
        return $this;
    }

    public function get_ajax_mask() {
        return $this->ajax_mask;
    }

    public function set_ajax_limit($ajax_limit = 60) {
        $this->ajax_limit = $ajax_limit;
        return $this;
    }

    public function get_ajax_limit() {
        return $this->ajax_limit;
    }

    public function set_ajax_data_source($ajax_data_source) {
        $this->ajax_data_source = $ajax_data_source;
        return $this;
    }

    public function set_ajax_advance_filter($ajax_advance_filter = true) {
        $this->ajax_advance_filter = $ajax_advance_filter;
        return $this;
    }

    public function get_ajax_advance_filter() {
        return $this->ajax_advance_filter;
    }

    public function get_ajax_data_source() {
        if (!$this->ajax_data_source && parent::get_source_type() == 'query')
            return parent::get_source_var();

        return $this->ajax_data_source;
    }

    public function add_ajax_condition($key, $value, $alias = null, $sign = '=', $requery = true) {
        $this->ajax_js_condition .= parent::get_name() . ".addCondition('" . addslashes($key) . "','" . addslashes($value) . "');";
        if (!$alias)
            $alias = $key;
        if ($requery) {
            $this->ajax_condition[$key] = $alias;
            $this->ajax_sign_condition[$key] = $sign;
        }
        return $this;
    }

    public function get_ajax_js_condition() {
        return $this->ajax_js_condition;
    }

    public function get_ajax_condition() {
        return $this->ajax_condition;
    }

    public function get_ajax_filter() {
        return $this->get_name() . '_mask';
    }

    public function load_ajax() {
        ####varaible to filter by
        if (!$this->get_ajax_mask())
            $this->set_ajax_mask(parent::get_option_view());
        ####mask condition
        $mask = $_GET[$this->get_ajax_filter()];
        if ($this->get_ajax_advance_filter()) {
            $mask = explode(" ", $_GET[$this->get_ajax_filter()]);
            $_GET[$this->get_ajax_filter()] = implode("%", $mask);
        }


        $filter_statment = preg_replace("/<([^>]+)>/", "", $this->get_ajax_mask()) . " like '%{$this->fix_value($_GET[$this->get_ajax_filter()])}%' ";
        ####ajax condition
        if ($this->get_ajax_condition()) {
            foreach ($this->get_ajax_condition() as $key => $value) {
                $_GET[$key] = $this->fix_value($_GET[$key]);
                $sign = strtoupper($this->ajax_sign_condition[$key]);
                switch ($sign) {
                    case "LIKE" :
                    case "NOT LIKE": $filter_statment .= " and  {$value} {$sign} '%{$_GET[$key]}%' ";
                        break;
                    case "IN" :
                    case "NOT IN" :$filter_statment .= " and  {$value} {$sign} ({$_GET[$key]}) ";
                        break;
                    case "NULL":$filter_statment .= " and  isNULL({$value}) ";
                        break;
                    case "NOT NULL":$filter_statment .= " and  !isNULL({$value}) ";
                        break;
                    default:$filter_statment .= " and  {$value} {$sign} '{$_GET[$key]}'";
                }
            }
        }
        ####statment condition
        $statment = $this->get_ajax_data_source();
        if (is_string($statment)) {

            $statment_sql = preg_split("/where /i", $statment, 2);
            $statment_select = $statment_sql[0];
            $statment_cond = $statment_sql[1];
            if ($statment_cond)
                $statment = "{$statment_select} where {$filter_statment} and {$statment_cond}";
            else {
                $sql_elements = preg_match_all("/group by |having |order by /", $statment, $matches);
                if ($matches[0][0])
                    $statment = str_replace($matches[0][0], " where {$filter_statment} {$matches[0][0]}", $statment);
                else
                    $statment .= " where {$filter_statment}";
            }
            $statment .= " limit 0,{$this->get_ajax_limit()}";
            $this->set_data_source($statment, 'query');
            if (parent::get_debug())
                echo $statment;
            echo $this->get_options($mask, $this->get_ajax_advance_filter());
        }
    }

    /**
     * @access private
     * @param string $value
     * @return sting $value after replace
     */
    private function fix_value($value) {
        return parent::get_sql()->escape($value);
    }

}

?>