<?php

/**
 * form class .
 * extends builder_message class to create form and its messages
 * @author Ihab A. Ali 
 * @copyright copyright (c)
 * @license GNU Public Licence (GPL)
 * @example  $form = new form();
 */
class form extends builder_message {

    /**
     * specify the height
     * @access private
     * @var int height
     */
    private $height = null;

    /**
     * specify if it is inside an iframe
     * @access private
     * @var bool is_framed
     */
    private $is_framed = true;

    /**
     * to create any new attribute
     * element attr
     * @access private
     * @var array attr
     */
    private $attr = array();

    /**
     * element validation
     * @access private
     * @var string valid
     */
    private $valid = true;

    /**
     * direction
     * @access private
     * @var string $dir
     */
    private $dir = 'ltr';

    /**
     * revers align
     * @access private
     * @var string ralign
     */
    private $text_ralign = 'right';

    /**
     * default align
     * @access private
     * @var string $text_align
     */
    private $text_align = 'left';

    /**
     * used to set the inside html
     * @access private
     * @var string $html
     */
    private $html = null;

    /**
     * set Buttons inside variable
     * @var string $buttons
     */
    private $buttons = null;

    /**
     *
     * @var string scripts
     */
    private $ready_script = array();

    /**
     *
     * @var string scripts
     */
    private $script = array();

    /**
     * class __construct
     * @access public
     */
    public function __construct() {
        if (dir) {
            $this->set_dir(dir);
        }
        $this->set_action(self)
                ->set_method('POST')
                ->set_name('form1');
    }

    /**
     *
     * @param string $height
     */
    public function set_height($height = null) {
        $this->height = $height;
        return $this;
    }

    /**
     *
     * @return string $height
     */
    public function get_height() {
        return $this->height;
    }

    /**
     *
     * @param string $html
     */
    public function set_is_framed($is_framed = true) {
        $this->is_framed = $is_framed;
        return $this;
    }

    /**
     *
     * @return string $is_framed
     */
    public function get_is_framed() {
        return $this->is_framed;
    }

    /**
     * @access public
     * @param string $name
     */
    public function set_name($name) {
        $this->attr['name'] = $name;
        if (!$this->id) {
            $this->attr['id'] = $this->get_name();
        }
        return $this;
    }

    /**
     * @access public
     * @return string $name
     */
    public function get_name() {
        return $this->attr['name'];
    }

    /**
     * @access public
     * @param string $id
     */
    public function set_id($id) {
        $this->attr['id'] = $id;
        return $this;
    }

    /**
     * @access public
     * @return string $id
     */
    public function get_id() {
        return $this->attr['id'];
    }

    /**
     * @access public
     * @param string $valid
     */
    public function set_valid($valid = true) {
        $this->valid = $valid;
        return $this;
    }

    /**
     * @access public
     * @return string $valid
     */
    public function get_valid() {
        if ($this->valid)
            return true;

        return false;
    }

    /**
     * @access public
     * @param string $action
     */
    public function set_action($action) {
        $this->add_attr('action', $action);
        return $this;
    }

    /**
     *
     * @return string $action
     */
    public function get_action() {
        return $this->attr['action'];
    }

    /**
     *
     * @param string $method
     */
    public function set_method($method) {
        $this->add_attr('method', $method);
        return $this;
    }

    /**
     *
     * @return string $method
     */
    public function get_method() {
        return $this->attr['method'];
    }

    /**
     * 
     */
    public function add_class($class) {
        $this->attr['class'] .= $class . " ";
        return $this;
    }

    /**
     * add attributes
     * @access public
     * @param string $key
     * @param string $value
     */
    public function add_attr($key, $value) {
        $this->attr[$key] = $value;
        return $this;
    }

    /**
     * get attributes
     * @access public
     * @return string $attributes
     */
    private function get_attr() {
        foreach ($this->attr as $key => $value) {
            $attributes .= $key . '="' . $value . '" ';
        }
        return $attributes;
    }

    /**
     * @access public
     * @param bool $bool
     */
    public function disable_context_menu($bool = true) {
        if ($bool)
            $this->add_script('document.oncontextmenu=new Function("return false");');
        return $this;
    }

    /**
     * set dir
     * @access public
     * @param string $dir
     */
    public function set_dir($dir = 'ltr') {
        $this->dir = $dir;
        switch ($dir) {
            case 'rtl':
                $this->text_align = 'right';
                $this->text_ralign = 'left';
                break;
            default:
                $this->text_align = 'left';
                $this->text_ralign = 'right';
        }
        return $this;
    }

    /**
     * @access public
     * @return string dir
     */
    public function get_dir() {
        return $this->dir;
    }

    /**
     * @access public
     * @return string text_ralign
     */
    public function get_text_ralign() {
        return $this->text_ralign;
    }

    /**
     * @access public
     * @return string $text_align
     */
    public function get_text_align() {
        return $this->text_align;
    }

    /**
     * @param string $add_script
     */
    public function add_script($script = null) {
        array_push($this->script, $script);
        return $this;
    }

    /**
     *
     * @return string $script
     */
    public function get_script() {

        return implode("\n", $this->script);
    }

    /**
     * @param string $add_ready_script
     */
    public function add_ready_script($ready_script = null) {
        array_push($this->ready_script, $ready_script);
        return $this;
    }

    /**
     *
     * @return string $ready_script
     */
    public function get_ready_script() {
        return implode("\n", $this->ready_script);
    }

    /**
     *
     * @param string $html
     */
    public function set_html($html = null) {
        $this->html = $html;
        return $this;
    }

    /**
     *
     * @return string $html
     */
    public function get_html() {
        return $this->html;
    }

    /**
     *
     * @param string $buttons
     */
    public function set_buttons($buttons = null) {
        $this->buttons = $buttons;
        return $this;
    }

    /**
     *
     * @return string $buttons
     */
    public function get_buttons() {
        return $this->buttons;
    }

    /**
     * function load_iframe_html
     * loads the html code for a form inside an iframe
     */
    public function load() {
        $ccache="";
        if(force_overide_cache == "1"){
            $ccache="?time=".time();
        }
        if ($this->get_valid()) {
            $this->add_class('valid');
        }
        $this->add_attr("enctype", "multipart/form-data");
        if ($this->get_is_framed()):
            ?>
            <!DOCTYPE html>
            <html>
                <head>
                    <title></title>
                    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
                    <meta name="viewport" content="initial-scale=1,maximum-scale=1,user-scalable=no" />
                    <link href="<?= theme_common_url_path ?>css/roboto.css?family=Roboto:300,500,700&display=swap" rel="stylesheet">
                    <link href="<?= theme_common_url_path ?>css/mdi.min.css<?=$ccache?>" rel="stylesheet">
                    <link href="<?= theme_common_url_path ?>css/mdil.min.css<?=$ccache?>" rel="stylesheet">
                    <link rel="stylesheet" href="<?= theme_common_url_path ?>css/grid.css<?=$ccache?>" type="text/css" />
                    <link rel="stylesheet" href="<?= theme_common_url_path ?>css/message.css<?=$ccache?>"/>
                    <link rel="stylesheet" href="<?= theme_common_url_path ?>css/tab_inner.css<?=$ccache?>" type="text/css" />
                    <link rel="stylesheet" href="<?= theme_common_url_path ?>css/context_menu.css<?=$ccache?>" />
                    <link rel="stylesheet" href="<?= theme_common_url_path ?>css/datepicker.css<?=$ccache?>" type="text/css" />
                    <link rel="stylesheet" href="<?= theme_common_url_path ?>css/template.css<?=$ccache?>" type="text/css" />
                    <link rel="stylesheet" href="<?= theme_common_url_path ?>css/controls.css<?=$ccache?>" type="text/css" />
                    <link rel="stylesheet" href="<?= plugins_url_path ?>/combo/dhtmlxcombo.css<?=$ccache?>">
                    <link href="<?= theme_common_url_path ?>css/jquery.tipsy.css<?=$ccache?>" rel="stylesheet">            
                    <link href="<?= theme_common_url_path ?>css/notiflix-2.1.2.min.css<?=$ccache?>" rel="stylesheet">
                    <?php include theme_common_physical_path.'definesjs.php';?>                    
                    <script src="<?= theme_common_url_path ?>js/notiflix-2.1.2.min.js<?=$ccache?>"></script>                
                    <script type="text/javascript" src="<?= theme_common_url_path ?>js/jquery.min.js<?=$ccache?>"></script>                
                    <script type="text/javascript" src="<?= theme_common_url_path ?>js/validate.js<?=$ccache?>"></script>
                    <script type="text/javascript" src="<?= theme_common_url_path ?>js/multilist.js<?=$ccache?>"></script>
                    <script type="text/javascript" src="<?= theme_common_url_path ?>js/filterlist.js<?=$ccache?>"></script>
                    <script type="text/javascript" src="<?= theme_common_url_path ?>js/jquery.cookie.js<?=$ccache?>"></script>
                    <script type="text/javascript" src="<?= theme_common_url_path ?>js/datepicker.js<?=$ccache?>"></script>
                    <script type="text/javascript" src="<?= theme_common_url_path ?>js/message.js<?=$ccache?>"></script>                                        
                    <script type="text/javascript" src="<?= theme_common_url_path ?>js/jquery_ext.js<?=$ccache?>"></script>
                    <script type="text/javascript" src="<?= theme_common_url_path ?>js/tab.js<?=$ccache?>"></script>
                    <script type="text/javascript" src="<?= theme_common_url_path ?>js/grid.js<?=$ccache?>"></script>
                    <script type="text/javascript" src="<?= theme_common_url_path ?>js/new_window.js<?=$ccache?>"></script>
                    <script type="text/javascript" src="<?= theme_common_url_path ?>js/jquery.json-2.2.min.js<?=$ccache?>"></script>
                    <script type="text/javascript" src="<?= theme_common_url_path ?>js/jquery.metadata.min.js<?=$ccache?>"></script>
                    <script type="text/javascript" src="<?= theme_common_url_path ?>js/jquery.rightClick.js<?=$ccache?>"></script>
                    <script type="text/javascript" src="<?= theme_common_url_path ?>js/money_format.js<?=$ccache?>"></script>
                    <script type="text/javascript" src="<?= theme_common_url_path ?>js/context_menu.js<?=$ccache?>"></script>
                    <script type="text/javascript" src="<?= theme_common_url_path ?>js/jquery.calculation.js<?=$ccache?>"></script>
                    <script type="text/javascript" src="<?= theme_common_url_path ?>js/jquery.hotkeys.js<?=$ccache?>"></script>
                    <script type="text/javascript" src="<?= plugins_url_path ?>/combo/dhtmlxcombo.js<?=$ccache?>"></script>                      
                    <script type="text/javascript" src="<?= theme_common_url_path ?>js/keybord.shortcuts.js<?=$ccache?>"></script>
                    <script type="text/javascript" src="<?= theme_common_url_path ?>js/jquery.tipsy.js<?=$ccache?>"></script>                
                    <script type="text/javascript" src="<?= theme_common_url_path ?>js/template.js<?=$ccache?>"></script>
                    <script type="text/javascript" src="<?= theme_common_url_path ?>js/octacheckbox.js<?=$ccache?>"></script>
                    <script type="text/javascript" src="<?= theme_common_url_path ?>js/fullscreen.api.js<?=$ccache?>"></script>
                </head>
                <body class="direction_<?= $this->get_dir() ?>">
                        <?php endif; ?>
                <form  <?= $this->get_attr() ?>>
                    <div id="scrollable_main_div">
                        <?= $this->get_html() ?>
                    </div>
                    <div  id="form_buttons_div">
        <?= $this->get_buttons() ?>
                    </div>
                </form>
                <script type='text/javascript'>
        <?= $this->get_script() ?>
                    $(document).ready(function () {
                        parent.parent.Notiflix.Loading.Remove();
                        mabvalid.init(document.<?= $this->get_name() ?>);
                        $('[data-toggle="required-tooltip"]').tipsy({position: "<?= DIR_RALIGN ?>"});
        <?= parent::load() ?>
                <?= $this->get_ready_script() ?>
                    })
                </script>
        <?php if ($this->get_is_framed()): ?>                
                </body>
            </html>

            <?php
        endif;
    }

}
?>
