<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of input_check
 *
 * @author ihab
 */
class input_check extends builder_input {

    /**
     * will be used later to get if checked from real value
     * @access private
     * @var string $actual_value
     */
    private $values = array();

    /**
     * class __construct
     */
    public function __construct($name) {
        parent::set_name($name);
        parent::set_type("checkbox");
        parent::set_value("1");
        parent::set_width(null);
    }

    /**
     * function set_value overrides parent::set_value
     * to set the real value after modify and get if checked or not
     * @access public
     * @param string $value
     */
    public function set_default_value($value = 1) {
        $this->values['default_value'] = $value;
        return $this;
    }

    /**
     *
     * @return string $actual_value
     */
    public function get_default_value() {
        return $this->values['default_value'];
    }

    /**
     * function set_value overrides parent::set_value
     * to set the real value after modify and get if checked or not
     * @access public
     * @param string $value
     */
    public function set_value($value) {
        $this->values['actual_value'] = $value;
        return $this;
    }

    /**
     *
     * @return string $actual_value
     */
    public function get_value() {
        return $this->values['actual_value'];
    }

    /**
     *
     */
    public function get_valid() {
        parent::add_class('checkbox');
    }

    /**
     * overrides parent::load()
     * @access public
     * function load
     */
    public function load() {


        $this->get_disable();
        
        if ($this->disable) {
            anti_inspection::push_disabled_elments(parent::get_name(), $this->get_value(),"checkbox");
        }
        //
        if (!$this->get_value()) {
            parent::set_value(0);
            $pic_class = "checkbox_off";
        }
        //
        if ($this->get_value() == 1) {
            parent::add_attr("checked", "checked");
            $pic_class = "checkbox_on";
        } elseif ($this->get_value() == 0 AND is_numeric($this->get_value())) {
            parent::remove_attr("checked");
            $pic_class = "checkbox_off";
        } elseif (!isset($GLOBALS["_{$_SERVER['REQUEST_METHOD']}"][$this->get_name()])) {
            if ($_SERVER['REQUEST_METHOD'] == 'GET' AND $this->get_default_value()) {
                parent::add_attr("checked", "checked");
                $pic_class = "checkbox_on";
            } elseif ($_SERVER['REQUEST_METHOD'] == 'POST' AND $_POST['action'] == 'add' AND $this->get_default_value()) {
                parent::add_attr("checked", "checked");
                $pic_class = "checkbox_on";
            }
        } elseif (isset($GLOBALS["_{$_SERVER['REQUEST_METHOD']}"][$this->get_name()])) {
            if ($_POST['action'] == 'add' AND $this->get_default_value()) {
                parent::add_attr("checked", "checked");
                $pic_class = "checkbox_on";
            }
        }
        if ($this->get_attr("disabled")) {
            $pic_class = "checkbox_disabled_{$this->get_value()}";
            parent::remove_attr("disabled");
        }

        return
                "<div class='div_checkbox {$pic_class}' >"
                . " <input type='hidden' id='{$this->get_name()}' name='{$this->get_name()}' value='{$this->get_value()}' " . parent::get_attr() . " />"
                . "</div>";

        parent::load();
    }

}

?>