<?php
/**
 * class input_mask .
 * extends builder_input class to create input mask
 * int is the default masking type.
 * @author Ihab A. Ali
 * @copyright copyright (c) copyright 2009 , Ihab A. Ali as a part of Opentechcom Development Team
 * @license GNU Public Licence (GPL)
 * @example  $input_mask = new input_mask($name);
 *
 */
class input_mask extends input_text {

    /**
     * determine valid or format
     * @var string $valid_type
     */
    private $mask = 'int';

    /**
     * class __construct
     * @param string $name
     * @param string $mask
     */
    public function __construct($name) {
        parent::__construct($name);
    }

    /**
     * set masking
     * sets the protect parent class variable $mask
     * @access public
     * @param string $mask
     */
    public function set_mask($mask) {
        $this->mask = $mask;
        return $this;
    }

    /**
     *
     * @return string $mask
     */
    public function get_mask() {
        return $this->mask;
    }
    /**
     * 
     */
    public function get_valid() {
        if (parent::get_valid())
            parent::add_class('valid-' . $this->get_mask());
        else
            parent::add_class('format-' . $this->get_mask());
    }

}

?>
