<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of parser_pop_window
 * last modify July 2020 (add permissions to pop up)
 *
 * @author ihab
 */
class pop_window extends builder_tags {

    private $window_attr = array();
    private $label = "no title";

    public function __construct($label, $link, $record_val = null, $record_key = null) {
        if(!preg_match("/http/", $link)){
            $link = ap_url_path.$link;                
        }
        parent::add_attr("href", $link);
        $this->set_label($label);
        $record_key = $record_key ? $record_key : pathinfo($link, PATHINFO_FILENAME) . '_id';
        $this->add_window_attr('record_key', "'{$record_key}'");
        if ($record_val)
            $this->add_window_attr('record_val', ($record_val === true ? "{$record_key}_id.getActualValue()" : $record_val));
    }

    public function set_label($label = null) {
        $this->label = $label;
        return $this;
    }

    public function get_label() {
        return $this->label;
    }

    private function add_window_attr($key, $value) {
        $this->window_attr[$key] = $value;
        return $this;
    }

    public function get_window_attrs() {
        if ($this->window_attr)
            return str_replace('"', "", json_encode($this->window_attr));
        return null;
    }

    public function get_window_attr($key) {
        return $this->window_attr[$key];
    }

    public function set_window_width($width) {
        $this->add_window_attr('width', $width);
        return $this;
    }

    public function set_window_height($height) {
        $this->add_window_attr('height', $height);
        return $this;
    }

    public function get_link_for_authenticate() {
        //maybe we send popup to open specific id, return everything before the ? if there is
        $link = explode('?', parent::get_attr('href'));
        return $link[0];
    }

    public function load() {
        if (authentication::check_authentication($this->get_link_for_authenticate())) {
            parent::add_class("_popup_");
            parent::add_event("onclick", "return $(this).new_window(" . $this->get_window_attrs() . ")");
            return "<a " . parent::get_attr() . ">{$this->get_label()}&nbsp;<i class='mdi mdi-launch'></i></a>";
        }
        return $this->get_label();
    }

}

?>
