<?php

/**
 * select select class . use this class build combo class
 * inherited from sql_class
 * @author Ihab A. Ali
 * @copyright copyright (c) copyright 2009 
 * @license GNU Public Licence (GPL)
 * @example  $html = new select($name,$option_view=null,$option_value=null)
 */
class select extends data_source {

    /**
     * @access
     * @var bool $with_empty
     */
    private $with_empty = false;

    /**
     *
     * @param string $name
     * @param string $option_view
     * @param string $option_value
     */
    public function __construct($name, $option_view = null, $option_value = null) {
        parent::__construct($option_view, $option_value);
        parent::set_name($name);
    }

    /**
     *
     * @param bool $with_empty
     */
    public function set_with_empty($with_empty = true) {
        $this->with_empty = $with_empty;
        return $this;
    }

    /**
     *
     * @return bool $with_empty
     */
    public function get_with_empty() {
        return $this->with_empty;
    }

    /**
     * @access public
     * @return bool $valid returns select validation
     */
    public function get_valid() {
        if (parent::get_valid()){
            parent::add_class('valid');
            return true;
        }
        return false;
    }

    /**
     * @access public
     * @return bool $disable returns select disable
     */
    public function get_disable() {
        if (parent::get_disable())
            parent::add_attr('disabled', 'disabled');
    }

    /**
     * @access private
     * @return array $options
     */
    public function get_options() {
        if ($this->get_with_empty())
            $options = '<option value=""></option>';
        foreach (parent::get_data_set() as $value => $view) {
            $selected = null;
            if ($value == parent::get_value() && is_numeric(parent::get_value()))
                $selected = 'selected';
            $options .='<option value="' . $value . '" ' . $selected . '>' . $view . '</option>';
        }
        return $options;
    }

    /**
     *
     * @access public
     */
    public function load() {
        $this->get_disable();
        $span = null;
        if($this->get_valid()){
            $span = $this->get_required_span();
        }
        if(parent::get_disable()){
            anti_inspection::push_disabled_elments(parent::get_name(), parent::get_value(),"select");
        }        
        $select = '<select ' . parent::get_attr() . ' ' . parent::get_css() . '>';
        $select .=$this->get_options();
        $select .= '</select>'.$span;
        return $select;
    }

}

?>