<?php

/**
 * taber class . use this class to create tabs
 * @author Ihab A. Ali
 * @copyright copyright (c) copyright 2020
 * 
 * @license GNU Public Licence (GPL)
 * @example  $taber = new taber($name)
 */
class taber {

    /**
     * @access private
     * @var strin $name
     */
    private $name = 'FormTabContainer';

    /**
     * this an array variable used to contain the name and innerHTML of each tab
     * @access private
     * @var array $tabs
     */
    private $tabs = array();

    /**
     *
     * @var int $default_tab
     */
    private $default_tab = null;

    /**
     *
     * @var int id
     */
    private $call_tab = null;
    private $disable_js = false;

    /**
     * @access public
     * @param string $name
     */
    public function __construct($name = 'FormTabContainer') {
        $this->set_name($name);
    }

    /**
     * @access public
     * @param string $name
     */
    public function set_name($name) {
        $this->name = $name;
        return $this;
    }

    /**
     * @access public
     * @return string $name
     */
    public function get_name() {
        return $this->name;
    }

    /**
     * @access public
     * @param string $disable_js
     */
    public function disable_js($disable_js = true) {
        $this->disable_js = $disable_js;
        return $this;
    }

    /**
     * @access public
     * @return string $disable_js
     */
    public function get_disable_js() {
        return $this->disable_js;
    }

    /**
     *
     * @param string $title
     * @param string $html
     */
    public function add_tab($title = 'untitled', $html = 'set an html code plz') {
        $new_tab = array('title' => $title, 'html' => $html);
        array_push($this->tabs, $new_tab);
        return $this;
        //push tab param into the class tabs array
    }

    /**
     *
     * @return <type>
     */
    public function get_tabs() {
        return $this->tabs;
    }

    public function set_default_tab($id) {
        $this->default_tab = $this->get_name() . '.expandit(' . $id . ');';
        return $this;
    }

    /**
     * call to open certain tab
     * @param int $id
     */
    public function call_tab($id) {
        $this->call_tab = $this->get_name() . '.expandit(' . $id . ');';
        return $this;
    }

    /**
     * call to open certain tab
     * @return $id
     */
    private function called_tab() {
        if ($this->call_tab)
            return $this->call_tab;
    }

    /**
     * @access public
     * @return string tabs
     */
    public function load() {
        ob_start();
        ?>

        <ul id="<?= $this->get_name() ?>-tab-container" class="shadetabs">
            <?php
            $i = 0;
            foreach ($this->get_tabs() as $value):
                ?><li><a href="javascript:;" rel="<?= $this->get_name() ?>-tabcontainer<?= $i ?>" ><?= $value['title'] ?></a></li><?php
                ++$i;
            endforeach;
            ?>
        </ul>
        <div class="tabcontainer" id="<?= $this->get_name() ?>-Tab-resize">
            <?php $i = 0;
            foreach ($this->get_tabs() as $value):
                ?>
                <div style="display:none;top:5px;padding:0 auto;margin:0 auto;" id="<?= $this->get_name() ?>-tabcontainer<?= $i ?>" class="tabcontent">
                <?= $value['html'] ?>
                </div>
                <?php
                ++$i;
            endforeach;
            ?>
        </div>  

        <script>
        <?php if (!$this->get_disable_js()): ?>
                var <?= $this->get_name() ?> = new ddtabcontent("<?= $this->get_name() ?>-tab-container");
            <?= $this->get_name() ?>.init();
            <?= $this->get_name() ?>.expandit(0);
            <?= $this->default_tab ?>
                $(document).ready(function () {
            <?= $this->called_tab() ?>
                });
        <?php else: ?>
                $(document).ready(function () {
                    $("#<?= $this->get_name() ?>-tabcontainer0").show();
                    $("[rel='<?= $this->get_name() ?>-tabcontainer0']").addClass("selected");
                });

        <?php endif; ?>
        </script>
        <?php
        $tabs = ob_get_contents();
        ob_clean();
        return $tabs;
    }

}
?>
