<?php
/* 
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

class tree {
    /**
     * array params to save the tree parameters
     * @var $params
     */
    private $params = array();
    /**
     * array options to save the tree js options
     * @var $options
     */
    private $options = array();
    /**
     *
     * @param int $id
     */
    public function  __construct($id='tree1') {
        $this->set_id($id)
                ->set_container_height()
                ->set_content_cache()
                ->set_remote()
                ->set_request_type()
                ->add_request_params('action', 'ajax_tree_children')
                ->set_editing_failer_msg()
                ->set_modify_title()
                ->set_copy_title()
                ->set_delete_title()
                ->set_print_title()
                ->set_reload_title()
                ->set_refresh_title()
                ->set_search_title()
                ->set_search_lable()
                ->set_expand_all_title()
                ->set_expand_one_level_title()
                ->set_collapse_all_title()
                ->set_no_result_msg()
                ->set_delete_confirmation_msg();
    }
    /**
     * set tree id
     * @param int $id
     * @return $this
     */
    public function set_id($id){
        $this->params['id'] = $id;
        return $this;
    }
    /**
     *
     * @return $id
     */
    public function get_id(){
        return $this->params['id'];
    }
    /**
     *
     * @param int $container_height
     * @return this
     */
    public function set_container_height($container_height=350){
        $this->options['containerHeight'] = $container_height;
        return $this;
    }
    /**
     *
     * @return container height
     */
    public function get_container_height(){
        return $this->options['containerHeight'];
    }
    /**
     *
     * @param bool $content_cache
     * @return this
     */
    public function set_content_cache($content_cache = true){
        $this->options['contentCache'] = $content_cache;
        return $this;
    }
    /**
     *
     * @return bool $content_cache
     */
    public function get_content_cache(){
        return $this->options['contentCache'];
    }
    /**
     *
     * @param string $remote
     * @return this
     */
    public function set_remote($remote = self){
        $this->options['remote'] = $remote;
        return $this;
    }
    /**
     *
     * @return string $remote
     */
    public function get_remote(){
        return $this->options['remote'];
    }
    /**
     *
     * @param string $request_type
     * @return $this
     */
    public function set_request_type($request_type = 'POST'){
        $this->options['requestType'] = $request_type;
        return $this;
    }
    /**
     *
     * @return string
     */
    public function get_request_type(){
        return $this->options['requestType'];
    }
    /**
     *
     * @param <type> $request_cache
     * @return <type> 
     */
    public function set_request_cache($request_cache = false){
        $this->options['requestCache'] = $request_cache;
        return $this;
    }
    /**
     *
     * @return $requestCache
     */
    public function get_request_cache(){
        return $this->options['requestCache'];
    }
    /**
     *
     * @param int $animation_speed
     * @return $this
     */
    public function set_animation_speed($animation_speed = 300){
        $this->options['animationSpeed'] = $animation_speed;
        return $this;
    }
    /**
     *
     * @return $animationSpeed
     */
    public function get_animation_speed(){
        return $this->options['animationSpeed'];
    }
    /**
     *
     * @param array $item_hover_colors
     * @return $this
     */
    public function set_item_hover_colors($item_hover_colors = array()){
        $this->options['itemHoverColors'] = $item_hover_colors;
        return $this;
    }
    /**
     *
     * @return $itemHoverColors
     */
    public function get_item_hover_colors(){
        return $this->options['itemHoverColors'];
    }
    /**
     *
     * @param array $item_classes
     * @return $this
     */
    public function set_item_classes($item_classes = array()){
        $this->options['itemClasses'] = $item_classes;
        return $this;
    }
    /**
     *
     * @return $itemClasses
     */
    public function get_item_classes(){
        return $this->options['itemClasses'];
    }
    /**
     *
     * @param <type> $key
     * @param <type> $value
     * @return <type> 
     */
    public function add_request_params($key,$value){
        $this->options['RequestParams'][$key] = $value;
        return $this;
    }
    /**
     *
     * @param string $name
     * @param string $title
     * @param string $event
     * @return 
     */
    public function add_context_menu_item($title,$event=null){
        $arr = array(
                       'title'=>$title,
                       'event'=>$event
                    );
        $this->options['contextMenuItems'][] = $arr;
        return $this;
    }
    /**
     *
     * @param bool $editing_toolbar
     * @return $this
     */
    public function set_editing_toolbar($editing_toolbar = true){
        $this->options['editingToolBar'] = $editing_toolbar;
        return $this;
    }
    /**
     *
     * @return $editing_toolbar
     */
    public function get_editing_toolbar(){
        return $this->options['editingToolBar'];
    }
    /**
     *
     * @param bool $editing_toolbar
     * @return $this
     */
    public function disable_modify($disable_modify = true){
        $this->options['disableModify'] = $disable_modify;
        return $this;
    }
    /**
     *
     * @return $editing_toolbar
     */
    public function get_disable_modify(){
        return $this->options['disableModify'];
    }
    /**
     *
     * @param bool $editing_toolbar
     * @return $this
     */
    public function disable_copy($disable_copy = true){
        $this->options['disableCopy'] = $disable_copy;
        return $this;
    }
    /**
     *
     * @return $editing_toolbar
     */
    public function get_disable_copy(){
        return $this->options['disableCopy'];
    }
    /**
     *
     * @param bool $editing_toolbar
     * @return $this
     */
    public function disable_delete($disable_delete = true){
        $this->options['disableDelete'] = $disable_delete;
        return $this;
    }
    /**
     *
     * @return $editing_toolbar
     */
    public function get_disable_delete(){
        return $this->options['disableDelete'];
    }
    /**
     *
     * @param bool $disableContextMenu
     * @return $this
     */
    public function disable_context_menu($disable_context_menu = true){
        $this->options['disableContextMenu'] = $disable_context_menu;
        return $this;
    }
    /**
     *
     * @return $disableContextMenu
     */
    public function get_disable_context_menu(){
        return $this->options['disableContextMenu'];
    }
    /**
     *
     * @param bool $disableBranchRefresh
     * @return $this
     */
    public function disable_branch_refresh($disable_branch_refresh = true){
        $this->options['disableBranchRefresh'] = $disable_branch_refresh;
        return $this;
    }
    /**
     *
     * @return $disableBranchRefresh
     */
    public function get_disable_branch_refresh(){
        return $this->options['disableBranchRefresh'];
    }
    /**
     *
     * @param bool $disableBranchExpandAll
     * @return $this
     */
    public function disable_branch_expand_all($disable_branch_expand_all = true){
        $this->options['disableBranchExpandAll'] = $disable_branch_expand_all;
        return $this;
    }
    /**
     *
     * @return $disableBranchExpandAll
     */
    public function get_disable_branch_expand_all(){
        return $this->options['disableBranchExpandAll'];
    }
    /**
     *
     * @param bool $disableExpandOneLevel
     * @return $this
     */
    public function disable_expand_one_level($disable_expand_one_level = true){
        $this->options['disableExpandOneLevel'] = $disable_expand_one_level;
        return $this;
    }
    /**
     *
     * @return $disableExpandOneLevel
     */
    public function get_disable_expand_one_level(){
        return $this->options['disableExpandOneLevel'];
    }
    /**
     *
     * @param bool $disableCollapseAll
     * @return $this
     */
    public function disable_collapse_all($disable_collapse_all = true){
        $this->options['disableCollapseAll'] = $disable_collapse_all;
        return $this;
    }
    /**
     *
     * @return $disableCollapseAll
     */
    public function get_disable_collapse_all(){
        return $this->options['disableCollapseAll'];
    }
    /**
     *
     * @param bool disableExpandAll
     * @return $this
     */
    public function disable_expand_all($disable_expand_all = true){
        $this->options['disableExpandAll'] = $disable_expand_all;
        return $this;
    }
    /**
     *
     * @return disableExpandAll
     */
    public function get_disable_expand_all(){
        return $this->options['disableExpandAll'];
    }
    /**
     *
     * @param bool $enable_print
     * @return $this
     */
    public function enable_print($enable_print = true){
        $this->options['enablePrint'] = $enable_print;
        return $this;
    }
    /**
     *
     * @return $enable_print
     */
    public function get_enable_print(){
        return $this->options['enablePrint'];
    }
    /**
     *
     * @param int $editing_target
     * @return $this
     */
    public function set_editing_target($editing_target = "tab_iframe0"){
        $this->options['editingTarget'] = $editing_target;
        return $this;
    }
    /**
     *
     * @return $editing_target
     */
    public function get_editing_target(){
        return $this->options['editing_target'];
    }
    /**
     *
     * @param string $editingFailerMsg
     * @return $this
     */
    public function set_editing_failer_msg($editing_failer_msg = LANG_TREE_EDIT_FAILER_MSG){
        $this->options['editingFailerMsg'] = $editing_failer_msg;
        return $this;
    }
    /**
     *
     * @return $editing_failer_msg
     */
    public function get_editing_failer_msg(){
        return $this->options['editingFailerMsg'];
    }
    /**
     *
     * @param bool $disableFiltering
     * @return $this
     */
    public function disable_filtering($disable_filtering = true){
        $this->options['disableFiltering'] = $disable_filtering;
        return $this;
    }
    /**
     *
     * @return $disable_filtering
     */
    public function get_disable_filtering(){
        return $this->options['disableFiltering'];
    }
    /**
     *
     * @param int $disableFiltering
     * @return $this
     */
    public function set_tageted_tab($tageted_tab = "0"){
        $this->options['tagetedTab'] = $tageted_tab;
        return $this;
    }
    /**
     *
     * @return $disable_filtering
     */
    public function get_tageted_tab(){
        return $this->options['tagetedTab'];
    }
    /**
     *
     * @param string $modifyTitle
     * @return $this
     */
    public function set_modify_title($modify_title = LANG_MODIFY){
        $this->options['modifyTitle'] = $modify_title;
        return $this;
    }
    /**
     *
     * @return $modify_title
     */
    public function get_modify_title(){
        return $this->options['modifyTitle'];
    }
    /**
     *
     * @param string $deleteTitle
     * @return $this
     */
    public function set_delete_title($delete_title = LANG_DELETE){
        $this->options['deleteTitle'] = $delete_title;
        return $this;
    }
    /**
     *
     * @return $delete_title
     */
    public function get_delete_title(){
        return $this->options['deleteTitle'];
    }
    /**
     *
     * @param string $printTitle
     * @return $this
     */
    public function set_print_title($print_title = LANG_PRINT){
        $this->options['printTitle'] = $print_title;
        return $this;
    }
    /**
     *
     * @return $print_title
     */
    public function get_print_title(){
        return $this->options['printTitle'];
    }
    /**
     *
     * @param string $copyTitle
     * @return $this
     */
    public function set_copy_title($copy_title = LANG_COPY){
        $this->options['copyTitle'] = $copy_title;
        return $this;
    }
    /**
     *
     * @return $copy_title
     */
    public function get_copy_title(){
        return $this->options['copyTitle'];
    }
     /**
     *
     * @param string $reloadTitle
     * @return $this
     */
    public function set_reload_title($reload_title = LANG_RELOAD){
        $this->options['reloadTitle'] = $reload_title;
        return $this;
    }
    /**
     *
     * @return $reload_title
     */
    public function get_reload_title(){
        return $this->options['reloadTitle'];
    }
     /**
     *
     * @param string $refreshTitle
     * @return $this
     */
    public function set_refresh_title($refresh_title = LANG_RELOAD){
        $this->options['refreshTitle'] = $refresh_title;
        return $this;
    }
    /**
     *
     * @return $refresh_title
     */
    public function get_refresh_title(){
        return $this->options['refreshTitle'];
    }
    /**
     *
     * @param string $searchTitle
     * @return $this
     */
    public function set_search_title($search_title = LANG_SEARCH){
        $this->options['searchTitle'] = $search_title;
        return $this;
    }
    /**
     *
     * @return $search_title
     */
    public function get_search_title(){
        return $this->options['searchTitle'];
    }
    /**
     *
     * @param string $searchlable
     * @return $this
     */
    public function set_search_lable($search_lable = LANG_SEARCH){
        $this->options['searchLable'] = $search_lable;
        return $this;
    }
    /**
     *
     * @return $search_lable
     */
    public function get_search_lable(){
        return $this->options['searchLable'];
    }
    /**
     *
     * @param string $searchlable
     * @return $this
     */
    public function set_no_result_msg($no_result_msg = LANG_NO_RESULT_MSG){
        $this->options['noResultMsg'] = $no_result_msg;
        return $this;
    }
    /**
     *
     * @return $no_result_msg
     */
    public function get_no_result_msg(){
        return $this->options['noResultMsg'];
    }
    /**
     *
     * @param string $searchlable
     * @return $this
     */
    public function set_expand_all_title($expand_all_title = LANG_EXPAND_ALL_TITLE){
        $this->options['expandAllTitle'] = $expand_all_title;
        return $this;
    }
    /**
     *
     * @return $expand_all_title
     */
    public function get_expand_all_title(){
        return $this->options['expandAllTitle'];
    }
    /**
     *
     * @param string $searchlable
     * @return $this
     */
    public function set_collapse_all_title($collapse_all_title = LANG_COLLAPSE_ALL_TITLE){
        $this->options['collapseAllTitle'] = $collapse_all_title;
        return $this;
    }
    /**
     *
     * @return $collapse_all_title
     */
    public function get_collapse_all_title(){
        return $this->options['collapseAllTitle'];
    }
    /**
     *
     * @param string $searchlable
     * @return $this
     */
    public function set_expand_one_level_title($expand_one_level_title = LANG_EXPAND_ONE_LEVEL_TITLE){
        $this->options['expandOneLevelTitle'] = $expand_one_level_title;
        return $this;
    }
    /**
     *
     * @return $expand_one_level_title
     */
    public function get_expand_one_level_title(){
        return $this->options['expandOneLevelTitle'];
    }
    /**
     *
     * @param string $searchlable
     * @return $this
     */
    public function set_delete_confirmation_msg($delete_confirmation_msg = LANG_DOM_DELETE_MSG){
        $this->options['deleteConfirmationMsg'] = $delete_confirmation_msg;
        return $this;
    }
    /**
     *
     * @return $delete_confirmation_msg
     */
    public function get_delete_confirmation_msg(){
        return $this->options['deleteConfirmationMsg'];
    }
    /**
     *
     * @return <type> 
     */
    public function load(){

        $container_div = new div($this->get_id());

        $html  = $container_div->load();
        $this->options['direction'] = dir;
        $options = json_encode($this->options);

        $html .=
        "<script type='text/javascript'>
            $(document).ready(function(){
                var tree = $('#{$this->get_id()}').ajaxTree({$options});
            })
        </script>";
        return $html;
    }
}
?>
