<?php

class sql {

    /**
     *
     * @var resource obj
     */
    public $conn = null;

    /**
     * the name of database
     * @access private
     * @var string $db_name
     */
    private $db_name = null;

    /**
     * the name of database
     * @access private
     * @var string $character_set_connection
     */
    private $character_set_connection = null;

    /**
     * database host name
     * @access private 
     * @var string $db_host_name
     */
    private $db_host_name = null;

    /**
     * data base user name
     * @access private
     * @var string $db_user_name
     */
    private $db_user_name = null;

    /**
     *  data base password
     * @access private
     * @var string $db_password
     */
    private $db_password = null;

    /**
     * store last database inserted id
     * @access private
     * @var int $last_id
     */
    private $last_id = 0;

    /**
     * @access private
     * @var type 
     */
    private $error_no = null;

    /**
     * @access private
     * @var type 
     */
    private $error_text = null;

    /**
     * @access private
     * show error
     */
    private $hide_error = false;

    /**
     *
     * @var type 
     */
    private $results = array();

    /**
     *
     * @var type 
     */
    private $autocomit = false;

    /**
     * Affected Rows
     */
    private $affected_rows = 0;

    /**
     * Affected Rows
     */
    private $show_commit = false;

    /**
     *
     * @var type 
     */
    private static $open_conns = array();
    /*
     * 
     */
    public static $is_rollback = false;

    /**
     * class constructor which will initate connection on calling
     * @param string $db_name
     * @param string $db_host_name
     * @param string $db_user_name
     * @param string $db_password
     * @access public
     */
    public function __construct($db_name = null, $db_host_name = null, $db_user_name = null, $db_password = null, $character_set_connection = null, $hide_sql_errors = false) {
        $this->set_db_name($db_name)
                ->set_db_host_name($db_host_name)
                ->set_db_user_name($db_user_name)
                ->set_db_password($db_password)
                ->set_character_set_connection($character_set_connection)
                ->hide_error()
                ->init_conn();
    }

    /**
     * Initiates MYSQLI Connection
     */
    protected function init_conn() {
//        $conn_key = "#{$this->get_db_host_name()}#_#{$this->get_db_user_name()}#_#{$this->get_db_password()}#";
        $connkey = "#{$this->get_db_host_name()}#_#{$this->get_db_user_name()}#_#{$this->get_db_password()}#_#{$this->get_db_name()}";
        nl2br($connkey);
        if (self::$open_conns[$connkey]) {
            $this->conn = self::$open_conns[$connkey];
            $this->conn->ping();
        } else {
            $this->conn = new mysqli($this->get_db_host_name(), $this->get_db_user_name(), $this->get_db_password(), $this->get_db_name());
            //Output any connection error
            if ($this->conn->connect_error) {
                die('Error : (' . $this->conn->connect_errno . ') ' . $this->conn->connect_error);
            }
            $this->conn->set_charset($this->get_character_set_connection());
            $mytime = new DateTime();          
            $gmttime = new DateTime(gmdate(('Y-m-d H:i:s'), time()));
            
            $interval = $mytime->diff($gmttime);
            $dif = $interval->format('%H:%I');
            $this->conn->query("SET time_zone = '+".$dif."'");
            
            self::$open_conns[$connkey] = $this->conn;
            $this->conn->autocommit(TRUE);
        }
        return $this;
    }

    /**
     * Checks MYSQLI Connection
     * @return type
     */
    protected function check_conn() {
        return is_resource($this->conn) ? true : false;
    }

    /**
     * start transection
     */
    public function begin() {
        if (!$this->autocomit) {
            $this->execute_statment("START TRANSACTION");
            $this->set_should_commit();
        } else {
            mysqli_autocommit($this->conn, $this->autocomit);
        }
    }

    /**
     * sql statment excuter , for select , update , insert, and delete
     * @param string $statment
     * @param bool $debug
     * @return array $result
     */
    public function execute_statment($statment, $debug = false) {

        if ($debug) {
            self::debuging($statment);
        }
        if (!$this->check_conn()) {
            $this->init_conn();
        }
        $result = $this->conn->query($statment);
         $this->affected_rows =$this->conn->affected_rows;
        logger::add($statment);

        $this->set_last_id($this->conn->insert_id);
        $this->set_error_no($this->conn->errno);
        $this->set_error_text($this->conn->error);
        if ($this->conn->errno) {
            sql::$is_rollback = TRUE;
        }
        if ($this->get_error_text() AND $this->get_hide_error() AND $this->error_no != 1062) :
            ?>
            <div style="text-align: ltr;background-color: #c0c0c0;border: 1px solid blue;padding: 5px;">
                <font color="green" size="3" face="Arial">SQL Error:<?= htmlentities($statment) ?></font><br/>
                <font color="blue" size="3" face="Arial"><?= $this->get_error_no() . ": " . $this->get_error_text() ?></font>
            </div>
            <?php
        endif;
        return $result;
    }

    public function commit() {
        if (!$this->autocomit AND $this->get_should_commit()) {

            $this->execute_statment("commit");
        }
    }

    public function rollback() {
        if (!$this->autocomit) {
            $this->execute_statment("ROLLBACK");
        }
    }

    /**
     *
     * @param string $statment
     * @param bool $debug
     * @return array $results
     */
    public function get_result($statment, $debug = false) {
        return $this->results[] = $this->execute_statment($statment, $debug);
    }

    /**
     * 
     * @param type $results
     */
    public function free_result($results = null) {
        if (!$results) {
            $results = $this->results[count($this->results) - 1];
        }
        $results->free();
        return $this;
    }

    /**
     *
     * @param string $statment
     * @return array arr
     */
    public function get_array_rows($statment, $debug = false) {
        $results = $this->execute_statment($statment, $debug);
        $arr = array();
        while ($row = $this->next($results)) {
            array_push($arr, $row);
        }
        $results->free();
        return $arr;
    }

    /**
     * for old projects
     * @param array $results
     * @return array records
     */
    public function next($results = null, $is_both = false) {
        if (!$results)
            $results = $this->results[count($this->results) - 1];
        //Fetch a result row as an associative, a numeric array, or both
        $records = $results->fetch_array($is_both ? MYSQLI_BOTH : MYSQLI_ASSOC);
        /**
         * for huge data queries free_results at the end of each query
         */
        return $records;
    }

    /**
     * 
     * @param type $result
     * @param integer $i
     */
    public function mysql_seek($i, $results = null) {
        if (!$results)
            $results = $this->results[count($this->results) - 1];
        $results->data_seek($i);
    }

    /**
     *
     * @param string $table_name
     * @return string $set
     */
    protected function build_set($table_name = null) {
        $set = "set ";

        $result = $this->get_result("describe`{$table_name}`");
        while ($row = $this->next($result)) {
            if (isset($_POST[$row['Field']]) AND $row['Key'] != 'PRI') {
                if ($_POST[$row['Field']] OR $_POST[$row['Field']] === '0') {
                    $set .= "`" . $row['Field'] . "` = " . $this->fix_value($_POST[$row['Field']]) . ",";
                } else
                if ($row['Null'] == 'YES' && !$row['Default']) {
                    $set .= "`" . $row['Field'] . "` = NULL,";
                } else {
                    $set .= "`" . $row['Field'] . "` = '{$row['Default']}',";
                }
            }
        }
        $set = substr($set, 0, -1);
        return $set;
    }

    /**
     *
     * @param string $table_name
     * @param bool $debug
     * @return int $last_id
     */
    public function insert($table_name, $debug = false) {
        $set = $this->build_set($table_name);
        $statment = 'insert into `' . $table_name . '` ' . $set;
        $this->execute_statment($statment, $debug);

        return $this->get_last_id();
    }

    /**
     * function update - updates data base
     * @param string $table_name
     * @param int $table_id the function gets the table_id by default from globals
     * @param bool $debug
     */
    public function update($table_name = null, $table_id = null, $debug = false) {
        if (!$table_id)
            $table_id = $_REQUEST[$table_name . _id];

        $set = $this->build_set($table_name);
        $statment = 'update `' . $table_name . '` ' . $set . '  where `' . $table_name . _id . '` = ' . $table_id;

        $this->execute_statment($statment, $debug);
    }

    /**
     * function delete -> deletes records from Data base
     * @param string $table_name
     * @param string $file_to_delete in case the form contains files , we send the name as string and  in array in case of multi files
     * @param int $table_id the function gets the table_id by default from globals
     * @param bool $debug
     */
    public function delete($table_name = null, $table_id = null, $debug = false) {
        if (!$table_id)
            $table_id = $_REQUEST[$table_name . _id];

        $statment = "delete from `$table_name` where `" . $table_name . _id . "` =" . $table_id;
        $this->execute_statment($statment, $debug);
        return $this->get_last_id();
    }

    /**
     *
     * @param string $statment
     */
    protected static function debuging($statment) {
        echo "<div dir=ltr><font color=red size=3 face=Arial><pre>[" . htmlentities($statment) . "]</pre></font></div><br>";
    }

    /**
     *
     * @param string $value
     * @return string $value
     */
    protected function replace_script($value = null) {
        if ($value) {
            $search = array("'<SCRIPT.*?/SCRIPT>'si", "'<style.*?/style>'si");
            $replace = array("", "");
            $value = preg_replace($search, $replace, $value);
        }
        return $value;
    }

    /**
     *
     * @param string $value
     * @return string $value
     */
    protected function fix_value($value) {
        return "'" . trim($this->replace_script($this->escape($value))) . "'";
    }

    public function escape($value) {
        return $this->conn->escape_string($value);
    }

    /**
     *
     * @param string $hide_error
     */
    public function hide_error($hide_error = true) {
        $hide_error ? $this->hide_error = $hide_error : $this->hide_error = (bool) hide_sql_errors;
        return $this;
    }

    /**
     *
     * @return string $show_error
     */
    public function get_hide_error() {
        return $this->hide_error;
    }

    /**
     *
     * @param string $character_set_connection
     */
    public function set_character_set_connection($character_set_connection = null) {
        $character_set_connection ? $this->character_set_connection = $character_set_connection : $this->character_set_connection = character_set_connection;
        return $this;
    }

    /**
     *
     * @return string $character_set_connection
     */
    public function get_character_set_connection() {
        return $this->character_set_connection;
    }

    /**
     *
     * @param string $db_name
     */
    public function set_db_name($db_name = null) {
        $db_name ? $this->db_name = $db_name : $this->db_name = db_name;
        return $this;
    }

    /**
     *
     * @return string $db_name
     */
    public function get_db_name() {
        return $this->db_name;
    }

    /**
     *
     * @param string $db_host_name
     */
    public function set_db_host_name($db_host_name = null) {
        $db_host_name ? $this->db_host_name = $db_host_name : $this->db_host_name = db_host_name;
        return $this;
    }

    /**
     *
     * @return string $db_host_name
     */
    public function get_db_host_name() {
        return $this->db_host_name;
    }

    /**
     *
     * @param string $db_user_name
     */
    public function set_db_user_name($db_user_name = null) {
        $db_user_name ? $this->db_user_name = $db_user_name : $this->db_user_name = db_user_name;
        return $this;
    }

    /**
     *
     * @return string $db_user_name
     */
    public function get_db_user_name() {
        return $this->db_user_name;
    }

    /**
     *
     * @param string $db_password
     */
    public function set_db_password($db_password) {
        $db_password ? $this->db_password = $db_password : $this->db_password = db_password;
        return $this;
    }

    /**
     *
     * @return string $db_password
     */
    protected function get_db_password() {
        return $this->db_password;
    }

    /**
     *
     * @param string $id
     */
    protected function set_last_id($id) {
        $this->last_id = $id;
        return $this;
    }

    /**
     *
     * @return string $id
     */
    public function get_last_id() {
        return $this->last_id;
    }

    /**
     *
     * @param string $id
     */
    protected function set_should_commit($should_commit = true) {
        $this->should_commit = $should_commit;
        return $this;
    }

    /**
     *
     * @return string $id
     */
    public function get_should_commit() {
        return $this->should_commit;
    }

    /**
     *
     * @return string $id
     */
    public function get_affected_rows() {
        return $this->affected_rows;
    }

    /**
     * @param type $error_no
     */
    protected function set_error_no($error_no) {
        $this->error_no = $error_no;
        return $this;
    }

    public function get_error_no() {
        return $this->error_no;
    }

    /**
     * @param type $error_text
     */
    protected function set_error_text($error_text) {
        $this->error_text = $error_text;
        return $this;
    }

    public function get_error_text() {
        return $this->error_text;
    }

    public function set_checkboxes($checkboxes) {
        foreach ($checkboxes as $checkbox) {
            if (!isset($_POST[$checkbox])) {
                $_POST[$checkbox] = '0';
            }
        }
        return $this;
    }

    /**
     * 
     */
    public function __destruct() {
//        $this->conn->close();
    }

}
?>