<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of builder_privileges_tree
 *
 * @author ihab
 */
class privileges_tree extends array_tree {

    public function __construct($db_table_name) {
        parent::__construct($db_table_name);
    }

    /**
     *
     * @param  <type> $parent_group_id
     * @return <type>
     */
    public function set_parent_group_id($parent_group_id = 0) {

        $this->params['parent_group_id'] = $parent_group_id;
        return $this;
    }

    /**
     *
     */
    public function get_parent_group_id() {
        return $this->params['parent_group_id'];
    }

    /**
     *
     * @param <type> $group_id
     * @return <type>
     */
    public function set_group_id($group_id = null) {
        $this->params['group_id'] = $group_id;
        return $this;
    }

    /**
     *
     */
    public function get_group_id() {
        return $this->params['group_id'];
    }

    /**
     *
     * @param  <type> $children
     * @param  <type> $level
     * @return <type>
     */
    public function get_children($children, $tree_child = null, $level = 15) {
        $actions = array("permit", "add", "modify", "delete", "print");
        foreach (@$children as $key => $value) {
            if (!$value['menu_link'])
                $value['menu_link'] = "&nbsp;";

            $value['menu_is_permit'] = 1;
            foreach ($actions as $action) {
                ${$action . "_checked"} = null;
                ${$action . "_disabled"} = null;
                ${$action . "_index_enabled"} = "index_enabled='1'";
                if (!$tree_child[$key]['group_privilege_is_permit'])
                    ${$action . "_disabled"} = 'disabled';

                /**
                 * if action is not checked in menu form and
                 * menu leve is link
                 * disable and uncheck it
                 */
                if (!$value['menu_is_' . $action]
                        AND
                        $value['menu_level'] == 'link') {
                    ${$action . "_checked"} = null;
                    ${$action . "_disabled"} = "disabled";
                    ${$action . "_index_enabled"} = "index_enabled='0'";
                } else
                if ($value['menu_is_' . $action]) {
                    /**
                     * case group is a child group
                     * and not checked privilege
                     */
                    if (!$value['group_privilege_is_' . $action]
                            AND $value['menu_level'] == 'link') {
                        ${$action . "_checked"} = null;
                        ${$action . "_disabled"} = "disabled";
                        ${$action . "_index_enabled"} = "index_enabled='0'";
                    }
                    /**
                     * if modify form and checked
                     */ else {

                        if ($tree_child[$key]['group_privilege_is_' . $action]) {
                            ${$action . "_checked"} = "checked";
                            ${$action . "_disabled"} = null;
                            ${$action . "_index_enabled"} = "index_enabled='1'";
                        }
                    }
                }
            }

            $html .= "<tr valign='top' class='{$value['menu_level']}'  index='{$value['index_id']}' self='{$value['menu_id']}'>";
            $html .= "    <td class='td_{$value['menu_level']} center'>
                            <input type='checkbox' class='checkbox permit_{$value['menu_level']}' cat='permit' name='is_permit[{$value['menu_id']}]'  value='1' {$permit_checked}/>
                        </td>";
            $html .= "    <td class='td_{$value['menu_level']} center'>
                            <input type='checkbox' class='checkbox add_{$value['menu_level']}'    cat='add'     name='is_add[{$value['menu_id']}]' value='1'  {$add_checked} {$add_disabled} {$add_index_enabled}/>
                        </td>";
            $html .= "    <td class='td_{$value['menu_level']} center'>
                            <input type='checkbox' class='checkbox modify_{$value['menu_level']}' cat='modify'  name='is_modify[{$value['menu_id']}]' value='1' {$modify_checked} {$modify_disabled} {$modify_index_enabled} />
                        </td>";
            $html .= "    <td class='td_{$value['menu_level']} center'>
                            <input type='checkbox' class='checkbox delete_{$value['menu_level']}' cat='delete'  name='is_delete[{$value['menu_id']}]' value='1' {$delete_checked} {$delete_disabled} {$delete_index_enabled}/>
                        </td>";
            $html .= "    <td class='td_{$value['menu_level']} center'>
                            <input type='checkbox' class='checkbox print_{$value['menu_level']}' cat='print'  name='is_print[{$value['menu_id']}]' value='1' {$print_checked} {$print_disabled} {$print_index_enabled}/>
                        </td>";
            $html .= "    <td class='td_{$value['menu_level']}' style='padding-" . DIR_ALIGN . ":{$level}px'>
                            <img src='" . theme_dir_url_path . "/images/common/branch.gif' atl=''/>
                            {$value['menu_name_'.dir]}
                        </td>";
            if (authentication::get_user_type() == "super") {
                $html .= "    <td class='td_{$value['menu_level']}' >
                            {$value['menu_link']}
                        </td>";
            }
            $html .= "</tr>";
            if ($value['children']) {
                $level1 = $level + 15;
                $html .= $this->get_children($value['children'], $tree_child[$key]['children'], $level1);
            }
        }
        return $html;
    }

    public function load() {

//        parr("group_id =".$this->get_group_id());
//        parr("parent_group_id =".$this->get_parent_group_id());

        $actions = array("permit", "add", "modify", "delete", "print");

        $condition = "where `menu`.`menu_is_disabled` = '0' ";
        if ($this->get_group_id()) {
            $condition = "
                inner join `group_privilege` on `group_privilege`.`menu_id`=`menu`.`menu_id`
                where 1=1
                and `group_privilege`.`group_id`='{$this->get_group_id()}'
                and `menu`.`menu_is_disabled` = '0'";
        }

        parent::set_query("select * from `menu`
                            {$condition }
                            order by char(concat(`menu`.`menu_parent_sort`,`menu`.`menu_sort`))");

        if (authentication::get_user_type() == 'admin' AND!$this->get_parent_group_id())
            $this->set_parent_group_id(authentication::get_group_id());

        $parent = new array_tree("menu");
        if ($this->get_parent_group_id() > 0)
            $parent->set_query("
                                select * from menu
                                inner join `group_privilege` on `group_privilege`.`menu_id`=`menu`.`menu_id`
                                where 1=1
                                and `group_privilege`.`group_id`='{$this->get_parent_group_id()}'
                                and `group_privilege_is_permit`<>'0'
                                and `menu`.`menu_is_disabled` = '0'
                            order by char(concat(`menu`.`menu_parent_sort`,`menu`.`menu_sort`))");

        else
        if (authentication::get_user_type() == 'super')
            $parent->set_query("
                                select * ,
                                        1 as group_privilege_is_permit ,
                                        1 as group_privilege_is_add,
                                        1 as group_privilege_is_modify,
                                        1 as group_privilege_is_delete,
                                        1 as group_privilege_is_print
                                from menu
                                where 1=1
                                and `menu`.`menu_is_disabled` = '0'
                                order by char(concat(`menu`.`menu_parent_sort`,`menu`.`menu_sort`))");


        $tree = $parent->load();
        $tree_child = parent::load();

        $html = "
            <style>
                    thead th{
                        height:18px;
                        font: bold 13px auto 'Trebuchet MS', 'Verdana', 'Arial', 'Helvetica', 'sans-serif';
//                        color: var(--primary-color);
                        color: #ebf6f6;
                        border:1px solid var(--primary-color);
                        letter-spacing: 2px;
                        text-transform: uppercase;
//                        text-align: " . DIR_ALIGN . ";
                        text-align:center;
                        background: var(--primary-color);
                    }
                    .td_main{
                        font: bold 13px auto 'Trebuchet MS', 'Verdana', 'Arial', 'Helvetica', 'sans-serif';
                        color: #2f4040;
                        border:1px solid var(--primary-color);
                        letter-spacing: 2px;
                        text-transform: uppercase;
//                        text-align: " . DIR_ALIGN . ";
                        background:var(--primary-color-3);
//                        background: blue;
//                        text-align:center;
                    }
                    .td_link:last-child, .td_main:last-child, td_sub:last-child{
                        text-align:left;
                        padding-top:5px;
                        padding-left:15px;
                    }
                    .td_sub{
                        font: bold 12px auto 'Trebuchet MS', 'Verdana', 'Arial', 'Helvetica', 'sans-serif';
                        color: #2f4040;
                        letter-spacing: 2px;
                        text-transform: uppercase;
//                        text-align: " . DIR_ALIGN . ";
                        border:1px solid var(--primary-color);
                        background:#C0E4E5;
//                        background:green;
//                        text-align:center;
                    }
                    .td_link{
                        font: bold 11px auto 'Trebuchet MS', 'Verdana', 'Arial', 'Helvetica', 'sans-serif';
                        color: #2f4040;
                        border:1px solid var(--primary-color);
                        background:var(--primary-color-4);
//                        background:yellow;
//                        text-align:center;
                    }
                    .center {
                        text-align:center;
                    }
                    .checkbox{
                        margin:5px;
                        text-align:center;
                        font-size: 16px;
                    }
                    thead th{font-size:20px;}
                    .mdi {
                        font-size:32px;
                        color:var(--primary-color-4);
                    }
//                    .mdi-check-bold, .mdi-plus-thick {color:#c0e5ca;}
//                    .mdi-pencil{color:#e5e3c0;}
//                    .mdi-close-thick{color:#e5c0c0;}
//                    .mdi-printer{color:#c0dde5;}
            </style>
            <table cellpadding='5'  cellspacing='0' border='0'  style='padding:auto 0;min-width:750px;' dir='" . dir . "'>
            <thead>
                <th style='min-width:50px'><i class='mdi mdi-check-bold'></i></td>
                <th style='min-width:50px'><i class='mdi mdi-plus-thick'></i></td>
                <th style='min-width:50px'><i class='mdi mdi-pencil'></i></td>
                <th style='min-width:50px'><i class='mdi mdi-close-thick'></i></td>
                <th style='min-width:50px'><i class='mdi mdi-printer'></i></td>
                <th>" . GROUP_PRIVILEGES_NAME . "</td>";
        if (authentication::get_user_type() == "super")
            $html .= "<th>" . GROUP_PRIVILEGES_LINK . "</td>";
        $html .= "</thead>";


        if ($tree)
            foreach (@$tree as $key => $value) {

                if ($value['menu_level'] == 'main' AND $value['menu_link']) {
                    $value['menu_level'] = 'link';
                }

                if (!$value['menu_link'])
                    $value['menu_link'] = "&nbsp;";
                $value['menu_is_permit'] = 1;
                foreach ($actions as $action) {
                    ${$action . "_checked"} = null;
                    ${$action . "_disabled"} = null;
                    ${$action . "_index_enabled"} = "index_enabled='1'";
                    if (!$tree_child[$key]['group_privilege_is_permit'])
                        ${$action . "_disabled"} = 'disabled';
                    /**
                     * if action is not checked in menu form and
                     * menu leve is link
                     * disable and uncheck it
                     */
                    if (!$value['menu_is_' . $action] AND
                            $value['menu_level'] == 'link') {
                        ${$action . "_checked"} = null;
                        ${$action . "_disabled"} = "disabled";
                        ${$action . "_index_enabled"} = "index_enabled='0'";
                    } else {
                        /**
                         * case group is a child group
                         * and not checked privilege
                         */
                        if (!$value['group_privilege_is_' . $action] AND
                                $value['menu_level'] == 'link') {
                            ${$action . "_checked"} = null;
                            ${$action . "_disabled"} = "disabled";
                            ${$action . "_index_enabled"} = "index_enabled='0'";
                        }
                        /**
                         * if modify form and checked
                         */ else {
                            if ($tree_child[$key]['group_privilege_is_' . $action]) {
                                ${$action . "_checked"} = "checked";
                                ${$action . "_disabled"} = null;
                                ${$action . "_index_enabled"} = "index_enabled='1'";
                            }
                        }
                    }
                }

                $html .= "<tr valign='top' class='{$value['menu_level']}' index='{$value['index_id']}' self='{$value['menu_id']}'>";
                $html .= "    <td class='td_{$value['menu_level']} center'>
                            <input type='checkbox' class='checkbox permit_{$value['menu_level']}' cat='permit' name='is_permit[{$value['menu_id']}]'  value='1'  {$permit_checked}/>
                        </td>";
                $html .= "    <td class='td_{$value['menu_level']} center'>
                            <input type='checkbox' class='checkbox add_{$value['menu_level']}'    cat='add'     name='is_add[{$value['menu_id']}]' value='1' {$add_checked} {$add_disabled} {$add_index_enabled}/>
                        </td>";
                $html .= "    <td class='td_{$value['menu_level']} center'>
                            <input type='checkbox' class='checkbox modify_{$value['menu_level']}' cat='modify'  name='is_modify[{$value['menu_id']}]' value='1' {$modify_checked} {$modify_disabled} {$modify_index_enabled} />
                        </td>";
                $html .= "    <td class='td_{$value['menu_level']} center'>
                            <input type='checkbox' class='checkbox delete_{$value['menu_level']}' cat='delete'  name='is_delete[{$value['menu_id']}]' value='1' {$delete_checked} {$delete_disabled} {$delete_index_enabled}/>
                        </td>";
                $html .= "    <td class='td_{$value['menu_level']} center'>
                            <input type='checkbox' class='checkbox print_{$value['menu_level']}' cat='print'  name='is_print[{$value['menu_id']}]' value='1' {$print_checked} {$print_disabled} {$print_index_enabled}/>
                        </td>";
                $html .= "    <td class='td_{$value['menu_level']}' style='padding-top:5px;padding-left:15px;padding-left:{$level}px'>
                    {$value['menu_name_'.dir]}
                        </td>";
                if (authentication::get_user_type() == "super") {
                    $html .= "    <td class='td_{$value['menu_level']}' >
                    {$value['menu_link']}
                        </td>";
                }
                $html .= "</tr>";
                if ($value['children']) {
                    $html .= $this->get_children($value['children'], $tree_child[$key]['children']);
                }
            }
        /**
         * build pannel privileges
         * in case if ajax
         */
        $condition_panel = "where `panel`.`panel_is_disable` = '0'";
        if ($this->get_group_id()) {

            $condition_panel = "
                inner join `group_privilege` on `group_privilege`.`panel_id`=`panel`.`panel_id`
                where 1=1
                and `group_privilege`.`group_id`='{$this->get_group_id()}'
                and `panel`.`panel_is_disable` = '0'
                ";
        }

        $result = parent::get_result("select * from panel $condition_panel order by `panel`.`panel_sort` ASC");
        $panel_tree_child = array();

        while ($row = parent::next($result))
            $panel_tree_child[] = $row;
        /**
         * build pannel privileges in case of modify form
         *
         */
        $panel_tree = array();
        if ($this->get_parent_group_id() > 0)
            $result = parent::get_result("
                                select * from panel
                                inner join `group_privilege` on `group_privilege`.`panel_id`=`panel`.`panel_id`
                                where 1=1
                                and `group_privilege`.`group_id`='{$this->get_parent_group_id()}'
                                and `group_privilege_is_permit`<>'0'
                                and `panel`.`panel_is_disable` = '0'
                            order by `panel`.`panel_sort` ASC");

        else
        if (authentication::get_user_type() == 'super')
            $result = parent::get_result("
                                select * ,
                                        1 as group_privilege_is_permit ,
                                        1 as group_privilege_is_add,
                                        1 as group_privilege_is_modify,
                                        1 as group_privilege_is_delete,
                                        1 as group_privilege_is_print
                                from panel
                                where 1=1
                                and `panel`.`panel_is_disable` = '0'
                               order by `panel`.`panel_sort` ASC");

        while ($row = parent::next($result))
            $panel_tree[] = $row;


        if ($panel_tree) {
            $html .= "<tr valign='top'>";
            $html .= "    <td class='td_main'>
                                &nbsp;
                            </td>";
            $html .= "    <td  class='td_main'>
                                &nbsp;
                            </td>";
            $html .= "    <td class='td_main'>
                                &nbsp;
                            </td>";
            $html .= "    <td class='td_main'>
                                &nbsp;
                            </td>";
            $html .= "    <td class='td_main'>
                                &nbsp;
                            </td>";
            $html .= "    <td class='td_main'>
                                " . COMPONENTS_CONTROL_PANEL . "
                            </td>";
            $html .= "    <td class='td_main'>
                                &nbsp;
                            </td>";
            $html .= "</tr>";
            foreach (@$panel_tree as $key => $value) {
                $value['panel_is_permit'] = 1;
                foreach ($actions as $action) {
                    ${$action . "_checked"} = null;
                    ${$action . "_disabled"} = null;
                    ${$action . "_index_enabled"} = "index_enabled='1'";
                    if (!$panel_tree_child[$key]['group_privilege_is_permit'])
                        ${$action . "_disabled"} = 'disabled';

                    /**
                     * case group is a child group
                     * and not checked privilege
                     */
                    if (!$value['panel_is_' . $action]) {
                        ${$action . "_checked"} = null;
                        ${$action . "_disabled"} = "disabled";
                        ${$action . "_index_enabled"} = "index_enabled='0'";
                    } else {
                        if (!$value['group_privilege_is_' . $action]) {
                            ${$action . "_checked"} = null;
                            ${$action . "_disabled"} = "disabled";
                            ${$action . "_index_enabled"} = "index_enabled='0'";
                        }
                        /**
                         * if modify form and checked
                         */ else {
                            if ($panel_tree_child[$key]['group_privilege_is_' . $action]) {
                                ${$action . "_checked"} = "checked";
                                ${$action . "_disabled"} = null;
                                ${$action . "_index_enabled"} = "index_enabled='1'";
                            }
                        }
                    }
                }
                $html .= "<tr valign='top'>";
                $html .= "    <td class='td_link center'>
                            <input type='checkbox' class='checkbox permit_panel' cat='permit' name='is_permit[panel{$value['panel_id']}]'  value='1' {$permit_checked}/>
                        </td>";
                $html .= "    <td  class='td_link center'>
                            <input type='checkbox' class='checkbox add_panel'    cat='add'     name='is_add[panel{$value['panel_id']}]' value='1'    {$add_checked} {$add_disabled} {$add_index_enabled}/>
                        </td>";
                $html .= "    <td class='td_link center'>
                            <input type='checkbox' class='checkbox modify_panel' cat='modify'  name='is_modify[panel{$value['panel_id']}]' value='1' {$modify_checked} {$modify_disabled} {$modify_index_enabled}/>
                        </td>";
                $html .= "    <td class='td_link center'>
                            <input type='checkbox' class='checkbox delete_panel' cat='delete'  name='is_delete[panel{$value['panel_id']}]' value='1' {$delete_checked} {$delete_disabled} {$delete_index_enabled}/>
                        </td>";
                $html .= "    <td class='td_link center'>
                            <input type='checkbox' class='checkbox print_panel' cat='print'  name='is_print[panel{$value['panel_id']}]' value='1' {$print_checked} {$print_disabled} {$print_index_enabled}/>
                        </td>";
                $html .= "    <td class='td_link'style='padding-" . DIR_ALIGN . ":15px'>
                            <img src='" . theme_dir_url_path . "/images/common/branch.gif' atl=''/>
                            {$value['panel_name']}
                        </td>";
                if (authentication::get_user_type() == "super") {
                    $html .= "    <td class='td_link'>
                            {$value['panel_link']}
                        </td>";
                }
                $html .= "</tr>";
            }
        }
        $html .= "</table>";
        $script = "
            <script>
                /**
                 * Horizental check for the same row
                 */
                jQuery('.permit_main,.permit_sub,.permit_link,.permit_panel').click(function(){
                    var status = jQuery(this).is(':checked');

                    if(status)
                        jQuery(this).parent('td:first').nextAll().children('.checkbox').not('input[index_enabled=\"0\"]').removeAttr('disabled');
                    else
                        jQuery(this).parents('td:first').nextAll().children('.checkbox').not('input[index_enabled=\"0\"]').attr('disabled','disabled');
                })
                /**
                 *is Last Check
                 *
                 */
                 function is_last_check(index,cat,status){
                    if(status == 0 && index>0){
                        var bool = 0;
                        jQuery('tr').nextAll().filter('tr[index=\"'+index+'\"]').each(function(){
                                var class_name = jQuery(this).attr('class');
                                if(jQuery(this).children('td').children('.'+cat+'_'+class_name+':enabled').not('input[index_enabled=\"0\"]').attr('checked'))
                                {
                                    bool++;
                                    return false;
                                }
                            })
                        if(bool>0)
                            return true;
                    }
                    return false
                 }
                /**
                 * drillup function.
                 * vertical + horizental check
                 */
                function drillup(obj,self,cat,status){
                    if(!is_last_check(self,cat,status)){
                        obj.prevAll().filter('tr[self=\"'+self+'\"]').each(function(){
                                jQuery(this).children('td').children('.'+cat+'_sub:enabled,.'+cat+'_main:enabled').not('input[index_enabled=\"0\"]').attr('checked',status);
                                if(status && cat == 'permit')
                                    jQuery(this).children('td').children('.checkbox').filter('input[cat!=\"permit\"]').not('input[index_enabled=\"0\"]').removeAttr('disabled');
                                if(!status && cat == 'permit')
                                    jQuery(this).children('td').children('.checkbox').filter('input[cat!=\"permit\"]').not('input[index_enabled=\"0\"]').attr('disabled','disabled');
                                drillup(jQuery(this),jQuery(this).attr('index'),cat,status);
                            }
                        )
                    }
                }
                /**
                 * drilldown function.
                 * vertical + horizental check
                 */
                function drilldown(obj,index,cat,status){
                    obj.nextAll().filter('tr[index=\"'+index+'\"]').each(function(){
                            jQuery(this).children('td').children('.'+cat+'_link:enabled,.'+cat+'_sub:enabled').not('input[index_enabled=\"0\"]').attr('checked',status);
                            if(status && cat == 'permit')
                                jQuery(this).children('td').children('.checkbox').filter('input[cat!=\"permit\"]').not('input[index_enabled=\"0\"]').removeAttr('disabled');
                            if(!status && cat == 'permit')
                                jQuery(this).children('td').children('.checkbox').filter('input[cat!=\"permit\"]').not('input[index_enabled=\"0\"]').attr('disabled','disabled');
                            drilldown(jQuery(this),jQuery(this).attr('self'),cat,status);
                        }
                    )
                  
                }
                /**
                 * main section
                 * vertical + horizental check
                 */
                jQuery('.permit_main,.add_main,.modify_main,.delete_main,.print_main').click(
                            function(){                            
                            var status = jQuery(this).is(':checked');
                            var cat = jQuery(this).attr('cat');
                            var self   =  jQuery(this).parent().parent().attr('self');
                            var index  =  jQuery(this).parent().parent().attr('index');

                            jQuery(this).parent().parent().nextAll().filter('tr[index=\"'+self+'\"]').each(
                                function(){
                                    jQuery(this).children('td').children('.'+cat+'_link:enabled,.'+cat+'_sub:enabled').not('input[index_enabled=\"0\"]').attr('checked',status);
                                    if(status && cat == 'permit')
                                        jQuery(this).children('td').children('.checkbox').filter('input[cat!=\"permit\"]').not('input[index_enabled=\"0\"]').removeAttr('disabled');
                                    if(!status && cat == 'permit')
                                        jQuery(this).children('td').children('.checkbox').filter('input[cat!=\"permit\"]').not('input[index_enabled=\"0\"]').attr('disabled','disabled');
                                    drilldown(jQuery(this),jQuery(this).attr('self'),cat,status);
                                }
                            )
                        }
                  );
                /**
                 * sub section
                 * vertical + horizental check
                 */
                jQuery('.permit_sub,.add_sub,.modify_sub,.delete_sub,.print_sub').click(
                            function(){
                            var status = jQuery(this).is(':checked');
                            var cat    = jQuery(this).attr('cat');
                            var self   =  jQuery(this).parent().parent().attr('self');
                            var index  =  jQuery(this).parent().parent().attr('index');
                            jQuery(this).parent().parent().nextAll().filter('tr[index=\"'+self+'\"]').each(
                                function(){
                                    jQuery(this).children('td').children('.'+cat+'_link:enabled,.'+cat+'_sub:enabled').not('input[index_enabled=\"0\"]').attr('checked',status);
                                    if(status && cat == 'permit'){                                    
                                        jQuery(this).children('td').children('.checkbox').filter('input[cat!=\"permit\"]').not('input[index_enabled=\"0\"]').removeAttr('disabled');
                                        }
                                    if(!status && cat == 'permit')
                                        jQuery(this).children('td').children('.checkbox').filter('input[cat!=\"permit\"]').not('input[index_enabled=\"0\"]').attr('disabled','disabled');
                                   drilldown(jQuery(this),jQuery(this).attr('self'),cat,status);
                                   }
                            )
                            jQuery(this).parent().parent().prevAll().filter('tr[self=\"'+index+'\"]').each(
                                function(){
                                if(!is_last_check(index,cat,status)){
                                    jQuery(this).children('td').children('.'+cat+'_main:enabled,.'+cat+'_sub:enabled').not('input[index_enabled=\"0\"]').attr('checked',status);
                                    if(status && cat == 'permit')
                                        jQuery(this).children('td').children('.checkbox').filter('input[cat!=\"permit\"]').not('input[index_enabled=\"0\"]').removeAttr('disabled');
                                    if(!status && cat == 'permit')
                                        jQuery(this).children('td').children('.checkbox').filter('input[cat!=\"permit\"]').not('input[index_enabled=\"0\"]').attr('disabled','disabled');
                                    drillup(jQuery(this),jQuery(this).attr('index'),cat,status);
                                    }
                                }
                            )

                        }
                    )
                /**
                 * link section
                 * vertical + horizental check
                 */
                  jQuery('.permit_link,.add_link,.modify_link,.delete_link,.print_link').click(function(){
                            var status = jQuery(this).is(':checked');
                            var cat    = jQuery(this).attr('cat');
                            var self   =  jQuery(this).parent().parent().attr('self');
                            var index  =  jQuery(this).parent().parent().attr('index');
                            var type   =  jQuery(this).parent().parent().attr('class');
                            jQuery(this).parent().parent().prevAll().filter('tr[self=\"'+index+'\"]').each(
                                function(){
                                if(!is_last_check(index,cat,status)){
                                    jQuery(this).children('td').children('.'+cat+'_main:enabled,.'+cat+'_sub:enabled').not('input[index_enabled=\"0\"]').attr('checked',status);
                                    if(status && cat == 'permit')
                                        jQuery(this).children('td').children('.checkbox').filter('input[cat!=\"permit\"]').not('input[index_enabled=\"0\"]').removeAttr('disabled');
                                    if(!status && cat == 'permit')
                                        jQuery(this).children('td').children('.checkbox').filter('input[cat!=\"permit\"]').not('input[index_enabled=\"0\"]').attr('disabled','disabled');
                                    drillup(jQuery(this),jQuery(this).attr('index'),cat,status);}
                                }
                            )
                        }
                    )
            </script>";

        return $html . $script;
    }

}

?>