<?php

include_once('../connecter.php');
include_once("builder_privileges_tree.php");

if (file_exists(extension_physical_path . "components/group.php")) {
    location(extension_url_path . "components/group.php");
    exit;
}
if (authentication::get_user_type() == "user") {
    echo def_no_privillages_err;
    exit;
}

define("theme_title", SETTINGS_MENU_GROUPS);
define("theme_width", "100%");
define("theme_height", "100%");
define("theme_align", "center");
define("text_align", DIR_ALIGN);
define("table_title", GROUP_TABLE_TITLE);
define("db_table_name", "group");
define("element_per_row", "1");
define("message_column", "group_name");

define("group_name", GROUP_NAME);
define("group_user_type", GROUP_USER_TYPE);
define("group_is_disabled", GROUP_IS_DISABLE);

authentication::block_user();
authentication::authenticate();
authentication::safe_buttons(array('add', 'modify', 'delete'));

class group_form extends basic_form {

    private $index_id = null;

    public function __construct() {
        parent::enable_tree();
        if (!$_POST['group_is_disabled'])
            $_POST['group_is_disabled'] = '0';
        if (!$_POST['group_is_backup'])
            $_POST['group_is_backup'] = '0';
        $this->index_id = new combo("index_id", "group_name", "group_id");
        parent::__construct();
    }

    public function get_childs_id($is_search = false, $group_id = null) {

        if ($is_search)
            $condition = " and `group`.group_id <> '" . authentication::get_group_id() . "' ";

        $ids = new children_ids("group");
        if ($group_id)
            $ids->set_needle($group_id);
        else
            $ids->set_needle(authentication::get_group_id());
        if (authentication::_get("app_dealer_id")) {
            $dealer_cond = " or app_dealer_id = " . authentication::_get("app_dealer_id");
        }
        $dealer_cond = " and (app_dealer_id IS NULL {$dealer_cond}) ";
        $ids->set_query("select * from `group`
                            where 1 = 1 {$dealer_cond}
            {$condition}
                         order by index_id")
                ->load();
        return $ids->get_ids();
    }

    public function childs_rec($index_id) {
        $result = parent::get_result("select * from `group` where index_id='{$index_id}'");
        while ($row = parent::next($result)) {
            parent::execute_statment("update `group` set group_is_disabled='{$_POST['group_is_disabled']}'
                                        where `group_id`='{$row['group_id']}'");
            if (!$_POST['group_is_backup'])
                parent::execute_statment("update `group` set group_is_backup='{$_POST['group_is_backup']}'
                                        where `group_id`='{$row['group_id']}'");
            $this->childs_rec($row['group_id']);
        }
    }

    public function add() {
        
        if(!$_POST["app_dealer_id"]){
            $_POST["app_dealer_id"]= authentication::_get("app_dealer_id");
        }
        if (!$_POST['is_permit']) {
            $this->form->set_message("error", GROUP_PRIVILEGES . ' ' . LANG_VALID);
            return parent::direct("add_form", $_POST);
        }
        if (!$_POST['is_add']
                AND!$_POST['is_modify']
                AND!$_POST['is_delete']
                AND!$_POST['is_print']
        ) {
            $this->form->set_message("error", GROUP_PRIVILEGES . ' ' . LANG_VALID);
            return parent::direct("add_form", $_POST);
        }
        /*         * * */

        parent::insert("group", false);
        $group_id = parent::get_last_id();
        if ($_POST['index_id'])
            $condition = "inner join `group_privilege` on `group_privilege`.`menu_id`=`menu`.`menu_id`
                          where 1=1
                          and `group_privilege`.`group_id`='{$_POST['index_id']}'
                          and group_privilege_is_permit<>0";

        $result = parent::get_result("select * from menu {$condition}");
        while ($row = parent::next($result)) {
            if (!$_POST['is_permit'][$row['menu_id']])
                $_POST['is_permit'][$row['menu_id']] = 0;
            if (!$_POST['is_add'][$row['menu_id']])
                $_POST['is_add'][$row['menu_id']] = 0;
            if (!$_POST['is_modify'][$row['menu_id']])
                $_POST['is_modify'][$row['menu_id']] = 0;
            if (!$_POST['is_delete'][$row['menu_id']])
                $_POST['is_delete'][$row['menu_id']] = 0;
            if (!$_POST['is_print'][$row['menu_id']])
                $_POST['is_print'][$row['menu_id']] = 0;
            parent::execute_statment(" insert into `group_privilege` set
                                        `group_id` ='" . $group_id . "',
                                        `menu_id`  = '{$row['menu_id']}',
                                        `group_privilege_is_permit`  = '{$_POST['is_permit'][$row['menu_id']]}',
                                        `group_privilege_is_add`     = '{$_POST['is_add'][$row['menu_id']]}',
                                        `group_privilege_is_modify`  = '{$_POST['is_modify'][$row['menu_id']]}',
                                        `group_privilege_is_print`  = '{$_POST['is_print'][$row['menu_id']]}',
                                        `group_privilege_is_delete`  = '{$_POST['is_delete'][$row['menu_id']]}'", false);
        }
        if ($_POST['index_id'])
            $condition = "inner join `group_privilege` on `group_privilege`.`panel_id`=`panel`.`panel_id`
                          where 1=1
                          and `group_privilege`.`group_id`='{$_POST['index_id']}'
                          and group_privilege_is_permit<>0";

        $result = parent::get_result("select * from panel {$condition}");
        while ($row = parent::next($result)) {
            if (!$_POST['is_permit'][$row['menu_id']])
                $_POST['is_permit'][$row['menu_id']] = 0;
            if (!$_POST['is_add'][$row['menu_id']])
                $_POST['is_add'][$row['menu_id']] = 0;
            if (!$_POST['is_modify'][$row['menu_id']])
                $_POST['is_modify'][$row['menu_id']] = 0;
            if (!$_POST['is_delete'][$row['menu_id']])
                $_POST['is_delete'][$row['menu_id']] = 0;
            if (!$_POST['is_print'][$row['menu_id']])
                $_POST['is_print'][$row['menu_id']] = 0;
            parent::execute_statment(" insert into `group_privilege` set
                                        `group_id` ='" . $group_id . "',
                                        `panel_id`  = '{$row['panel_id']}',
                                        `group_privilege_is_permit`  = '{$_POST['is_permit']["panel{$row['panel_id']}"]}',
                                        `group_privilege_is_add`     = '{$_POST['is_add']["panel{$row['panel_id']}"]}',
                                        `group_privilege_is_modify`  = '{$_POST['is_modify']["panel{$row['panel_id']}"]}',
                                        `group_privilege_is_print`  = '{$_POST['is_print'][$row['menu_id']]}',                                            
                                        `group_privilege_is_delete`  = '{$_POST['is_delete']["panel{$row['panel_id']}"]}'", false);
        }
        $this->form->set_message("success", MSG_SUCCESS . ",  " . $GLOBALS['_POST'][$this->message_column] . " " . MSG_ADDED);
        return parent::direct("add_form");
    }

    public function modify() {
        if(!$_POST["app_dealer_id"] and authentication::_get("app_dealer_id")){
            $_POST["app_dealer_id"]= authentication::_get("app_dealer_id");
        }
        if (!$_POST['is_permit']) {
            $this->form->set_message("error", GROUP_PRIVILEGES . ' ' . LANG_VALID);
            return parent::direct("modify_form", $_POST['group_id']);
        }
        if (!$_POST['is_add']
                AND!$_POST['is_modify']
                AND!$_POST['is_delete']
                AND!$_POST['is_print']
        ) {
            $this->form->set_message("error", GROUP_PRIVILEGES . ' ' . LANG_VALID);
            return parent::direct("modify_form", $_POST['group_id']);
        }

        $group_id = $_POST['group_id'];
        parent::execute_statment("delete from group_privilege where group_id='{$group_id}'");
        if ($_POST['index_id'])
            $condition = "inner join `group_privilege` on `group_privilege`.`menu_id`=`menu`.`menu_id`
                          where 1=1
                          and `group_privilege`.`group_id`='{$_POST['index_id']}'
                          and group_privilege_is_permit<>0";

        $result = parent::get_result("select * from menu {$condition}");
        while ($row = parent::next($result)) {

            if (!$_POST['is_permit'][$row['menu_id']])
                $_POST['is_permit'][$row['menu_id']] = 0;
            if (!$_POST['is_add'][$row['menu_id']])
                $_POST['is_add'][$row['menu_id']] = 0;
            if (!$_POST['is_modify'][$row['menu_id']])
                $_POST['is_modify'][$row['menu_id']] = 0;
            if (!$_POST['is_delete'][$row['menu_id']])
                $_POST['is_delete'][$row['menu_id']] = 0;
            if (!$_POST['is_print'][$row['menu_id']])
                $_POST['is_print'][$row['menu_id']] = 0;

            parent::execute_statment(" insert into `group_privilege` set
                                        `group_id` ='" . $group_id . "',
                                        `menu_id`  = '{$row['menu_id']}',
                                        `group_privilege_is_permit`  = '{$_POST['is_permit'][$row['menu_id']]}',
                                        `group_privilege_is_add`     = '{$_POST['is_add'][$row['menu_id']]}',
                                        `group_privilege_is_modify`  = '{$_POST['is_modify'][$row['menu_id']]}',
                                        `group_privilege_is_print`   = '{$_POST['is_print'][$row['menu_id']]}',
                                        `group_privilege_is_delete`  = '{$_POST['is_delete'][$row['menu_id']]}'", false);
            if (!$_POST['is_permit'][$row['menu_id']]
                    OR
                    !$_POST['is_add'][$row['menu_id']]
                    OR
                    !$_POST['is_modify'][$row['menu_id']]
                    OR
                    !$_POST['is_print'][$row['menu_id']]
                    OR
                    !$_POST['is_delete'][$row['menu_id']]
            ) {
                $data_source = $this->get_childs_id(false, $_POST['group_id']);
                unset($data_source[$_POST['group_id']]);
                $actions = array("permit", "add", "modify", "delete", "print");
                if ($data_source)
                    foreach ($actions as $value) {
                        if (!$_POST['is_' . $value][$row['menu_id']])
                            parent::execute_statment(" update `group_privilege` set `group_privilege_is_{$value}` = '0'
                                                        where `group_id` in (" . implode(",", array_keys($data_source)) . ")
                                                        and    `menu_id` = '{$row['menu_id']}'");
                    }
            }
        }

        if ($_POST['index_id'])
            $condition = "inner join `group_privilege` on `group_privilege`.`panel_id`=`panel`.`panel_id`
                          where 1=1
                          and `group_privilege`.`group_id`='{$_POST['index_id']}'
                          and group_privilege_is_permit<>0";

        $result = parent::get_result("select * from panel {$condition}");
        while ($row = parent::next($result)) {
            parent::execute_statment(" insert into `group_privilege` set
                                        `group_id` ='" . $group_id . "',
                                        `panel_id`  = '{$row['panel_id']}',
                                        `group_privilege_is_permit`  = '{$_POST['is_permit']["panel{$row['panel_id']}"]}',
                                        `group_privilege_is_add`     = '{$_POST['is_add']["panel{$row['panel_id']}"]}',
                                        `group_privilege_is_modify`  = '{$_POST['is_modify']["panel{$row['panel_id']}"]}',
                                        `group_privilege_is_print`  = '{$_POST['is_print']["panel{$row['panel_id']}"]}',
                                        `group_privilege_is_delete`  = '{$_POST['is_delete']["panel{$row['panel_id']}"]}'
                ", false);
            if (!$_POST['is_permit'][$row['panel_id']]
                    OR
                    !$_POST['is_add'][$row['panel_id']]
                    OR
                    !$_POST['is_modify'][$row['panel_id']]
                    OR
                    !$_POST['is_print'][$row['panel_id']]
                    OR
                    !$_POST['is_delete'][$row['panel_id']]
            ) {
                $data_source = $this->get_childs_id(false, $_POST['group_id']);
                unset($data_source[$_POST['group_id']]);
                $actions = array("permit", "add", "modify", "delete", "print");
                if ($data_source)
                    foreach ($actions as $value) {
                        if (!$_POST['is_' . $value]["panel{$row['panel_id']}"])
                            parent::execute_statment(" update `group_privilege` set `group_privilege_is_{$value}` = '0'
                                                        where `group_id` in (" . implode(",", array_keys($data_source)) . ")
                                                        and    `panel_id` = '{$row['panel_id']}'");
                    }
            }
        }
        $result = parent::get_result("select * from `group` where index_id='{$_POST['group_id']}'");
        while ($row = parent::next($result)) {
            parent::execute_statment("update `group` set group_is_disabled='{$_POST['group_is_disabled']}'
                                        where `group_id`='{$row['group_id']}'");
            if (!$_POST['group_is_backup'])
                parent::execute_statment("update `group` set group_is_backup='{$_POST['group_is_backup']}'
                                        where `group_id`='{$row['group_id']}'");
            $this->childs_rec($row['group_id']);
        }

        parent::modify();
    }

    public function delete() {
        if ($_POST['group_id'] == authentication::get_group_id() && authentication::get_user_type() != 'super') {
            $this->form->set_message("error", GROUP_SELF_DELETE_ERR);
            return parent::direct("modify_form", $_REQUEST['group_id']);
        }
        $check = new check_exsitence("user");
        $check->add_sql_condition(" and group_id ='{$_REQUEST['group_id']}' ");
        if ($check->check()) {
            $this->form->set_message("error", GROUP_USERS_EXISTS);
            return parent::direct("modify_form", $_REQUEST['group_id']);
        }
        $check = new check_exsitence("group");
        $check->add_sql_condition(" and group_id <>'{$_REQUEST['group_id']}' ");
        $check->add_sql_condition(" and index_id ='{$_REQUEST['group_id']}' ");
        if ($check->check()) {
            $this->form->set_message("error", GROUP_CHILDREN_EXISTS);
            return parent::direct("modify_form", $_REQUEST['group_id']);
        }
        parent::execute_statment("delete from `group_privilege` where `group_id`='{$_POST['group_id']}'");
        parent::delete();
    }

    public function search() {
        $this->grid_result->add_join('left join `group` as parent_group on `group`.index_id = parent_group.group_id ');

        if (authentication::get_user_type() == 'admin') {
            $ids = implode(",", array_keys($this->get_childs_id(true)));
            if ($ids)
                $this->grid_result->attach_conditions(" and `group`.`group_id` in ({$ids}) ");
            else
                $this->grid_result->attach_conditions(" and `group`.`index_id` ='" . authentication::get_group_id() . "' ");
        }
//        if (authentication::_get("app_dealer_id")) {
//            $this->grid_result->attach_conditions(" and `group`.`app_dealer_id` ='" . authentication::_get("app_dealer_id") . "' ");
//        }
//        $this->grid_result->debug();
        parent::search();
    }

    public function search_form() {
//        $this->grid->debug();
        $this->grid->set_width(700);
        $this->grid_exe->show_numbering();

        $this->grid_exe->set_modify_id("group.group_id");
        $this->grid_exe->new_obj('group_name');
        $this->grid_exe->set_alias("`group`.`group_name`");
        $this->grid_exe->set_title(group_name);
        $this->grid_exe->set_type('string');
        $this->grid_exe->set_width(140);
        $this->grid_exe->add_obj();
        $this->get_group_combo();
        $this->grid_exe->new_obj("index_id");
        $this->grid_exe->set_header_alias("parent_group.group_name");
        $this->grid_exe->set_type("string", "combo");
        $this->grid_exe->set_title(GROUP_INDEX);
        $this->grid_exe->set_filter_alias("`group`.`index_id`");
        $this->grid_exe->set_object($this->index_id);
        $this->grid_exe->set_header_width(140);
        $this->grid_exe->add_obj();

        $this->grid_exe->new_obj('group_is_backup');
        $this->grid_exe->set_alias("`group`.`group_is_backup`");
        $this->grid_exe->set_title(GROUP_IS_BACKUP);
        $this->grid_exe->set_type('bool');
        $this->grid_exe->set_width(300);
        $this->grid_exe->add_obj();

        $this->grid_exe->new_obj('group_is_disabled');
        $this->grid_exe->set_alias("`group`.`group_is_disabled`");
        $this->grid_exe->set_title(group_is_disabled);
        $this->grid_exe->set_type('bool');
        $this->grid_exe->set_width(100);
        $this->grid_exe->add_obj();

        return parent::search_form();
    }

    public function ajax_tree_children() {
        if (authentication::get_user_type() == 'admin') {
            $ids = implode(",", array_keys($this->get_childs_id(true)));
            if ($ids)
                $this->tree_result->attach_conditions(" and `group`.`group_id` in ({$ids}) ");
            else
                $this->tree_result->attach_conditions(" and `group`.`index_id` ='" . authentication::get_group_id() . "' ");
        }
        //$this->tree_result->debug();
        parent::ajax_tree_children();
    }

    public function ajax() {

        switch ($_POST['event']) {
            case 'get_tree':
                $tree = new privileges_tree("menu");
                if ($_POST['group_id'])
                    $tree->set_group_id($_POST['group_id']);

                $tree->set_parent_group_id($_POST['group_id']);

                echo $tree->load();

                $result = parent::get_result("select group_is_backup from `group` where group_id = '{$_POST['group_id']}'");
                $row = parent::next($result);
                if (!$row['group_is_backup'])
                    echo "  <script type='text/javascript'>
                                    jQuery('#group_is_backup').attr('disabled','disabled');
                                </script>";
                else
                    echo "  <script type='text/javascript'>
                                    jQuery('#group_is_backup').attr('disabled',false);
                                </script>";
                break;
            case 'validation':
                $check = new check_exsitence("group", "group_name");
                if ($_POST['group_id'] != "undifined")
                    $check->add_sql_condition(" and group_id <>'{$_POST['group_id']}'");
                if ($check->check())
                    echo 'false';
                else
                    echo 'true';
                break;
        }
    }

    public function load($var) {
        /*
         * dealer
         */
        
        $ajax = new parser_ajax();
        $ajax->set_url(self)
                ->set_data_type("json")
                ->set_type("post")
                ->add_data("action", "get_dealer_groups")
                ->add_data("app_dealer_id", "app_dealer_id.getActualValue()", true)
                ->set_before_send("")
                ->set_success("
                           {$this->index_id->get_name()}.clearData();
                              eval('{$this->index_id->get_name()}'+result.groups);
                ");
        $cond = NULL;
        if (authentication::_get("app_dealer_id")) {
            $all_childs = array();
            get_all_child(authentication::_get("app_dealer_id"), $all_childs);
            if (count($all_childs) > 0)
                $cond = " and app_dealer.app_dealer_id in (" . implode(",", $all_childs) . ")";
        }
        $app_dealer_id = new combo("app_dealer_id", "app_dealer_name", "app_dealer_id");
        $app_dealer_id->set_data_source("select app_dealer_id,app_dealer_name from app_dealer where 1=1 {$cond} order by app_dealer_name")
                ->set_value($var['app_dealer_id'])
                ->set_onchange($ajax->load())
        ;
        $this->table->set_col_span(2)->new_element(def_app_subscriber_dealer_name, $app_dealer_id->load());
        /*
         * 
         */
        $this->get_group_combo($var['group_id']);
        if ($var['index_id'] > 0)
            $this->index_id->set_value($var['index_id']);
        $this->index_id->set_onchange("
                            jQuery.ajax({
                                type:'POST',
                                url:'group.php',
                                data : 'action=ajax&event=get_tree&group_id='+{$this->index_id->get_name()}.getActualValue(),
                                beforeSend:function(){
                                    jQuery('#tree_div').html('Loading...');
                                },
                                success:function(result){
                                    jQuery('#tree_div').html(result);
                                },
                                error:function(err){
                                    alert(err);
                                }
            })");

        if (authentication::get_user_type() == 'admin')
            $this->index_id->set_valid();

//        $this->index_id->set_valid_msg(GROUP_INDEX." ".LANG_VALID);
        $this->table->new_element(GROUP_INDEX, $this->index_id->load());

        $group_name = new input_text("group_name");
        $group_name->set_valid();
//        $group_name->set_valid_msg(group_name.' '.LANG_VALID);
        $group_name->set_value($var['group_name']);
        $this->table->new_element(group_name, $group_name->load());


        $group_is_backup = new input_check('group_is_backup');
        if ($var['index_id']) {
            $result = parent::get_result("select group_is_backup from `group` where group_id = '{$var['index_id']}'");
            $row = parent::next($result);
            if (!$row['group_is_backup'])
                $group_is_backup->set_disable();
        }

        $group_is_backup->set_value($var['group_is_backup']);
        $this->table->new_element(GROUP_IS_BACKUP, $group_is_backup->load());

        $group_is_disabled = new input_check('group_is_disabled');
        $group_is_disabled->set_value($var['group_is_disabled']);
        if ($var['index_id']) {
            $result = parent::get_result("select group_is_disabled from `group` where group_id = '{$var['index_id']}' ");
            $row = parent::next($result);
            if ($row['group_is_disabled'] == 1) {
                $group_disable = new input_hidden('group_is_disabled');
                $group_disable->set_value($row['group_is_disabled']);
                $this->add_html($group_disable->load());
                $group_is_disabled->set_disable();
                $success_div = new div("warn_div");
                $success_div->set_id("warn_div");
                $success_div->add_css("position", "relative");
                $success_div->add_css("height", "30px");
                $success_div->add_css("width", "500px");
                $success_div->add_css("direction", dir);
                $success_div->add_css("border", "2px solid #CC0000");
                $success_div->add_css("background-color", "#FFFFCC ");
                $success_div->add_css("display", "block");
                $success_div->add_css("height", "45px");
                $success_div->add_css("color", "#CC0000");
                $table = "<table border='0' cellpadding='0' cellspacing='10' style='height:45px;'>
                            <tr>
                                <td valign='middle'><img src='" . theme_common_url_path . "images/message/s_warn.png' alt=''/></td>
                                <td valign='middle'>" . GROUP_DISABLE_MSG . "</td>
                            </tr>
                            </table>
                            ";
                $success_div->set_html($table);
                $this->add_html($success_div->load() . "<br/>");
            }
        }

        $this->table->new_element(group_is_disabled, $group_is_disabled->load());

        $tree = new privileges_tree("menu");
        $tree->set_group_id($var['group_id']);
//
        if ($var['index_id'])
            $tree->set_parent_group_id($var['index_id']);
        else
        if (authentication::get_index_id())
            $tree->set_parent_group_id(authentication::get_index_id());
        else
            $tree->set_parent_group_id('0');

        if ($var['group_id'])
            $tree->set_group_id($var['group_id']);
        else
        if (authentication::get_group_id())
            $tree->set_group_id(authentication::get_group_id());
        else
            $tree->set_group_id('0');

        $tree_div = new div("tree_div");
        $tree_div->set_html($tree->load());
        $this->table->new_element(GROUP_PRIVILEGES, $tree_div->load());
        if (authentication::get_user_type() == 'admin')
            $condition = "&& {$this->index_id->get_name()}.getActualValue()";
        $this->form->add_script("jQuery('form').bind('submit',function(){
            var action = $(':focus', this).val();
                            if(jQuery('#no_valid').val()!=1 && action!='delete' && jQuery('#group_name').val() {$condition })
                            {
                           
                                jQuery.ajax({
                                        type:'POST',
                                        url:'group.php',
                                        data:'action=ajax&event=validation&group_id='+jQuery('#group_id').val()+'&group_name='+jQuery('#group_name').val(),
                                        beforeSend:function(){

                                        },
                                        success:function(result){
                                            if(eval(result))
                                                {   
                                                    jQuery('form').append('<input type=\"hidden\" id=\"no_valid\" value=\"1\"/>')
                                                    jQuery('button[value=\"'+action+'\"]').click();
                                                }
                                              else
                                                load_message('error','" . group_name . ' ' . SERVER_VALID_EXISTS . "','" . theme_common_url_path . "');
                                        },
                                        error:function(err){
                                            alert(err);
                                        }
                                    })
                                return false;
                            }


            })");
        parent::load();
    }

    public function get_group_combo($group_id = null) {
        if (authentication::get_user_type() == 'admin') {
            $data_source = $this->get_childs_id();
            if ($group_id) {
                $current_group_data_source = $this->get_childs_id(false, $group_id);
                $data_source = array_diff($data_source, $current_group_data_source);
            }
            $this->index_id->set_data_source($data_source, 'array');
        } else
        if (authentication::get_user_type() == 'super') {
            $condition = null;
            if ($group_id) {
                $condition = " and group_id not in (" . implode(",", array_keys($this->get_childs_id(false, $group_id))) . ")";
            }
            $this->index_id->set_data_source("select * from `group`
                                                        where 1=1
                    {$condition}
                                                        order by index_id");
        }
    }

    public function get_dealer_groups() {
        if ($_REQUEST["app_dealer_id"])
            $con = " or app_dealer_id = {$_REQUEST["app_dealer_id"]}";
        $con = " and (app_dealer_id IS NULL{$con})";
        $index_id = new combo("index_id", "group_name", "group_id");
        $index_id->set_data_source("select group_id,group_name from `group` "
                . " where 1=1 {$con}"
                . " group by group_id");
        $json['groups'] = $index_id->get_options();
        echo json_encode($json);
    }

}

new group_form();
?>
