<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
include("../connecter.php");
authentication::authenticate();
define("theme_width", "100%");
define("theme_height", "100%");
define("theme_align", "center");
define("text_align", "left");
define("element_per_row", "1");

if (dir == 'rtl') {
    define("theme_title", "إدارة سجل التغير");
    define("table_title", "السجل");
    define("log_theme_title", "إسم النموذج");
    define("log_record_name", "إسم السجل");
} else {
    define("log_theme_title", "Form Name");
    define("log_record_name", "Record Name");
    define("theme_title", "Logs");
    define("table_title", "Log");
}

class log_graphical_interface extends basic_form {

    public $log_type_array = array(0 => LOG_TYPE_ERROR, 1 => LOG_TYPE_NORMAL);
    public $admin_groups = array();
    public $admin_users = null;
    public $sql = null;

    public function __construct() {
        parent::set_theme_height("100%")
                ->set_context_menu(false)
                ->set_show_message(false)
                ->set_db_table_name("log");
        
        if (authentication::get_user_type() == 'admin') {
            $this->sql = new sql();
            
            $this->get_admin_groups(authentication::get_group_id());
            $this->get_group_users();
        }

        parent::__construct();
    }

    //here to stop the buttoms in the form (add, modify, delete)
    public function load_buttons() {
        return false;
    }

    public function get_admin_groups($group_id) {
        $this->admin_groups[] = $group_id;
        $result = $this->sql->get_result("select group_id from `group` where index_id = '" . $group_id . "' ");
        if ($result->num_rows) {
            while ($row = $this->sql->next($result))
                $this->get_admin_groups($row['group_id']);
        }
    }

    public function get_group_users() {

        if (!count($this->admin_groups))
            return null;
        $result = $this->sql->get_result("select user_id from `user` where group_id in (" . @implode(",", $this->admin_groups) . ") ");
        if ($result->num_rows) {
            while ($row = $this->sql->next($result))
                $this->admin_users[] = $row['user_id'];
        }
    }

    public function search() {
        //$this->grid_result->debug();
        $this->grid_result->add_join(" left join user on user.user_id = log.user_id ");
        if (authentication::get_user_type() != 'super') {

            //$this->grid_result->attach_conditions(" and (!(user.user_type='super') or ISNULL(user.user_type)) ");
            $this->grid_result->attach_conditions(" and user_type<>'super' or ISNULL(user_type))");
            //if we just put like below the query from front-end or file can execute it 
            //without permission like 'sync_menu' will be in log without user_id
            //so we can't get it since it will be of user_type NULL
            //$this->grid_result->attach_conditions(" and user_type<>'super' ");

            if (authentication::get_user_type() == 'admin')
                $this->grid_result->attach_conditions(" and log.user_id in (" . implode(',', $this->admin_users) . ") ");
            else    //user
                $this->grid_result->attach_conditions(" and log.user_id='".authentication::get_user_id()."' ");
        }
        
//        $this->grid_result->set_init_order("order by log_date_time DESC");

        parent::search();
    }

    public function search_form() {
        $this->grid->set_modify_title(more_details);
        $this->grid->disable_copy();
        $this->grid->disable_delete();
        //$this->grid->debug();
        $this->grid->set_width(800);
        $this->grid_exe->show_numbering();
        $this->grid_exe->set_modify_id("log_id");
        //-------------------------------------------------->
        $this->grid_exe->new_obj("user_id");
        $this->grid_exe->set_header_alias("user.user_name");
        $this->grid_exe->set_type("string", "combo");
        $this->grid_exe->set_title(user_id);
        $this->grid_exe->set_filter_alias("user.user_id");
        $users = new combo("user_id", "user_name", "user_id");
        if (authentication::get_user_type() != 'super') {
            $condition = " and user_type<>'super'";
            if (authentication::get_user_type() == 'admin')
                $condition = " and user_id in (" . implode(',', $this->admin_users) . ") ";
            else {   //user
                $condition = " and user_id='".authentication::get_user_id()."' ";
                $this->grid_exe->show_in("header");
            }
        }
        $users->set_data_source("select * from user where 1=1 $condition order by user_name asc");
        $this->grid_exe->set_object($users);
        $this->grid_exe->set_width(120);
        $this->grid_exe->add_obj();
        //-------------------------------------------------->
        $this->grid_exe->new_obj('log_date_time');
        $this->grid_exe->set_title(log_date_time);
        $this->grid_exe->set_type('date');
        $this->grid_exe->set_width(150);
        $this->grid_exe->add_obj();
        //-------------------------------------------------->
        $this->grid_exe->new_obj('log_theme_title');
        $this->grid_exe->set_title(log_theme_title);
        $this->grid_exe->set_type('string');
        $this->grid_exe->set_width(120);
        $this->grid_exe->add_obj();
        //-------------------------------------------------->
        $this->grid_exe->new_obj('log_record_name');
        $this->grid_exe->set_title(log_record_name);
        $this->grid_exe->set_type('string');
        $this->grid_exe->set_width(180);
        $this->grid_exe->add_obj();
        //-------------------------------------------------->
        $this->grid_exe->new_obj("log_request_page");
        $this->grid_exe->set_header_alias("log_request_page");
        $this->grid_exe->set_type("string", "combo");
        $this->grid_exe->set_title(log_request_page);
        $this->grid_exe->set_filter_alias("log_request_page");
        $pages = new combo("log_request_page", "log_request_page", "log_request_page");
        if (authentication::get_user_type() != 'super')
            $condition = " and log_user_name <>'developer'";
        $pages->set_data_source("select distinct log_request_page from log where 1=1 $condition order by log_request_page asc");
        $this->grid_exe->set_object($pages);
        $this->grid_exe->set_width(150, 400);
        $this->grid_exe->add_obj();
        //-------------------------------------------------->
        $this->grid_exe->new_obj('log_action');
        $this->grid_exe->set_title(log_action);
        $this->grid_exe->set_type('string');
        $this->grid_exe->set_width(80);
        $this->grid_exe->add_obj();
        //-------------------------------------------------->
        $this->grid_exe->new_obj('log_db_query');
        $this->grid_exe->set_header_alias("substring(log_db_query,1,250)");
        $this->grid_exe->set_title(log_db_query);
        $this->grid_exe->set_type('text');
        $this->grid_exe->set_width(200);
        $this->grid_exe->add_obj();
        //-------------------------------------------------->
        $this->grid_exe->new_obj('log_remote_address');
        $this->grid_exe->set_title(log_remote_address);
        $this->grid_exe->set_type('string');
        $this->grid_exe->set_width(100);
        $this->grid_exe->add_obj();
        //-------------------------------------------------->
        $this->grid_exe->new_obj('log_type');
        $this->grid_exe->set_header_alias("if(log_type=1,'" . LOG_TYPE_NORMAL . "','" . LOG_TYPE_ERROR . "') ");
        $this->grid_exe->set_title(log_type);
        $this->grid_exe->set_type("string", "combo");
        $log_type = new combo("log_type");
        $log_type->set_data_source($this->log_type_array, 'array');
        $this->grid_exe->set_object($log_type);
        $this->grid_exe->set_width(60);
        $this->grid_exe->add_obj();
        //-------------------------------------------------->

        return parent::search_form();
    }

    public function add_form() {
        $this->form->set_html("New records insertion is disabled.");
        $this->form->load();
    }

    public function load($var) {

        $taber = new taber();
        if ($var) {
            $result = $this->get_result("select user_name,user_full_name,user_type from user where user_id = '" . $this->escape($var['user_id']) . "' ");
            $row = $this->next($result);
            $var['log_user_real_name'] = $var['log_user_real_name'] ? $var['log_user_real_name'] : $row['user_full_name'];
            $var['log_user_type'] = $var['log_user_type'] ? $var['log_user_type'] : $row['user_type'];
            $info_table = "<table cellspacing='5' cellpadding='5' id='table_log'>
                                <tr>
                                    <th>" . log_date_time . "</th>
                                    <th>" . log_user_name . "</th>
                                    <th>" . log_user_real_name . "</th>
                                    <th>" . user_name_from_id . "</th>
                                    <th>" . log_user_type . "</th>
                                    <th>" . log_action . "</th>
                                    <th>" . log_remote_address . "</th>
                                    <th>" . log_type . "</th>
                                </tr>
                                <tr>
                                    <td>{$var['log_date_time']}</td>
                                    <td>{$var['log_user_name']}</td>
                                    <td>{$var['log_user_real_name']}</td>
                                    <td>{$row['user_name']}</td>
                                    <td>{$var['log_user_type']}</td>
                                    <td>{$var['log_action']}</td>
                                    <td>{$var['log_remote_address']}</td>
                                    <td>{$this->log_type_array[$var['log_type']]}</td>
                                </tr>
                                 <tr>
                                    <th>" . log_theme_title . "</th>
                                    <td colspan='7' id='log_db_query_td'>{$var['log_theme_title']}</td>
                                </tr>
                                 <tr>
                                    <th>" . log_record_name . "</th>
                                    <td colspan='7' id='log_db_query_td'>{$var['log_record_name']}</td>
                                </tr>
                                 <tr>
                                    <th>" . log_request_page . "</th>
                                    <td colspan='7' id='log_db_query_td'>{$var['log_request_page']}</td>
                                </tr>
                                <tr>
                                    <th>" . log_db_query . "</th>
                                    <td colspan='7' id='log_db_query_td'>{$var['log_db_query']}</td>
                                </tr>
                            </table>
                                ";
            $taber->add_tab(info_details, $info_table);
        }


        $del_table = new table();
        $from_date = new calendar('from_date');
        $from_date->set_valid();
//        $from_date->set_valid_msg(from_date . ' ' . LANG_VALID);
        $del_table->new_element(from_date, $from_date->load());

        $to_date = new calendar('to_date');
        $to_date->set_valid();
//        $to_date->set_valid_msg(to_date . ' ' . LANG_VALID);
        $del_table->new_element(to_date, $to_date->load());
        //below we take it to known function like add, modify delete so on it we can display message
        //since only on this fts. we create the $this->form or we must create new form
        $delete_log = new input_submit('delete');
        $delete_log->set_value(delete_log);
        $delete_log->add_event('onclick', 'if(confirm(\'' . LANG_DOM_DELETE_MSG . '\'))return true;else return false;');
        $del_table->new_element('', $delete_log->load());
        if (authentication::get_user_type() == 'super')
            $taber->add_tab(LANG_DELETE, $del_table->load());


        $this->table->new_element('', $taber->load());
        $this->add_html("<style>
            
                            #table_log td, #table_log th{
                                    vertical-align:middle;
                                    padding: 6px 6px 6px 6px;
                            }
                            #table_log th{
                                    color: #4f6b72;
                                    border:1px solid #7095C8;
                                    background: #D3DFEE;
                                    font-weight:bold;
                                    font-size:14px;
                            }
                            #table_log td{
                                 border:1px solid #C1DAD7;
                                 background: #ffffff;
                            }
                            #log_db_query_td{
                                 white-space:pre-wrap;
                            }
                           
                        </style>");
        parent::load();
    }

    public function delete() {
        if (authentication::get_user_type() == 'super') {
            if ($_POST['from_date'] && $_POST['to_date']) {
                parent::execute_statment("delete from log where date(log_date_time) between '{$_POST['from_date']}' and '{$_POST['to_date']}' ");

                $this->form->override_message_type("success");
                $this->form->override_message_text(MSG_DELETED);
                return $this->direct("add_form");
            }
            $this->form->override_message_type("error");
            $this->form->override_message_text(MSG_FAILED);
            return $this->direct("add_form");
        }
    }

}

new log_graphical_interface();
?>