<?php
include_once("../connecter.php");
define("panel_name",MENU_NAME);
define("panel_icon",MENU_ICON);

define("panel_sort",MENU_SORT);
define("panel_link",MENU_LINK);
define("theme_title",SETTINGS_MENU_PANEL);
define("theme_width","100%");
define("theme_height","100%");
define("theme_align","center");
define("text_align","left");
define("table_title",SETTINGS_MENU_PANEL);
define("db_table_name","panel");
define("element_per_row","1");
define("message_column","panel_name");
define("icon_ext","gif|png|ico");


authentication::authenticate();
class  panel_form extends basic_form {
    private $panel_icon=null;

    public  function  __construct() {
        $this->panel_icon = new input_file("panel_icon");
        $this->panel_icon->set_valid();
        $this->panel_icon->set_valid_msg(panel_icon.' '.LANG_VALID);
        $this->panel_icon->set_size(500);
        $this->panel_icon->set_extensions(icon_ext);
        parent::__construct();
    }
    public function delete() {
        parent::delete(array($this->panel_icon));
    }
    public function add() {
        $check = new check_exsitence("panel","panel_name");
        if($check->check()) {
            $this->form->override_message_type("error");
            $this->form->override_message_text(menu_name.' '.SERVER_VALID_EXISTS);
            return $this->direct("add_form",$_POST);
        }
        $check->add_and_col("panel_sort");
        if($check->check()) {
            $this->form->set_message("error",menu_rank.' '.SERVER_VALID_EXISTS);
            return $this->direct("add_form",$_POST);
        }

        parent::add(array($this->panel_icon));
    }

    public function modify() {
        $check = new check_exsitence("panel","panel_name");
        $check->add_sql_condition(" AND panel_id <>".$_POST['panel_id']);
        if($check->check()) {
            $this->form->override_message_type("error");
            $this->form->override_message_text(menu_name.' '.SERVER_VALID_EXISTS);
            return $this->direct("modify_form",$_POST['panel_id']);
        }
        $check->add_and_col("panel_sort");
        $check->add_sql_condition(" AND panel_id <>".$_POST['panel_id']);
        if($check->check()) {
            $this->form->set_message("error",menu_rank.' '.SERVER_VALID_EXISTS);
            return $this->direct("modify_form",$_POST['panel_sort']);
        }

        parent::modify(array($this->panel_icon));
    }


    public function search_form() {
        $this->grid->set_width(800);
        $this->grid_exe->show_numbering();
        $this->grid_exe->set_modify_id("panel_id");

        $this->grid_exe->new_obj('panel_name');
        $this->grid_exe->set_title(panel_name);
        $this->grid_exe->set_type('string');
        $this->grid_exe->set_width(200);
        $this->grid_exe->add_obj();

        $this->grid_exe->new_obj('panel_sort');
        $this->grid_exe->set_title(panel_sort);
        $this->grid_exe->set_type('int');
        $this->grid_exe->set_width(100);
        $this->grid_exe->add_obj();

        $this->grid_exe->new_obj('panel_target');
        $this->grid_exe->set_title(panel_target);
        $this->grid_exe->set_type('radio');
        $this->grid_exe->set_object(
                    array(
                    "mainframe"=>PANEL_POPIN,
                    "_blank"=>PANEL_POPOUT
                    )
                );
        $this->grid_exe->set_width(90);
        $this->grid_exe->add_obj();

        $this->grid_exe->new_obj('panel_is_add');
        $this->grid_exe->set_alias("`panel`.`panel_is_add`");
        $this->grid_exe->set_title(MENU_IS_ADD);
        $this->grid_exe->set_type('bool');
        $this->grid_exe->set_width(80);
        $this->grid_exe->add_obj();

        $this->grid_exe->new_obj('panel_is_modify');
        $this->grid_exe->set_alias("`panel`.`panel_is_modify`");
        $this->grid_exe->set_title(MENU_IS_MODIFY);
        $this->grid_exe->set_type('bool');
        $this->grid_exe->set_width(80);
        $this->grid_exe->add_obj();

        $this->grid_exe->new_obj('panel_is_delete');
        $this->grid_exe->set_alias("`panel`.`panel_is_delete`");
        $this->grid_exe->set_title(MENU_IS_DELETE);
        $this->grid_exe->set_type('bool');
        $this->grid_exe->set_width(80);
        $this->grid_exe->add_obj();

        $this->grid_exe->new_obj('panel_is_print');
        $this->grid_exe->set_alias("`panel`.`panel_is_print`");
        $this->grid_exe->set_title(MENU_IS_PRINT);
        $this->grid_exe->set_type('bool');
        $this->grid_exe->set_width(80);
        $this->grid_exe->add_obj();

        $this->grid_exe->new_obj('panel_is_disable');
        $this->grid_exe->set_title(GROUP_IS_DISABLE);
        $this->grid_exe->set_type('bool');
        $this->grid_exe->set_width(90);
        $this->grid_exe->add_obj();
        
        return parent::search_form();
    }

    public function load($var) {
        $name = new input_text('panel_name');
        $name->set_value($var['panel_name']);
        $name->set_valid_msg(panel_name.' '.LANG_VALID);
        $name->set_valid();
        $this->table->new_element(panel_name,$name->load());

        $this->panel_icon->set_value($var['panel_icon']);
        $this->table->new_element(panel_icon,$this->panel_icon->load());

        $order = new input_mask('panel_sort');
        $order->set_value($var['panel_sort']);
        $order->set_valid_msg(panel_sort.' '.LANG_VALID);
        $order->set_valid();
        $this->table->new_element(panel_sort,$order->load());
        $target = new input_radio("panel_target");
        $target->add_option(PANEL_POPIN, "mainframe")
            ->add_option(PANEL_POPOUT, "_blank")
            ->set_value($var['panel_target'])
            ->set_default('mainframe');

        $this->table->new_element(panel_target,$target->load());

        $link = new textarea('panel_link');
        $link->set_value($var['panel_link']);
        $link->set_valid_msg(panel_link.''.LANG_VALID);
        $link->set_valid();

        $this->table->add_attr("id","form_table");
        $link_type = new combo('panel_link_type');
        $source_var = array(ap_url_path=>"ap_url_path","http://"=>"http://");
        $link_type->set_value($var["panel_link_type"])
            ->set_readonly()->set_data_source($source_var,"array")->set_width(300)
            ->set_onchange("
                        if({$link_type->get_name()}.getActualValue()=='http://')
                        {
                            jQuery('#form_table tr:eq(7)').hide();
                            jQuery('.checkbox').attr('checked',false);
                        }
                         else
                         {
                            jQuery('#form_table tr:eq(7)').show();
                            jQuery('.checkbox').not('input[id=\"panel_is_disable\"]').not('input[id=\"panel_is_print\"]').attr('checked',true);
                         }
                    ");
        $this->table->new_element(panel_link,$link_type->load().''.$link->load());
        /**
         * add button types
         */
        $is_add = new input_check("panel_is_add");
        $is_add->set_default_value();
        $is_add->set_value($var['panel_is_add']);
        
        $is_modify = new input_check("panel_is_modify");
        $is_modify->set_default_value();
        $is_modify->set_value($var['panel_is_modify']);
        
        $is_delete = new input_check("panel_is_delete");
        $is_delete->set_default_value();
        $is_delete->set_value($var['panel_is_delete']);
        
        $is_print = new input_check("panel_is_print");
        $is_print->set_value($var['panel_is_print']);
        
        $table = "
            <style>
            thead th{
                height:18px;
                font: bold 13px auto 'Trebuchet MS', 'Verdana', 'Arial', 'Helvetica', 'sans-serif';
                color: #DFAC00;
                border:1px solid #204697;
                letter-spacing: 2px;
                text-transform: uppercase;
                text-align: ".DIR_ALIGN.";
                background: #353136;
            }
            .td_main{
                font: bold 13px auto 'Trebuchet MS', 'Verdana', 'Arial', 'Helvetica', 'sans-serif';
                color: #DFAC00;
                border:1px solid #204697;
                letter-spacing: 2px;
                text-transform: uppercase;
                text-align: ".DIR_ALIGN.";
                background:#646C7C;
            }
            </style>
            <table cellpadding='10' cellspacing='5' border='0'>
            <thead>
                <th><img src='".theme_common_url_path."/images/grid/copy.png'/></td>
                <th><img src='".theme_common_url_path."/images/grid/edit.png'/></td>
                <th><img src='".theme_common_url_path."/images/grid/drop.png'/></td>
                <th><img src='".theme_common_url_path."/images/grid/print.png'/></td>
            </thead>
            <tr>
                <td class='td_main'>{$is_add->load()}</td>
                <td class='td_main'>{$is_modify->load()}</td>
                <td class='td_main'>{$is_delete->load()}</td>
                <td class='td_main'>{$is_print->load()}</td>
            </tr>
            </table> ";
        $this->table->new_element(MENU_ACTIONS, $table);

        $panel_is_disable = new input_check("panel_is_disable");
        $panel_is_disable->set_value($var['panel_is_disable']);
        $this->table->new_element(GROUP_IS_DISABLE, $panel_is_disable->load());
        /**
         * js scripting
         */

        $this->form->add_script("
                                jQuery('#panel_is_print').click(function(){
                                    var status = jQuery(this).attr('checked');
                                    if(status)
                                        jQuery('#panel_is_add,#panel_is_modify,#panel_is_delete').removeAttr('checked');
                                    })
                                jQuery('#panel_is_add,#panel_is_modify,#panel_is_delete').click(function(){
                                    var status = jQuery(this).attr('checked');
                                    if(status)
                                        jQuery('#panel_is_print').removeAttr('checked');
                                    })
                                ");

        parent::load();
    }
}
new panel_form();
?>