<?php

include_once('../connecter.php');

if (file_exists(extension_physical_path . "components/user.php")) {
    location(extension_url_path . "components/user.php");
    exit;
}
if (authentication::get_user_type() == "user") {
    echo def_no_privillages_err;
    exit;
}
define("theme_title", SETTINGS_MENU_USERS);
define("theme_width", "100%");
define("theme_height", "100%");
define("theme_align", "center");
define("text_align", "left");
define("table_title", USER_TABLE_TITLE);
define("db_table_name", "user");
define("element_per_row", "1");
define("message_column", "user_name");

define("user_name", USER_NAME);
define("user_pass", USER_PASS);
define("user_full_name", USER_FULL_NAME);
define("user_is_disabled", USER_IS_DISABLED);
define("user_email", USER_EMAIL);
define("user_phone", USER_PHONE);
define("user_type", USER_TYPE);
define("group_id", GROUP_ID);
define("group_name", GROUP_NAME);
define("ROLE", "Roles");
authentication::authenticate();
if (authentication::get_user_type() == 'user')
    authentication::safe_buttons(array('modify'));
else
    authentication::safe_buttons(array('add', 'modify', 'delete'));

class user_form extends basic_form {

    private $group_id = null;
    private $user_role = null;
    private $jwt_key = JWT_PASSWORD_KEY;

    public function __construct() {

        if (authentication::get_user_type() == 'user')
            $this->disable_search();
        parent::__construct();
    }

    public function init_group_id() {
        $this->group_id = new combo("group_id", "group_name", "group_id");
        $this->group_id->set_ajax_url(self . '?action=group_filter');
    }

    public function get_childs_id($index_id) {
        $ids = new children_ids("group");
        $ids->set_needle($index_id)
                ->set_query("select * from `group`
                         where group_is_disabled='0'
                         order by index_id")
                ->load();
        return $ids->get_ids();
    }

    public function add() {
        $check = new check_exsitence("user", "user_name");
        if ($check->check()) {
            $this->form->set_message("error", user_name . " " . SERVER_VALID_EXISTS);
            return $this->direct("add_form", $_POST);
        }
        $check->add_and_col("user_email");
        if ($check->check()) {
            $this->form->set_message("error", user_email . " " . SERVER_VALID_EXISTS);
            return $this->direct("add_form", $_POST);
        }
        $token = array(
            "password" => $_POST['user_pass'],
        );
        $_POST['user_pass'] = JWT::encode($token, $this->jwt_key);

        parent::add();
    }

    public function before_add_modify($type) {

        parent::before_add_modify($type);
    }
    public function modify() {
        $check = new check_exsitence("user", "user_name");
        $check->add_sql_condition(" AND user_id <>" . $_POST['user_id']);
        if ($check->check()) {
            $this->form->set_message("error", user_name . " " . SERVER_VALID_EXISTS);
            return $this->direct("modify_form", $_POST);
        }
        $check->add_and_col("user_email");
        $check->add_sql_condition(" AND user_id <>" . $_POST['user_id']);
        if ($check->check()) {
            $this->form->set_message("error", user_email . " " . SERVER_VALID_EXISTS);
            return $this->direct("modify_form", $_POST);
        }
        parent::get_result("select user_pass from user where user_id='{$_POST["user_id"]}'");
        $row = parent::next();
        $old_password = $row["user_pass"];
        if ($old_password != $_POST['user_pass']) {
            $token = array(
                "password" => $_POST['user_pass'],
            );
            $_POST['user_pass'] = JWT::encode($token, $this->jwt_key);
        }
        parent::modify();
    }

    public function before_delete() {

        $check = new check_exsitence("app_client");
        $check->add_sql_condition(" and user_id='{$_REQUEST['user_id']}'");
        if ($check->check()) {
            $this->form->override_message_type("error")
                    ->override_message_text(ERROR_CANNOT_DELETE_USED_RECORD);
            return $this->direct("modify_form", $_REQUEST['user_id']);
        }
        
        $check = new check_exsitence("log");
        $check->add_sql_condition(" and user_id='{$_REQUEST['user_id']}'");
        if ($check->check()) {
            $this->form->override_message_type("error")
                    ->override_message_text(ERROR_CANNOT_DELETE_USED_RECORD);
            return $this->direct("modify_form", $_REQUEST['user_id']);
        }
      

//        $this->form->set_message("error", CANNOT_DELETE_ERR);
//        return $this->direct("modify_form", $_POST);
        parent::before_delete();
    }

    public function delete() {
        if ($_REQUEST['user_id'] == authentication::get_user_id()) {
            $this->form->set_message("error", USER_SELF_DELETE_ERR);
            return $this->direct("modify_form", $_POST);
        }
        parent::delete();
    }

    public function search() {
//$this->grid_result->debug();
        $this->grid_result
                ->attach_select(" `group`.group_name as group_id_mask")
                ->add_join(" left join `group` on `group`.`group_id` = `user`.`group_id` ")
        ;
        parent::search();
    }

    public function search_form() {
//        $this->grid->debug();
        $this->grid->set_width(800)
                ->disable_copy();

        $this->grid_exe
                ->show_numbering()
                ->set_modify_id(array("user_id", "`group`.group_id", "group_id_mask"))
                ->new_obj('group_name')
                ->set_title(group_name)
                ->set_type('string')
                ->set_width(120)
                ->add_obj()
                ->new_obj('user_type')
                ->set_title(user_type)
                ->set_type('radio')
                ->set_width(120)
        ;

        switch (authentication::get_user_type()) {
            case 'super':
                $ds_user_type = array('super' => SUPER_USER, 'admin' => ADMIN_USER, 'user' => END_USER);

                break;
            case 'admin':
                $ds_user_type = array('admin' => ADMIN_USER, 'user' => END_USER);

                break;
            case 'user':
                $ds_user_type = array('user' => END_USER);
                $this->grid_exe->show_in('header');
                break;
        }

        $this->grid_exe
                ->set_object($ds_user_type)
                ->add_obj()
                ->new_obj('user_is_disabled')
                ->set_title(user_is_disabled)
                ->set_type('bool')
                ->set_width(100)
                ->add_obj()

                ->new_obj('user_name')
                ->set_title(user_name)
                ->set_type('string')
                ->set_width(120)
                ->add_obj()
                ->new_obj('user_full_name')
                ->set_title(user_full_name)
                ->set_type('string')
                ->set_width(120)
                ->add_obj()
                ->new_obj('user_email')
                ->set_title(user_email)
                ->set_type('string')
                ->set_width(200)
                ->add_obj();

        return parent::search_form();
    }

    public function group_filter() {
//        $this->init_group_id();
        $this->group_id = new combo("group_id", "group_name", "group_id");
        if ($_GET["client"]) {
            $con=" and group_id=3";
            $this->group_id->set_disable();
        }
        switch (authentication::get_user_type()) {
            case 'admin': $ids = implode(",", array_keys($this->get_childs_id(authentication::get_group_id())));
                $statment = "select * from `group`
                                            where group_is_disabled='0' {$con}
                                            order by index_id";
                break;
            case 'user' :
                $statment = "select * from `group`
                                    where group_is_disabled='0' {$con}
                                    order by index_id";
                break;
            default:
                $statment = "select * from `group` 
                                    where group_is_disabled='0' {$con}
                                    order by index_id";
        }


        $this->group_id->set_data_source($statment);
//                ->load_ajax();
    }

    public function load($var) {
//        $this->init_group_id();
        /**
         *
         */
        $disabled = false;
        if ($var['user_name_mask']) {
            $var['user_name'] = $var['user_name_mask'];
        }
        if ($var['user_name'] AND ( in_array($_REQUEST['action'], array("modify", "modify_form")))) {
            $user_name = new input_hidden('user_name_mask');
            $user_name->set_value($var['user_name']);
            parent::add_html($user_name->load());
            $disabled = true;
        }
        /**
         * user is disabled
         */
        $user_is_disabled = new input_check("user_is_disabled");
        $user_is_disabled->set_value($var["user_is_disabled"]);
        if ($var['user_type'] == 'super')
            $user_is_disabled->set_disable();
        $this->table->new_element(user_is_disabled, $user_is_disabled->load());
        /**
         * user type
         */
        $user_type = new input_radio('user_type');
        if (authentication::get_user_type() == 'super') {
            $user_type
                    ->add_option(SUPER_USER, "super");
        }
        $user_type
                ->add_option(ADMIN_USER, "admin")
                ->add_option(END_USER, "user")
                ->set_default("user")
                ->set_value($var['user_type']);


        if ($var['user_id'] == authentication::get_user_id()) {
            $user_type->set_name("user_type_fake");
            $hidden_user_type = new input_hidden("user_type");
            $hidden_user_type->set_value($var["user_type"]);
            $this->add_html($hidden_user_type->load());
            $user_type->set_disable();
        } else {
            if (authentication::get_user_type() == 'user')
                $user_type->set_disable(array(true, false));
            else
            if (authentication::get_user_type() == 'admin')
                $user_type->set_disable(array(false, false));
            else
                $user_type->set_disable(array(true, false, false));
        }
        $this->table->new_element(user_type, $user_type->load());
        /**
         *
         */
//        $this->group_id = new combo("group_id", "group_name", "group_id");
        $this->group_filter();
        if ($var['user_id'] == authentication::get_user_id()) {
            $this->group_id->set_disable();
        } else
            $this->group_id->set_valid();
//        if (authentication::get_user_type() == "admin")
//            $this->group_id->set_onblur("
//                if({$this->group_id->get_name()}.getActualValue()!=" . authentication::get_group_id() . ")
//                $('.radio').filter('input[name=\"user_type\"]').each(function(){
//                    if($(this).val()=='admin' || $(this).val()=='user')
//                        $(this).attr('disabled',false)
//                })
//                else
//                $('.radio').filter('input[name=\"user_type\"]').each(function(){
//                    if($(this).val()=='admin')
//                        $(this).attr('disabled',true)
//                    if($(this).val()=='user'){
//                        $(this).attr('disabled',false)
//                        $(this).attr('checked',true)
//                    }
//                })
//            ");
        /* if we enter by a user or admin, make modify then we will get group without name, if click modify another time will get NULL group id in db */

//        if ($var['group_id'] && !$var['group_id_mask'])
//            $this->group_id->set_data_source("select * from `group` where `group_id`='{$var['group_id']}' ");
//
        if ($_GET["client"]) {
            $var['group_id']=3;
        }
        $this->group_id->set_value($var['group_id'], $var["group_id_mask"]);

        $pop_window = new pop_window(group_id, ap_url_path . "framework/components/group.php");
        $this->table->new_element($pop_window->load(), $this->group_id->load());

        $user_name = new input_text('user_name');
        $user_name->set_valid()
                ->set_value($var['user_name'])
                ->set_disable($disabled);
        $this->table->new_element(user_name, $user_name->load());

        $user_pass = new input_password_gen('user_pass');
        $user_pass->set_valid()
                ->set_value($var['user_pass'])
//                ->set_readonly()
        ;
        $this->table->new_element(user_pass, $user_pass->load());
//        $user_pass = new input_password('user_pass');
//        $user_pass->set_valid()
//                ->set_value($var['user_pass']);
//        $this->table->new_element(user_pass, $user_pass->load());
//        $confirm_user_pass = new input_password('confirm_user_pass');
//        $confirm_user_pass->set_valid()
//                ->set_value($var['user_pass']);
//        $this->table->new_element(CONFIRM . " " . user_pass, $confirm_user_pass->load());

        $user_full_name = new input_text('user_full_name');
        $user_full_name->set_valid()
                ->set_value($var['user_full_name']);
        $this->table->new_element(user_full_name, $user_full_name->load());

        $user_email = new input_mask('user_email');
        $user_email->set_value($var['user_email'])
                ->set_mask('email')
                ->set_valid();
        $this->table->new_element(user_email, $user_email->load());


        parent::load();
    }
    public function set_search_conditions() {
        $statment = null;
        switch (authentication::get_user_type()) {
            case 'user':$statment = " and user_id = '" . authentication::get_user_id() . "' ";
                break;
            case 'admin':
                $ids = implode(",", array_keys($this->get_childs_id(authentication::get_group_id())));
                $statment = " and (
                                                                    ( user.group_id = '" . authentication::get_group_id() . "'
                                                                        and(
                                                                                user_id = '" . authentication::get_user_id() . "'
                                                                                or user_type = 'user'
                                                                            )
                                                                     )
                                                                     or user_type <> 'super'
                                                                )
                                                                and user.group_id in ({$ids})";
                break;
            case 'super':$statment = " and (user_id = '" . authentication::get_user_id() . "' or user_type <> 'super')";
                break;
        }

        $this->grid_result->attach_conditions($statment);
    }

}

if (authentication::get_user_type() == "user") {
    echo def_no_privillages_err;
    exit;
}
new user_form();
?>