(function ($) {
    $.fn.ajaxTree = function (o) {
        var options = {
            remote: 'remote.php',
            requestType: "POST",
            requestCache: true,
            animationSpeed: 300,
            contentCache: true,
            RequestParams: {},
            contextMenuItems: {},
            itemClasses: ['mdi-menu-right', 'mdi-menu-down', 'loading_item', 'mdi-minus'],
            containerHeight: 300,
            editingToolBar: true,
            disableModify: false,
            disableDelete: false,
            disableCopy: false,
            enablePrint: false,
            disableFiltering: false,
            disableExpandAll: false,
            disableExpandOneLevel: false,
            disableCollapseAll: false,
            disableContextMenu: false,
            disableBranchExpandAll: false,
            disableBranchRefresh: false,
            editingTarget: 'tab_iframe0',
            editingFailerMsg: '',
            targetedTab: 0,
            modifyTitle: '',
            copyTitle: '',
            deleteTitle: '',
            printTitle: '',
            refreshTitle: '',
            expandAllTitle: '',
            collapseAllTitle: '',
            expandOneLevelTitle: '',
            searchLable: 'Search',
            reloadTitle: '',
            searchTitle: '',
            noResultMsg: '',
            selectedItem: 'selected_item',
            lastChildClass: 'last_child',
            deleteConfirmationMsg: '',
//            isExpanded:'ihab',
            direction: 'ltr',
            tooltipCfg: {position: "bottom-center", trigger: "hover"}
        }
        $.extend(options, o);
        if (options.direction === 'rtl') {
            options.itemClasses = ['mdi-menu-left', 'mdi-menu-down', 'loading_item', 'mdi-minus'];
        }
        var t = $(this);
        if (options.editingToolBar) {
            var editingToolBar = $("<div/>")
                    .addClass("editing_toolbar")
                    .attr('id', t.attr('id') + "_editing_toolbar")
                    .insertAfter(t);

            if (!options.disableFiltering) {
                var pbsearch = $("<div/>").addClass("grid-quicksearch-container").attr("id", "filtering_input")
                        .append($("<i/>").addClass("mdi").addClass("mdi-magnify").click(function () {
                            var val = $("input#filtering_input").val();
                            t.filter(val);
                        }))
                        .append($("<input/>").attr("type", "text").attr("name", "quicksearch").attr("id", "filtering_input").attr("placeholder", options.searchTitle).attr("title", options.searchTitle)
                                .tipsy(options.tooltipCfg)
                                .bind("keydown", function (e) {
                                    if (e.keyCode == 13) {
                                        var val = $("input#filtering_input").val();
                                        t.filter(val);
                                    }
                                })
                                )
                        .append($("<i/>").addClass("mdi").addClass("mdi-reload").attr("id", "relaod_href").attr("title", options.reloadTitle).tipsy(options.tooltipCfg).bind("click", function (e) {
                            $("input#filtering_input").val("")
                            t.getParents()
                        }))
                        ;
                editingToolBar
                        .append(pbsearch)
//                .append($("<a/>")
//                    .attr("id","search_href")
//                    .attr("href","javascript:;")
//                    .attr("title",options.searchTitle)
//                    .click(function(){
//                        var val =$("#filtering_input").val();
//                        t.filter(val)
//                    })
//                    )
//                .append( $("<a/>")
//                    .attr("id","relaod_href")
//                    .attr("title",options.reloadTitle)
//                    .attr("href","javascript:;")
//                    .bind("click",function(e){
//                        $("#filtering_input").val("")
//                        t.getParents()
//                    }))
//                .append($("<div/>")
//                    .addClass("editing_toolbar_separator")
//                    .html("|"))

//            if(options.disableExpandOneLevel == false){
//                var expandOneLevel = $("<a/>")
//                .attr("id","expand_one_level_href")
//                .attr("title",options.expandOneLevelTitle)
//                .attr("href","javascript:;")
//                .bind("click",function(){
//                    t.expandOneLevel();
//                })
//                expandOneLevel.appendTo(editingToolBar);
//            }
//
//            if(options.disableCollapseAll == false){
//                var collapseAll     = $("<a/>")
//                .attr("id","collapse_all_href")
//                .attr("title",options.collapseAllTitle)
//                .attr("href","javascript:;")
//                .bind("click",function(){
//                    t.collapseAll();
//                })
//                collapseAll.appendTo(editingToolBar);
//            }
//
//            if(options.disableCollapseAll == false && options.disableCollapseAll==false && options.disableExpandOneLevel==false){
//                editingToolBar
//                .append($("<div/>")
//                    .addClass("editing_toolbar_separator")
//                    .html("|"))
//            }

            }
//            if(options.disableExpandAll == false){
//                var expandAll     = $("<a/>")
//                .attr("id","expand_all_href")
//                .attr("title",options.expandAllTitle)
//                .attr("href","javascript:;")
//                .bind("click",function(e){
//                    $("#filtering_input").val("")
//                    t.expandAll();
//                })
//                expandAll.appendTo(editingToolBar);
//            }


        }

        if (!options.disableContextMenu) {
            var contextMenu = $('<div class="contextMenu" id="' + t.attr('id') + '_context_menu"><ul></ul></div>').appendTo($('body'));
            if (!options.disableModify)
                var modifyMenuItem = $('<li title="' + options.modifyTitle + '"><a href="#modify" alt="modify"><i class="mdi mdi-square-edit-outline"></i></a></li>').tipsy(options.tooltipCfg).appendTo(contextMenu.find("ul"));
            if (!options.disableCopy)
                var copyMenuItem = $('<li title="' + options.copyTitle + '"><a href="#copy" alt="copy"><i class="mdi mdi-content-copy"></i></a></li>').tipsy(options.tooltipCfg).appendTo(contextMenu.find("ul"));
            if (!options.disableDelete)
                var deleteMenuItem = $('<li title="' + options.deleteTitle + '"><a href="#delete"  alt="delete"><i class="mdi mdi-delete"></i></a></li>').tipsy(options.tooltipCfg).appendTo(contextMenu.find("ul"));
            if (options.enablePrint)
                var printMenuItem = $('<li title="' + options.printTitle + '"><a href="#print"   alt="print"><i class="mdi mdi-printer"></i></a></li>').tipsy(options.tooltipCfg).appendTo(contextMenu.find("ul"));
            if (!options.disableBranchRefresh)
                var refreshMenuItem = $('<li title="' + options.refreshTitle + '" class="refresh"><a href="#refresh" alt="refresh"><i class="mdi mdi-reload"></i></a></li>').tipsy(options.tooltipCfg).appendTo(contextMenu.find("ul"));
            if (!options.disableBranchExpandAll)
                var expandMenuItem = $('<li title="' + options.expandAllTitle + '" class="expand"><a href="#expand" alt="expand"><i class="mdi mdi-arrow-expand"></i></a></li>').tipsy(options.tooltipCfg).appendTo(contextMenu.find("ul"));
            $.each(options.contextMenuItems, function (i, data) {
                $('<li class=" event"><a href="#event_' + i + '"   alt="event_' + i + '">' + data.title + '</a></li>').appendTo(contextMenu.find("ul"));
            })

        }

        t
                .addClass("ajax_tree_container")
                .extend({
                    isContainer: function (obj) {
                        if (obj.get(0).tagName.toLowerCase().toString() === 'div')
                            return true;
                        return false;
                    },
                    requestRemote: function (params, obj, filter, isExpandAll) {
                        if (isExpandAll == undefined
                                || isExpandAll == '')
                            isExpandAll = false;
                        if (isExpandAll)
                            params = $.toJSON(params);

                        var data = $.extend(options.RequestParams, {
                            'data': params,
                            'filter': filter,
                            'get_full_tree': isExpandAll
                        });

                        $.ajax({
                            type: options.requestType,
                            url: options.remote,
                            data: data,
                            cache: options.requestCache,
                            beforeSend: function () {
                                if (options.editingToolBar)
                                    ;
                                $("#relaod_href").removeClass("mdi-reload").addClass("grid-quicksearch-loading");
                                if (!t.isContainer(obj)) {
                                    obj.find("div:first i").attr("class", options.itemClasses[2])
                                }
                                if (options.enableFiltering && options.editingToolBar) {
                                    $("#filtering_input").attr('readonly', true);
                                }
                            },
                            success: function (result) {
                                if (t.isContainer(obj))
                                {
                                    obj.html(result);
                                } else {
                                    obj.find("ul").remove();
                                    obj.append(result);
                                }
                            },
                            complete: function () {
                                if (isExpandAll != "true") {
                                    obj.find("ul li").filter("li[expandable=true]").find("div").prepend("<i class='mdi " + options.itemClasses[0] + "'></i>");
                                    obj.find("ul li").filter("li[expandable=false]").find("a:last").addClass(options.lastChildClass);
                                    obj.find("ul li").filter("li[expandable=false]").find("div").prepend("<i class='mdi " + options.itemClasses[3] + "'></i>");
                                }
                                obj.find("ul:first")
                                        .show(options.animationSpeed, function () {
                                            if (!t.isContainer(obj)) {
                                                obj.find("div:first i").attr("class", "mdi").addClass(options.itemClasses[1]);
                                            } else {
                                                ///write something
                                            }
                                            t.initEvents(obj);
                                            if (options.enableFiltering && options.editingToolBar) {
                                                $("#filtering_input").attr('readonly', false);
                                            }

                                            if (options.editingToolBar)
                                                $("#relaod_href").removeClass("grid-quicksearch-loading").addClass("mdi-reload");
                                        });

                                if (!obj.find("ul li").length && options.editingToolBar)
                                    load_message('info', options.noResultMsg);



                            },
                            error: function () {

                            }

                        })
                    },
                    getChildren: function (li) {

                        if (!li.find("ul").length || !options.contentCache)
                            t.requestRemote($.toJSON(li.metadata({
                                type: 'attr',
                                name: 'data'
                            })), li, '', '');
                        else
                        if (options.contentCache)
                            li.find("ul:first").show(options.animationSpeed, function () {
                                li.find("div:first i").attr("class", "mdi " + options.itemClasses[1]);
                            });

                    },
                    getParents: function () {
                        t.requestRemote({}, t, '', '');
                    },
                    filter: function (o) {
                        t.requestRemote({}, t, o, '');
                    },
                    expandAll: function (id) {
                        var arr = {
                            'classes': $.toJSON(options.itemClasses),
                            'last_child_class': options.lastChildClass
                        };
                        t.requestRemote(arr, t, "", 'true');
                    },
                    branchExpandAll: function (id, li) {
                        if (!li.hasClass(options.itemClasses[3])) {
                            var arr = {
                                'classes': $.toJSON(options.itemClasses),
                                'last_child_class': options.lastChildClass,
                                'id': id
                            };
                            t.requestRemote(arr, li, "", 'true');
                        }
                    },
                    expandOneLevel: function () {
                        t.find("li").filter("li[expandable=true]").each(function () {
                            t.getChildren($(this));
                        })
                    },
                    collapseAll: function () {
                        t.find("ul li ul:first").hide(options.animationSpeed, function () {
                            var parent = $(this).parent();
                            parent.attr("class", options.itemClasses[0]);
                            if (!options.contentCache)
                                $(this).remove();
                        });
                    },
                    trigger: function (href, el) {
                        if ($(el).attr('alt') == 'delete') {
                            if (!confirm(options.deleteConfirmationMsg))
                                return false;
                        }
                        var link = $(href).attr($(el).attr("alt") + '_link');
                        $("iframe[name='" + options.editingTarget + "']").attr("src", link)
                        $("#message_obj_div").show();
                        $("#message_div").empty().attr("class", "message_loading");
                        if ($(href).attr('action') != 'delete') {
                            options.targetedTab = parseInt(options.targetedTab);
                            FormTabContainer.expandit(options.targetedTab);
                        } else {
                            //$(el).parent().remove();
                        }
                        return false;
                    },
                    initEvents: function (obj) {
                        obj
                                .find("a.control_href")
                                .filter("a[class != '" + options.lastChildClass + "']")
                                .click(function () {

                                    switch ($(this).parent().find("i:first").attr("class").toString()) {
                                        default:
                                            t.getChildren($(this).parent().parent());
                                            break;
                                        case "mdi " + options.itemClasses[1]:
                                            var parent = $(this).parent().parent();
                                            parent.find("ul:first").hide(options.animationSpeed, function () {
                                                parent.find("div:first i").attr("class", "mdi " + options.itemClasses[0]);
                                                if (!options.contentCache)
                                                    $(this).remove();
                                            });
                                            break;
                                    }
                                    return false;
                                });
                        obj.find("a." + options.lastChildClass).unbind("click");

                        obj
                                .find("ul li ")
                                .find("a.control_href")
                                .mouseover(function () {
                                    contextMenu.hide();
                                    if ($(this).hasClass(options.lastChildClass)) {
                                        if (!options.disableBranchRefresh)
                                            refreshMenuItem.hide();

                                        if (!options.disableBranchExpandAll)
                                            expandMenuItem.hide();
                                    } else {
                                        if (!options.disableBranchRefresh)
                                            refreshMenuItem.show();

                                        if (!options.disableBranchExpandAll)
                                            expandMenuItem.show();
                                    }

                                    $(this).contextMenu({
                                        menu: contextMenu.attr('id')
                                    },
                                            function (action, el, pos, self) {
                                                switch (self.attr('alt')) {
                                                    case 'modify':
                                                    case 'copy'  :
                                                    case 'delete':
                                                        t.trigger(el, self);
                                                        break;
                                                    case 'refresh':
                                                        var li = el.parent().parent();
                                                        if (!li.hasClass(options.itemClasses[3])) {
                                                            t.requestRemote($.toJSON(li.metadata({
                                                                type: 'attr',
                                                                name: 'data'
                                                            })), li, '', '');
                                                        }
                                                        break;
                                                    case "expand" :
                                                        t.branchExpandAll(el.attr('id'), el.parent().parent());
                                                        break;
                                                    default:
                                                        $.each(options.contextMenuItems, function (i, data) {
                                                            if (self.attr('alt') == 'event_' + i)
                                                                eval(data.event);
                                                        });
                                                        break;
                                                }
                                            });
                                })

                        if (options.disableContextMenu)
                            obj.find("ul li")
                                    .find("a.control_href")
                                    .disableContextMenu()
                    }
                })
        t.getParents();
        return this.extend({
            t: t
        });
    }

})(jQuery)