(function ($) {

    $.fn.ingrid = function (o) {
        var cfg = {// grid configurations
            gridType: 'grid', // grid or dom
            dir: 'ltr',
            width: 500,
            minWidth: 220/*450*/,
            height: 350,
            minHeight: 150,
            form_height: 0,
            savedStateLoad: false, // when Ingrid is initialized,should it load data from a previously saved state?
            initialLoad: false, //when Ingrid is initialized,should it load data immediately?
            colWidths: [250, 250, 250, 250],
            colMinWidths: [],
            colIsResizables: [],
            colAligns: ['center', 'center', 'center', 'center'],
            headerAligns: ['center', 'center', 'center', 'center'],
            colHeight: 30,
            minColWidth: 120,
            headerHeight: 43,
            headerClass: 'grid-header-bg',
            resizableCols: true,
            showFilter: true,
            showExportXls: false,
            disableGroupDelete: false,
            enableDebug: false,
            targetedTab: 0, //modify tab id
            gridClass: 'datagrid',
            rowClasses: ['grid-row-style1', 'grid-row-style2'],
            rowHoverClass: 'grid-row-hover',
            rowSelection: true, //allow row selection?
            rowSelectedClass: 'grid-row-sel', //hovering over a row? use this class
            onRowSelect: function (tr, selected) {},
            sorting: true, //is sorting enabled
            colSortParams: [], //value to pass as sort param when header clicked (i.e. '&sort=param') ex: ['col1','col2','col3','col4']
            sortAscParam: 'asc', //param passed on ascending sort (i.e. '&dir=asc)
            sortDescParam: 'desc', //param passed on descending sort (i.e. '&dir=desc)
            sortedCol: 'col1', //current data's sorted column (can be a key from 'colSortParams', or an int 0-n for n columns)
            sortedColDir: 'desc', //current data's sorted dorections
            sortDefaultDir: 'desc', //on 1st click, sort tihs direction
            sortAscClass: 'mdi-menu-down', //class for ascending sorted col
            sortDescClass: 'mdi-menu-up',
            sortNoneClass: 'mdi-menu-swap',
            paging: true,
            pageNumber: 1,
            recordsPerPage: 50,
            totalRecords: 100,
            totalShownRecords: 100,
            totalPages: '',
            defaultParams: {},
            pageToolbarClass: 'grid-page-toolbar',
            pagePrevClass: 'grid-page-prev',
            pageInfoClass: 'grid-page-info',
            pageInputClass: 'grid-page-input',
            pageNextClass: 'grid-page-next',
            reloadButtonClass: 'reload-button',
            plusButtonClass: 'plus-button',
            plusButtonClickedClass: 'plus-button-clicked',
            exportXlsClass: 'export-xls-button',            
            groupDeleteBtClass: 'group_delte_bt',
            pageViewingRecordsInfoClass: 'grid-page-viewing-records-info',
            url: 'remote.php',
            extendActions: '',
            type: 'POST',
            dataType: 'html',
            extraParams: {},
            searchAction: {},
            resizeHandleClass: 'grid-col-resize',
            editingTarget: 'tab_iframe0',
            disableModify: false,
            disableDelete: false,
            disableCopy: false,
            enablePrint: false,
            disableContextMenu: false,
            modifyTitle: '',
            copyTitle: '',
            deleteTitle: '',
            printTitle: '',
            deleteConfirmationMsg: '',
            groupDeleteConfirmationMsg: '',
            noSelectedRowsErr: '',
            extendedFunction: '',
            onCopy: '',
            onDelete: '',
            onShowModifyForm: '',
            formPosition: 'absolute',
            showHideGridHotKey: 'ctrl+g',
            saveHotKey: 'ctrl+s',
            newHotKey: 'ctrl+n',
            _ajaxInAction: false,
            matching_cols1_err: 'Error: Total columns returned [',
            matching_cols2_err: '] do not match Grid [',
            no_connection_err: 'No Connection',
            records: 'Records',
            of: ' of ',
            no_result: 'No Results found',
            page: 'Page ',
            searchButtonTitle: 'Show search options',
            pagePrevTitle: 'Previous',
            pageNextTitle: 'Next',                        
            plusButtonTitle: 'Open form',            
            exportXlsTitle: 'Export',
            groupDeleteBtTitle: 'Delete Selected Rows',            
            valid_number_msg: 'Please Enter a Valid Page Number.',
            quickSearchTitle: "Type then hit enter",
            reloadButtonTitle: 'Reload grid', 
            searchInputPlaceholder: 'Search',
            totalRecordsTitle:" total records",
            tooltipCfg: {position: "bottom-center", trigger: "hover"}
        };
        var dir = {
            get_dir: function () {
                return cfg.dir;
            },
            get_align: function () {
                return cfg.dir === 'ltr' ? 'left' : 'right';
            },
            get_ralign: function () {
                return cfg.dir === 'ltr' ? 'right' : 'left';
            }
        }
        /**
         * [FixHeaderClass]
         * created fixed headers
         */
        $.fn.fixedHeader = function (o) {
            var s = {
                adjustWidth: $.fixedHeader.calcWidth
            };
            if (o)
                $.extend(s, o);

            return this.each(function () {
                var table = $(this); //table
                var tId = this.id;

                var scrollBarWidth = $.fixedHeader.getScrollBarWidth();
                if (!scrollBarWidth)
                    scrollBarWidth = 15;

                //wrap a body container
                var bodyContainer = table.wrap('<div></div>').parent()
                        .attr('id', tId + "_body_container")
                        .css({
                            width: s.width,
                            height: s.height,
                            overflow: 'auto',
                            direction: cfg.dir,
                            "margin-top": "42px",
                            "border-radius": "0px 0px 5px 5px"
                        });

                //Wrap with an overall container
                var tableContainer = bodyContainer.wrap('<div></div>').parent()
                        .attr('id', tId + '_table_container')
                        .css({position: 'relative'});

                //clone the header
                var position;
                try {
                    position = table.position();
                } catch (err) {
                    position = {
                        top: 0,
                        left: 0
                    };
                }

                var headerContainer = $(document.createElement('div'))
                        .attr('id', tId + '_header_container')
                        .addClass("grid-header-cntr-div")
                        .css({
                            width: bodyContainer.innerWidth() ? bodyContainer.innerWidth() - scrollBarWidth : s.width - scrollBarWidth,
                            top: position.top,
                            height: cfg.headerHeight
                        });

                //remove left put zero since in I.E. the header of search form will begin before it is position [by bilal]
                dir.get_dir() === 'ltr' ? headerContainer.css('left', '0px') : headerContainer.css('right', '0px');
                //for browser FF 4 and below scroll in the right if rtl,but ff4 & above in the left like IE, version =2 is FF4
                headerContainer.prependTo(tableContainer);

                var headerContainerMask = $(document.createElement('div'))
                        .attr('id', tId + '_header_container_mask')
                        .addClass("grid-header-cntr-div-mask");
                headerContainerMask.prependTo(tableContainer);

                //alert(bodyContainer.find("th:first").offset().left)
                var headerTable = table.clone(true)
                        .find('tbody')
                        .remove()
                        .end()
                        .attr('id', tId + "_header")
                        .addClass(s.tableClass || table[0].className)
                        .css({
                            position: 'absolute',
                            top: 0,
                            direction: dir.get_dir(),
                            height: cfg.headerHeight
                        })
                        //.append(table.find('thead')) edited by ihab
                        .appendTo(headerContainer);
                headerTable.css(dir.get_ralign(), 'auto').css(dir.get_align(), '0');

                //sync scroll

                bodyContainer.scroll(function () {
                    $("#" + table_id + "_context_menu").hide();
                    var scroll_val = 0;
                    if (cfg.dir == 'ltr') {
                        scroll_val = $(this).scrollLeft() * -1;
                    } else {

                        scroll_val = $(this).scrollLeft();

                    }
                    scroll_val += 'px';
                    headerTable.css(dir.get_ralign(), 'auto').css(dir.get_align(), scroll_val);

                })



            });
        }

        $.fixedHeader = {
            calcWidth: function (th) {
                var w = $(th).width();

                var borderWidth = $.fixedHeader.getComputedStyleInPx(th, 'borderRightWidth');

                w = w + borderWidth; //FF2 still got a border-left missing problem, this is the best I can do.
                return w;
            },
            getComputedStyleInPx: function (elem, style) {

                try {
                    var computedStyle = (typeof elem.currentStyle != 'undefined')
                            ? elem.currentStyle
                            : document.defaultView.getComputedStyle(elem, null);
                    var val = computedStyle[style];
                    val = val ? parseInt(val.replace("px", "")) : 0;
                } catch (err) {
                    val = 0;
                }



                return (!val || val == 'NaN') ? 0 : val;
            },
            getScrollBarWidth: function () { //calculate or get from global the scroll bar width
                if (!$.fixedHeader.scrollBarWidth) {
                    var inner = $(document.createElement('p')).css({
                        width: '100%',
                        height: '100%'
                    });
                    var outer = $(document.createElement('div'))
                            .css({
                                position: 'absolute',
                                top: '0px',
                                visibility: 'hidden',
                                width: '200px',
                                height: '150px',
                                overflow: 'hidden'
                            })
                            .append(inner)
                            .appendTo(document.body);
                    outer.css(dir.get_align(), '0px')
                    var w1 = inner[0].offsetWidth;
                    outer[0].style.overflow = 'scroll';
                    var w2 = inner[0].offsetWidth;
                    if (w1 == w2)
                        w2 = outer[0].clientWidth;
                    document.body.removeChild(outer[0]);
                    $.fixedHeader.scrollBarWidth = (w1 - w2);
                }
                return $.fixedHeader.scrollBarWidth;
            }
        }
        /**
         * extend cfg with user specified options
         * like set params in php
         */
        $.extend(cfg, o);

        var table_id = $(this).attr("id");
        cfg.height = parseFloat(cfg.height);
        //if not a number then let it auto, we only can put height auto for grid [search form] can't do that for dom
        var is_auto_height = false;
        if (isNaN(cfg.height) && cfg.gridType == 'grid') {
            cfg.height = get_full_cfg_height();
            is_auto_height = true;
        }
        function get_full_cfg_height() {
            //97 is for theme & tab above + grid toolbar (next, page no, export xls) + 7 height of __vertical_resizer
            //if don't want to use jquery window.height [height of browser viewport] use document.body.parentNode.clientHeight
            //we can't use document .height which return the html content height == [window height + the scrollable below html]
            //always we subtract the scrollbar of the window even if not exist or we reresize the new width after window load
            //so can check if there is scroll or not & we take the scroll width not height just to don't create new ft.
            //also subtract -10 just to be far from the bottom theme border
            cfg.height = parseInt($(window).height() - 201/*-$.fixedHeader.getScrollBarWidth()*/);

            if (cfg.height < cfg.minHeight)
                return cfg.minHeight;
            return cfg.height;
        }

        cfg.width = parseFloat(cfg.width);

        //if not a number then let it auto, can give width auto to grid & dom also
        var is_auto_width = false;
        if (isNaN(cfg.width)) {
            cfg.width = get_full_cfg_width();
            is_auto_width = true;
        }
        function get_full_cfg_width() {

            //we put scrollbar two times, for inside scroll & one for the whole window scroll that not always exist but we can't know now
            //then subtract 20 since there is padding for the main grid div & to be far from the right or left border theme
            cfg.width = $(".work_space").width();
            if (cfg.width < cfg.minWidth)
                return cfg.minWidth;
            return cfg.width;
        }

        /**
         * [DomClass]
         */
        var domId = $(this).attr('id').replace('_clone', '');
        var dom = $("#" + domId)
                .extend({
                    setData: function (copy) {
                        var data_selector = $("#" + domId + "_hidden");

                        if ($("#" + domId + "_selected").length && !copy)
                            data_selector = $("#" + domId + "_selected");

                        var mask_selector = "#" + domId + "_display";
                        var element, id, container, dateformat;
                        data_selector.find('input,select').each(function () {
                            id = $(this).attr('id');
                            try {
                                element = $(mask_selector).find('#' + id).get(0);
                                if (element.tagName.match('SELECT')) {
                                    $(this).prev().html($(mask_selector + ' #' + id).find(':selected').text());
                                    $(this).val($(mask_selector + ' #' + id).val());
                                } else
                                if ($('#' + id).parent().attr('for') == 'money') {
                                    $(this).prev().html($('#' + id).getMoneyValue());
                                    $(this).val($('#' + id).getFloatValue());
                                } else if (element.className.match('int-8-date') && element.type.match('hidden')) {
                                    container = $(mask_selector).find('#' + id + '_container').find('input');
                                    if (container.get(0).value > 0 && container.get(1).value > 0 && container.get(2).value > 0) {
                                        dateformat = container.get(0).value + "-" + container.get(1).value + "-" + container.get(2).value;
                                        $(this).prev().html(dateformat);
                                        $(this).val($(mask_selector).find('#' + id).val());
                                    } else {
                                        $(this).prev().html('');
                                        $(this).val('');
                                    }
                                } else {
                                    $(this).val($(mask_selector).find('#' + id).val().replace(/\n/g, '<br>'));
                                    $(this).prev().html($(this).val());
                                }

                            } catch (err) {
                                try {

                                    if (eval(id).getActualValue()) {
                                        $(this).val(eval(id).getActualValue());
                                        $(this).prev().html(eval(id).getComboText());
                                        $(this).next().val(eval(id).getComboText());
                                    } else {
                                        $(this).val('');
                                        $(this).prev().html('');
                                    }
                                } catch (err) {
                                }
                            }
                            ;

                        });
                    },
                    setSelectedRow: function (currentTr, copy) {
                        $('#' + domId + '_display').find('input,select,textarea').val('');
                        $('#' + domId + '_clone tbody tr').attr('id', '');
                        $(currentTr).attr('id', domId + '_selected');
                        if (copy == undefined) {
                            $('#' + domId + '_modify').show();
                            $('#' + domId + '_add').hide();
                        }
                    },
                    getSelectedRow: function () {
                        return $("#" + domId + '_selected');
                    },
                    setParentData: function (currentTr, copy) {
                        dom.setSelectedRow(currentTr, copy);
                        var val, obj, id, new_id;
                        $('#' + domId + '_display').find('input,select,textarea').each(function () {

                            id = $(this).attr('name');
                            if (id)
                                val = dom.getFieldValue(id)
                            try {
                                obj = eval(id)
                                obj.setComboValueText(val, $(currentTr).find("#" + id + '_label').val());
                            } catch (err) {
                                if ($(this).attr('class') != undefined && $(this).attr('class').match('int-8-date') && $(this).attr('type').match('hidden')) {
                                    /*instead of replace*/
                                    new_id = $(this).prev().attr('id');
                                    $('#' + new_id).date_val($(currentTr).find("#" + new_id).val());
                                } else
                                if ($(this).parent().attr('for') == 'money' && !$(this).attr('name').match('_mask')) {
                                    eval($(this).attr('name')).val(val);
                                } else {
                                    if (val)
                                        $(this).val(val.replace(/<br>/g, '\n'));
                                }
                            }
                        });
                    },
                    addAction: function () {
                        dom.setData(true);
                        var new_row = $('#' + domId + '_hidden tr').clone();
                        $('#' + domId + '_clone tbody').append(new_row);
                        /**
                         * Put Fix Row size here
                         */
                        if ($('#' + domId + '_clone tbody tr').length) {
                            g.initStylesAndWidths()
                        }
                        $('#' + domId + '_hidden').find('input').val('');
                        dom.newRecordAction();
                        $("#" + domId + "_new_record").click();
                    },
                    modifyAction: function () {
                        dom.setData();
                    },
                    deleteAction: function (row) {
                        dom.newRecordAction();
                        $("#" + domId + "_new_record").click();
                        row.remove();
                    },
                    newRecordAction: function () {
                        $('#' + domId + '_modify').hide();
                        $('#' + domId + '_add').show();
                        $('#' + domId + '_clone tbody tr').attr('id', '');
                    },
                    clearAction: function () {
                        $('#' + domId + '_clone tbody').html('');
                        $('#' + domId + '_hidden').find('input').val('');
                    },
                    getLastRecord: function () {
                        var lastRow = $('#' + domId + '_clone tbody').children('tr:last-child');
                        dom.setParentData(lastRow, domId, true);
                    },
                    copy: function (curentTr) {
                        dom.setParentData(curentTr, true);
                        $('#' + domId + '_modify').hide();
                        $('#' + domId + '_add').show();
                    },
                    getFieldValue: function (fieldId) {
                        if (fieldId)
                            return $('#' + domId + '_selected').find('#' + fieldId).val();

                        return '';


                    },
                    checkIfExist: function (needle, haystack, button) {

                        var action = $(button).attr("id");
                        var is_existed = false;
                        if (typeof (haystack) == 'string') {
                            haystack = $("input:hidden").filter("input[name='" + haystack + "[]']");
                        }
                        $(haystack).each(function () {
                            if ($(this).val()) {
                                if ($(this).val() == needle) {
                                    if (action.match("_modify") && $(this).parents("tr:first").attr("id") != domId + "_selected")
                                        is_existed = true;
                                    else if (action.match("_modify") && $(this).parents("tr:first").attr("id") == domId + "_selected")
                                        /*is_existed=false*/ ;
                                    else
                                        is_existed = true;
                                }
                            }
                        });

                        return  is_existed;
                    },
                    getSize: function () {
                        return $("#" + domId + "_clone tbody tr").length;

                    },
                    limitSize: function (size, button) {
                        var action = $(button).attr("id");
                        if (dom.getSize() >= size && !action.match("_modify")) {
                            return true;
                        }
                        return false;
                    }
                });
        /**
         * at start i should reset all the table properties
         * like width,cellpadding and border to zero
         */
        $(this).attr({
            cellPadding: 0,
            cellSpacing: 0,
            border: 0,
            dir: cfg.dir
        }).removeAttr('width');

        /**
         * init a new variable h
         * assign the thead object to it
         * assign new class for grid and header
         * assign a new height also
         */
        var grid_width = 0;

        $(this)
                .attr("align", dir.get_align())
                .find('thead')
                .addClass(cfg.gridClass)
                .addClass(cfg.headerClass)
                .find('th').each(function (i) {
            /*
             * loop on each th in header and fix it class
             * and width
             */
            if (cfg.colWidths[i] == undefined)
                cfg.colWidths[i] = cfg.minColWidth;

            if (cfg.headerAligns[i] == undefined)
                cfg.headerAligns[i] = '';

            if (cfg.colIsResizables[i] == undefined)
                cfg.colIsResizables[i] = cfg.resizableCols;
            if (cfg.colMinWidths[i] == undefined)
                cfg.colMinWidths[i] = cfg.minColWidth;

            cfg.colWidths[i] = parseInt(cfg.colWidths[i]);


            if (cfg.colWidths[i] < cfg.colMinWidths[i]) {
                cfg.colWidths[i] = cfg.colMinWidths[i];
            }

            $(this).width(cfg.colWidths[i])
                    .css({
                        'white-space': "nowrap",
                        'height': cfg.headerHeight - 7
                    });
            /*
             *  put column text in a div, make unselectable
             */

            var col_label = $('<div />').addClass("header-th-div").append($('<div />')
                    .append($("<span/>").html(extractContent($(this).html())))
                    .append($("<i/>"))
                    .css({'text-align': cfg.headerAligns[i]}));
            /**
             * used to set Grids total width
             */
            grid_width += parseInt(cfg.colWidths[i]);
            $(this).html(col_label);
            /**
             * if grid is sorting enabled
             */
            if (cfg.sorting) {

                var key = cfg.colSortParams[i] ? cfg.colSortParams[i] : i;
                /*
                 *   is this column the default sorted column?
                 */
                var cls = (key === cfg.sortedCol || i === cfg.sortedCol) ?
                        (cfg.sortedColDir === cfg.sortAscParam ? cfg.sortAscClass : cfg.sortDescClass) :
                        (cfg.sortNoneClass);

                /**
                 * set action on click
                 * send the {ASC,DESC} to server to sort Query
                 */
                col_label.find("i").addClass("mdi").addClass(cls);
                col_label.find("div:first").click(function () {

                    col_label = $(this).find("i");
                    var dir = cfg.sortDefaultDir;
                    if (col_label.attr("class").match(cfg.sortAscClass)) {
                        dir = cfg.sortDescParam;
                    } else {
                        dir = cfg.sortAscParam;
                    }
                    cfg.sortedColDir = dir;
                    /*
                     * set sor direction
                     * and sorted column
                     */
                    var params = {
                        sort: key,
                        dir: dir
                    };
                    /*
                     * set Page number for paging
                     */
                    if (p)
                        $.extend(params, {
                            page: p.getPage()
                        });
                    /*
                     * call load function to request data from server
                     */
                    g.load(params, function () {
                        /*
                         * Assign a new class to the column according to its sorting direction
                         */

                        var cls = cfg.sortNoneClass;
                        cls = (cfg.sortedColDir === cfg.sortAscParam ? cfg.sortAscClass : cfg.sortDescClass);
                        /*
                         * change all the columns classes to default
                         */
                        g.getHeaders(function (col) {
                            col.find(".header-th-div").find("i").attr("class", "mdi").addClass(cfg.sortNoneClass);
                        });
                        /*
                         * set the new sort direction class to the clicked th column
                         */
                        col_label.attr("class", "mdi").addClass(cls);

                    });

                });
            }

            /*
             * append resize handle?
             */
            if (cfg.resizableCols && $.toBoolean(cfg.colIsResizables[i]) === true) {

                /*
                 * bind an event to easily resize columns
                 */
                $(this).bind('resizeColumn', {
                    col_num: i
                }, function (e, w) {

                    g.resize(w, e.data.col_num);
                    $(this).width(w);
                    /*
                     * set body cells to this width
                     */
                    $("#" + table_id + "_body_container thead th").slice(e.data.col_num, e.data.col_num + 1).width(w)

                    g.getColumn(e.data.col_num).css('width', w);
                });
                /*
                 * make column headers resizable
                 */
                var handle = $('<div />').addClass(cfg.resizeHandleClass);
                handle.bind('mousedown', function (e) {
                    /*
                     * start resize drag
                     */
                    var th = $(this).parent().parent();
                    z.resizeStart(th, i);
                });
                $(this).find("div.header-th-div").append(handle);
            }
        });
        $(this).css({
            width: (grid_width)
        })

        /*
         *  resizable cols?
         *  if so create a vertical resize divider, with unique ID
         */
        if (cfg.resizableCols) {
            var z = $('<div/>')
                    .hide()
                    .appendTo($("body"))
                    .extend({
                        resizeStart: function (th, position) {
                            document.body.style.webkitUserSelect = "none";

                            /**
                             * when resizing, bind some listeners for mousemove & mouseup events
                             */
                            $("body").bind('mousemove', {
                                col: th
                            }, function (e) {
                                var th = e.data.col;
                                var pos = th.offset();

                                var col_w = cfg.dir === 'ltr' ? e.clientX - pos.left : th.width() + (pos.left - e.clientX);
                                var innerWidth = parseInt(th.find("span").width()) + parseInt(th.find("i").width()) + 15;
                                var minWidth = cfg.colMinWidths[position] < innerWidth ? innerWidth : cfg.colMinWidths[position];

                                if (col_w > minWidth)
                                    th.trigger('resizeColumn', [col_w]);
                                else
                                    th.trigger('resizeColumn', [minWidth]);
                            })
                            $("body").bind('mouseup', {
                                col: th
                            }, function (e) {
                                document.body.style.webkitUserSelect = "auto";
                                $(this).unbind('mousemove').unbind('mouseup');
                            })
                        }
                    });
        }





        // create our paging control container
        var p = $('<div />')
                .attr("id", table_id + "_footer_div")
                .addClass(cfg.pageToolbarClass);


        if (cfg.showFilter) {

            /**
             * a div which was created in parse
             * in order to append a search form in it
             * here we fix its width hight style ....
             * according to the grid width and height
             */
            var filterDiv =
                    $('#' + table_id + '_filter_div').css(dir.get_align(), 0)
            if (cfg.gridType === 'dom') {
                filterDiv.addClass("dom-filter-div");
            }
            /**
             * #filer_form_div_container
             * is a div that contains the form ,
             * element div and buttons div.
             * i use this div to show and hide
             * the search feilds and buttons in order to
             * increase or maintain the speed of sliding show hide.
             * here we set its width height and styles.
             */
            var filterFormDivContainer = $("#" + table_id + "_filter_form_div_container");
            /**
             * #fiter_form_div
             * the div that contains the search elements
             * we fix the width height and style in order
             * to give a fixed position at the top
             * with scrolling
             */
            if (cfg.gridType === 'dom') {
                var keysAction = "keydown";

                $("input:text,textarea,select").bind(keysAction, cfg.showHideGridHotKey, function () {
                    $("#" + domId + "_show_hide").click();
                    return false;
                });
                $(window).bind(keysAction, cfg.showHideGridHotKey, function () {
                    $("#" + domId + "_show_hide").click();
                    return false;
                });
                $('#' + table_id + '_filter_form_div_container')
                        .find("input,textarea,select")
                        .bind(keysAction, cfg.saveHotKey, function () {

                            if ($(this).val())
                                $(this).change();
                            if ($("#" + domId + "_add").parent().is(":visible") == true) {
                                $("#" + domId + "_add").click();
                                return false;
                            }
                            $("td:visible #" + domId + "_modify").click();
                            return false;
                        })
                        .bind(keysAction, cfg.newHotKey, function () {
                            $("#" + domId + "_new_record").click();
                            return false;
                        })
                        .bind(keysAction, cfg.showHideGridHotKey, function (event) {
                            $("#" + domId + "_show_hide").click();
                            return false;
                        }).bind(keysAction, "ctrl+down", function () {
                    if ($(this).val())
                        $(this).change();
                    if ($("#" + domId + "_add").parent().is(":visible") === true) {
                        $("#" + domId + "_add").click();
                        return false;
                    }
                    $("td:visible #" + domId + "_modify").click();
                    return false;
                });
            }

            var pb5 = $("<i/>").addClass("mdi").addClass("mdi-filter").attr("id", table_id + "-quicksearch-filter")
                    .attr("title", cfg.searchButtonTitle).click(function () {
                if ($('#' + table_id + '_filter_div').is(':visible') === false) {
                    $('#' + table_id + '_filter_div').slideDown("normal", function callback() {
                        filterFormDivContainer.show();
                    });
                } else {
                    filterFormDivContainer.hide();
                    $('#' + table_id + '_filter_div').slideUp("normal", function callback() {});
                }
            }).extend({
                searchAction: function () {
                    filterFormDivContainer.hide();
                    $('#' + table_id + '_filter_div').slideUp("normal", function callback() {
                    });
                }
            }).tipsy(cfg.tooltipCfg);


            if (cfg.gridType === 'grid') {
                var pbsearch = $("<div/>").addClass("grid-quicksearch-container").attr("id", table_id + "-quicksearch-container")
                        .append($("<i/>").addClass("mdi").addClass("mdi-magnify"))
                        .append($("<input/>").attr("type", "text").attr("name", "quicksearch").attr("id", table_id + "-quicksearch").attr("placeholder", cfg.searchInputPlaceholder).attr("title", cfg.quickSearchTitle).tipsy(cfg.tooltipCfg))
                        .append($("<i/>").addClass("mdi").addClass("mdi-reload").attr("id", table_id + "-quicksearch-reload").attr("title", cfg.reloadButtonTitle).tipsy(cfg.tooltipCfg))
                        .append(pb5);

                p.append(pbsearch);
            }
        }
        /*
         * paging?
         * if so create a paging toolbar
         *
         */

        if (cfg.paging) {

            /*
             * create a paging toolbar
             * total records viewing message (if we know total records)
             * total record count might not be passed in config,
             * it's sometimes an expensive hit to the DB
             */

            var ptotal;

            ptotal = $('<div />').addClass("grid-records-count-info").appendTo($("body"));
            var pv;

            pv = $('<div />')
                    .attr("id", table_id + "_paging_tool_bar")
                    .attr('unselectable', 'on')
                    .addClass(cfg.pageViewingRecordsInfoClass)
                    .extend({
                        updateViewInfo: function (p, _total, _viewing) {
                            var input = g.find('input.' + cfg.pageInputClass);
                            var nextBt = g.find('.' + cfg.pageNextClass);
                            var prevBt = g.find('.' + cfg.pagePrevClass);

                            var _total_txt = _total;
                            _total = parseInt(_total.toString().replace(/,/, ""));
                            if (_total > 0)
                                cfg.totalPages = Math.ceil(_total / cfg.recordsPerPage);
                            else
                                cfg.totalPages = 1;


                            $('#' + table_id + 'pagesFont').empty().html(cfg.of + cfg.totalPages);
                            cfg.totalRecords = _total;
                            cfg.totalShownRecords = _viewing;

                            input.val(p);
                            prevBt.removeClass("grid-page-nav-disabled");
                            nextBt.removeClass("grid-page-nav-disabled");
                            if (p <= 1) {
                                prevBt.addClass("grid-page-nav-disabled");
                            }
                            if (p >= cfg.totalPages) {
                                nextBt.addClass("grid-page-nav-disabled");
                            }
                            if (_total > 0) {
                                ptotal.html(cfg.totalRecordsTitle).prepend($("<font/>").html(_total_txt));
                            }
                            return this;
                        }
                    });

            p.extend({
                setPage: function (p) {
                    g.load({page: p});
                    return this;
                },
                getPage: function () {
                    var p = Number(this.find('input.' + cfg.pageInputClass).val());
                    return p;
                }
            });

            // prev page button
            var pb2 = $('<a href="javascript:;"></a>')
                    .addClass(cfg.pagePrevClass)
                    .addClass("grid-page-nav-disabled")
                    .attr("title", cfg.pagePrevTitle)
                    .tipsy(cfg.tooltipCfg)
                    .click(function () {
                        var _p = p.getPage();
                        if (_p > 1) {
                            _p--;
                            p.setPage(_p);
                        }
//                else{
//                    $(this);
//                }
                    });
            // next page button

            var pb3 = $('<a href="javascript:;"></a>')
                    .addClass(cfg.pageNextClass)
                    .addClass("grid-page-nav-disabled")
                    .attr("title", cfg.pageNextTitle)
                    .tipsy(cfg.tooltipCfg)
                    .click(function () {
                        var _p = p.getPage();
                        _p++;
                        if (cfg.totalPages) {
                            if (_p <= cfg.totalPages)
                                p.setPage(_p);
                        } else {
                            p.setPage(_p);
                        }
                    });
            if (p.getPage() === cfg.totalPages) {
                pb3.addClass("grid-page-nav-disabled");
            }
            // page field & form
            var pfld = $('<input type="text" value="' + cfg.pageNumber + '"/>').addClass(cfg.pageInputClass).attr('id', 'paging-input');

            var pinfo = $('<div />')
                    .addClass(cfg.pageInfoClass)
                    .extend({
                    })
                    .attr('unselectable', 'on');

            var pform = $('<form/>').append(pfld).submit(function () {
                var _p = parseInt(p.getPage());
                if (_p) {
                    if (cfg.totalPages) {
                        if (_p <= cfg.totalPages)
                            p.setPage(_p);
                    } else if (_p > 0) {
                        p.setPage(_p);
                    }
                } else {
                    alert(cfg.valid_number_msg);
                }
                return false;
            });

            // last page button & info (if we know total records)

            if (cfg.totalRecords > 0) {
                pinfo.append($("<span/>").html(pform))
                        .prepend($("<span/>").html(cfg.page))
                        .append($('<span />').html(cfg.of + "&nbsp;" + cfg.totalPages).attr('id', table_id + 'pagesFont'));

            } else {
                pinfo.html(cfg.page + '&nbsp;' + pinfo.html());
            }

            var pb6 = $('<a href="javascript:;"></a>').addClass(cfg.reloadButtonClass).attr("id", table_id + "searchReloadButton").attr('title', cfg.reloadButtonTitle);
            if (cfg.showExportXls)
                var pbxls = $('<a href="javascript:;"></a>').addClass(cfg.exportXlsClass).attr('title', cfg.exportXlsTitle).attr("id", table_id + "exportXlsButton")
                        .attr("title", cfg.exportXlsTitle)
                        .tipsy(cfg.tooltipCfg);
            if (!cfg.disableGroupDelete)
                var pbgd = $('<a href="javascript:;"></a>').addClass(cfg.groupDeleteBtClass).attr('title', cfg.groupDeleteBtTitle).attr("id", table_id + "groupDeleteBt").click(function () {
                    g.group_delete()
                });

            if (cfg.showExportXls)
                p.append(pbxls);

            p.append(pb2).append(pb3).append(pinfo).append(pv);

//            if (!cfg.disableGroupDelete)
//                p.append(pbgd);
        }

        if (!cfg.disableContextMenu) {
            var contextMenu = $('<div class="contextMenu" id="' + table_id + '_context_menu"><ul></ul></div>').appendTo($('body'));
            if (!cfg.disableModify)
                var modifyMenuItem = $('<li title="' + cfg.modifyTitle + '"><a href="#modify" alt="modify"><i class="mdi mdi-square-edit-outline"></i></a></li>').tipsy(cfg.tooltipCfg).appendTo(contextMenu.find("ul"));
            if (!cfg.disableCopy)
                var copyMenuItem = $('<li title="' + cfg.copyTitle + '"><a href="#copy" alt="copy"><i class="mdi mdi-content-copy"></i></a></li>').tipsy(cfg.tooltipCfg).appendTo(contextMenu.find("ul"));
            if (!cfg.disableDelete)
                var deleteMenuItem = $('<li title="' + cfg.deleteTitle + '"><a href="#delete"  alt="delete"><i class="mdi mdi-delete"></i></a></li>').tipsy(cfg.tooltipCfg).appendTo(contextMenu.find("ul"));
            if (cfg.enablePrint)
                var printMenuItem = $('<li title="' + cfg.printTitle + '"><a href="#print"   alt="print"><i class="mdi mdi-printer"></i></a></li>').tipsy(cfg.tooltipCfg).appendTo(contextMenu.find("ul"));

        }


        $(this).fixedHeader({
            width: cfg.width,
            height: cfg.height
        }).addClass("datagrid");

        $("#" + table_id + " thead:first").remove();

        var g = $("#" + table_id + "_table_container");
        $("body").prepend(z);
        g.css({
            'border': '1px solid transparent',
            'border-width': '1px 0px 0px'
        });//.width(cfg.width);
        /*
         *...a loading modal mask
         */
        g.append(p)
                .extend({
                    g: g,
                    p: p
                })

        g.parent()
                .attr("id", table_id + "_divContainsAll")
                .css({
                    "direction": cfg.dir,
                    "text-align": dir.get_align()
                });

        if (cfg.gridType == 'dom') {
            g.parent().addClass("dom-divContainsAll");
        }

        //this to get the offset right which is the all windows width subtract the left & [the border & padding== outerwidth]
        function getRightOffset(obj) {
            return ($(window).width() - obj.offset().left - obj.outerWidth());
        }
        //on browser or document resize change the grid width & height if it is set to auto
        if ((is_auto_height && cfg.gridType === 'grid') || is_auto_width) {
            $(window).bind("resize", function () {
                if (is_auto_height && cfg.gridType === 'grid') {
                    var newHeight = get_full_cfg_height();
                    newHeight = parseInt(newHeight);

                    z.height(newHeight);
                    $("#" + table_id + "_body_container").height(newHeight);
                }

                if (is_auto_width) {
                    var newWidth = get_full_cfg_width();
                    //console.log(newWidth);
                    //if dom then subtract the dom label in the table space
                    if (cfg.gridType === "dom") {
                        var dom_offset_dir_align = cfg.dir === 'ltr' ? g.offset().left : getRightOffset(g);
                        newWidth -= dom_offset_dir_align;
                        //we rmove below some width so to don't allow make scroll below in the whole form
                        newWidth -= 30;
                        if (newWidth < cfg.minWidth)
                            newWidth = cfg.minWidth;
                    }
                    newWidth = parseInt(newWidth);

                    g.width(newWidth); //_table_container
                    $('#' + table_id + '_header_container').width(newWidth - $.fixedHeader.getScrollBarWidth());
                    $('#' + table_id + '_body_container').width(newWidth);
                }
            });
        }




        $(document).ready(function () {
            if (dir.get_dir() === 'rtl') {
                $("#" + table_id + "_body_container").animate({
                    scrollLeft: grid_width
                }, {
                    duration: 50
                });
            }
        });

        /**
         * create methods on our grid object
         * [GridClass]
         */
        g.extend({
            group_delete: function () {
                if (g.getSelectedRows().length > 0) {
                    if (confirm(cfg.groupDeleteConfirmationMsg)) {
                        var action_link = g.getLastRow().attr("group_delete");
                        var link = cfg.url + action_link + cfg.extendActions + "&ids=" + $.cookie("rowSelection");
                        $.cookie("rowSelection", "")
                        g.target(link);
                        g.callTab();
                    }

                } else {
                    load_message('error', cfg.noSelectedRowsErr);
                }
            },
            export_file: function (data) {
                if (data) {

                    data = $.extend(cfg.extraParams, data);
                    var inputs = '';
                    for (var key in data) {

                        inputs += '<input type="hidden" name=\'' + key + '\' value=\'' + data[key] + '\' />';
                    }
                    $('<form action="' + cfg.url + '" method="post" target="' + table_id + '-export-xlspdf-iframe">' + inputs + '</form>')
                            .appendTo('#' + table_id + '-export-pdf-xls-div').submit().remove();
                    $("#" + table_id + "-export-xlspdf-iframe").contents().ready(function () {});
                }
            },
            stripTag: function (oldString) {
                var newString = "";
                var inTag = false;
                for (var i = 0; i < oldString.length; i++) {

                    if (oldString.charAt(i) === '<')
                        inTag = true;
                    if (oldString.charAt(i) === '>') {
                        if (oldString.charAt(i + 1) === "<")
                        {
                            /*
                             * dont do anything
                             */
                        } else
                        {
                            inTag = false;
                            i++;
                        }
                    }

                    if (!inTag)
                        newString += oldString.charAt(i);

                }

                return newString;
            },
            resize: function (w, i) {

                var width = 0;
                $("#" + table_id + "_header thead th").each(function (pos) {
                    if (pos === i)
                        width += parseFloat(w);
                    else
                        width += parseFloat($(this).width());
                })
                //               width += 16;
                //alert(width)
                $("#" + table_id + "_header").width(width);
                $("#" + table_id + "_header thead").width(width);
                $("#" + table_id + "_body_container table,thead,tbody").width(width);
                /*if(dir.get_dir()=="rtl"){
                 $("#"+table_id+"_header_container").css("right",15)
                 $("#"+table_id+"_header").css("right",0)
                 }*/



            }
            ,
            load: function (params, cb) {
                var data = $.extend(cfg.extraParams, params, cfg.searchAction);
                if (data.page === undefined)
                    data.page = 1;

                $.ajax({
                    type: cfg.type.toUpperCase(),
                    url: cfg.url,
                    data: data,
                    beforeSend: function () {
                        if (cfg.gridType == 'grid') {
                            cfg._ajaxInAction = true;
                            $("#" + table_id + "-quicksearch-reload").removeClass("mdi-reload").addClass("grid-quicksearch-loading");
                        }
                    },
                    success: function (result) {
                        if (cfg.enableDebug)
                            console.log(g.stripTag(result));


                        var $tbl = $(result);
                        var row = $tbl.find('tr:first');

                        $(row).find("td").each(function () {
                            $(this).html();
                        });
                        var _total = $tbl.find('tr:last').attr('_total');
                        var _viewing = $tbl.find('tr:last').attr('_viewing');

                        if ($(row).find('td').length === cfg.colWidths.length) {

                            g.find('tbody').replaceWith($tbl.find('tbody'));
                            g.initStylesAndWidths();
                            pv.updateViewInfo(data.page, _total, _viewing);

                        } else {
                            /*
                             * inconsistent results... too many (or too few) columns returned
                             */
                            load_message('error', cfg.matching_cols1_err + $tbl.find('tbody tr:first td').length + cfg.matching_cols2_err + cfg.colWidths.length + '].');
                        }
                        if (_total === '0') {
                            /*
                             * no rows returned
                             */
                            load_message('info', cfg.no_result);
                        }
                    },
                    error: function () {
                        load_message('error', cfg.no_connection_err);
                    },
                    complete: function () {
                        if (cb)
                            cb();
                        if (cfg.gridType === 'grid') {
                            cfg._ajaxInAction = false;
                            setTimeout(function () {
                                $("#" + table_id + "-quicksearch-reload").removeClass("grid-quicksearch-loading").addClass("mdi-reload");
                            }, 10);
                        }
                    }
                });
                return this;
            },
            /*
             * returns <th> els
             */
            getHeaders: function (cb) {
                var ths = this.find('th');
                if (cb) {
                    ths.each(function () {
                        cb($(this));
                    });
                    return this;
                } else {
                    return ths;
                }
            },
            /*
             * returns <th> el
             */
            getHeader: function (i, cb) {
                var th = this.find('th').slice(i, i + 1);
                if (cb) {
                    cb($(this));
                    return this;
                } else {
                    return th;
                }
            },
            /*
             * returns <td> els in column i
             */
            getColumn: function (i, cb) {
                var tds = this.find("tbody td").eq(i);
                if (cb) {
                    tds.each(function () {
                        cb($(this));
                    });
                    return this;
                } else {
                    return tds;
                }
            },
            /*
             * returns <tr> els
             */
            getRows: function (cb) {
                var trs = this.find("tbody tr");
                if (cb) {
                    trs.each(function () {
                        cb($(this));
                    });
                    return this;
                } else {
                    return trs;
                }
            },
            /*
             * returns <tr> els
             */
            getLastRow: function () {
                return this.find("tbody tr:last");

            },
            /*
             * returns <tr> els
             */
            getSelectedRows: function () {
                return this.find("tbody tr[_selected='true']");
            },
            /*
             * returns an array of IDs (current view)
             */
            getSelectedRowIds: function () {
                var rows = g.getSelectedRows();
                var row_ids = [];
                for (i = 0; i < rows.length; i++) {
                    if ($(rows[i]).attr('id'))
                        row_ids.push($(rows[i]).attr('id'));
                }
                return row_ids;
            },
            initRowStylesAndWidths: function (row, r) {

                if (typeof row === 'undefined')
                    row = this.find("tbody tr:last");

                if (typeof r === 'undefined')
                    r = this.getRows().length - 1;

                /*
                 * custom row styles (striping, etc) & hover
                 */
                if (cfg.rowClasses.length > 0) {
                    var cursor = (r === 0 ? 0 : r % cfg.rowClasses.length);
                    if (cfg.rowClasses[cursor] !== '') {
                        /*
                         * custom row class
                         */
                        $(row).attr('class', cfg.rowClasses[cursor]);

                        if ($(row).attr('_selected') === 'true')
                            $(row).attr('class', cfg.rowSelectedClass);
                    }
                    if (cfg.rowHoverClass !== '') {
                        /*
                         * hover class
                         */
                        $(row).hover(
                                function () {
                                    if ($(this).attr('_selected') !== 'true')
                                        $(this).removeClass(cfg.rowClasses[cursor]).addClass(cfg.rowHoverClass);
                                },
                                function () {
                                    if ($(this).attr('_selected') !== 'true')
                                        $(this).removeClass(cfg.rowHoverClass).addClass(cfg.rowClasses[cursor]);
                                }
                        );
                    }
                    /*
                     * bind row selection behaviors
                     */

                    if (cfg.rowSelection === true) {
                        $(row).click(function () {
                            var $r = new Array();
                            if ($.cookie("rowSelection"))
                                $r = $.cookie("rowSelection").split(",");

                            if (!$(this).attr('_selected') || $(this).attr('_selected') === 'false') {
                                $(this).attr('_selected', 'true').addClass(cfg.rowSelectedClass);

                                if ($.inArray($(this).attr('_record_id'), $r) === -1)
                                    $r.push($(this).attr('_record_id'));
                            } else {
                                $(this).attr('_selected', 'false').removeClass(cfg.rowSelectedClass);

                                if ($.inArray($(this).attr('_record_id'), $r) > -1)
                                    $r.splice($.inArray($(this).attr('_record_id'), $r), 1);
                            }

                            if (cfg.onRowSelect) {
                                cfg.onRowSelect(this, ($(this).attr('_selected') === 'true' ? true : false));
                            }
                            $r.toString();
                            $.cookie("rowSelection", $r, {
                                expires: 30
                            });
                        });

                    }
                }
                if (cfg.gridType === 'dom' && !cfg.disableContextMenu)
                {
                    $(row).dblclick(function () {
                        if (cfg.onShowModifyForm) {
                            var action = "modify";
                            var el = $(this);
                            var pos = $(this).position();
                            var self = modifyMenuItem.find("a");
                            var onShowModifyForm = function (action, el, pos, self) {
                                eval(cfg.onShowModifyForm);
                            };
                            onShowModifyForm(action, el, pos, self);
                        }

                    }).contextMenu({
                        menu: table_id + '_context_menu'
                    }
                    ,
                            function (action, el, pos, self) {

                                switch ($(self).attr('alt'))
                                {
                                    case "modify":
                                        if (cfg.onShowModifyForm) {
                                            var onShowModifyForm = function (action, el, pos, self) {
                                                eval(cfg.onShowModifyForm)
                                            }
                                            onShowModifyForm(action, el, pos, self);
                                        }
                                        break;
                                    case "copy":
                                        if (cfg.onCopy) {
                                            var onCopy = function (action, el, pos, self) {
                                                eval(cfg.onCopy)
                                            }
                                            onCopy(action, el, pos, self);
                                        }

                                        break;
                                    case "delete":
                                        load_confirm(cfg.deleteConfirmationMsg, function () {
                                            if (cfg.onDelete) {
                                                var onDelete = function (action, el, pos, self) {
                                                    eval(cfg.onDelete)
                                                }
                                                onDelete(action, el, pos, self);
                                                g.initStylesAndWidths();
                                            }
                                        }, function () {})

                                        break;
                                }
                            }
                    );
                }

            },
            callTab: function () {
                cfg.tagetedTab = parseInt(cfg.targetedTab);
                FormTabContainer.expandit(cfg.targetedTab);
            }
            ,
            target: function (link) {
                parent.parent.Notiflix.Loading.Pulse('');
                var target = cfg.editingTarget.toString();
                $("iframe[name='" + target + "']").attr("src", link);

            },
            initStylesAndWidths: function () {
                g.find("tbody tr:first td").each(function (i) {
                    /*
                     * column IDs & width
                     */
                    var width = $("#" + table_id + "_header thead th").eq(i).width();
                    $(this).width(width);
                });
                this.getRows().height(cfg.colHeight).each(function (r) {
                    g.initRowStylesAndWidths($(this), r);
                })

                if (cfg.gridType == 'grid'/* && !cfg.disableContextMenu */) {

                    g.getRows()
                            .dblclick(function () {
                                var $act = "modify";

                                if ($act) {
                                    var action_link = $(this).parent().find("tr:last").attr($act);
                                    var link = $(this).attr("__remote_page") ? $(this).attr("__remote_page") : cfg.url;
                                    link += action_link + $(this).attr("extended_link") + cfg.extendActions;

                                    g.target(link);
                                    setTimeout(function () {
                                        g.callTab();
                                    }, 200);
                                }

                            })
                            .contextMenu({
                                menu: table_id + '_context_menu'
                            }
                            ,
                                    function (action, el, pos, self) {
                                        var action_link = $(el).parent().find("tr:last").attr($(self).attr("alt"));

                                        var link = $(el).attr("__remote_page") ? $(el).attr("__remote_page") : cfg.url;
                                        link += action_link + $(el).attr("extended_link") + cfg.extendActions;

                                        if ($(self).attr('alt') == 'delete') {
                                            load_confirm(cfg.deleteConfirmationMsg, function () {
                                                g.target(link);
                                                g.callTab();
                                            }, function () {

                                            });
                                        } else {
                                            g.target(link);
                                            g.callTab();
                                            if ($(self).attr('alt') != 'delete') {
                                                cfg.tagetedTab = parseInt(cfg.targetedTab);
                                                FormTabContainer.expandit(cfg.targetedTab);
                                            }
                                        }
                                    });

                    if ((!cfg.enablePrint && cfg.disableCopy && cfg.disableModify && cfg.disableDelete)
                            || cfg.disableContextMenu)
                        g.getRows().disableContextMenu();

                }


            }
        });

        if (cfg.paging) {
            document.getElementById(table_id + "_header").onselectstart = function () {
                return false
            }
            document.getElementById(table_id + "_paging_tool_bar").onselectstart = function () {
                return false
            }
        }
        if (cfg.extendedFunction) {
            var extendedFunction = function () {
                eval(cfg.extendedFunction)
            }
            extendedFunction();
        }


        return this.each(function () {
            if (cfg.initialLoad) {
                g.load(cfg.defaultParams);
            }
        }).extend({
            g: g,
            pb5: pb5,
            contextMenu: contextMenu,
            dom: dom
        })
    }

})(jQuery)