
Notiflix.Notify.Init({
    position: defines.DIR_RALIGN+"-bottom",
    width: 'fit-content',
    timeout: 3000,
    closeButton: false,
    backOverlay: false,
    showOnlyTheLastOne: true,
    //messageMaxLength: 45,
    borderRadius: '10px',
    clickToClose: false,
    fontSize: '17px',
    //distance:null,
    rtl: false,
    plainText: true,
    fontFamily: 'Roboto',
    success: {
        background: '#32c682',
        textColor: '#fff',
        childClassName: 'success',
        notiflixIconColor: 'rgba(255,255,255,1)',
    }, failure: {
        background: '#ff5549',
        textColor: '#fff',
        childClassName: 'failure',
        notiflixIconColor: 'rgba(255,255,255,1)',
    }, warning: {
        background: '#eebf31',
        textColor: '#fff',
        childClassName: 'warning',
        notiflixIconColor: 'rgba(255,255,255,1)'
    }, info: {
        background: '#26c0d3',
        textColor: '#fff',
        childClassName: 'info',
        notiflixIconColor: 'rgba(255,255,255,1)', }
});



function notifyInit(json) {
    try {
        parent.parent.Notiflix.Notify.Merge(json);
    } catch (e) {
        parent.Notiflix.Notify.Merge(json);
    }

}



Notiflix.Loading.Init({
    className: 'notiflix-loading',
    zindex: 4000,
    backgroundColor: 'rgba(var(--overlay-rgb),0.6)',
    rtl: false,
    useGoogleFont: false,
    fontFamily: 'Roboto',
    cssAnimation: true,
    cssAnimationDuration: 400,
    clickToClose: true,
    customSvgUrl: null,
    svgSize: '80px',
    svgColor: 'var(--primary-color)',
    messageID: 'NotiflixLoadingMessage',
    messageFontSize: '15px',
    messageMaxLength: 34,
    messageColor: '#000',
});
// Notiflix Confirm - All Options 
Notiflix.Confirm.Init({
    className: 'notiflix-confirm',
    width: '350px',
    zindex: 4003,
    position: 'center',
    distance: '10px',
    backgroundColor: '#ffffff', //'#f8f8f8'// 
    borderRadius: '15px',
    backOverlay: true,
    backOverlayColor: 'rgba(var(--overlay-rgb),0.6)',
    rtl: false,
    useGoogleFont: false,
    fontFamily: 'roboto',
    cssAnimation: true,
    cssAnimationStyle: 'fade',
    cssAnimationDuration: 300,
    plainText: true,
    titleColor: 'var(--primary-color)',
    titleFontSize: '26px',
    titleMaxLength: 34,
    messageColor: '#1e1e1e',
    messageFontSize: '14px',
    messageMaxLength: 110,
    buttonsFontSize: '15px',
    buttonsMaxLength: 34,
    okButtonColor: '#f8f8f8',
    okButtonBackground: 'var(--primary-color)',
    cancelButtonColor: '#f8f8f8',
    cancelButtonBackground: '#a9a9a9',
});

function load_confirm(message, yes_function, no_function) {
    try {
        parent.parent.Notiflix.Confirm.Show(defines.PLEASE_CONFIRM,
                message,
                defines.YES,
                defines.NO,
                function () {
                    return yes_function();
                },
                function () {
                    return  no_function();
                });
    } catch (exception) {
        parent.Notiflix.Confirm.Show(defines.PLEASE_CONFIRM,
                message,
                defines.YES,
                defines.NO,
                function () {
                    return yes_function();
                },
                function () {
                    return  no_function();
                });
    }

}
function load_message(type, message)
{
    if (type === 'success') {
        try {
            parent.parent.Notiflix.Notify.Success(message);
        } catch (exception) {
            parent.Notiflix.Notify.Success(message);
        }
    }
    if (type === 'error') {
        try {
            parent.parent.Notiflix.Notify.Failure(message);
        } catch (exception) {
            parent.Notiflix.Notify.Failure(message);
        }

    }
    if (type === 'info') {
        try {
            parent.parent.Notiflix.Notify.Info(message);
        } catch (exception) {
            parent.Notiflix.Notify.Info(message);
        }

    }
    if (type === 'warning') {
        try {
            parent.parent.Notiflix.Notify.Warning(message);
        } catch (exception) {
            parent.Notiflix.Notify.Warning(message);
        }

    }
}
function load_report_message(type, title, message)
{
    if (type === 'success') {
        try {
            parent.parent.Notiflix.Report.Success(title, message);
        } catch (exception) {
            parent.Notiflix.Notify.Success(title, message);
        }
    }
    if (type === 'error') {
        try {
            parent.parent.Notiflix.Report.Failure(title, message);
        } catch (exception) {
            parent.Notiflix.Notify.Failure(title, message);
        }

    }
    if (type === 'info') {
        try {
            parent.parent.Notiflix.Report.Info(title, message);
        } catch (exception) {
            parent.Notiflix.Notify.Info(title, message);
        }

    }
    if (type === 'warning') {
        try {
            parent.parent.Notiflix.Report.Warning(title, message);
        } catch (exception) {
            parent.Notiflix.Notify.Warning(title, message);
        }

    }
}
function extractContent(s) {
    var span = document.createElement('span');
    span.innerHTML = s;
    return span.textContent || span.innerText;
}
function hide_message() {
    parent.parent.Notiflix.Loading.Remove();
}
function show_file(img) {
    var mainDiv = document.createElement("div");
    mainDiv.className = "whiteoverlay";

    var lang = {
        ok: 'OK',
        dimensions: 'Dimensions',
        close: 'Close'
    };

    if (window.dir == 'rtl')
        lang = {
            ok: 'موافق',
            dimensions: 'الأبعاد',
            close: 'إغلاق'
        };

    $(mainDiv)
            .append(
                    $("<div/>").addClass("file_viewer")
                    .append($("<div/>").append($("<img/>").attr("src", img.src).addClass("img_size")).addClass("img_container"))
                    .append($("<div/>").addClass("fv_dim").css({float: window.dirAlign}).append(lang.dimensions + " = " + img.width + " * " + img.height))
                    .append($("<div/>").addClass("fv_close").addClass("mdi").addClass("mdi-window-close").bind("click", function () {
                        $(mainDiv, parent.parent.document).fadeOut(300, function () {
                            $(this).remove();
                        });
                    }))
                    ).click(function () {
        $(this).fadeOut(250)
    });
    $("body", parent.parent.document).append(mainDiv);
    $(mainDiv, parent.parent.document).fadeIn(250);
}
function showOverlay() {
    var mainDiv = document.createElement("div");
    mainDiv.className = "whiteoverlay";
    $("body", parent.parent.document).append(mainDiv);
    $(mainDiv, parent.parent.document).fadeIn(250);
}
function hideOverlay() {
    $(".whiteoverlay", parent.parent.document).fadeOut(300, function () {
        $(this).remove();
    });
}
function show_loading_pulse() {
    try {
        parent.parent.Notiflix.Loading.Pulse();
    } catch (exception) {
        try {
            parent.Notiflix.Loading.Pulse();
        } catch (exception) {
            Notiflix.Loading.Pulse();
        }
    }
}
function hide_loading_pulse() {
    try {
        parent.parent.Notiflix.Loading.Remove();
    } catch (exception) {
        try {
            parent.Notiflix.Loading.Remove();
        } catch (exception) {
            Notiflix.Loading.Remove();
        }
    }
}
if (defines.DIR === 'rtl') {
    Notiflix.Notify.Merge({position: 'left-bottom', rtl: true, fontFamily: 'GretaArabic'});
    Notiflix.Confirm.Merge({rtl: true, fontFamily: 'GretaArabic'});
}