(function($){
    var isString =  function(num){
        if((num*0)==0)
            return false;
        return true;
    }
    $.fn.moneyConverter = function(o){
        var options = {
            moneyPrecision:2,
            floatPrecision:2,
            currencyCode:'',
            enableSign:false,
            enableZeroValue:true
        }
        $.extend(options, o);

        var elem = $(this)
        elem.extend({
            convFloat : function(num){

                if(num == undefined || (typeof(num) == 'string' && num==''))
                    return '';
                if(options.enableZeroValue == false && parseFloat(num) == 0)
                    return '';
                if(num.toString().match(/e\-/))
                    return 0;
                if(num.toString().match(/e\+/))
                    return ;
                if(parseFloat(num) == 0)
                    return 0;
                //here we make to fixed to precision we have for the number
                var dec_num = num.toString().match(/\.\d+$/gi);
                var len = (dec_num) ? dec_num[0].length-1 : 0;
                //this to keep only numbers, & remove char
                num = num.toString().match(/\d|\./g,'');
                if(num == null)
                    num = 0;
                else
                    num = num.join('');

                if( len > options.floatPrecision ) options.floatPrecision = len;
                num = parseFloat(num).toFixed(options.floatPrecision);
                num = num.split('.');
                num[1] = num[1].replace(/(0)+$/,'');

                num = num.join('.');
                
                if(num == parseInt(num))
                    num = parseInt(num);
                
                return num;
            },
            convMoney:function(num){
                if(num == undefined || (typeof(num) == 'string' && num==''))
                    return '';
                if(num.toString().match(/e\-/))
                    return 0;
                if(num.toString().match(/e\+/))
                    return ;
                if(options.enableZeroValue == false && parseFloat(num) == 0)
                    return '';
                
                if(parseFloat(num) == 0)
                    return parseFloat(num).toFixed(options.moneyPrecision);
                           
                num = num.toString();
                if(options.enableSign==false){
                    num = num.toString().match(/\d|\./g,'');
                }
                else{
                    num = num.toString().match(/\d|\.|\-|\+/g,'');
                }
                if(num == null)
                    num = 0;
                else
                    num = num.join('');
                var cents = 0;
                if(!isString(num)){
                    cents = parseFloat(num);
                }
                cents = cents.toFixed(options.moneyPrecision)
                cents = cents.split('.');
                cents = cents[1];

                if(isString(num))
                    num = 0;

                var sign = (num == (num = Math.abs(num)));

                num = Math.floor(num*100+0.50000000001);
                num = Math.floor(num/100).toString();

                for (var i = 0; i < Math.floor((num.length-(1+i))/3); i++)
                    num = num.substring(0,num.length-(4*i+3))+','+
                    num.substring(num.length-(4*i+3));
                num = (((sign)?'':'-') + options.currencyCode + num + '.' + cents);
                return num;
            },
            isMoney:function(num){

                if(num.toString().match(/\,/g) ||(num.match(options.currencyCode) && num.toString().match(/\,/g)) )
                    return true;
                return false;
            }

        })
        return elem;
    }

    $.fn.moneyFormat = function(o){
        var options = {
            moneyPrecision:2,
            floatPrecision:2,
            currencyCode:'',
            enableSign:false,
            enableZeroValue:true
        }
        $.extend(options, o);

        var value;
        var mask;
        var container;


        value = $("<input type='hidden'/>")
        .attr({
            'name':$(this).attr('name'),
            'id':$(this).attr('id'),
            'value':$(this).val(),
            'class':$(this).attr('class'),
            '_for_':'money'
        })



        mask = $("<input type='text'/>")
                .attr({
            'name':$(this).attr('name')+'_mask',
            'id':$(this).attr('id')+'_mask',
            'value':$(this).val(),
            'class':$(this).attr('class'),
            'title':$(this).attr('title'),
            'style':$(this).attr('style'),
            'readonly':$(this).attr('readonly'),
            'disabled':$(this).attr('disabled'),
            'autocomplete':$(this).attr('autocomplete'),
            '_for_':'money'
            }).keydown(function(){   
                if(mask.val()){
                    $('#'+value.attr('id')+'_required_alert').css('color', '');
                }
            });

        container = $('<div/>')
        .attr('id',$(this).attr('id')+'Container')
        .attr('for','money')
        .attr('data',JSON.stringify(options))
        .css("display","inline-flex")
        .append(mask)
        .append(value);
        $(this).replaceWith(container);


        var elem = $(this).moneyConverter(options);
        elem.extend({
            val:function(num){
                if(num || num == ''){
                    if(elem.isMoney(num))
                        num = elem.convFloat(num);

                    mask.val(elem.convMoney(num));
                    value.val(elem.convFloat(num));
                    return elem;
                }
                return value.val();
            },
            getMoneyValue : function(){
                return elem.convMoney(value.val());
            },
            getFloatValue : function(){
                return value.val();
            }

        });
        
        mask.extend({
            toMoney : function(){
                var num = $(this).val();
                $(this).val(elem.convMoney(num));
                return mask;
            },
            toFloat : function(){
                $(this).val(value.val());
                return mask;
            }
        })
        value.extend({
            toFloat : function(){
                $(this).val(elem.convFloat(mask.val()));
                return value;
            }
        })



        mask.focus(function(){
            mask.toFloat();
            mask.attr('_is_focused','true');
        })
        mask.blur(function(){
            if(mask.val())
                mask.toMoney();
            mask.removeAttr('_is_focused');
        })
        $("#add,#modify").click(function(){
            if(mask.attr('_is_focused'))
                mask.change();
        })
        value.change(function(){
            elem.change();
        })

        mask.change(function(){
            value.toFloat();
            mask.toMoney();
            value.change();
            mask.removeAttr('_is_focused');
        })

        $(document).ready(function(){
            if(mask.val()){
                value.toFloat();
                mask.toMoney();
            }
        })

        return elem.extend({
            mask:mask,
            value:value
        });
    }
    $.fn.getFloatValue = function(){
        var o;
        var options = {
            moneyPrecision:2,
            floatPrecision:2,
            currencyCode:''
        };
        
        try{
            var obj = $(this).filter("input[_for_='money']");
            o= obj.parent().metadata({
                type:'attr',
                name:'data'
            });

            $.extend(options, o);
        }catch(err){
            $.extend(options, $.toJSON(o));
        }
        if(obj.length == 0) return null;
        
        var elem = obj.moneyConverter(options);
        return elem.convFloat(obj.val());
    }
    $.fn.getMoneyValue = function(){
        var o;
        var options = {
            moneyPrecision:2,
            floatPrecision:2,
            currencyCode:''
        };
        try{
            var obj = $(this).filter("input[_for_='money']");
            o= obj.parent().metadata({
                type:'attr',
                name:'data'
            });

            $.extend(options, o);
        }catch(err){
            $.extend(options, $.toJSON(o));
        }

        $.extend(options, o);
        var elem = obj.moneyConverter(options);
        return elem.convMoney(obj.val());
    }
    $.fn.setMoneyValue = function(val){
        var mask ;
        var o;
        var options = {
            moneyPrecision:2,
            floatPrecision:2,
            currencyCode:''
        };
        
        try{
            var obj = $(this).filter("input[_for_='money']");
            o= obj.parent().metadata({
                type:'attr',
                name:'data'
            });

            $.extend(options, o);
        }catch(err){
            $.extend(options, $.toJSON(o));
        }
        if(obj.length == 0) return null;

        var elem = obj.moneyConverter(options);
        obj.val(elem.convFloat(val));
        mask  = obj.parent().find('#'+obj.attr('id')+'_mask');
        mask.val(elem.convMoney(val));

        return obj;

    }
    $.fn.setMoneyDisable = function(bool){

        bool = $.toBoolean(bool);

        var obj = $(this).filter("input[_for_='money']");
        if(obj.length == 0) return null;
        
        obj.attr('readonly',bool);
        obj.parent().find('#'+obj.attr('id')+'_mask').attr('readonly',bool);
        return obj;
    }
    $.fn.hasNumericValue = function(){
        if(($(this).val() * 1) > 0)
            return true;
        return false;
    }
    $.hasNumericValue = function(num){
        if((num * 1) > 0)
            return true;
        return false;
    }

    $.fn.isString = function(){
        if((this.val()*0)==0)
            return false;
        return true;
    }
    $.isString = function(val){
        if((val*0)==0)
            return false;
        return true;
    }
})(jQuery)
