<?php
 include_once("framework/connecter.php");
include_once("framework/classes/builder_array_tree.php");
include_once("framework/classes/builder_children_ids.php");
include_once("framework/theme/common/builder_menu.php");
if (!authentication::check_login()) {
    location("index.php");
}
globals::register();
if ($_POST['action'] == 'filter') {
    $menu = new builder_menu();
    $html_menu = $menu->load();
    echo $html_menu;
    exit;
}
?>

<!DOCTYPE html>
<html>
    <head>
        <?php include theme_common_physical_path . 'definesjs.php'; ?>
        <!--<meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=1">-->
        <link rel="icon" type="image/x-icon" href="fav.png">
        <title><?= authentication::_get("settings_project_name") ?></title>
        <link href="<?= theme_common_url_path ?>css/roboto.css?family=Roboto:300,500,700&display=swap" rel="stylesheet">
        <link href="<?= theme_common_url_path ?>css/mdi.min.css<?= $ccache ?>" rel="stylesheet">
        <link href="<?= theme_common_url_path ?>css/adminpanel.css<?= $ccache ?>" rel="stylesheet">
        <link href="<?= theme_common_url_path ?>css/message.css<?= $ccache ?>" rel="stylesheet">
        <link href="<?= theme_common_url_path ?>css/jquery.tipsy.css<?= $ccache ?>" rel="stylesheet">
        <link href="<?= extension_url_path ?>css/popup_box.css<?= $ccache ?>" rel="stylesheet">
        <link href="<?= theme_common_url_path ?>css/notiflix-2.1.2.min.css<?= $ccache ?>" rel="stylesheet">
        <link rel="stylesheet" href="<?= plugins_url_path ?>/combo/dhtmlxcombo.css<?= $ccache ?>" type="text/css" />
        <link rel="stylesheet" href="<?= theme_common_url_path ?>css/controls.css<?= $ccache ?>" type="text/css" />                
        <script src="<?= theme_common_url_path ?>js/jquery.min.js<?= $ccache ?>"></script>
        <script src="<?= theme_common_url_path ?>js/notiflix-2.1.2.min.js<?= $ccache ?>"></script>
        <script src="<?= theme_common_url_path ?>js/message.js?time=<?= $ccache ?>"></script>        
        <script src="<?= theme_common_url_path ?>js/octacheckbox.js<?= $ccache ?>"></script>
        <script src="<?= theme_common_url_path ?>js/jquery.tipsy.js<?= $ccache ?>"></script>
        <script src="<?= theme_common_url_path ?>js/fullscreen.api.js<?= $ccache ?>"></script>
        <script type="text/javascript" src="<?= theme_common_url_path ?>js/jquery.hotkeys.js<?= $ccache ?>"></script>
        <script type="text/javascript" src="<?= plugins_url_path ?>/combo/dhtmlxcombo.js<?= $ccache ?>"></script>
        <script src="<?= theme_common_url_path ?>js/adminpanel.js<?= $ccache ?>"></script>      
        <script type="text/javascript" src="<?= theme_common_url_path ?>js/new_window.js<?= $ccache ?>"></script>
        <style>
            .direction_ltr.section_closed .sidemenu img{max-width:50px;transition: all 0.6s;}
        </style>
    </head>
    <body class="section_closed direction_<?= dir ?>">
        <header>
            <div id="action_icons_div">
                <div class="action_icons popup">
                    <i class="mdi mdi-account"></i>
                    <div class="popuptext" id="info_popover">
                        <span><?= LANG_WELCOME ?>&nbsp;<b><?= authentication::get_user_full_name() ?>!</b></span>
<!--                    <span>Your last login {DD/MM/YYYY mm:hh am/pm}</span>-->
                        <span><a href="<?= framework_url_path ?>components/user_change_pass.php" target='mainframe'><?= LANG_CHANGE_PASSWORD ?></a></span>
                        <span><a href="<?= ap_url_path ?>logout.php"><?= LANG_LOG_OUT ?></a></span>
                    </div>
                </div>
                <div class="action_icons_spacer"></div>
               
                <div class="action_icons"><i class="mdi mdi-bell" data-toggle="tipsy" title="<?= LANG_TIP_NOTIFICATION ?>" trigger="hover focus"></i></div>
                <div class="action_icons_spacer hide_on_mobile"></div>
                <div class="action_icons hide_on_mobile"><i class="mdi mdi-comment-processing" data-toggle="tipsy" title="<?= LANG_TIP_FEEDBACK ?>" trigger="hover focus"></i></div>
                <!--<div class="action_icons_spacer hide_on_mobile"></div>-->
                <!--<div class="action_icons hide_on_mobile"><i class="mdi mdi-information" data-toggle="tipsy" title="Info" trigger="hover focus"></i></div>-->
                <!--<div class="action_icons_spacer hide_on_mobile"></div>-->
                <!--<div class="action_icons hide_on_mobile"><i class="mdi mdi-help-circle" data-toggle="tipsy" title="Help" trigger="hover focus"></i></div>-->
                <div class="action_icons_spacer hide_on_mobile"></div>
                <div class="action_icons"><i class="mdi mdi-refresh" data-toggle="tipsy" title="<?= LANG_TIP_REFRESH ?>" trigger="hover focus"></i></div>
                <div class="action_icons_spacer hide_on_mobile"></div>
                <div class="action_icons hide_on_mobile" id="toggle_fullscreen"><i class="mdi mdi-fullscreen" data-toggle="tipsy" title="<?= LANG_TIP_FULLSCREEN ?>" trigger="hover focus"></i></div>
            </div>
            <div class="menu_icon">
                <span></span>
                <span></span>
                <span></span>
            </div>
        </header>
        <!--<section>-->
        <section>
            <div class="sidemenu">
                <div>
                    <img src="logo.svg" style=" margin-left: 45px; width: 200px;" >
                    
                    <div class="search_div" id="search_div">
                        <i class="mdi mdi-magnify"></i>
                        <input type="text" id="filter_txt" placeholder="<?= LANG_SEARCH ?>"/>
                        <i id="expand" class="mdi mdi-unfold-more-horizontal expand_icon"  data-toggle="tipsy" title="<?= LANG_TIP_EXPAND_MENU ?>"></i>
                        <i id="collapse" class="mdi mdi-unfold-less-horizontal display_none" data-toggle="tipsy" title="<?= LANG_TIP_COLLAPSE_MENU ?>"></i>
                        <i id="menu_reload" class="mdi grid-quicksearch-loading display_none"></i>
                    </div>
                </div>
                <div class="scroll-bar-wrap">
                    <div class="cover-bar"></div>
                    <div class="scroll-box">
                        <div id="inner-content-div">
                            <div id="menu" >
                                <?php
                                $menu = new builder_menu();
                                echo $menu->load();
                                ?>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </section>
        <a style='display:none' href='<?= aaa_url_path ?>app_currency_rate.php' id='dealer_preference' onclick='return $(this).new_window()'></a>
                 <div id="iframe_container">
            <iframe id="mainframe" name="mainframe"  src="<?= ap_url_path . authentication::get_settings('settings_default_link') ?>" width="100%" marginheight="0" height="100%" scrolling="yes"  frameborder="0"  noresize="1"></iframe>
        </div>
    </body>
</html>
