<?php
include_once "framework/classes/recaptcha.class.php";
include_once "framework/connecter.php";
if(authentication::check_login()){
    header("home.php");
}
if ($_POST['action'] == 'authenticate' OR $_POST['action'] == 'reset_password') {
    $json = array();
    $json['type'] = "error";
// your secret key
    $secret = "6LcKWuMUAAAAABsqAtDrgUDRq34AAqPs04Y3Oe2E";
// empty response
    $response = null;
// check secret key
    $reCaptcha = new ReCaptcha($secret);
// if submitted check response
    if ($_POST["recaptcha"]) {
        $response = $reCaptcha->verifyResponse(
                $_SERVER["REMOTE_ADDR"], $_POST["recaptcha"]
        );
    }
    if ($response != null && $response->success) {
        //do login
        if ($_POST['action'] == 'authenticate') {
            $json = authentication::login();
        }
        //do reset password
        if ($_POST['action'] == 'reset_password') {
            //if email exists send new password with email
            if ($_POST["user_email"]) {
                $json = authentication::reset_password();
            } else {
                //if email not exist
                $json['type'] = "error";
                $json['message'] = "Invalid Email Address.";
            }
        }
    } else {
        $json['message'] = "Prove you are not a bot!";
    }
    exit(json_encode($json));
}
?>
<!DOCTYPE html>
<html>
    <head>
        <meta name="viewport" content="width=device-width, initial-scale=1.0,maximum-scale=1">
        <title><?= authentication::_get("settings_project_name") ?></title>
        <link rel="icon" type="image/x-icon" href="fav.png">
        <link href="<?=theme_common_url_path ?>css/roboto.css?family=Roboto:300,500,700&display=swap" rel="stylesheet">
        <link href="<?=theme_common_url_path ?>css/mdi.min.css" rel="stylesheet">
        <link href="<?=theme_common_url_path ?>css/login.css?time" rel="stylesheet"/>
        <script src="<?=theme_common_url_path?>js/jquery.min.js"></script>
        <script src="https://www.google.com/recaptcha/api.js?onload=onloadCallback&render=explicit" async defer></script>
        <script src="<?=theme_common_url_path ?>js/login.js"></script>        
    </head>
    <body style="background: var(--primary-color-5)">
        <header>
            <a href="#" >
                <img  alt="" src="<?=ap_url_path?>logo.svg" style="width: 300px; padding-right: 1px;">
            </a>   
        </header>
        <section>
            <div class="login_window">
                
                <svg class="loading_bg" stroke="var(--primary-color)" width="80px" height="80px" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 44 44"><g fill="none" fill-rule="evenodd" stroke-width="2"><circle cx="22" cy="22" r="1"><animate attributeName="r" begin="0s" dur="1.8s" values="1; 20" calcMode="spline" keyTimes="0; 1" keySplines="0.165, 0.84, 0.44, 1" repeatCount="indefinite"></animate><animate attributeName="stroke-opacity" begin="0s" dur="1.8s" values="1; 0" calcMode="spline" keyTimes="0; 1" keySplines="0.3, 0.61, 0.355, 1" repeatCount="indefinite"></animate></circle><circle cx="22" cy="22" r="1"><animate attributeName="r" begin="-0.9s" dur="1.8s" values="1; 20" calcMode="spline" keyTimes="0; 1" keySplines="0.165, 0.84, 0.44, 1" repeatCount="indefinite"></animate><animate attributeName="stroke-opacity" begin="-0.9s" dur="1.8s" values="1; 0" calcMode="spline" keyTimes="0; 1" keySplines="0.3, 0.61, 0.355, 1" repeatCount="indefinite"></animate></circle></g></svg>
                <div id="notification">
                    <div id="notification_type" class="notification-success">
                        <i class="mdi mdi-check-circle" ></i>
                        <span id="message" ></span>
                        <div style="clear: both"></div>
                    </div>
                </div>
                <div id="loginInfo" >
                    <form method="post" >
                        <div class="spacer" id="spacer1"></div>
                        <div class="spacer"></div>
                        <div class="enter_details text_center">
                            Enter your details below:
                        </div>
                        <div class="spacer"></div>
                        <div class="spacer"></div>
                        <div class="input_div">
                            <i class="mdi mdi-account-outline"></i>
                            <input name="log_user_name" type="text" placeholder="Username" required/>
                        </div>
                        <div class="spacer"></div>
                        <div class="input_div">
                            <i class="mdi mdi-lock"></i>
                            <input name="log_password" type="password" placeholder="Password" required/>
                            <i class="mdi mdi-eye"  id="showPassword"></i>
                        </div>
                        <div class="spacer"></div>
                        <div class="g-recaptcha" id="login_recaptcha" is-verified="no" ></div>
                        <div class="spacer"></div>
                        <button type="submit" name="login">
                            SIGN IN
                        </button>
                        <div class="spacer"></div>
<!--                        <a href="javascript:;" class="forget_pass">
                            Forgot Password
                        </a>-->
                        
                        <div class="spacer"></div>
                    </form>
                </div>
                <div id="forgetPass">
                    <form>
                        <div class="spacer" id="spacer1"></div>
                        <div class="spacer"></div>
                        <div class="enter_details text_center">
                            Forgot Password
                        </div>

                        <div class="spacer"></div>
                        <div class="enter_details text_justify" >
                            Enter the email associated with your account to retrieve the password.
                        </div>
                        <div class="spacer"></div>
                        <div class="input_div">
                            <i class="mdi mdi-email"></i>
                            <input type="email" name="user_email" placeholder="type your email here" required/>
                        </div>
                        <div class="spacer"></div>
                        <div class="g-recaptcha"  id="reset_pass_recaptcha" is-verified="no"></div>
                        <div class="spacer"></div>
                        <button type="button" name="reset_password">
                            Reset Password
                        </button>
                        <div class="spacer"></div>
                        <a href="javascript:;" class="bold back_to_login">
                            Back to Login
                        </a>
                        <div class="spacer"></div>
                        <div class="spacer"></div>
                    </form>
                </div>
            </div>
        </section>
    </body>
</html>
