<?php

include_once "../framework/common.php";

define("db_table_name", "app_currency");

authentication::authenticate();

class app_currency extends basic_form {
    
    public function before_add_modify($type) {
        if($_POST["app_currency_is_disabled"] == 1 and $_POST["app_currency_is_basic"] ==1){
            $this->form->override_message_type("error")
                    ->override_message_text("Cannot Disable Basic Currency");
            return $this->direct("modify_form", $_POST);
        }
        
        parent::before_add_modify($type);
    }

    public function modify() {
        $check = new check_exsitence("app_currency");
        $check
                ->add_or_col("app_currency_code")
                ->add_or_col("app_currency_name")
                ->add_sql_condition(" AND app_currency_id <>'" . $_POST['app_currency_id'] . "'");
        //$check->debug();
        if ($check->check()) {
            $this->form->override_message_type("error")
                    ->override_message_text(message_exist);
            return $this->direct("modify_form", $_POST);
        }

        if ($_POST['app_currency_is_basic'] == 1) {
            $_POST['app_currency_rate'] = 1;
            $_REQUEST['app_currency_rate'] = 1;
            parent::execute_statment($statment = "update app_currency set app_currency_is_basic='0' where app_currency_id <>'" . $_POST['app_currency_id'] . "'", $debug = false);
        }
        parent::modify();
    }

    /**
     * _______________________________________________________________________________________
     */
    public function search_form() {
        $this->grid->set_width(500);
        ;
        $this->grid_exe->show_numbering()
                ->set_modify_id("app_currency.app_currency_id")
                /**
                 * app_currency_is_disabled
                 */
                ->new_obj('app_currency_is_disabled')
                ->set_title(def_app_currency_is_disabled)
                ->set_type('bool')
                ->set_width(200)
                ->add_obj()
                /**
                 * app_currency_is_basic
                 */
                ->new_obj('app_currency_is_basic')
                ->set_title(def_app_currency_is_basic)
                ->set_type('bool')
                ->set_width(200)
                ->add_obj()
                /**
                 * app_currency_name
                 */
                ->new_obj('app_currency_name')
                ->set_title(def_app_currency_name)
                ->set_type('string')
                ->set_width(200)
                ->add_obj()
                /**
                 * app_currency_code
                 */
                ->new_obj('app_currency_code')
                ->set_title(def_app_currency_code)
                ->set_type('string')
                ->set_width(200)
                ->add_obj()
                /**
                 * app_currency_rate
                 */
                ->new_obj('app_currency_rate')
                ->set_title(def_app_currency_rate)
                ->set_type('string')
                ->set_width(200)
                ->add_obj()
                /**
                 * app_currency_precision
                 */
                ->new_obj('app_currency_precision')
                ->set_title(def_app_currency_precision)
                ->set_type('string')
                ->set_width(200)
                ->add_obj()
                /**
                 * app_currency_order
                 */
                ->new_obj('app_currency_order')
                ->set_title(def_app_currency_order)
                ->set_type('string')
                ->set_width(200)
                ->add_obj()
        ;

        return parent::search_form();
    }

    /**
     * _______________________________________________________________________________________
     */
    public function load($var) {


        /**
         * app_currency_is_disabled
         */
        $app_currency_is_disabled = new input_check('app_currency_is_disabled');
        $app_currency_is_disabled->set_value($var['app_currency_is_disabled'])
                ->set_valid();
        $this->table->new_element(def_app_currency_is_disabled, $app_currency_is_disabled->load());

        /**
         * app_currency_is_basic
         */
        $app_currency_is_basic = new input_check('app_currency_is_basic');
        $app_currency_is_basic->set_value($var['app_currency_is_basic'])
                ->set_valid();
        $this->table->new_element(def_app_currency_is_basic, $app_currency_is_basic->load());

        /**
         * app_currency_name
         */
        $app_currency_name = new input_text('app_currency_name');
        $app_currency_name->set_value($var['app_currency_name'])
                ->set_valid();
        $this->table->new_element(def_app_currency_name, $app_currency_name->load());

        /**
         * app_currency_code
         */
        $app_currency_code = new input_text('app_currency_code');
        $app_currency_code->set_value($var['app_currency_code'])
                ->set_valid();
        $this->table->new_element(def_app_currency_code, $app_currency_code->load());

        /**
         * app_currency_rate
         */
        $app_currency_rate = new input_money('app_currency_rate');
        $app_currency_rate->set_value($var['app_currency_rate'])
                ->set_valid();
        $this->table->new_element(def_app_currency_rate, $app_currency_rate->load());

        /**
         * app_currency_precision
         */
        $q = array("1", "2", "3", "4", "5", "6", "7", "8", "9", "10");
//        parr($q);
        $app_currency_precision = new combo("app_currency_precision");
        $app_currency_precision
                ->set_data_source($q, "array")
                ->set_value($var['app_currency_precision'])
//                ->set_valid()
        ;
        $this->table->new_element(def_app_currency_precision, $app_currency_precision->load());

        /**
         * app_currency_order
         */
        $arr = array("1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30");
//        parr($arr);

        $app_currency_order = new combo('app_currency_order');
        $app_currency_order
                ->set_data_source($arr, "array")
                ->set_value($var['app_currency_order'])
                ->set_valid()
        ;
        $this->table->new_element(def_app_currency_order, $app_currency_order->load());

        parent::load();
    }

}

new app_currency();
?>