<?php
$str = __DIR__;
$path = explode("/", $str);
//$path= array_rev($path);
unset($path[count($path) - 1]);
$dirct = (implode("/", $path));
include($dirct . "/framework/common.php");

define("theme_width", "100%");
define("theme_height", "100%");
define("theme_align", "center");

define("db_table_name", "app_product_qty");
define("def_users_not_recharge", "Users Not Rechrge:");
authentication::authenticate();

class app_product_qty extends report_generator {

    public function __construct() {
        parent::set_theme_height("100%")
                ->set_context_menu(false)
                ->set_show_message(true)
                ->set_theme_title(theme_title)
                ->set_search_type('form')
                ->set_report_type()
        ;
        parent::set_btn_export_xls(false);
        parent::set_btn_print(false);

        parent::__construct();
    }

    public function update_quantity() {
        if (!$_POST["qty"]) {
            $type = "error";
            $msg = "Quantity cannot be null";
        } elseif ($_POST["qty"] < 0) {
            $type = "error";
            $msg = "Quantity value should be positive number";
        } else {
            parent::execute_statment("UPDATE `app_product_qty` set app_product_qty_val='{$_POST["qty"]}' where app_product_qty_id = '{$_POST["id"]}'", false);
            $type = "success";
            $msg = MSG_OPERATION_SUCCESS;
        }

        $json["type"] = $type;
        $json["message"] = $msg;

        echo json_encode($json);
        exit;
    }

    /**
     * load_app_service_id
     */
    public function load_app_product_id() {
        $this->app_product_id = new multilist("app_product_id", "app_product_name", "app_product_id");
        $this->app_product_id->set_data_source(" select app_product_name_en, app_product_id "
                . "from app_product "
                . " order by app_product_id");
    }

    public function ajax_app_product_id() {
        $this->app_product_id = new multilist("app_product_id", "app_product_name", "app_product_id");
        $this->app_product_id->set_width(280)
                ->set_data_source(" select app_product_name_en as app_product_name, app_product.app_product_id from app_product "
                        . " where app_category_id ='{$_REQUEST["app_category_id"]}'");
        $json['app_product_id'] = $this->app_product_id->load();

        echo json_encode($json);
    }
    function get_subcategory($index_id, &$all_childs) {

        $result = parent::get_result("select app_category_id from `app_category` where index_id='{$index_id}' and app_category_is_disabled='0'");

        if ($result->num_rows) {
            while ($row = parent::next($result)) {
                $this->get_subcategory($row['app_category_id'], $all_childs);
            }
        }
        else {
            array_push($all_childs, $index_id);
            }
    //    return $all_childs;
    }


    public function load() {

        /*
         * category
         */
        $ajax = new parser_ajax();
        $ajax->set_url(self)
                ->set_data_type("json")
                ->set_type('post')
                ->add_data("action", "ajax_app_product_id")
                ->add_data("app_category_id", "app_category_id.getActualValue()", true);
        $ajax->set_before_send()
                ->set_success("$('#section_div').html(result.app_product_id);")
                ->set_complete("mabvalid.init('section_div');");

        
        $all_childs = array();
        array_push($all_childs, 0);
        $index_id = 0;
        $this->get_subcategory($index_id, $all_childs);
        $cond = " and app_category_id in (" . implode(",", $all_childs) . ")";
        /**
         * app_category_id
         */
        $app_category_id = new combo('app_category_id', 'app_category_name_en', 'app_category_id');
        $app_category_id
                ->set_data_source("select app_category_id,app_category_name_en from app_category "
//                        . " where app_category_id > '3'")
                        . " where app_category_is_disabled = 0 {$cond}")
                ->set_value($var['app_category_id'])
                ->set_onchange("{$ajax->load()}")
                ->set_valid();
        $this->table->set_col_span(2)->new_element(def_app_category_id, $app_category_id->load());

        /*
         * box
         */
        $app_product_id = new multilist("app_product_id", "app_product_name", "app_product_id");
        $app_product_id->set_data_source("select app_product_id,app_product_name_en as app_product_name from app_product")
                ->set_width(280);
        $this->table->new_element(def_app_product_id, "<div id='section_div'>" . $app_product_id->load() . "</div>");

        /*
         * color
         */
        $app_product_color_id = new multilist("app_product_color_id", "app_product_color_title", "app_product_color_id");
        $app_product_color_id->set_data_source("select app_product_color_id,app_product_color_title from app_product_color")
                ->set_width(260);
        $this->table->new_element(def_app_product_color_title, "<div id='section_div'>" . $app_product_color_id->load() . "</div>");
        /*
         * size
         */
        $app_product_size_id = new multilist("app_product_size_id", "app_product_size_title", "app_product_size_id");
        $app_product_size_id->set_data_source("select app_product_size_id,app_product_size_title from app_product_size")
                ->set_width(260);
        $this->table->new_element(def_app_product_size_title, "<div id='section_div'>" . $app_product_size_id->load() . "</div>");

        /*
         * for reload click in generate report
         */
        $this->form->add_script("
                    $(document).ready(function(){                        
                        $('button').click(function(){
                            var act=$(this).val();
                            $('#report_viewer_iframe').attr('curr_action',act);
                        });
                    });
                ");
        return parent::load();
    }

    public function generate_report() {

        $links = array();
        foreach ($_REQUEST as $get_key => $get_val):
            if (in_array($get_key, array("offset"))) {
                array_push($links, $get_key . "=" . $get_val);
            }
        endforeach;
        if ($links) {
            $links_str = "&" . implode("&", $links);
        }

        if ($_POST["app_category_id"]) {
            $condition .= " and app_product.app_category_id in ({$_POST["app_category_id"]})";
            ;
        }
        if ($_POST["app_product_id"]) {
            $condition .= " and app_product_qty.app_product_id in ({$_POST["app_product_id"]})";
        }
        if ($_POST["app_product_color_id"]) {
            $condition .= " and app_product_qty.app_product_color_id in ({$_POST["app_product_color_id"]})";
        }
        if ($_POST["app_product_size_id"]) {
            $condition .= " and app_product_qty.app_product_size_id in ({$_POST["app_product_size_id"]})";
        }
        

        $arr_head = array();
        array_push($arr_head, "Category");
        array_push($arr_head, "Product");
        array_push($arr_head, "Color");
        array_push($arr_head, "Size");
        array_push($arr_head, "Quantity");

        $arr_value = array();
        array_push($arr_value, "app_category_name");
        array_push($arr_value, "app_product_name");
        array_push($arr_value, "app_product_color_title");
        array_push($arr_value, "app_product_size_title");
        array_push($arr_value, "quantity");

        /*
         * 
         */
        $statment = "select *,app_category_name_en as app_category_name,app_product_name_en as app_product_name from app_product_qty"
                . " inner join app_product on app_product.app_product_id = app_product_qty.app_product_id "
                . " inner join app_category on app_category.app_category_id = app_product.app_category_id   "
                . " inner join app_product_color on app_product_color.app_product_color_id = app_product_qty.app_product_color_id "
                . " inner join app_product_size on app_product_size.app_product_size_id = app_product_qty.app_product_size_id "
                . " where 1=1 {$condition} order by app_product_qty.app_product_id,app_product_qty.app_product_color_id ";
        
        $paging = new extended_paging($statment);
        $paging->set_limit(10);
        $paging->set_end(3);
        $pages = $paging->html($links_str);
        $total_record = $paging->get_total_num_rows();
        $ccache = "?time=" . time();
        ?>
        <!DOCTYPE html>
        <!DOCTYPE html>
        <html>
            <head>
                <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
                <link rel="stylesheet" href="<?= ap_url_path ?>root.css" />
                <link rel="stylesheet" href="<?= theme_common_url_path ?>css/roboto.css?family=Roboto:300,500,700&display=swap" />
                <link rel="stylesheet" href="<?= theme_common_url_path ?>css/mdi.min.css"/>
                <link rel='stylesheet' href='<?= theme_common_url_path ?>css/controls.css' type='text/css' />                                                                                                                                                                                                                                                                                         <!--<link rel="stylesheet" href="<?= theme_common_url_path ?>css/message.css"/>-->
                <link rel="stylesheet" href="<?= extension_url_path ?>css/style_ltr.css<?= $ccache ?>" type="text/css" />  
                <link rel="stylesheet" href="<?= extension_url_path ?>css/app_product_qty.css<?= $ccache ?>" type="text/css" />  
                <?php include theme_common_physical_path . 'definesjs.php'; ?>
                
                <script type='text/javascript' src='<?= theme_common_url_path ?>js/jquery.min.js'></script>
                <script type="text/javascript" src="<?= theme_common_url_path ?>js/notiflix-2.1.2.min.js"></script>
                <script type='text/javascript' src='<?= theme_common_url_path ?>js/new_window.js'></script>
                <script type='text/javascript' src='<?= theme_common_url_path ?>js/validate.js'></script>
                <script type='text/javascript' src='<?= theme_common_url_path ?>js/message.js'></script>
                <script type='text/javascript' src='<?= extension_url_path ?>js/app_product_qty.js<?= $ccache ?>'></script>
                <script>
                    var definition = {};
                    definition.no_checked_user = "<?= LANG_GRID_NO_ROWS_SELECTED_ERR ?>";
                </script>
            </head>                      
            <body style='direction: <?= dir ?>' class="direction_<?= dir ?>">
                <?php if ($paging->get_total_num_rows() == 0): ?>
                    <div class="no_result">
                        <?= def_msg_no_result ?>
                    </div>
                    <?php
                    exit;
                endif;
                ?>
                <form action='' method='post'>
                    <div class='thead_mask'>
                        <div class="thead">
                            <table class="report_table" style="table-layout: fixed;">
                                <thead>
                                    <tr>
                                        <?php
                                        $i = 1;

                                        foreach ($arr_head as $column):
                                            if ($i < 3) {
                                                ?>
                                                <th freeze="true"><div class="nowrap_div" style="width:150px;"><?= $column ?></div></th>
                                                <?php
                                            } else {
                                                ?>
                                                <th><div class="nowrap_div" style="width:150px;"><?= $column ?></div></th>    
                                                <?php
                                            }
                                            $i++;
                                        endforeach;
                                        ?>
                                    </tr>
                                </thead> 
                            </table>

                        </div>
                    </div>
                    <div id='report_cntnr_bdy_div'>

                        <table class="report_table" >
                            <?php
                            while ($row = $paging->next()):
                                ?>
                                <tr class="all_rows rows_<?= $row['app_product_qty_id'] ?>" 
                                    org-row-size="true" id="<?= $row['app_product_qty_id'] ?>" oqt="<?= $row["app_product_qty_val"] ?>">
                                        <?php
                                        foreach ($arr_value as $value):
                                            $popup = null;
                                            $width = "width:150px";
                                            if ($i == 2)
                                                $popup = "<i class='mdi mdi-launch'></i>";
                                            if ($value == "quantity") {
                                                $str = "<input type='number' min='0' class='input_qty' value='{$row["app_product_qty_val"]}' style='background-color:#cea581;width:150px;color:white;font-size: 18px;font-weight: bolder;'>";
                                                $row[$value] = $str;
                                                $width = "width:200px";
                                            }
                                            ?>
                                        <td>
                                            <div class="nowrap_div" style="<?= $width ?>"><?= $row[$value] . $popup ?></div>
                                        </td>
                                        <?php
                                    endforeach;
                                    ?>
                                </tr>


                                <?php
                            endwhile;
                            ?>
                        </table>
                        <input type="hidden" name="app_category_id" value="<?= $_REQUEST['app_category_id'] ?>"/>
                        <input type="hidden" name="app_product_id" value="<?= $_REQUEST['app_product_id'] ?>"/>
                        <input type="hidden" name="app_product_color_id" value="<?= $_REQUEST['app_product_color_id'] ?>"/>
                        <input type="hidden" name="app_product_size_id" value="<?= $_REQUEST['app_product_size_id'] ?>"/>
                    </div>

                    <div id='report_cntnr_btns_div' class="cntr">
                        <div style='width:calc(33% - 5px);margin-<?= DIR_ALIGN ?>: 5px;float:<?= DIR_ALIGN ?>'>
                            <div class="ttls_footer_prnt_dvs" style="float: <?= DIR_ALIGN ?>">
                                <div class="ttls_footer_dvs" title="<?= def_app_recharge_ttl_chk ?>" style="text-align:<?= DIR_ALIGN ?> ">
                                    <div><?= LANG_GRID_TOTAL_RECORDS_TITLE . " " . $total_record ?></div>
                                </div>
                            </div>
                        </div>
                        <div style='width: 67%;float: <?= DIR_ALIGN ?>' >

                            <div style="float: <?= DIR_RALIGN ?>;"><?= $pages ?></div>
                            <div class="clr_flt"></div>
                        </div>           
                        <div class="clr_flt"></div>
                    </div>
                </form>        
            </body>
        </html>
        <?php
    }

}

new app_product_qty();
