<?php

include_once "../framework/common.php";
define("db_table_name", "category");

authentication::authenticate();

class category extends basic_form {

    public function after_add_modify($type) {
        /*
         * forign table for each language
         */
        $table = "category";
        $response = form_insert($_POST, $table, $type);
        if ($response == "error") {
            $this->form->override_message_type("error")->override_message_text(MSG_OPERATION_FAILED);
            return $this->direct("add_form", $_POST);
        }

        parent::after_add_modify($type);
    }

    public function search() {
        $this->grid_result
                ->add_join("inner JOIN category_lang on category_lang.category_id = category.category_id")
                ->add_join("left JOIN category_lang as parent_cat on parent_cat.category_id = category.index_id")
        ;

        $this->grid_result->attach_conditions(" and category_lang.lang_id=(select lang_id from lang where lang_code='en')");
        parent::search();
    }

    /**
     * _______________________________________________________________________________________
     */
    public function attach_input_files() {

        $this->init_input_files();
        $input_files = array();

        array_push($input_files, $this->category_image);

        return parent::attach_input_files($input_files);
    }

    /**
     * _______________________________________________________________________________________
     */
    public function search_form() {
        $this->grid->set_width(500);
        ;
        $this->grid_exe->show_numbering()
                ->set_modify_id("category.category_id")
                /**
                 * app_category_is_disabled
                 */
                ->new_obj('category_is_disabled')
                ->set_alias("category.category_is_disabled")
                ->set_title(def_category_is_disabled)
                ->set_type('bool')
                ->set_width(130)
                ->add_obj()
                /*
                 * parent category
                 */
                ->new_obj('parent_category_name')
                ->set_alias("parent_cat.name")
                ->set_title(def_category_index_id)
                ->set_type('string')
                ->set_width(200)
                ->add_obj()

                /**
                 * app_category_name_ar
                 */
                ->new_obj('category_name')
                ->set_alias("category_lang.name")
                ->set_title(def_category_name)
                ->set_type('string')
                ->set_width(200)
                ->add_obj()

        ;

        return parent::search_form();
    }

    /**
     * _______________________________________________________________________________________
     */
    public function load($var) {
        $arr_lang = get_lang();
        $var = get_lang_values($var, "category");

        $commn_tb = new table();
        $commn_tb->set_elements_per_row(1);
        /**
         * app_category_is_disabled
         */
        $category_is_disabled = new input_check('category_is_disabled');
        $category_is_disabled->set_value($var['category_is_disabled'])
                ;
        $commn_tb->new_element(def_category_is_disabled, $category_is_disabled->load());

        /*
         * parent category
         */
        $index_id = new combo("index_id", "name", "category_id");
        $index_id->set_data_source("select category.category_id,category_lang.name from category "
                        . " inner join category_lang on category_lang.category_id = category.category_id "
                        . " where category_is_disabled=0 and category_lang.lang_id=(select lang_id from lang where lang_code='en')"
                )
                ->set_value($var["index_id"])
        ;
        $commn_tb->new_element(def_category_index_id, $index_id->load());
 /*
         * app_category_image
         */
        $this->init_input_files();
        $this->category_image->set_value($var['category_image']);
        $commn_tb->new_element(def_category_image, $this->category_image->load());
        /*
         * language
         */
        foreach ($arr_lang as $id => $lang):
            ${"tb_{$lang}"} = new table();
            ${"tb_{$lang}"}->set_elements_per_row(1);

            ${"name_{$lang}"} = new input_text("name__{$id}");
            ${"name_{$lang}"}->set_value($var["name__{$id}"])
                    ->set_valid();
            ${"tb_{$lang}"}->new_element(def_category_name, ${"name_{$lang}"}->load());
        endforeach;
        /*
         * tabs
         */
        $tbr = new taber();
        $tbr->set_name("taber");
        foreach ($arr_lang as $lang):
            $tbr->add_tab($lang, ${"tb_{$lang}"}->load());
        endforeach;

        parent::add_html($commn_tb->load());
        parent::add_html($tbr->load());
        parent::load();

    }

    public function init_input_files() {
        $this->category_image = new input_file('category_image');
        $this->category_image->set_value($var['category_image'])
                ->set_extensions("jpeg|jpg|png")
                ->set_valid()
                ->set_size(10000)
        ;
    }
}

new category();
?>