<?php
include_once "../framework/common.php";

define("db_table_name", "coupon");
define("message_column", "coupon_name");

authentication::authenticate();

class coupon extends basic_form {

    public function __construct() {

        parent::set_auto_message_column(false)
                ->set_message_column("")
                ->set_called_tab(0);
        parent::__construct();
    }

    public function load_buttons($type) {
//        parr($var);

        if ($type === "add_form"):
            $add_button = new button("action");
            $add_button->set_value(parent::generate_action_token("add"))->set_text(LANG_GENERATE);
            return $add_button->load();
        else:
            $modify_button = new button("action");
            $modify_button->set_value(parent::generate_action_token("modify"))->set_text(LANG_NEW_RECORD);
            return $modify_button->load();
        endif;
    }

    public function modify() {
        unset($_REQUEST);
        $_REQUEST["action"] = "add_form";
        return parent::direct("add_form");
    }

    public function add() {

        $quantity = $_POST["coupon_qty"];
        $name = $_POST["coupon_name"];
        $desc = $_POST["coupon_desc"];
        $gen = $_POST["coupon_gen_date"];
        $expiry = $_POST["coupon_expiry"];
        $discount = $_POST["coupon_discount"];

        parent::begin();
        $is_used = 0;
        $rech_date = NULL;
        $extra_id = NULL;
        $counter = 0;
        for ($i = 0; $i < $quantity; $i++):
            $counter++;
            $code = random_string(9);
            parent::execute_statment("INSERT INTO `coupon` (`coupon_code`, `coupon_name`,`coupon_expiry`,"
                    . " `coupon_gen_date`, `coupon_desc`,`coupon_discount`) VALUES "
                    . "('{$code}','{$name}' ,'{$expiry}', '{$gen}', '{$desc}', {$discount});", false);
        endfor;

        if (parent::$is_rollback) {
            $this->form->override_message_type("error")->override_message_text(MSG_OPERATION_FAILED);
            return parent::direct("add_form");
        }
        parent::commit();
        $this->form->set_message("success", MSG_OPERATION_SUCCESS);
        return parent::direct("add_form");
    }

    public function search() {
        $this->grid_result
                ->add_join('left join app_user on app_user.app_user_id = coupon.user_id');
        parent::search();
    }

    /**
     * _______________________________________________________________________________________
     */
    public function search_form() {
        $this->grid->set_width(500)
//        ->debug()
        ;
        $this->grid_exe->show_numbering()
                ->set_modify_id("coupon_id");

        $this->grid_exe
                /**
                 * coupon_name
                 */
                ->new_obj('coupon_name')
                ->set_title(def_coupon_name)
                ->set_type('string')
                ->set_width(200)
                ->add_obj()
                /**
                 * coupon_code
                 */
                ->new_obj('coupon_code')
                ->set_title(def_coupon_code)
                ->set_type('string')
                ->set_width(200)
                ->add_obj()

                /**
                 * coupon_gen_date
                 */
                ->new_obj('coupon_gen_date')
                ->set_title(def_coupon_gen_date)
                ->set_type('date')
                ->set_width(200)
                ->add_obj()
                /**
                 * coupon_expiry_date
                 */
                ->new_obj('coupon_expiry')
                ->set_title(def_coupon_expiry)
                ->set_type('date')
                ->set_width(200)
                ->add_obj()
                
                /**
                 * coupon_is_used
                 */
                ->new_obj('coupon_is_used')
                ->set_title(def_coupon_is_used)
                ->set_type('bool')
                ->set_width(100)
                ->add_obj()
                /**
                 * coupon_used_date
                 */
                ->new_obj('coupon_used_date')
                ->set_title(def_coupon_used_date)
                ->set_type('datetime')
                ->set_width(150)
                ->add_obj()
                /**
                 * app_user_name
                 */
                ->new_obj('app_user_name')
                ->set_header_alias("concat(if(app_user_first_name is null,'',app_user_first_name),' ',if(app_user_last_name is null,'',app_user_last_name))")
                ->set_title(def_app_user_id)
                ->set_type('string')
                ->set_width(150)
                ->add_obj()
                /**
                 * coupon_discount
                 */
                ->new_obj('coupon_discount')
                ->set_title(def_coupon_discount)
                ->set_type('double')
                ->set_width(100)
                ->add_obj()

                /**
                 * coupon_desc
                 */
                ->new_obj('coupon_desc')
                ->set_title(def_coupon_desc)
                ->set_type('string')
                ->set_width(200)
                ->add_obj()

        ;

        return parent::search_form();
    }

    /**
     * _______________________________________________________________________________________
     */
    public function load($var) {

        if (!$var['coupon_id']) {
            /**
             * coupon_name
             */
            $coupon_name = new input_text('coupon_name');
            $coupon_name
                    ->set_width("350px")
                    ->set_valid();
            $this->table->new_element(def_coupon_name, $coupon_name->load());
            /*
             * coupon_gen_date
             */
            $coupon_gen_date = new calendar("coupon_gen_date");
            $coupon_gen_date
                    ->set_value($var["coupon_gen_date"] ? $var["coupon_gen_date"] : date("Y-m-d"))
                    ->set_width(350)
                    ->set_valid()
            ;
            $this->table->new_element(def_coupon_gen_date, $coupon_gen_date->load());
            /*
             * coupon_expiry
             */
            $expiry = date("Y-m-d", strtotime("+ 1 month"));
            $coupon_expiry = new calendar('coupon_expiry');
            $coupon_expiry->set_value($var['coupon_expiry'] ? $var['coupon_expiry'] : $expiry)
                    ->set_width("350px")
                    ->set_valid();
            $this->table->new_element(def_coupon_expiry, $coupon_expiry->load());
            /**
             * coupon_qty
             */
            $coupon_qty = new input_mask('coupon_qty');
            $coupon_qty
                    ->set_width("350px")
                    ->set_valid();
            $this->table->new_element(def_coupon_quantity, $coupon_qty->load());
            /**
             * coupon_discount
             */
            $coupon_discount = new input_mask('coupon_discount');
            $coupon_discount
                    ->set_width("350px")
                    ->set_valid();
            $this->table->new_element(def_coupon_discount, $coupon_discount->load());
            /*
             * coupon_desc
             */
            $coupon_desc = new textarea("coupon_desc");
            $coupon_desc
                    ->set_width("350px")
            ;
            $this->table->new_element(def_coupon_desc, $coupon_desc->load());
        } else {
            parent::get_result("select * from coupon "
                    . " left join app_user on app_user.app_user_id = coupon.app_user_id"
                    . " where coupon_id={$var['coupon_id']}");
            $row = parent::next();
            ob_start();
            ?>
            <style>
                .td_title{
                    width:150px;
                    background-color:var(--primary-color);
                }
                td{
                    border:0.55px solid var(--primary-color);
                    width:350px;
                    padding:10px;
                }
            </style>
            <table>
                <tr>
                    <td class="td_title">
                        <?= def_coupon_name ?>
                    </td>
                    <td>
                        <?= $row["coupon_name"] ?>
                    </td>
                </tr>
                <tr>
                    <td class="td_title">
                        <?= def_coupon_code ?>
                    </td>
                    <td>
                        <?= $row["coupon_code"] ?>
                    </td>
                </tr>
                <tr>
                    <td class="td_title">
                        <?= def_coupon_gen_date ?>
                    </td>
                    <td>
                        <?= $row["coupon_gen_date"] ?>
                    </td>
                </tr>
                <tr>
                    <td class="td_title">
                        <?= def_coupon_expiry ?>
                    </td>
                    <td>
                        <?= $row["coupon_expiry"] ?>
                    </td>
                </tr>

                <tr>
                    <td class="td_title">
                        <?= def_coupon_is_used ?>
                    </td>
                    <?php
                    $clas = "minus";
                    if ($row["coupon_is_used"] == 1)
                        $clas = "check";
                    ?>
                    <td>
                        <i class="mdi mdi-<?= $clas ?>"></i>
                    </td>
                </tr>
                <tr>
                    <td class="td_title">
                        <?= def_coupon_used_date ?>
                    </td>
                    <td>
                        <?= $row["coupon_used_date"] ?>
                    </td>
                </tr>
                <tr>
                    <td class="td_title">
                        <?= def_app_user_name ?>
                    </td>
                    <td>
                        <?= $row["app_user_first_name"]." ".$row["app_user_last_name"] ?>
                    </td>
                </tr>
            </table>


            <?php
            $html_info = ob_get_contents();
            ob_clean();
            if ($row["coupon_is_used"] == 0 and $row["coupon_is_email"] == 0) {
                parent::add_html($html_info);
                $str_html = "<table><tr><td class='td_title'>" . def_coupon_code . "</td><td>{$row["coupon_code"]}</td></tr>
                <tr><td class='td_title'>" . def_coupon_gen_date . "</td><td>{$row["coupon_gen_date"]}</td></tr>
                <tr><td class='td_title'>" . def_coupon_expiry . "</td><td>{$row["coupon_expiry"]}</td></tr></table>";
                $input_html = new input_hidden("input_html");
                $input_html->set_value($str_html);
                parent::add_html($input_html->load());

                $label = new label("label_email");
                $label->set_html("Sending Email : ");

                $ajax = new parser_ajax();
                $ajax->set_url(self)
                        ->set_data_type("json")
                        ->add_data("action", "get_user_email")
                        ->add_data("app_user_id", "app_user_id.getActualValue()", true)
                        ->set_success("
                        $('#app_user_email').val(result.app_user_email);
                ");

                $app_user_id = new combo("app_user_id", "app_user_name", "app_user_id");
                $app_user_id->set_data_source("select app_user_id,concat(if(app_user_first_name is null,'',app_user_first_name),' ',if(app_user_last_name is null,'',app_user_last_name)) as app_user_name from app_user")
                        ->set_onchange("{$ajax->load()}");

                $app_user_email = new input_text("app_user_email");

                $email_button = new button("action");
                $email_button->set_id('send_email')
                        ->set_value(parent::generate_action_token("send_email"))
                        ->set_text("Send Email")
                ;
                
                parent::add_html("<div style='height:50px'>&nbsp;</div>");
                parent::add_html($label->load() ." <br/><br/>");
                parent::add_html("<label>".def_app_user_id."</label>&nbsp;&nbsp;&nbsp;&nbsp; ".$app_user_id->load()." <br/><br/>");
                parent::add_html("<label>".def_app_user_email."</label>&nbsp;&nbsp;&nbsp;".$app_user_email->load() ." <br/><br/>");
                parent::add_html($email_button->load());
            }
        }



        parent::load();
    }

    public function send_email() {
        if ($_POST["app_user_email"]) {
            
            include '../extension/libraries/phpmailer/class.phpmailer.php';
            $mail = new PHPMailer();
            $mail->CharSet = 'UTF-8';
//                    $mail->IsSMTP();
//                    $mail->SMTPDebug = false;                     // enables SMTP debug information (for testing)
            // 1 = errors and messages
            // 2 = messages only
//                    $mail->SMTPAuth = true;                  // enable SMTP authentication
//                    $mail->SMTPSecure = "ssl";                 // sets the prefix to the servier
//                    $mail->Host = "smtp.gmail.com";
//                    $mail->Port = 465;
//
//                    $mail->Username = "";  // GMAIL username
//                    $mail->Password = '';            // GMAIL password
//                    $mail->SetFrom("marwantaha93@hotmail.com", "MARWAN");

            $mail->AddAddress($_POST["app_user_email"]);
            $mail->WordWrap = 200;
            $mail->Body = $_POST["input_html"];
            $mail->Subject = "Coupon Card";
            $mail->IsHTML(true);

            if (!$mail->Send()) {
                $this->form->override_message_type("error")->override_message_text("Cannot send this email");
                return $this->direct("modify_form", $_POST["coupon_id"]);
            } else {
                parent::execute_statment("update coupon set coupon_is_email='1',coupon_to_email='{$_POST["app_user_email"]}' "
                . " where coupon_id='{$_POST["coupon_id"]}'");
                $this->form->override_message_type("error")->override_message_text("Email send successfully");
                return $this->direct("modify_form", $_POST["coupon_id"]);
            }
        } else {
            $this->form->override_message_type("warning")->override_message_text("No email to send");
            return $this->direct("modify_form", $_POST["coupon_id"]);
        }
    }

    public function get_user_email() {
        if ($_GET["app_user_id"]) {
            $res = parent::get_result("select app_user_email from app_user where app_user_id='{$_GET["app_user_id"]}'");
            $row = parent::next($res);
        }
        echo json_encode($row);
        exit;
    }

}

new coupon();
?>