<?php
include_once "../framework/connecter.php";

define("theme_width", "100%");
define("theme_height", "100%");
define("theme_align", "center");
define("text_align", "left");

authentication::authenticate();

class report_timer extends report_generator {

    public function __construct() {
        parent::set_theme_height("100%")
                ->set_context_menu(false)
                ->set_show_message(true)
                ->set_theme_title(theme_title)
                ->set_search_type('form');
        parent::set_btn_export_xls(false);
        parent::__construct();
    }

    public function ajax_aligner_no() {
        $aligner_no = new multilist("aligner_id", "aligner_no", "aligner_id");
        $aligner_no->set_width(280)
                ->set_data_source(" select aligner_id,concat('" . def_aligner_no . "',' ',aligner_no) as aligner_no from aligner "
                        . " where treatment_id = '{$_REQUEST["treatment_id"]}' order by aligner_id desc ");
        $json['aligner_no'] = $aligner_no->load();

        echo json_encode($json);
    }

    public function load() {
        /**
         * From Date
         */
        $date_from = new calendar('date_from');
        $date_from->set_format("Y-m-d")->set_value(date('Y-m-d'));
        $date_from->set_valid()->set_width(324)
        ;
        $this->table->new_element(def_date_from, $date_from->load());
        /**
         * To Date
         */
        $end_date = date('Y-m-d');
        $date_to = new calendar('date_to');
        $date_to->set_format("Y-m-d")->set_value(date("Y-m-t", strtotime($end_date)));
        $date_to->set_valid()->set_width(324)
        ;
        $this->table->new_element(def_date_to, $date_to->load());
        /*
         * treatmet
         */

        $ajax = new parser_ajax();
        $ajax->set_url(self)
                ->set_data_type("json")
                ->set_type('post')
                ->add_data("action", "ajax_aligner_no")
                ->add_data("treatment_id", "treatment_id.getActualValue()", true);
        $ajax->set_before_send()
                ->set_success("$('#section_div').html(result.aligner_no);")
                ->set_complete("mabvalid.init('section_div');");

        $treatment = new combo("treatment_id", "treatment_casenumber", "treatment_id");
        $treatment->set_data_source("select treatment_id,concat(app_user_first_name,' ',app_user_last_name ,'[',treatment_casenumber,']') "
                . " as treatment_casenumber from treatment "
                . " inner join app_user on app_user.app_user_id = treatment.user_id ")
//                ->set_valid()
                ->set_value($_GET["treatment_id"])
                ->set_onchange($ajax->load())
        ;
        $this->table->new_element(def_treatment_casenumber, $treatment->load());

        /*
         * aligner_no
         */
        $aligner_no = new multilist("aligner_id", "aligner_no", "aligner_id");
        $aligner_no->set_width(280)->set_value($_GET["aligner_id"]);
        if($_GET["treatment_id"]){
                $aligner_no->set_data_source(" select aligner_id,concat('" . def_aligner_no . "',' ',aligner_no) as aligner_no from aligner "
                        . " where treatment_id='{$_GET["treatment_id"]}'");
        }
        
        $this->table->new_element(def_treatment_aligner_no, "<div id='section_div'>{$aligner_no->load()}</div>");
        if ($_GET["aligner_id"])
            $this->form->add_script("
  $(document).ready(function(){                        
                        setTimeout(function(){ $('#generate_html').click();},1);
                    });
                ");
        return parent::load();
    }

    public function generate_report() {

        $is_html = true;
        if ($_POST["action"] == "export_xls") {
            $is_html = false;
        }
        $osql = new sql();
        $date_from = date("Ymd", strtotime($_POST["date_from"]));
        $date_to = date("Ymd", strtotime($_POST["date_to"]));
        $con = " and timer_day_id >= '{$date_from}' and timer_day_id <= '{$date_to}' ";
        if ($_POST["treatment_id"]):
            $con = " and treatment.treatment_id='{$_POST["treatment_id"]}'";
        endif;
        if ($_POST["aligner_id"]):
            $con .= " and aligner.aligner_id in ({$_POST["aligner_id"]})";
        endif;
        /*
         * column table
         */
        $head_arr = array();
        if (!$_POST["treatment_id"])
            array_push($head_arr, def_treatment_casenumber);
        array_push($head_arr, def_aligner_no);
        array_push($head_arr, def_timer_start);
        array_push($head_arr, def_timer_end);
//        array_push($head_arr, def_timer_sum_in);
//        array_push($head_arr, def_timer_sum_out);
        $arr_values = array();
        if (!$_POST["treatment_id"])
            array_push($arr_values, "treatment_casenumber");
        array_push($arr_values, "aligner_no");
        array_push($arr_values, "timer_start");
        array_push($arr_values, "timer_end");
//        array_push($arr_values, "timer_diff_val_in");
//        array_push($arr_values, "timer_diff_val_out");
        /*
         * 
         */
        $res = $osql->get_result("select  timer.timer_id,treatment_casenumber,aligner.aligner_no,timer_start,timer_end,timer_diff_val,aligner.aligner_id "
                . " from timer "
                . " left join timer_diff on timer_diff.timer_id=timer.timer_id "
                . " inner join aligner on aligner.aligner_id=timer.aligner_id "
                . " inner join treatment on treatment.treatment_id=aligner.treatment_id "
                . " where 1=1 {$con} "
                . " order by aligner.treatment_id,aligner.aligner_no,aligner.aligner_id,timer.timer_start desc"
                , false);

        if ($res->num_rows == 0):
            $_POST["no_result"] = 1;
        endif;

        if ($is_html or $_POST["no_result"]) {
            ob_start();
            ?>
            <table class='report_table' border="1">
                <thead>
                    <tr>
                        <th><div>#</div></th>
                        <?php foreach ($head_arr as $key => $hvalue) { ?>
                            <th><div><?= $hvalue ?></div></th>
                        <?php } ?>
                    </tr>
                </thead>
                <?php
                while ($row = $osql->next($res)):
                    ?>
                    <tr>
                        <?php
                        $arr_aligner_id = array();
//        while ($row = parent::next($result)):
                        while ($row = $osql->next($res)):
                            $ro_number++;
                            $row["timer_diff_val"] = $row["timer_diff_val"] ? $row["timer_diff_val"] : 0;
                            
                            if (!in_array($row["aligner_id"], $arr_aligner_id)) {

                                array_push($arr_aligner_id, $row["aligner_id"]);
                                ?>
                            <tr><td align="center" style="background: #EEE" colspan="6">
                                    <strong><?= def_aligner_no . " : " . $row["aligner_no"] ?></strong>
                                </td>
                            </tr>
                        <?php } ?>
                        <tr id="<?= $row['timer_id'] ?>" style="background: var(--scroll-color-2) !important">
                            <td >
                                <div>
                                    <?= $ro_number ?>
                                </div>
                            </td>                                  
                            <?php
                            foreach ($arr_values as $value):
                                ?>
                                <td>
                                    <div ><?= $row[$value] ?></div>
                                </td>
                                <?php
                            endforeach;
                            ?>
                        </tr>


                        <?php
                    endwhile;
                    ?>
                </tr> 
                <?php
            endwhile;
            ?>

            </table>    


            <?php
            $html_day = ob_get_contents();
            ob_clean();
            ?>
            <html>
                <head>
                    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
                    <link rel="stylesheet" href="<?= theme_common_url_path ?>css/roboto.css?family=Roboto:300,500,700&display=swap" />
                    <link rel="stylesheet" href="<?= extension_url_path ?>css/report.css?t=<?=time()?>" />
                </head>
                <body>
                    <?php
                    $arr_header_left = array();
                    if ($_POST["treatment_id"]) {
                        $arr["title"] = def_treatment_casenumber;
                        $arr["value"] = strtoupper($_POST["treatment_id_mask"]);
                        array_push($arr_header_left, $arr);
                    }
                    include_once extension_physical_path . 'lib/report_header_html.php';
                    ?>
                    <br/>
                    <?php
                    if ($is_html)
                        echo $html_day;
                    ?>
                </body>
            </html>

            <?php
        } else {
            

            $top_header = array();
            if ($_POST["app_dealer_id"]) {
                $arr["value"] = def_app_subscriber_dealer_name . "  " . $_POST["app_dealer_id_mask"];
                array_push($top_header, $arr);
            }
            include extension_physical_path . 'lib/report_header_xls.php';
            $clr_rows = 0; //to color rows
            while ($rows = $osql->next($res, false)) {
                $row++;
                $rows['sum_input'] = number_format($rows['sum_input'] / $_POST["units"]) . " " . $_POST["units_mask"];
                $rows['sum_output'] = number_format($rows['sum_output'] / $_POST["units"]) . " " . $_POST["units_mask"];
                $style = $odd_row_style;
                if ($clr_rows % 2 == 0) {
                    $style = $even_row_style;
                }
                foreach ($arr_values as $key => $val):
                    $sheet->getCell(chr(64 + $key) . $row)->setValue($rows[$val]);
                    $sheet->getStyle(chr(64 + $key) . $row)->applyFromArray(array_merge($style, $align_cntr));
                    $sheet->getColumnDimension(chr(64 + $key))->setAutoSize(true);

                endforeach;
                $clr_rows++;
            }
            //excel write
            $file_name = "Dealer-Consumption";
            phpexcel_load($excel, $file_name);
        }
    }
}

new report_timer();
?>
