<?php

include_once "../framework/common.php";
define("db_table_name", "treatment");

authentication::authenticate();

class treatment extends basic_form {


    public function search() {
        $this->grid_result
                ->add_join("inner JOIN app_user on app_user.app_user_id = treatment.user_id")
        ;
                $this->grid_result->set_init_order(' order by treatment_id desc ');
        parent::search();
    }

    /**
     * _______________________________________________________________________________________
     */
    public function search_form() {
        $this->grid->set_width(500);
        ;
        $this->grid_exe->show_numbering()
                ->set_modify_id("treatment.treatment_id")
                /**
                 * treatment_casenumber
                 */
                ->new_obj('treatment_casenumber')
                ->set_title(def_treatment_casenumber)
                ->set_type('string')
                ->set_width(130)
                ->add_obj()
                /**
                 * app_user_name
                 */
                ->new_obj('app_user_first_name')
                ->set_alias('concat(app_user_first_name," ",app_user_last_name)')
                ->set_title(def_treatment_user_id)
                ->set_type('string')
                ->set_width(130)
                ->add_obj()
                /**
                 * treatment_date
                 */
                ->new_obj('treatment_date')
                ->set_title(def_treatment_date)
                ->set_type('date')
                ->set_width(130)
                ->add_obj()
                /*
                 * aligner_no
                 */
                ->new_obj('aligner_no')
                ->set_title(def_treatment_aligner_no)
                ->set_type('int')
                ->set_width(150)
                ->add_obj()

                /**
                 * lower_aligner
                 */
                ->new_obj('lower_aligner')
                ->set_title(def_treatment_lower_aligner)
                ->set_type('int')
                ->set_width(150)
                ->add_obj()
                /**
                 * upper_aligner
                 */
                ->new_obj('upper_aligner')
                ->set_title(def_treatment_upper_aligner)
                ->set_type('int')
                ->set_width(150)
                ->add_obj()

        ;

        return parent::search_form();
    }

    /**
     * _______________________________________________________________________________________
     */
    public function load($var) {
        $tbl1=new table();
        /**
         * app_user_name
         */
        $app_user_id = new combo('app_user_id','app_user_name','app_user_id');
        $app_user_id->set_data_source("select app_user_id,concat(app_user_first_name,app_user_last_name) as app_user_name from app_user")
                ->set_valid()->set_disable()
                ->set_value($var['user_id'])
        ;
        $tbl1->new_element(def_treatment_user_id, $app_user_id->load());
        /**
         * treatment_casenumber
         */
        $treatment_casenumber = new input_text('treatment_casenumber');
        $treatment_casenumber->set_valid()
                ->set_value($var['treatment_casenumber'])
        ;
        $tbl1->new_element(def_treatment_casenumber, $treatment_casenumber->load());
        /**
         * treatment_date
         */
        $treatment_date = new calendar('treatment_date');
        $treatment_date->set_valid()->set_format("Y-m-d H:i:s")
                ->set_value($var['treatment_date'])
        ;
        $tbl1->new_element(def_treatment_date, $treatment_date->load());
        /**
         * treatment_aligner_no
         */
        $treatment_aligner_no = new input_text('aligner_no');
        $treatment_aligner_no->set_valid()
                ->set_value($var['aligner_no'])
        ;
        $tbl1->new_element(def_treatment_aligner_no, $treatment_aligner_no->load());
        /**
         * treatment_upper_aligner
         */
        $treatment_upper_aligner = new input_text('upper_aligner');
        $treatment_upper_aligner->set_valid()
                ->set_value($var['upper_aligner'])
        ;
        $tbl1->new_element(def_treatment_upper_aligner, $treatment_upper_aligner->load());
        /**
         * treatment_lower_aligner
         */
        $treatment_lower_aligner = new input_text('lower_aligner');
        $treatment_lower_aligner->set_valid()
                ->set_value($var['lower_aligner'])
        ;
        $tbl1->new_element(def_treatment_lower_aligner, $treatment_lower_aligner->load());
         
        /*
         * 
         */
        if ($var["treatment_id"]) {
            $img_res= parent::get_result("select aligner_image.aligner_id from aligner_image "
                    . " inner join aligner on aligner.aligner_id=aligner_image.aligner_id "
                    . " where treatment_id='{$var["treatment_id"]}'");
            while($img_row=parent::next($img_res)):
                $arr_img[$img_row["aligner_id"]]=$img_row["aligner_id"];
            endwhile;
            
            
            $result= parent::get_result("select * from aligner "
                            . " where treatment_id='{$var["treatment_id"]}' order by aligner_no asc");
            ob_start();
            ?>
            <style>
                #tbl_addres .td_title,#tbl_addres th{
                    width:150px;
                    background-color:var(--primary-color);
                    color:white;
                }
                #tbl_addres td{
                    border:0.55px solid var(--primary-color);
                    width:350px;
                    padding:10px;
                    background: white;
                }
                #tbl_addres{
                    background: var(--primary-color);
                    width: 56%;
                }
            </style>
            <br>
            <table id="tbl_addres">
                <tr>
                    <th><?= def_aligner_no ?></th>
                    <th><?= def_aligner_date ?></th>
                    <th><?= def_aligner_time_in ?></th>
                    <th><?= def_aligner_time_out ?></th>
                    <th><?= def_aligner_in_progress ?></th>
                    <th><?= def_aligner_is_finish ?></th>
                    <th><?= def_aligner_timer?></th>
                    <th><?= def_aligner_image?></th>
                    
                    
                    
                </tr>
                <?php
                
                while ($row = parent::next($result)):
                    $img_popup = new pop_window('',static_url_path . 'aligner_images.php?action=add_form&aligner_id='.$row["aligner_id"]);
                    $timer_popup = new pop_window('',static_url_path . 'report_timer.php?aligner_id='.$row["aligner_id"]."&treatment_id=".$var["treatment_id"]);
                    $progress_class="minus";
                    if($row["in_progress"] == 1)
                        $progress_class="check";
                    $finish_class="minus";
                    if($row["is_finish"] == 1){
                        $finish_class="check";
                        $progress_class="minus";
                    }
                    ?>
                    <tr>
                        <td>
                            <?= $row["aligner_no"] ?>
                        </td>
                        <td>
                            <?= $row["aligner_date"] ?>
                        </td>
                        <td>
                            <?= $row["time_in"] ?>
                        </td>
                        <td>
                            <?= $row["time_out"] ?>
                        </td>
                        <td>
                            <i class="mdi mdi-<?=$progress_class?>"></i>
                        </td>
                        <td>
                            <i class="mdi mdi-<?=$finish_class?>"></i>
                        </td>
                        <td>
                            <?=$timer_popup->load()?>
                        </td>
                        <td>
                            <?php if($arr_img[$row["aligner_id"]]){ ?>
                            <?=$img_popup->load()?>
                            <?php } ?>
                        </td>
                        
                    </tr>
                    <?php
                endwhile;
                ?>
            </table>
            <?php
            $html_info = ob_get_contents();
            ob_clean();
//            parent::add_html($html_info);
        }
        parent::add_html($tbl1->load());
        if ($html_info)
            parent::add_html($html_info);
       
        parent::load();
    }
}

new treatment();
?>