<?php

// required headers
// required headers
header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json");
header("Access-Control-Allow-Methods: POST");
header("Access-Control-Max-Age: 3600");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");
$json = file_get_contents('php://input');
$obj = json_decode($json, true);
include_once '../ap/framework/connecter.php';
include_once './function.php';
include_once 'mail/send_mail.php';
$osql = new sql();
$user_id = $osql->escape($obj['user_id']);
$token["jwt"] = getBearerToken();
include 'jwt/header.php';
include_once "lang_{$token_lang_code}.php";
if (!$user_id or !$token_user_id or $user_id != $token_user_id) {
    $jsons["type"] = "error";
    $jsons["status"] = 0;
    //$jsons["message"] = def_different_user;
    $jsons["message"] = "token user($token_user_id) not same as user sended ({$user_id})";
    //$jsons["data_request"] = $obj;
//    $osql->execute_statment("insert into test (`date`,`user_id`,`token_user_id`,`data`)"
//            . " values (now(),'{$user_id}','{$token_user_id}','{$json}') ");
    echo json_encode($jsons);
    exit;
}

$lang_id = $token_lang_id;
if (!$token_lang_id) {
    $lang = $obj['lang'] ? $obj['lang'] : "en";
    $res = $osql->get_result("SELECT lang_id FROM lang where lang_code='{$lang}' ");
    $ro = $osql->next($res);
    $lang_id = $ro["lang_id"];
}
$action = $obj['action'];
$product_id = $osql->escape($obj['product_id']);
$color_id = $obj["color_id"];
$size_id = $obj["size_id"];
if ($action == "set_wishlist") {
    if (!$product_id) {
        $response_type = "error";
        $message = def_MSG_OPERATION_FAILED;
        $status = 0;
    } else {
        $osql->begin();
        $res = $osql->get_result("select * from wishlist where product_id='{$product_id}' and user_id='{$user_id}' limit 1");
        if ($res->num_rows == 0)
            $osql->execute_statment("insert into wishlist (`product_id`,`user_id`) values ('{$product_id}','{$user_id}') ");
        if ($osql::$is_rollback) {
            $osql->rollback();
            $response_type = "error";
            $message = def_MSG_OPERATION_FAILED;
            $status = 0;
        } else {
            $osql->commit();
            $response_type = "success";
            $message = def_MSG_OPERATION_SUCCESS;
            $status = 1;
        }
    }
} elseif ($action == "set_cart") {
    $qty = $obj["qty"] ? $obj["qty"] : 1;

    if (!$color_id or !$user_id or !$product_id) {
        $response_type = "error";
        $message = def_data_missing;
        $status = 0;
    } else {
        $osql->begin();
        if ($obj["type"] == "-") {
            $res = $osql->execute_statment("select cart_id,cart_qty from cart where product_id='{$product_id}' and user_id='{$user_id}'");
            $row = $osql->next($res);
            if ($row["cart_qty"] > 1) {
                $statment = "update cart set  cart_qty=(cart_qty-1) where cart_id='{$row["cart_id"]}'";
            } else {
                $statment = "delete from cart where cart_id='{$row["cart_id"]}'";
            }
            $osql->execute_statment($statment);
        } else {
            $size_id = $size_id ? $size_id : 0;
            $osql->execute_statment("insert into cart (`product_id`,`user_id`,`color_id`,`size_id`,`cart_qty`) "
                    . "values ('{$product_id}','{$user_id}','{$color_id}','{$size_id}','{$qty}') "
                    . "  ON DUPLICATE KEY "
                    . " UPDATE `cart_qty` = (cart_qty + 1) ");
        }
        $jsons = cart_list($user_id, $lang_id, $product_id);

        if ($osql::$is_rollback) {
            $osql->rollback();
            $response_type = "error";
            $message = def_MSG_OPERATION_FAILED;
            $status = 0;
        } else {
            $osql->commit();
            $response_type = "success";
            $message = def_MSG_OPERATION_SUCCESS;
            $status = 1;
        }
    }
} elseif ($action == "delete") {
    if (!$user_id or !$product_id or !$obj["type"] or ($obj["type"] == "cart" and (!$size_id or !$color_id))) {
        $response_type = "error";
        $message = def_data_missing;
        $status = 0;
    } else {
        $cond = null;
        if ($obj["type"] == "cart") {
            $cond = " and color_id='{$color_id}' and size_id='{$size_id}'";
        }
        $osql->begin();
        $osql->execute_statment("delete from {$obj["type"]} where `product_id`='{$product_id}' and `user_id`='{$user_id}' {$cond}");
        if ($osql::$is_rollback) {
            $osql->rollback();
            $response_type = "error";
            $message = def_MSG_OPERATION_FAILED;
            $status = 0;
        } else {
            $osql->commit();
            $response_type = "success";
            $message = def_MSG_OPERATION_SUCCESS;
            $status = 1;
        }
    }
} elseif ($action == "set_order") {

    $date = $osql->escape($obj["date"]);
    if (!$obj["date"])
        $date = date("Y-m-d H:i");
    $date = date("Y-m-d H:i", strtotime($date));
    $totals = 0;
    $payment_type = $osql->escape($obj["payment_id"]);
    $address_id = $osql->escape($obj["address_id"]);
    $coupon = $osql->escape($obj["coupon"]);
    $arr_address = $obj["address"];

    $status = 1;
    if (!$user_id) {
        $response_type = "error";
        $message = def_no_customer_sent;
        $status = 0;
    } elseif (!$address_id and (!$arr_address or count($arr_address) == 0)) {
        $response_type = "error";
        $message = def_no_address_for_customer;
        $status = 0;
    } else {
        $result = $osql->get_result("select cart.*,product_discount,product_price,"
                . "product_tax "
                . " from cart "
                . " inner join product on product.product_id = cart.product_id "
                . " where user_id='{$user_id}' "
        );
        if ($result->num_rows == 0) {
            $response_type = "error";
            $message = def_empty_cart;
            $status = 0;
        } else {
            $usradd_res = $osql->get_result("select * from user_address where user_address_id='{$address_id}'"); //check if supplier
            $useradd_row = $osql->next($usradd_res);
            $address_name = $useradd_row["address_name"];
            $locality = $useradd_row["locality"];
            $country = $useradd_row["country"];
            $street_name = $useradd_row["street_name"];
            $street_no = $useradd_row["street_no"];
            $floor = $useradd_row["floor"];
            $flat_no = $useradd_row["flat_no"];
            $extra_detail = $useradd_row["extra_detail"];
            $details = $useradd_row["details"];
            $area = $useradd_row["area"];

            $usr_res = $osql->get_result("select * from app_user where app_user_id='{$user_id}'"); //check if supplier
            $user_row = $osql->next($usr_res);
            $user_email = $user_row["app_user_email"];
            /*
             * get items from cart
             */
            $arr_qty_ids = array();
            $arr_pr_ids = array();
            if ($status == 1) {
                $osql->begin();
                /*
                 * 
                 */
                $stres = $osql->get_result("select order_status_id,order_status_name from order_status where order_status_mask='review'");
                $strow = $osql->next($stres);
                $order_status = $strow["order_status_id"] ? $strow["order_status_id"] : 3;
                $status_name = $strow["order_status_name"];

                $ores = $osql->get_result("SELECT order_no AS order_no FROM orders ORDER BY order_no DESC LIMIT 1");
                $orow = $osql->next($ores);
                $order_no = $orow["order_no"] + 1;
                /*
                 * 
                 */
                $coupon_id = 0;
                $coupon_discount = 0;
                if ($coupon) {
                    $cpres = $osql->get_result("select coupon_id,coupon_discount from coupon where coupon_code='{$coupon}'");
                    $cprow = $osql->next($cpres);
                    $coupon_id = $cprow["coupon_id"] ? $cprow["coupon_id"] : 0;
                    $coupon_discount = $cprow["coupon_discount"] ? $cprow["coupon_discount"] : 0;
                }
                $osql->execute_statment("insert into orders (`order_no`,`user_id`,`order_date`,`user_address_id`,`order_total`,"
                        . "`order_status_id`,`payment_id`,`order_discount`,`coupon_id`) values "
                        . " ('{$order_no}','{$user_id}','{$date}','{$address_id}','{$totals}','3',"
                        . "'{$payment_type}','{$coupon_discount}','{$coupon_id}')");
                $order_id = $osql->get_last_id();

                //order event
                $osql->execute_statment("insert into order_event (`order_event_date`,`order_id`,`order_status_id`,`order_event_title`) "
                        . " values ('{$date}','{$order_id}','{$order_status}','{$status_name}')");

                $qry_insrt = "insert into order_product (`order_id`,`product_id`,`order_product_price`,`order_product_qty`,"
                        . "`order_product_discount`,`color_id`,`size_id`,`order_product_tax`,`order_product_total`)"
                        . " values ";
                $vals = array();
                $order_row["products"] = array();
                $sum_tax = 0;

                while ($row = $osql->next($result)):
                    $product_id = $row["product_id"];
                    $color_id = $row["color_id"] ? $row["color_id"] : 0;
                    $size_id = $row["size_id"];
                    $discount = $row["product_discount"] ? $row["product_discount"] : 0;
                    $qty = $row["cart_qty"];
                    $product_price = $row["product_price"];
                    $qty_price = $product_price * $qty;
                    $tax = $row["product_tax"];

                    $new_price = (1 - $discount / 100) * $qty_price;

                    $tax_amount = ($tax / 100) * $new_price;
                    $sum_tax += $tax_amount;

                    $totals += $new_price;

                    if (!$sizing)
                        $sizing = 'NULL';
                    else
                        $sizing = "'" . $sizing . "'";
                    array_push($vals, "('{$order_id}','{$product_id}','{$product_price}','{$qty}','{$discount}','{$color_id}','{$size_id}',"
                            . "'{$tax}','{$new_price}')");

                    //for email
                    $product_row["product_name"] = $product_detail["product_name"];
                    $product_row["order_product_qty"] = $qty;
                    $product_row["order_product_qty_price"] = $qty * $product_price;
                    $product_row["order_product_price"] = $product_price;
                    $product_row["order_product_discount"] = $discount;
                    $product_row["order_product_tax"] = $tax;
                    array_push($order_row["products"], $product_row);
                endwhile;

                $total_amount = $totals;
                if ($coupon_discount > 0) {
                    $total_amount = (1 - $coupon_discount / 100) * $totals;
                }
                if ($sum_tax > 0) {
                    $total_amount += $sum_tax;
                }
                if (count($vals) > 0) {
                    $osql->execute_statment($qry_insrt . implode(",", $vals));

                    $osql->execute_statment("update orders set order_total='{$totals}',order_add='{$sum_tax}',order_total_amount='{$total_amount}' where order_id='{$order_id}'");
                }
                if ($osql::$is_rollback) {
                    $osql->rollback();
                    $response_type = "error";
                    $message = def_MSG_OPERATION_FAILED;
                    $status = 0;
                } else {
                    if ($coupon_id > 0) {
                        $osql->execute_statment("update coupon set coupon_is_used='1',coupon_used_date='{$date}',user_id='{$user_id}'"
                                . " where coupon_id='{$coupon_id}'");
                    }
                    $osql->execute_statment("delete from cart where user_id='{$user_id}'");
                    $osql->commit();
//                $curr_res = $osql->get_result("select app_currency_code_ltr as app_currencey_code from app_currency where app_currency_is_basic=1");
//                $curr_row = $osql->next($curr_res);
//                $curr_code = $curr_row["app_currencey_code"];
                    $pay_res = $osql->get_result("select method from payment_lang where payment_id='{$payment_type}' and lang_id='{$lang_id}'");
                    $pay_row = $osql->next($pay_res);
                    $payment_method = $pay_row["method"];

                    $order_row["order_date"] = $date;
                    $order_row["order_no"] = $order_no;
                    $order_row["order_total"] = $total_amount;

                    $order_row["user_email"] = $user_email;
                    $order_row["country_name"] = $country;
                    $order_row["locality"] = $locality;
                    $order_row["area"] = $area;
                    $order_row["user_address_name"] = $address_name;
                    $order_row["payment_method"] = $payment_method;
                    $jsons["order_id"] = $order_id;
                    $response_type = "success";
                    $message = def_MSG_OPERATION_SUCCESS;
                    $status = 1;
                    sendMail("order", $user_id, $order_row);
                }
            }
        }
    }
} elseif ($action == "scan_api") {
    $res = $osql->get_result("select * from treatment where user_id='{$user_id}' and date(treatment_date)=date(now()) ");
//    if ($res->num_rows > 0) {
//        $response_type = "error";
//        $message = "Cannot scan more then one treatment in same day";
//        $status = 0;
//    } else {
//$user_id=9;
//    $path = "https://qr.parisaline.com/01/321436353552/17/undefined/10/undefined/21/129565486";
    $path = $obj["link"];
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $path);
    $headers = array(
        "Content-Type: application/json"
    );
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $json);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
//curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0); // On dev server only!
    $result1 = curl_exec($ch);
    curl_close($ch);
    $response = (array) json_decode($result1, true);
    if ($response["error"] == 1) {
        $msg = $response["message"] ? $response["message"] : def_MSG_OPERATION_FAILED;
        $msg = $msg . " ressponse error";
        $response_type = "error";
        $message = $msg;
        $status = 0;
    } else {
        if ($response["message"]) {
            $max_aligner = $response["message"]["UpperAligners"];
            if ($max_aligner < $response["message"]["LowerAligners"])
                $max_aligner = $response["message"]["LowerAligners"];

            $align_day = 10;
            $now_date = date("Y-m-d H:i:s");
            $upper = $response["message"]["UpperAligners"];
            $lower = $response["message"]["LowerAligners"];
            $casenumber = $response["message"]["CaseNumber"];
            $fullname = $response["message"]["fullname"];
            if (!$casenumber) {
                $response_type = "error";
                $message = def_no_treatment_case_number;
                $status = 0;
            } else {
                $res = $osql->get_result("select * from treatment where treatment_casenumber='{$casenumber}'");
                if ($res->num_rows > 0) {
                    $response_type = "error";
                $message = def_treatment_case_number_exist;
                $status = 0;
                } else {
                    $osql->begin();
                    $fname="'$fullname'";
                    if(!$fullname){
                        $fname="NULL";
                    }
                    $osql->execute_statment("insert into treatment (`user_id`,`aligner_no`,`treatment_date`,`aligner_days`,`upper_aligner`,`lower_aligner`,`treatment_casenumber`,`treatment_fullname`) "
                            . " values ('{$user_id}','{$max_aligner}','{$now_date}','{$align_day}','{$upper}','{$lower}','{$casenumber}',{$fname})");
                    $treat_id = $osql->get_last_id();
                    $arr_align = array();
                    $next_aligner_id = 0;
                    for ($i = $max_aligner; $i >= 1; $i--):

                        $time_in = "NULL";
                        $in_progres = 0;
//            if($i == 1){
//                $time_in="'$now_date'";
//                $in_progres=1;
//            }


                        $osql->get_result("insert into aligner (`aligner_date`,`user_id`,`aligner_no`,`treatment_id`,`time_in`,`in_progress`,`next_aligner_id`) "
                                . " values ('{$now_date}','{$user_id}','{$i}','{$treat_id}',{$time_in},'{$in_progres}','{$next_aligner_id}')");
                        $next_aligner_id = $osql->get_last_id();
                    endfor;
                    if (count($arr_align) > 0) {
//            $osql->get_result("insert into aligner (`aligner_date`,`user_id`,`aligner_no`,`treatment_id`,`time_in`,`in_progress`) "
//                    . " values " . implode(",", $arr_align));
//            $aligner_id=$osql->get_last_id();
//            $osql->execute_statment("insert into timer (`timer_start`,`aligner_id`) values ('{$now_date}','{$aligner_id}')");
                    }

                    if ($osql::$is_rollback) {
                        $osql->rollback();
                        $response_type = "error";
                        $message = def_MSG_OPERATION_FAILED;
                        $status = 0;
                    } else {
                        $osql->commit();
                        $response_type = "success";
                        $message = def_MSG_OPERATION_SUCCESS;
                        $status = 1;
                        $jsons["aligners"] = $max_aligner;
                        $jsons["treatment"] = get_treatment_detail($user_id);
                    }
                }
            }
        } else {
            $response_type = "error";
            $message = def_MSG_OPERATION_FAILED;
            $status = 0;
        }
    }
//    }
} elseif ($action == "set_aligner") {
    $osql->begin();
    $day_id = date("Ymd");
    $is_click = $obj["is_click"];
    $treatment_id = get_treatment_id($user_id);

    if (!$treatment_id) {
        $response_type = "error";
        $message = def_no_treatment_found;
        $status = 0;
    } else {
        if ($is_click == 1) {
            $now_date = date("Y-m-d H:i:s");
            $datenow = new DateTime(date("Y-m-d H:i:s"));

            $res = $osql->get_result("select aligner.*,treatment.aligner_days "
                    . " from aligner "
                    . " inner join treatment on treatment.treatment_id = aligner.treatment_id "
                    . " where aligner.user_id='{$user_id}' and aligner.treatment_id='{$treatment_id}' and is_finish=0 "
                    . " order by aligner_no asc");
            while ($row = $osql->next($res)):
                $aligner_id = $row["aligner_id"];
                $time_in = $row["time_in"];
                $is_start = $row["is_start"];
                $is_end = $row["is_end"];
                if ($row["in_progress"] == 0) {

                    if (!$row["time_in"]) {
                        $fld_up = " ,time_in='{$now_date}'";
                        $time_in = $now_date;
                    }
                    break;
                } else {
                    $limit_time = new DateTime(date("Y-m-d H:i", strtotime("{$row["time_in"]} + {$row["aligner_days"]} days")));
                    if ($limit_time <= $datenow) {
                        $close_aligner = $aligner_id;
                    } else {
                        break;
                    }
                }
            endwhile;

            if ($close_aligner) {
                $osql->execute_statment("update aligner set in_progress=0,time_out='{$now_date}' where aligner_id='{$close_aligner}'");
                $osql->execute_statment("update timer set timer_end='{$now_date}' where aligner_id='{$close_aligner}' and timer_end is NULL");
            }
            if ($aligner_id) {
                if ($is_start == 1) {
                    $osql->execute_statment("update timer set timer_end='{$now_date}',timer_last_update='{$now_date}' "
                            . " where aligner_id='{$aligner_id}' and timer_day_id='{$day_id}' and timer_end is null ");
                    $start = 0;
                    $end = 1;
                } else {
                    $osql->execute_statment("insert into timer (`timer_start`,`aligner_id`,`timer_day_id`,timer_last_update) "
                            . " values ('{$now_date}','{$aligner_id}','{$day_id}','{$now_date}')");
                    $start = 1;
                    $end = 0;
                }
                $osql->execute_statment("update aligner set in_progress=1{$fld_up},is_start='{$start}',is_end='{$end}' "
                        . " where aligner_id='{$aligner_id}'");
            }
        } else {
            $res = $osql->get_result("select aligner.* from aligner "
                    . " inner join treatment on treatment.treatment_id = aligner.treatment_id "
                    . " where aligner.user_id='{$user_id}' and aligner.treatment_id='{$treatment_id}' and is_finish=0 "
                    . " order by aligner_no asc");
            $rr = $osql->next($res);
            $aligner_id = $rr["aligner_id"];
            $start = $rr["is_start"];
            $end = $rr["is_end"];
            $osql->execute_statment("update timer set timer_last_update=now() "
                    . "  where aligner_id='{$aligner_id}' and timer_end is null");
        }
        $arr = get_timers($aligner_id, $day_id);
        $time_in = $arr["time_in"];
        $time_out = $arr["time_out"];

        if ($osql::$is_rollback) {
            $osql->rollback();
            $response_type = "error";
            $message = def_MSG_OPERATION_FAILED;
            $status = 0;
        } else {
            $osql->commit();
            $response_type = "success";
            $message = def_MSG_OPERATION_SUCCESS;
            $status = 1;
            $jsons["aligner_id"] = $aligner_id;
            $jsons["is_in"] = false;
            if ($start)
                $jsons["is_in"] = true;
            $jsons["is_out"] = false;
            if ($end)
                $jsons["is_out"] = true;

            $jsons["time_in"] = $time_in;
            $jsons["time_out"] = $time_out;
        }
    }
} elseif ($action == "get_aligners") {
    $date = $osql->escape($obj["date"]);
    $date = date("Ymd", strtotime($date));
    $now_date = date("Ymd");
    $is_insert_date = false;
    if ($date < $now_date) {
        $is_insert_date = true;
        $day_out = 86400;
        if ($date == $now_date) {
            $start = date("Y-m-d 00:00:00");
            $now = date("Y-m-d H:i:s");
            $day_out = strtotime($now) - strtotime($start);
        }
    }
    if (!$date) {
        $response_type = "error";
        $message = def_no_calender_date_send;
        $status = 0;
    } else {
        $treatment_id = get_treatment_id($user_id);
        if (!$treatment_id) {
            $response_type = "error";
            $message = def_no_treatment_found;
            $status = 0;
        } else {
            $osql->begin();
            $statment = "select timer_sum_id,aligner.aligner_id,aligner_no,aligner.time_in,timer_sum_in,timer_sum_out "
                    . " from `timer_sum` "
                    . " inner join aligner on aligner.aligner_id=timer_sum.aligner_id "
                    . " where timer_day_id='{$date}' and treatment_id='{$treatment_id}' order by timer_sum_id desc limit 1 ";
            $res = $osql->get_result($statment);
            if ($res->num_rows == 0 and $is_insert_date) {
                $rr = get_current_aligner($user_id, $treatment_id);
                $aligner_id = $rr["aligner_id"];
                $sum_out = $day_out;
                if ($aligner_id)
                    $osql->execute_statment("insert into timer_sum (`aligner_id`,`timer_day_id`,`timer_sum_in`,`timer_sum_out`) "
                            . " values ('{$aligner_id}','{$date}','0','{$sum_out}')");
            }
            $res = $osql->get_result($statment);
            while ($row = $osql->next($res)):
                if ($is_insert_date) {
                    $aligner_id = $row["aligner_id"];
                    $in = $row["timer_sum_in"];
                    $out = $day_out - $in;
                    if ($out != $row["timer_sum_out"]) {
                        $osql->execute_statment("update timer_sum set timer_sum_out='{$out}' where timer_sum_id='{$row["timer_sum_id"]}'");
                        $row["timer_sum_out"] = $out;
                    }
                }
                $row_n["aligner_no"] = $row["aligner_no"];
                $hr_in = floor($row["timer_sum_in"] / 3600);
                $min_in = floor($row["timer_sum_in"] / 60) % 60;
                $row_n["timer_sum_in_hr"] = $hr_in;
                $row_n["timer_sum_in_min"] = $min_in;
                $hr_out = floor($row["timer_sum_out"] / 3600);
                $min_out = floor($row["timer_sum_out"] / 60) % 60;
                $row_n["timer_sum_out_hr"] = $hr_out;
                $row_n["timer_sum_out_min"] = $min_out;
                $time_in = $row["time_in"];
                $row_n["time_switched_at_in_hr"] = date("H", strtotime($time_in));
                $row_n["time_switched_at_in_min"] = date("i", strtotime($time_in));
                $row_n["aligner_id"] = $row["aligner_id"];
                $jsons = $row_n;
            endwhile;

            if ($osql::$is_rollback) {
                $osql->rollback();
                $response_type = "error";
                $message = def_MSG_OPERATION_FAILED;
                $status = 0;
            } else {
                $osql->commit();
                $response_type = "success";
                $message = def_MSG_OPERATION_SUCCESS;
                $status = 1;
//                $jsons["aligner"] = $arr;
            }
        }
    }
} elseif ($action == "set_aligner_image") {
    $files = $obj["image"];
    $rows = get_current_aligner($user_id);
    $aligner_id = $rows["aligner_id"];
    $date = date("Y-m-d H:i:s");
    if (!$files) {
        $response_type = "error";
        $message = def_no_image_send;
        $status = 0;
    } else {
        $rand = rand(10000, 99999);
        $image_parts = explode(";base64,", $files);
//            $resp_size = check_size($image_parts[1]);
//            if ($resp_size["type"] == "error") {
//                echo json_encode($resp_size);
//                exit;
//            }
        $image_type_aux = explode("image/", $image_parts[0]);
        if (count($image_type_aux) != 2)
            $image_type_aux = explode("application/", $image_parts[0]);

        $image_extension = $image_type_aux[1];
        $res_check = check_extension($image_extension);
        if ($res_check["type"] == "error") {
            echo json_encode($res_check);
            exit;
        }
        $new_file_dir = upload_physical_path . "aligner_image";
        if (!is_dir($new_file_dir)) {
            mkdir($new_file_dir, 0777);
        }
        $current = date("Y-m");
        $new_file_dir = $new_file_dir . "/" . $current;
        if (!is_dir($new_file_dir)) {
            mkdir($new_file_dir, 0777);
        }
        $image_base64 = base64_decode($image_parts[1]);
        $file_name_new = "image_" . date("Ymd") . "_{$user_id}_{$rand}.{$image_extension}";
        $file = "$new_file_dir/$file_name_new";

        file_put_contents($file, $image_base64);
        $aligner_image = "aligner_image/{$current}/{$file_name_new}";

        $url_file = "'{$aligner_image}'";
        $osql->begin();
        $osql->execute_statment("insert into aligner_image (`aligner_image_date`,`aligner_id`,`aligner_image_src`) "
                . " values ('{$date}','{$aligner_id}',{$url_file})");
        if ($osql::$is_rollback) {
            $osql->rollback();
            $response_type = "error";
            $message = def_MSG_OPERATION_FAILED;
            $status = 0;
        } else {
            $osql->commit();
            $response_type = "success";
            $message = def_MSG_OPERATION_SUCCESS;
            $status = 1;
            $arr_align = get_images($user_id);
            $jsons["data"]["aligner_images"] = $arr_align;
        }
    }
} elseif ($action == "get_aligner_images") {
    $aligner_image_id = $osql->escape($obj["aligner_image_id"]);
    if ($aligner_image_id) {
        $condition = " and aligner_image_id='{$aligner_image_id}' ";
    }
    $osql->begin();
    $arr_align = get_images($user_id, $condition);
    if ($osql::$is_rollback) {
        $osql->rollback();
        $response_type = "error";
        $message = def_MSG_OPERATION_FAILED;
        $status = 0;
    } else {
        $osql->commit();
        $response_type = "success";
        $message = def_MSG_OPERATION_SUCCESS;
        $status = 1;
        $jsons["data"]["aligner_images"] = $arr_align;
    }
} elseif ($action == "delete_aligner_image") {
    $aligner_img_id = $osql->escape($obj["aligner_image_id"]);
    if (!$aligner_img_id) {
        $response_type = "error";
        $message = def_no_image_send;
        $status = 0;
    } else {
        $osql->begin();
        $arr_align = array();
        $osql->execute_statment("delete from aligner_image where aligner_image_id='{$aligner_img_id}'");
        if ($osql::$is_rollback) {
            $osql->rollback();
            $response_type = "error";
            $message = def_MSG_OPERATION_FAILED;
            $status = 0;
        } else {
            $osql->commit();
            $response_type = "success";
            $message = def_MSG_OPERATION_SUCCESS;
            $status = 1;
            $arr_align = get_images($user_id, $condition);
            $jsons["data"]["aligner_images"] = $arr_align;
        }
    }
} elseif ($action == "contactus") {
    if (!$obj["firstname"] or !$obj["lastname"] or !$obj["email"] or !$obj["mobile"]) {
        $response_type = "error";
        $message = def_missing_requires_data;
        $status = 0;
    } else {
        if (!filter_var($obj["email"], FILTER_VALIDATE_EMAIL)) {
            $response_type = "error";
            $status = 0;
            $message = def_invalid_email_format;
        } else {
            include_once 'file.php';
            $osql->begin();
            $firstname = $osql->escape($obj["firstname"]);
            $lastname = $osql->escape($obj["lastname"]);
            $email = $osql->escape($obj["email"]);
            $mobile = $osql->escape($obj["mobile"]);
            $msg = "'{$osql->escape($obj["message"])}'";
            if (!$obj["message"]) {
                $msg = "NULL";
            }
            $images = $obj["images"];
            $arr_names = array();
            $store = new FileStore('contactus');
            $store->groupBy(date('Y-m'));
            foreach ($images as $file):
                $file_name = $store->uploadDataURL($file);
                $file_name = $store->getLocalUploadPath($file_name);
                array_push($arr_names, $file_name);
            endforeach;
            $imgs = 'NULL';
            if (count($arr_names) > 0) {
                $imgs = "'" . implode(",", $arr_names) . "'";
                foreach($arr_names as $key=>$path):
                    $i=$key+1;
                    $arr_val["attachment_{$i}"]=$path;
                endforeach;
            }
            $date = date("Y-m-d H:i:s");
            $osql->execute_statment("insert into contactus (`date`,`firstname`,`lastname`,`email`,`mobile`,`message`,`images`) values "
                    . " ('{$date}','{$firstname}','{$lastname}','{$email}','{$mobile}',{$msg},{$imgs})");

            if ($osql::$is_rollback) {
                $osql->rollback();
                $response_type = "error";
                $message = def_MSG_OPERATION_FAILED;
                $status = 0;
            } else {
                $osql->commit();
                 $source=$token_device_os;
                $arr_val["source"]=$source;
                $arr_val["firstname"]=$firstname;
                $arr_val["lastname"]=$lastname;
                $arr_val["email"]=$email;
                $arr_val["phone"]=$mobile;
                $arr_val["message"]=$obj["message"];
                $arr_val["form_name"] = "Contact Us Patient App Form";
                crmapi($arr_val);
                $response_type = "success";
                $message = def_MSG_OPERATION_SUCCESS;
                $status = 1;
            }
        }
    }
}

function get_current_aligner($user_id, $treatment_id = null) {
    global $osql;
    if (!$treatment_id)
        $treatment_id = get_treatment_id($user_id);
    $res = $osql->get_result("select aligner_id from aligner "
            . " where treatment_id='{$treatment_id}' and in_progress='1'");
    $row = $osql->next($res);
    return $row;
}

function get_timers($aligner_id, $day_id) {
    global $osql;
    $res = $osql->get_result("select sum(timer_diff_val) as ttl_diff from timer_diff "
            . " inner join timer on timer.timer_id = timer_diff.timer_id "
            . " where aligner_id='{$aligner_id}' and timer_day_id='{$day_id}'");
    $row = $osql->next($res);
    $sum_in = $row["ttl_diff"] ? $row["ttl_diff"] : 0;
    $start = date("Y-m-d 00:00:00");
    $now = date("Y-m-d H:i:s");
    $sec = strtotime($now) - strtotime($start);
//    parr($start);
//    parr($now);
//    parr("sum in ".$sum_in);
//    exit;
    if ($sum_in > $sec)
        $sum_in = $sec;
    $sum_out = $sec - $sum_in;

    $rest = $osql->get_result("select * from timer_sum where aligner_id='{$aligner_id}' and timer_day_id='{$day_id}'");
    if (!$rest->num_rows) {
        $osql->execute_statment("insert into timer_sum (`aligner_id`,`timer_day_id`,`timer_sum_in`,`timer_sum_out`) "
                . " values ('{$aligner_id}','{$day_id}','{$sum_in}','{$sum_out}')");
    } else {
        $osql->execute_statment("update timer_sum set timer_sum_in='{$sum_in}',timer_sum_out='{$sum_out}' "
                . " where aligner_id='{$aligner_id}' and timer_day_id='{$day_id}'");
    }
    $hr_in = floor($sum_in / 3600);
    $min_in = floor($sum_in / 60) % 60;

    $in = date("Y-m-d {$hr_in}:$min_in");
    $arr["time_in"] = date("Y-m-d H:i:s", strtotime($in));
    $hr_out = floor($sum_out / 3600);
    $min_out = floor($sum_out / 60) % 60;

    $out = date("Y-m-d {$hr_out}:$min_out");
    $arr["time_out"] = date("Y-m-d H:i:s", strtotime($out));
    return $arr;
}

$jsons["type"] = $response_type;
$jsons["status"] = $status;
$jsons["message"] = $message;

header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: POST");
header("Access-Control-Max-Age: 3600");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");
echo json_encode($jsons);
