<?php

include('../apple_login_config.php');
include('php-jwt-main/src/JWT.php');
include('php-jwt-main/src/Key.php');
include('php-jwt-main/src/JWK.php');
include('php-jwt-main/src/ExpiredException.php');
include('php-jwt-main/src/SignatureInvalidException.php');
include('php-jwt-main/src/CachedKeySet.php');
include('php-jwt-main/src/BeforeValidException.php');

use Firebase\JWT\JWT;
use Firebase\JWT\Key;

$payload = [
    "iss" => $teamid,
    "iat" => time(),
    "exp" => time() + 86400,
    "aud" => "https://appleid.apple.com",
    "sub" => $identifier
];

/**
 * IMPORTANT:
 * You must specify supported algorithms for your application. See
 * https://tools.ietf.org/html/draft-ietf-jose-json-web-algorithms-40
 * for a list of spec-compliant algorithms.
 */
$jwt = JWT::encode($payload, $key, 'ES256', $kid);

$code = $_POST['code'];
if ($code) {

    if ($_SESSION['state'] != $_POST['state']) {
        $json["type"] = "error";
        $json["message"] = "Authorization server returned an invalid state parameter";
        echo json_encode($json);
        exit;
    }

    // Token endpoint docs: 
    // https://developer.apple.com/documentation/signinwithapplerestapi/generate_and_validate_tokens
    $arr = [
        'grant_type' => 'authorization_code',
        'code' => $code,
        'redirect_uri' => $redirect_uri,
        'client_id' => $identifier,
        'client_secret' => $jwt,
    ];

    $response = http('https://appleid.apple.com/auth/token', $arr);

    if (!$response->access_token) {
        $is_error = 1;
        $message = "";
        $json["type"] = "error";
        $json["message"] = "Error getting an access token:";
        echo json_encode($json);
        exit;
    }


    $data = json_decode($_POST["user"]);
    $email = $data["email"];
    $first_name = $data["first_name"];
    $last_name = $data["last_name"];

    include '../../../ap/popup.php';
    include '../../../ap/framework/classes/sql.php';
    include '../../../ap/framework/classes/logger.php';

    $osql = new sql();
    $res = $osql->get_result("select * from app_user where app_user_email='{$email}' and app_user_is_social=1");
    if ($res->num_rows == 0) {
        $osql->execute_statment("insert into app_user (`app_user_first_name`,`app_user_last_name`,`app_user_email`,`app_user_is_social`) values "
                . " ('{$first_name}','{$last_name}','{$email}','1')");
        $row["app_user_id"] = $osql->get_last_id();
        $row["app_user_first_name"] = $first_name;
        $row["app_user_last_name"] = $last_name;
        $row["app_user_email"] = $email;
    } else {
        $row = $osql->next($res);
    }
    $json["data"] = $row;
    $json["type"] = "success";

    echo json_encode($json);
    exit;
} else {
    $json["type"] = "error";
    $json["message"] = $_POST["error"];
    echo json_encode($json);
    exit;
}
?>