<?php

function cart_list($user_id, $lang_id) {
    $arr_cart = array();
    $con = null;

    $osql = new sql();
    $res = $osql->get_result("SELECT product.product_id,product_price,cart.color_id,cart.size_id,product_lang.name as product_name,"
            . "product_price,product_discount,product_tax,"
            . "product_lang.description as product_description,product_lang.subtitle as product_subtitle,cart_qty,"
            . "product_attachment_1,product_attachment_2,product_attachment_3,product_attachment_4,product_attachment_5,product_attachment_6 "
            . "FROM product "
            . " inner join product_lang on product_lang.product_id=product.product_id "
            . " inner join cart on cart.product_id = product.product_id "
            . " where cart.user_id = '{$user_id}' and product_lang.lang_id='{$lang_id}'", false);
    while ($row = $osql->next($res)):
        if ($row["product_attachment_1"])
            $row["product_attachment_1"] = upload_url_path . $row["product_attachment_1"];
        if ($row["product_attachment_2"])
            $row["product_attachment_2"] = upload_url_path . $row["product_attachment_2"];
        if ($row["product_attachment_3"])
            $row["product_attachment_3"] = upload_url_path . $row["product_attachment_3"];
        if ($row["product_attachment_4"])
            $row["product_attachment_4"] = upload_url_path . $row["product_attachment_4"];
        if ($row["product_attachment_5"])
            $row["product_attachment_5"] = upload_url_path . $row["product_attachment_5"];
        if ($row["product_attachment_6"])
            $row["product_attachment_6"] = upload_url_path . $row["product_attachment_6"];

        $row["product_discount"] = $row["product_discount"] ? $row["product_discount"] : 0;
        $price = $row["product_price"] * $row["cart_qty"];
        $row["product_price"] = (1 - $row["product_discount"] / 100) * $price;
        $row["product_price"] = $price;
        //
        $totals += $price;
        //
        $tax_val = ($row["product_tax"] / 100) * $price;
        $row["tax_val"] = $tax_val;
        $sum_tax += $tax_val;
        array_push($arr_cart, $row);
    endwhile;
    $fees = 0;
    $arr["product"] = $arr_cart;
    $arr["sum_tax"] = round($sum_tax, 4);
    $arr["sub_total"] = $totals;
    $discount_value = 0;
//        $discount_value = ($coupon_discount / 100) * $totals;
    $arr["discount_value"] = $discount_value;
    $arr["fees"] = $fees;
    $arr["total"] = $totals - $discount_value + $sum_tax + $fees;
    return $arr;
}

function check_extension($ext) {
    $response = array();
    if ($ext != "png" and $ext != "jpg" and $ext != "pdf" and $ext != "svg" and $ext != "jpeg") {
        $message = def_invalid_extension;
        $response["type"] = "error";
        $response["status"] = 0;
        $response["message"] = $message;
    }
    return $response;
}

function get_images($user_id, $condition = null) {
    $osql = new sql();
    $arr_align = array();
    $res = $osql->get_result("select aligner_image.*,aligner_no from aligner_image"
            . " inner join aligner on aligner.aligner_id= aligner_image.aligner_id "
            . " where aligner.user_id='{$user_id}' {$condition}");
    while ($row = $osql->next($res)):
        if ($row["aligner_image_src"]) {
            $row["aligner_image_src"] = upload_url_path . $row["aligner_image_src"];
        }
        array_push($arr_align, $row);
    endwhile;
    return $arr_align;
}

function get_treatment_detail($user_id) {
    $osql = new sql();
    $osql->begin();
    $res = $osql->get_result("select * from treatment "
            . " where user_id='{$user_id}' order by treatment_date desc limit 1");
    $row = $osql->next($res);
    $treatment_id = $row["treatment_id"];
    $treat_date= $row["treatment_date"];
    $upper = $row["upper_aligner"] ? $row["upper_aligner"] : 0;
    $lower = $row["lower_aligner"] ? $row["lower_aligner"] : 0;
    $case_number=$row["treatment_casenumber"];
    //
    $ress = $osql->get_result("select time_in from aligner "
            . " where treatment_id='{$treatment_id}' and aligner_no='1'");
    $roww = $osql->next($ress);
    $start_time = $roww["time_in"] ? date("Y-m-d", strtotime($roww["time_in"])) : date("Y-m-d", strtotime($treat_date));
    //
    $res1 = $osql->get_result("select aligner_no from aligner "
            . " where treatment_id='{$treatment_id}' and in_progress='1'");
    $row1 = $osql->next($res1);
    $upper_progress = $row1["aligner_no"] ? $row1["aligner_no"] : 0;
    $lower_progress = $row1["aligner_no"] ? $row1["aligner_no"] : 0;
    if ($upper < $upper_progress)
        $upper_progress = $upper;

    if ($lower < $lower_progress)
        $lower_progress = $lower;

    $arr["upper_aligner"] = $upper;
    $arr["upper_progress_no"] = $upper_progress;
    $arr["lower_aligner"] = $lower;
    $arr["lower_progress_no"] = $lower_progress;
    $arr["start_date"] = $start_time;
    $arr["case_number"] = $case_number;
    return $arr;
}

function get_treatment_id($user_id) {
    $osql = new sql();
    $res = $osql->get_result("select treatment.treatment_id from treatment "
            . " where user_id='{$user_id}'  order by treatment_date desc limit 1");
    $row = $osql->next($res);
    return $row["treatment_id"];
}

function get_statistics($user_id) {
    $osql = new sql();
    $treatment_id = get_treatment_id($user_id);
    $day7 = date("Ymd", strtotime("- 7 day"));
    $day30 = date("Ymd", strtotime("- 30 day"));
    $day90 = date("Ymd", strtotime("- 90 day"));
    $res = $osql->get_result("select aligner.aligner_id,aligner_no from aligner "
            . " where aligner.treatment_id='{$treatment_id}'");
    while ($rows = $osql->next($res)):
        $arr_sum[$rows["aligner_id"]] = 0;
        $arr_aligner_id[$rows["aligner_id"]] = $rows["aligner_no"];
    endwhile;

    /*
     * summation of time in 7,30,90 
     */
    $cond = " and aligner_id in (" . implode(",", array_keys($arr_aligner_id)) . ")";
    if (count($arr_aligner_id) > 0) {
        $res1 = $osql->get_result("select sum(timer_sum_in) as ttl_in from timer_sum where timer_day_id > '{$day7}' {$cond}");
        $row1 = $osql->next($res1);
        $res2 = $osql->get_result("select sum(timer_sum_in) as ttl_in from timer_sum where timer_day_id > '{$day30}' {$cond}");
        $row2 = $osql->next($res2);
        $res3 = $osql->get_result("select sum(timer_sum_in) as ttl_in from timer_sum where timer_day_id > '{$day90}' {$cond}");
        $row3 = $osql->next($res3);
        $result = $osql->get_result("select * from timer_sum "
                . " where 1=1 {$cond} ");
        while ($row = $osql->next($result)):
            $arr_sum[$row["aligner_id"]] += $row["timer_sum_in"];
        endwhile;
    }
    $ttl_in_7 = $row1["ttl_in"] ? $row1["ttl_in"] : 0;
    $ttl_in_30 = $row2["ttl_in"] ? $row2["ttl_in"] : 0;
    $ttl_in_90 = $row3["ttl_in"] ? $row3["ttl_in"] : 0;

    $hr_in_7 = (floor($ttl_in_7 / 3600)) / (7 * 24);
//    $min_in_7 = (floor($ttl_in_7 / 60) % 60) /7;
    $hr_in_30 = (floor($ttl_in_30 / 3600)) / (30 * 24);
//    $min_in_30 = (floor($ttl_in_30 / 60) % 60) /30;
    $hr_in_90 = (floor($ttl_in_90 / 3600)) / (90 * 24);
//    $min_in_90 = (floor($ttl_in_90 / 60) % 60) /90;

    $arr["average_7_day_wearing_in_hr"] = no_format($hr_in_7*24);
//    $jsons["average_7_day_wearing_in_min"] = $min_in_7;
    $arr["average_30_day_wearing_in_hr"] = no_format($hr_in_30*24);
//    $jsons["average_30_day_wearing_in_min"] = $min_in_30;
    $arr["average_90_day_wearing_in_hr"] = no_format($hr_in_90*24);
//    $jsons["average_90_day_wearing_in_min"] = $min_in_90;
    /*
     * 
     */
//    $arr_aligner_sum=array();
    foreach ($arr_sum as $id => $secs):
        $hr = sprintf("%02d", floor($secs / 3600));
        $min = sprintf("%02d", floor($secs / 60) % 60);
        $no = $arr_aligner_id[$id];
        $arr_aligner_sum[$no] = $hr . ":" . $min;
    endforeach;
    $arr["total_wear_aligner_in_hr"] = $arr_aligner_sum;
    return $arr;
}

function get_payment($lang_code) {
    $osql = new sql();
    //payment
    $res = $osql->get_result("select payment.payment_id,method "
            . " from payment "
            . " inner join payment_lang on payment_lang.payment_id=payment.payment_id "
            . " where payment_lang.lang_id=(select lang_id from lang where lang_code='{$lang_code}')");
    $arr_payments = array();
    while ($row = $osql->next($res)):
        array_push($arr_payments, $row);
    endwhile;
    return $arr_payments;
}

function get_language() {
    $osql = new sql();
    //lang
    $lang_res = $osql->get_result("select lang_id,lang_name,lang_code "
            . " from lang "
            . " where lang_is_disable='0'");
    $arr_lang = array();
    while ($lang_row = $osql->next($lang_res)):
        array_push($arr_lang, $lang_row);
    endwhile;
    return $arr_lang;
}
function crmapi($arr_data)
{
    $arr["fullname"] = $arr_data["fullname"];
    $arr["phone"] = $arr_data["phone"];
    $arr["email"] = $arr_data["email"];
    $arr["message"] = $arr_data["message"];
    $arr["status"] = "";
    $arr["source"] = $arr_data["source"]; //parisaline.com | Android Patient App | iOS Patient App
    $arr["firstname"] = $arr_data["firstname"];
    $arr["lastname"] = $arr_data["lastname"];
    $arr["age"] = $arr_data["age"];
    $arr["country"] = $arr_data["country"];
    $arr["city"] = $arr_data["city"];
    $arr["subject"] = $arr_data["subject"];
    $arr["specialty"] = "";
    $arr["form_name"] = $arr_data["form_name"]; // Contact Us Website Form | Appointment WebsiteForm | Eligible Website Form | Catalog Website Form | PP Personal Meeting Website Form | Contact Us Patient App Form
    $arr["utm_source"] = "";
    $arr["utm_campaign"] = "";
    $arr["utm_medium"] = "";
    $arr["utm_term"] = "";
    $arr["utm_content"] = "";
    $arr["describe_malocclusion"] = $arr_data["describe_malocclusion"];
    $arr["describe_spacing"] = $arr_data["describe_spacing"];
    $arr["bothers_about_teeth"] = $arr_data["bothers_about_teeth"];
    $arr["worn_braces_before"] = $arr_data["worn_braces_before"];
    $arr["wearing_permanent_retainer"] = $arr_data["wearing_permanent_retainer"];
    $arr["last_visit_to_dentist"] = $arr_data["last_visit_to_dentist"];
    $arr["preferred_method_to_contact"] = $arr_data["preferred_method_to_contact"];
    $arr["best_time_to_contact"] = $arr_data["best_time_to_contact"];
    $arr["best_date_to_contact"] = $arr_data["best_date_to_contact"];
    $arr["how_did_you_hear_about_us"] = $arr_data["how_did_you_hear_about_us"];
    $arr["offer_clear_aligner"] = $arr_data["offer_clear_aligner"];
    $arr["have_intra_oral_scanner"] = $arr_data["have_intra_oral_scanner"];
    $arr["opt_in_email"] = "";
    $arr["attachment_1"] = $arr_data["attachment_1"];
    $arr["attachment_2"] = $arr_data["attachment_2"];
    $arr["attachment_3"] = $arr_data["attachment_3"];
    $arr["attachment_4"] = $arr_data["attachment_4"];
    $arr["attachment_5"] = $arr_data["attachment_5"];
    $arr["attachment_6"] = $arr_data["attachment_6"];
    $arr["attachment_7"] = $arr_data["attachment_7"];
    $arr["attachment_8"] = $arr_data["attachment_8"];
    $arr["attachment_9"] = $arr_data["attachment_9"];
    $arr["attachment_10"] = $arr_data["attachment_10"];
    $path = "https://crmapi.paline.me/v1/b2c/patients";
    $path2 = "https://crmapi.paline.me/v1/b2b/doctors";
    $res1 = curl_send($path,json_encode($arr));
    $res2 = curl_send($path2,json_encode($arr));
    
    
}
function curl_send($path,$json)
{
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $path);
    $headers = array(
        "Content-Type: application/json",
        "Authorization: Bearer 1003.c059758048a4d6909a95a78c580b20a7.c249d0c1b8f1608255df0fc04d47b494",
    );
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $json);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    $result1 = curl_exec($ch);
    curl_close($ch);
    $response = (array) json_decode($result1, true);
    return $response;
}

