<?php

// required headers

include_once '../ap/framework/connecter.php';
include_once './function.php';
//use \Firebase\JWT\JWT;
$json = file_get_contents('php://input');
// decoding the received JSON and store into $obj variable.
$obj = json_decode($json, true);
$osql = new sql();

$action = $obj['action'];
$user_id = $osql->escape($obj['user_id']);
$product_id = $osql->escape($obj['product_id']);
$lang = $obj["lang_code"] ? $osql->escape($obj["lang_code"]) : "en";
if ($action == "get_scan_image") {
    $lang_code = $lang;
    if ($user_id) {
        $user_res = $osql->get_result("select * from app_user where app_user_email='{$user_email}'");
        $user_row = $osql->next($user_res);
        if ($user_row["lang_code"])
            $lang_code = $user_row["lang_code"];
    }
    include "lang_{$lang_code}.php";
    $osql->begin();
    $arr_product = array();
    $res = $osql->get_result("SELECT preference_image FROM preference");
    $row = $osql->next($res);
    if ($row["preference_image"])
        $image = upload_url_path . "" . $row["preference_image"];
    if ($osql::$is_rollback) {
        $osql->rollback();
        $response_type = "error";
        $message = def_MSG_OPERATION_FAILED;
        $status = 0;
    } else {
        $osql->commit();
        $response_type = "success";
        $message = def_MSG_OPERATION_SUCCESS;
        $status = 1;
    }
    $jsons["scan_image"] = $image;
    $jsons["type"] = $response_type;
    $jsons["status"] = $status;
    $jsons["message"] = $message;

    echo json_encode($jsons);
    exit;
}

$token["jwt"] = getBearerToken();
include 'jwt/header.php';
$lang_id = $token_lang_id;
include_once "lang_{$token_lang_code}.php";
if (!$token_lang_id) {

    $lang = $osql->escape($obj['lang'] ? $obj['lang'] : "en");
    $res = $osql->get_result("SELECT lang_id FROM lang where lang_code='{$lang}' ");
    $ro = $osql->next($res);
    $lang_id = $ro["lang_id"];
}
if (!$user_id or !$token_user_id or $user_id != $token_user_id) {
    $reponse_msg["status"] = 0;
    $reponse_msg["type"] = "error";
    $reponse_msg["message"] = def_unauthorized;
    echo json_encode($reponse_msg);
    exit;
}

function get_questions($id) {
    global $lang_id;
    global $osql;

    if ($id) {
        $id = strval($osql->escape($id ?: 0));

        $cond = "AND `faq_parent_id`='$id'";
    } else {
        $cond = "AND `faq_parent_id` is NULL";
    }

    $questions = $osql->get_array_rows("SELECT faq.`faq_id`,`faq_question`,`faq_answer` FROM faq INNER JOIN faq_lang ON faq.`faq_id` = faq_lang.`faq_id` WHERE `lang_id`=$lang_id $cond");
    return $questions;
}

if ($action == 'get_question_data') {
    $jsons["questions"] = get_questions($obj["question_parent_id"]);
    if (empty($jsons["questions"])) {
        // Fallback if no questions were found
        $jsons["questions"] = get_questions(null);
    }
    $response_type = "success";
    $status = 0;
    $message = def_MSG_OPERATION_SUCCESS;
} else if ($action == "get_product") {
    $search_val = $obj["search_value"];
    if ($search_val) {
        $cond .= " and (product_lang.name like '%{$search_val}%' or product_lang.subtitle like '%{$search_val}%' or product_lang.description like '%{$search_val}%' )";
    }
    if ($obj["category_id"]) {
        $cond .= " and product.category_id ='" . $osql->escape($obj["category_id"]) . "'";
    }
    if ($obj["color_id"]) {
        $cond .= " and  FIND_IN_SET('{$osql->escape($obj["color_id"])}', product.color_id )";
    }
    if ($obj["price_from"] and $obj["price_to"]) {
        $cond .= " and  product_price between {$osql->escape($obj["price_from"])} and {$osql->escape($obj["price_to"])}";
    }
    $order = null;
    if ($obj["price_order"]) {
        $order = " order by product_price {$obj["price_order"]} ";
    }
    $osql->begin();
    $arr_product = array();
    $res = $osql->get_result("SELECT product.*,product_lang.name as product_name,"
            . "product_lang.description as product_description,product_lang.subtitle as product_subtitle "
            . " FROM product "
            . " inner join product_lang on product_lang.product_id = product.product_id "
            . " where product_is_disabled='0' and product_lang.lang_id='{$lang_id}' {$cond} {$order}");
    while ($row = $osql->next($res)):
        if ($row["product_attachment_1"])
            $row["product_attachment_1"] = upload_url_path . $row["product_attachment_1"];
        if ($row["product_attachment_2"])
            $row["product_attachment_2"] = upload_url_path . $row["product_attachment_2"];
        if ($row["product_attachment_3"])
            $row["product_attachment_3"] = upload_url_path . $row["product_attachment_3"];
        if ($row["product_attachment_4"])
            $row["product_attachment_4"] = upload_url_path . $row["product_attachment_4"];
        if ($row["product_attachment_5"])
            $row["product_attachment_5"] = upload_url_path . $row["product_attachment_5"];
        if ($row["product_attachment_6"])
            $row["product_attachment_6"] = upload_url_path . $row["product_attachment_6"];
        array_push($arr_product, $row);
    endwhile;
    if ($osql::$is_rollback) {
        $osql->rollback();
        $response_type = "error";
        $message = def_MSG_OPERATION_FAILED;
        $status = 0;
    } else {
        $osql->commit();
        $response_type = "success";
        $message = def_MSG_OPERATION_SUCCESS;
        $status = 1;
    }

    $jsons["product"] = $arr_product;
} elseif ($action == "check_product") {
    if (!$user_id or !$product_id) {
        $type = "error";
        $status = 0;
        $message = def_data_missing;
    } else {
        $is_cart = false;
        $res = $osql->get_result("select * from cart where user_id='{$user_id}' and product_id='{$product_id}' limit 1");
        if ($res->num_rows > 0)
            $is_cart = true;
        $is_wishlist = false;
        $res1 = $osql->get_result("select * from wishlist where user_id='{$user_id}' and product_id='{$product_id}' limit 1");
        if ($res1->num_rows > 0)
            $is_wishlist = true;

        $jsons["is_cart"] = $is_cart;
        $jsons["is_wishlist"] = $is_wishlist;
        $type = "success";
        $status = 0;
        $message = def_MSG_OPERATION_SUCCESS;
    }
} elseif ($action == "get_user_address") {
    if ($obj["user_address_id"]) {
        $con = " and user_address_id='{$osql->escape($obj["user_address_id"])}'";
    }
    if ($obj["user_id"]) {
        $con .= " and user_id='{$osql->escape($obj["user_id"])}'";
    }
    if ($obj["is_desc"]) {
        $order = " order by user_address_id desc";
    }
//    $offset = intval($obj["offset"]);
//    $limit_rows = intval($obj["limit"]);
//    if (!is_numeric($offset) or !is_numeric($limit_rows)) {
//        $response_type = "error";
//        $message = def_MSG_OPERATION_FAILED;
//        $status = 0;
//    } else {
//        $qry_limit = " limit {$offset},{$limit_rows}";
    $osql->begin();
    $arr_add = array();
    $statment = "select * from user_address where 1=1 {$con} {$order}";
    $tt_res = $osql->get_result($statment);
    $json["total_record"] = $tt_res->num_rows;
    $add_ress = $osql->get_result("{$statment} {$qry_limit}");
    while ($add_row = $osql->next($add_ress)):
        array_push($arr_add, $add_row);
    endwhile;
    if ($osql::$is_rollback) {
        $osql->rollback();
        $response_type = "error";
        $message = def_MSG_OPERATION_FAILED;
        $status = 0;
    } else {
        $osql->commit();
        $response_type = "success";
        $message = def_MSG_OPERATION_SUCCESS;
        $status = 1;
    }
//    }
    $jsons["data"] = $arr_add;
} elseif ($action == "get_cart") {
    if ($user_id) {
        $jsons = cart_list($user_id, $lang_id);
        $response_type = "success";
        $status = 1;
        $message = def_MSG_OPERATION_SUCCESS;
    } else {
        $response_type = "error";
        $status = 0;
        $message = def_login_first;
    }
} elseif ($action == "get_wishlist") {
    if ($user_id) {
        $arr_product = array();
        $res = $osql->get_result("SELECT product.*,product_lang.name as product_name,"
                . "product_lang.description as product_description,product_lang.subtitle as product_subtitle FROM product "
                . " inner join product_lang on product_lang.product_id=product.product_id "
                . " inner join wishlist on wishlist.product_id = product.product_id "
                . " where wishlist.user_id = '{$user_id}' and product_lang.lang_id='{$lang_id}'");
        while ($row = $osql->next($res)):
            if ($row["product_attachment_1"])
                $row["product_attachment_1"] = upload_url_path . $row["product_attachment_1"];
            if ($row["product_attachment_2"])
                $row["product_attachment_2"] = upload_url_path . $row["product_attachment_2"];
            if ($row["product_attachment_3"])
                $row["product_attachment_3"] = upload_url_path . $row["product_attachment_3"];
            if ($row["product_attachment_4"])
                $row["product_attachment_4"] = upload_url_path . $row["product_attachment_4"];
            if ($row["product_attachment_5"])
                $row["product_attachment_5"] = upload_url_path . $row["product_attachment_5"];
            if ($row["product_attachment_6"])
                $row["product_attachment_6"] = upload_url_path . $row["product_attachment_6"];
            array_push($arr_product, $row);
        endwhile;
        $jsons["product"] = $arr_product;
        $response_type = "success";
        $status = 1;
        $message = def_MSG_OPERATION_SUCCESS;
    } else {
        $response_type = "error";
        $status = 0;
        $message = def_login_first;
    }
} elseif ($action == "get_order") {
    $arr_orders = array();
    $offset = $osql->escape($obj["offset"]);
    $limit_rows = $osql->escape($obj["limit"]);
//    if (is_null($obj["offset"]) or is_null($obj["limit"]) or !is_numeric($offset) or !is_numeric($limit_rows)) {
//        $response_type = "error";
//        $message = def_MSG_OPERATION_FAILED;
//        $status = 0;
//    } else {
//        $qry_limit = " limit {$offset},{$limit_rows}";
    $osql->begin();
    if ($obj["order_id"]) {
        $cond .= " and orders.order_id='{$osql->escape($obj["order_id"])}'";
//order event store
        $arr_event_store = array();
        $res_event = $osql->get_result("select order_id,order_event_title as title,order_event_date as date from order_event "
                . " where order_id='{$osql->escape($obj["order_id"])}'");
        while ($row_event = $osql->next($res_event)):
            array_push($arr_event_store, $row_event);
        endwhile;
    }
    $cond .= " and orders.user_id='{$osql->escape($user_id)}'";
    if ($obj["product_name"]) {
        $n_cond = " and product_lang._name like '%{$osql->escape($obj["product_name"])}%'";
    }
    if ($obj["search_date"]) {
        $date = date("Y-m-d", strtotime($osql->escape($obj["search_date"])));
        $cond .= " and date(order_date) ='{$date}'";
    }
    if ($obj["order_status_id"]) {
        $cond .= " and orders.order_status_id = '{$osql->escape($obj["order_status_id"])}'";
    }
//
//        $curr_res = $osql->get_result("select app_currency_code_ltr as app_currencey_code from app_currency where app_currency_is_basic=1");
//        $curr_row = $osql->next($curr_res);
//        $curr_code = $curr_row["app_currencey_code"];
//        $json["currency"] = $curr_code;
//products
    $res_prod = $osql->get_result("select order_product.order_id,order_product.product_id,product_lang.name as product_name,order_product_tax,"
            . "order_product_price,order_product_discount,product_attachment_1,"
            . " order_product.color_id,order_product.size_id,order_product_qty, "
            . " is_refund,refund_date,refund_desc "
            . " from order_product "
            . " inner join product on product.product_id = order_product.product_id "
            . " inner join product_lang on product_lang.product_id= product.product_id "
            . " inner join orders on orders.order_id = order_product.order_id "
            . " left join color_lang on color_lang.color_id = order_product.color_id "
            . " where 1=1 {$cond} {$n_cond} and product_lang.lang_id='{$lang_id}' "
            . " and color_lang.lang_id='{$lang_id}'");
    while ($row_prod = $osql->next($res_prod)):
        if ($row_prod["refund_date"]) {
            $row_prod["refund_date"] = date("Y-m-d", strtotime($row_prod["refund_date"]));
        }
        if ($row_prod["product_attachment_1"])
            $row_prod["product_attachment_1"] = upload_url_path . $row_prod["product_attachment_1"];
        if (!$arr_product[$row_prod["order_id"]])
            $arr_product[$row_prod["order_id"]] = array();

        array_push($arr_product[$row_prod["order_id"]], $row_prod);
    endwhile;

//            if (count($arr_product) > 0)
//                $cond .= " and orders.order_id in (" . implode(",", array_keys($arr_product)) . ")";
//            else {
//                $cond .= " and orders.order_id in (0)";
//            }
//orders
    $statment = "select order_date,order_code,order_total,order_status_name,orders.order_id,order_total_amount,"
            . " orders.order_no,order_status_mask,order_discount,order_add,method as payment_method,order_fees,"
            . " user_address.* "
            . " from orders "
            . " left join user_address on user_address.user_address_id=orders.user_address_id "
            . " left join order_status on order_status.order_status_id=orders.order_status_id "
            . " left join payment_lang on payment_lang.payment_id=orders.payment_id "
//                . " left join coupon on coupon.coupon_id= order.coupon_id"
            . " where 1=1 and payment_lang.lang_id='{$lang_id}' {$cond} order by order_date desc ";
    $ttl_res = $osql->get_result($statment);
    $jsons["total_record"] = $ttl_res->num_rows;

    $res = $osql->get_result($statment . "{$qry_limit}", false);
    $arr_orders = array();
    while ($row = $osql->next($res)):
        $row["products"] = $arr_product[$row["order_id"]];

        if ($obj["order_id"])
            $row["event_store"] = $arr_event_store;

        $row["discount_val"] = ($row["order_discount"] / 100) * $row["order_total"];

        array_push($arr_orders, $row);
    endwhile;

    if ($osql::$is_rollback) {
        $osql->rollback();
        $response_type = "error";
        $message = def_MSG_OPERATION_FAILED;
        $status = 0;
    } else {
        $osql->commit();
        $response_type = "success";
        $message = def_MSG_OPERATION_SUCCESS;
        $status = 1;
    }
    $jsons["data"] = $arr_orders;
//    }
} else {
    $osql->begin();
    //color
    $res = $osql->get_result("select color.color_id,color_lang.title,color_hex_code "
            . " from color "
            . " inner join color_lang on color_lang.color_id=color.color_id "
            . " where color_lang.lang_id='{$lang_id}'");
    $arr_color = array();
    while ($row = $osql->next($res)):
        $row["color_hex_code"] = str_replace("#", "0xff", $row["color_hex_code"]);
        array_push($arr_color, $row);
    endwhile;
    //size
    $res = $osql->get_result("select size.size_id,size_lang.title "
            . " from size "
            . " inner join size_lang on size_lang.size_id=size.size_id "
            . " where size_lang.lang_id='{$lang_id}' and size_is_disable='0'");
    $arr_size = array();
    while ($row = $osql->next($res)):
        array_push($arr_size, $row);
    endwhile;
    //category
    $cat_res = $osql->get_result("select category.category_id,category_lang.name "
            . " from category "
            . " inner join category_lang on category_lang.category_id=category.category_id "
            . " where category_lang.lang_id='{$lang_id}' and category_is_disabled='0'");
    $arr_category = array();
    while ($cat_row = $osql->next($cat_res)):
        if ($cat_row["category_image"]) {
            $cat_row["category_image"] = upload_url_path . $cat_row["category_image"];
        }
        array_push($arr_category, $cat_row);
    endwhile;
    if ($osql::$is_rollback) {
        $osql->rollback();
        $response_type = "error";
        $message = def_MSG_OPERATION_FAILED;
        $status = 0;
    } else {
        $osql->commit();
        $response_type = "success";
        $message = def_MSG_OPERATION_SUCCESS;
        $status = 1;
        $jsons["color"] = $arr_color;
        $jsons["size"] = $arr_size;
        $jsons["categories"] = $arr_category;
    }
}
$jsons["type"] = $response_type;
$jsons["status"] = $status;
$jsons["message"] = $message;

header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: POST");
header("Access-Control-Max-Age: 3600");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");
echo json_encode($jsons);
